package com.sobot.calldemo;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.text.TextUtils;
import android.text.method.ScrollingMovementMethod;
import android.view.View;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;

import com.sobot.callbase.api.utils.SobotStompEventConstant;
import com.sobot.callbase.constant.SobotCallBaseConstant;
import com.sobot.callbase.constant.SobotCallLiveDataBusKey;
import com.sobot.callbase.listener.SobotVoipCallListener;
import com.sobot.callbase.listener.SobotVoipRegisterListener;
import com.sobot.callbase.model.CallSipModel;
import com.sobot.callbase.model.CallStompMsgModel;
import com.sobot.callbase.model.SobotAgentStatusInfo;
import com.sobot.callbase.model.SobotEventAgentLogin;
import com.sobot.callbase.model.SobotExtensionEntity;
import com.sobot.callbase.stomp.SobotStompClient;
import com.sobot.callsdk.SobotCallOpenApi;
import com.sobot.callsdk.listener.SobotRegistrationListener;
import com.sobot.callsdk.service.SobotJanusService;
import com.sobot.callsdk.sip.SobotSipUtils;
import com.sobot.callsdk.utils.CallSharedPreferencesUtils;
import com.sobot.callsdk.utils.CallStatusUtils;
import com.sobot.callsdk.utils.SobotCallConstant;
import com.sobot.callsdk.v1.sipphonelibrary.SobotLogUtil;
import com.sobot.common.login.SobotLoginTools;
import com.sobot.common.login.callback.SobotResultBlock;
import com.sobot.common.login.callback.SobotResultCode;
import com.sobot.common.login.model.SobotServiceInfoModel;
import com.sobot.common.utils.SobotGlobalContext;
import com.sobot.gson.SobotGsonUtil;
import com.sobot.network.http.callback.SobotResultCallBack;
import com.sobot.utils.SobotLogUtils;
import com.sobot.utils.SobotStringUtils;
import com.sobot.widget.livedatabus.SobotLiveEventBus;
import com.sobot.widget.ui.toast.SobotToastUtil;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;


public class SobotCallInterfaceTestActivity extends Activity implements View.OnClickListener, SobotResultBlock {

    private RelativeLayout sobot_tv_left;
    private TextView tv_stomp_log;

    private String sessionDescription;//接听
    private Observer<CallStompMsgModel> stompMsgObserver;//stomp 消息事件

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_sobot_demo_new_setting);
        sobot_tv_left = (RelativeLayout) findViewById(R.id.sobot_demo_tv_left);
        TextView sobot_text_title = (TextView) findViewById(R.id.sobot_demo_tv_title);
        tv_stomp_log = (TextView) findViewById(R.id.tv_stomp_log);
        //然后TextView支持点击
        tv_stomp_log.setMovementMethod(ScrollingMovementMethod.getInstance());
        sobot_text_title.setText("接口测试");
        sobot_tv_left.setOnClickListener(this);

        findViewsById();

    }


    private void findViewsById() {

        RelativeLayout rl_1 = (RelativeLayout) findViewById(R.id.rl_1);
        rl_1.setOnClickListener(this);
        RelativeLayout rl_2 = (RelativeLayout) findViewById(R.id.rl_2);
        rl_2.setOnClickListener(this);
        RelativeLayout rl_3 = (RelativeLayout) findViewById(R.id.rl_3);
        rl_3.setOnClickListener(this);
        RelativeLayout rl_4 = (RelativeLayout) findViewById(R.id.rl_4);
        rl_4.setOnClickListener(this);
        RelativeLayout rl_5 = (RelativeLayout) findViewById(R.id.rl_5);
        rl_5.setOnClickListener(this);
        RelativeLayout rl_6 = (RelativeLayout) findViewById(R.id.rl_6);
        rl_6.setOnClickListener(this);
        RelativeLayout rl_7 = (RelativeLayout) findViewById(R.id.rl_7);
        rl_7.setOnClickListener(this);
        RelativeLayout rl_8 = (RelativeLayout) findViewById(R.id.rl_8);
        rl_8.setOnClickListener(this);
        RelativeLayout rl_9 = (RelativeLayout) findViewById(R.id.rl_9);
        rl_9.setOnClickListener(this);
        RelativeLayout rl_10 = (RelativeLayout) findViewById(R.id.rl_10);
        rl_10.setOnClickListener(this);
        RelativeLayout rl_11 = (RelativeLayout) findViewById(R.id.rl_11);
        rl_11.setOnClickListener(this);
        RelativeLayout rl_12 = (RelativeLayout) findViewById(R.id.rl_12);
        rl_12.setOnClickListener(this);
        RelativeLayout rl_13 = (RelativeLayout) findViewById(R.id.rl_13);
        rl_13.setOnClickListener(this);
        RelativeLayout rl_14 = (RelativeLayout) findViewById(R.id.rl_14);
        rl_14.setOnClickListener(this);
        RelativeLayout rl_15 = (RelativeLayout) findViewById(R.id.rl_15);
        rl_15.setOnClickListener(this);
        findViewById(R.id.rl_16).setOnClickListener(this);
        findViewById(R.id.rl_17).setOnClickListener(this);
        findViewById(R.id.rl_18).setOnClickListener(this);
        findViewById(R.id.rl_19).setOnClickListener(this);
        findViewById(R.id.rl_20).setOnClickListener(this);
        findViewById(R.id.rl_21).setOnClickListener(this);
        findViewById(R.id.rl_22).setOnClickListener(this);
        findViewById(R.id.rl_23).setOnClickListener(this);
        findViewById(R.id.rl_24).setOnClickListener(this);
        findViewById(R.id.rl_2_2).setOnClickListener(this);
        findViewById(R.id.rl_2_3).setOnClickListener(this);
        findViewById(R.id.rl_4_5).setOnClickListener(this);
        findViewById(R.id.rl_4_7).setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.sobot_demo_tv_left) {
            //返回
            finish();
        } else {
            try {
                Intent intent = new Intent(SobotCallInterfaceTestActivity.this, SobotSecondInterfaceActivity.class);
                String requestName = "";
                String requestFunName = "";
                String requestParamExampleUrl = "";
                JSONObject jsonObject = new JSONObject();
                switch (v.getId()) {
                    case R.id.rl_1://1.1 初始化
                        requestName = "初始化";
                        requestFunName = "initWithConfig";
                        requestParamExampleUrl = "";

                        jsonObject.put("openApiHost", "https://test-branche1.sobot.com");
                        jsonObject.put("callApiHost", "https://test-branche1.sobot.com/text");
                        jsonObject.put("stompSocketUri", "wss://test-branche1.sobot.com/v6.0.0/webmsg/cc-webmsg");
                        jsonObject.put("janusSocketUri", "wss://test-rtc.sobot.com.cn");
                        jsonObject.put("sipProxy", "sip:192.168.1.209:5060");

                        break;
                    case R.id.rl_2://2.1 登录
                        requestName = "登录";
                        requestFunName = "loginWithAcount";
                        requestParamExampleUrl = "";
                        jsonObject.put("loginUser", "9494@sobot.com");
                        jsonObject.put("loginPwd", "sobot123");
                        initBrocastReceiver();
                        break;
                    case R.id.rl_2_2://2.2 获取分机号
                        requestName = "获取分机号";
                        requestFunName = "queryUnusedExts";
                        requestParamExampleUrl = "";
                        break;
                    case R.id.rl_2_3://2.3 查询座席可用的接听方式
                        requestName = "查询座席可用的接听方式";
                        requestFunName = "queryPhoneType";
                        requestParamExampleUrl = "";
                        break;
                    case R.id.rl_3://3.1 座席签入
                        requestName = "座席签入";
                        requestFunName = "agentLogin";
                        requestParamExampleUrl = "http://code.sobot.tech/cc/public-docs/blob/dev/doc/client-websocket-api.md#%E5%BA%A7%E5%B8%AD%E7%AD%BE%E5%85%A5";
                        jsonObject.put("agentState", "1");
                        jsonObject.put("phoneType", "webrtc");
                        jsonObject.put("bindExt", "7777");
                        jsonObject.put("bindMobile", "");
                        List<String> list = new ArrayList<>();
                        list.add("2666");
                        list.add("2888");
                        list.add("5656");
                        list.add("9999");
                        jsonObject.put("thisQueues", SobotGsonUtil.beanToJson(list));
                        break;
                    case R.id.rl_4://3.2 座席签出
                        requestName = "座席签出";
                        requestFunName = "agentLogout";
                        break;
                    case R.id.rl_5://3.3 座席置忙
                        requestName = "座席置忙";
                        requestFunName = "agentNotReady";
                        jsonObject.put("reasonCode", "3");
                        break;
                    case R.id.rl_6://3.4 座席置闲
                        requestName = "座席置闲";
                        requestFunName = "agentReady";
                        break;
                    case R.id.rl_7://3.5 查询座席的签入信息
                        requestName = "查询座席的签入信息";
                        requestFunName = "queryLoginBindingInfo";
                        break;
                    case R.id.rl_8://3.6 查询座席可使用分机帐号
                        requestName = "查询座席可使用分机帐号";
                        requestFunName = "queryAvailableExts";
                        break;
                    case R.id.rl_9://3.7 查询座席可用的置忙原因
                        requestName = "查询座席可用的置忙原因";
                        requestFunName = "queryBusyStatus";
                        requestParamExampleUrl = "";
                        break;
                    case R.id.rl_10://3.8 查询座席可签入的技能组
                        requestName = "查询座席可签入的技能组";
                        requestFunName = "queryAvailableQueues";
                        break;
                    case R.id.rl_11://3.9 重置离线（退出登录）
                        requestName = "重置离线（退出登录）";
                        requestFunName = "resetLogout";
                        break;
                    case R.id.rl_12://4.1 外呼
                        requestName = "外呼";
                        requestFunName = "makeCall";
                        requestParamExampleUrl = "http://code.sobot.tech/cc/public-docs/blob/dev/doc/client-websocket-api.md#%E5%A4%96%E5%91%BC";
                        jsonObject.put("otherDN", "18611961150");
                        jsonObject.put("privacyNumber", "");
                        jsonObject.put("ANI", "02131218653");
                        jsonObject.put("outboundPlanCode", "");
                        jsonObject.put("agentANI", "");
                        break;
                    case R.id.rl_13://4.2 接听
                        requestName = "接听";
                        requestFunName = "answer";
                        break;
                    case R.id.rl_14://4.3 挂机
                        requestName = "挂机";
                        requestFunName = "hangup";
                        break;

                    case R.id.rl_15://4.4 保持
                        requestName = "保持";
                        requestFunName = "holdCall";
                        break;
                    case R.id.rl_4_5://4.4 保持取消
                        requestName = "保持取消";
                        requestFunName = "retrieveCall";
                        break;
                    case R.id.rl_16://4.5 静音
                        requestName = "静音";
                        requestFunName = "muteCall";
                        break;
                    case R.id.rl_4_7://4.5 静音取消
                        requestName = "静音取消";
                        requestFunName = "unMuteCall";
                        break;
                    case R.id.rl_17://4.6 设置播放类型
                        requestName = "设置播放类型";
                        requestFunName = "changedPlayCategory";
                        jsonObject.put("isSpeakerphoneOn", true);
                        break;
                    case R.id.rl_18://4.7 发送满意度
                        requestName = "发送满意度";
                        requestFunName = "sendSatisfaction";
                        jsonObject.put("autoSatisfy", 1);
                        break;
                    case R.id.rl_19://4.8 延长整理时长
                        requestName = "延长整理时长";
                        requestFunName = "delayCallAfterWork";
                        jsonObject.put("delayTime", 30);
                        break;
                    case R.id.rl_20://4.9 结束整理
                        requestName = "结束整理";
                        requestFunName = "finishCallAfterWork";
                        break;
                    case R.id.rl_21://4.10 发送按键
                        requestName = "发送按键";
                        requestFunName = "sendDtmf";
                        jsonObject.put("dtmfDigits", 8);
                        break;
                    case R.id.rl_22://4.11 结束整理并置忙
                        requestName = "结束整理并置忙";
                        requestFunName = "finishCallAfterWorkAndBusy";
                        break;
                    case R.id.rl_23://5.1 查询座席的外呼路由规则
                        requestName = "查询座席的外呼路由规则";
                        requestFunName = "queryOutBoudRoutesRules";
                        break;
                    case R.id.rl_24://5.2 修改自修的外呼路由规则
                        requestName = "修改自修的外呼路由规则";
                        requestFunName = "switchOutBoudRoutesRules";
                        jsonObject.put("explicitRule", "1");
                        jsonObject.put("explicitCode", "");
                        jsonObject.put("explicitNumber", "");
                        break;
                    default:
                        break;
                }
                if ("agentReady".equals(requestFunName)) {
                    SobotCallOpenApi.agentReady(this, this);
                } else if ("agentLogout".equals(requestFunName)) {
                    SobotCallOpenApi.agentLogout(this, this);
                } else if ("finishCallAfterWork".equals(requestFunName)) {
                    SobotCallOpenApi.finishCallAfterWork(this, this);
                } else if ("finishCallAfterWorkAndBusy".equals(requestFunName)) {
                    SobotCallOpenApi.finishCallAfterWorkAndBusy(this, this);
                } else if ("answer".equals(requestFunName)) {
                    SobotCallOpenApi.answer(this, sessionDescription, new SobotResultBlock() {
                        @Override
                        public void resultBolok(SobotResultCode code, String msg, Object obj) {
                            sessionDescription = "";
                            SobotToastUtil.showToast(SobotCallInterfaceTestActivity.this, msg);
                        }
                    });
                } else if ("resetLogout".equals(requestFunName)) {
                    SobotCallOpenApi.resetLogout(this, this);
                } else if ("hangup".equals(requestFunName)) {
                    SobotCallOpenApi.hangup(this, this);
                } else if ("holdCall".equals(requestFunName)) {
                    SobotCallOpenApi.holdCall(this, this);
                } else if ("retrieveCall".equals(requestFunName)) {
                    SobotCallOpenApi.retrieveCall(this, this);
                } else if ("muteCall".equals(requestFunName)) {
                    SobotCallOpenApi.muteCall(this, this);
                } else if ("unMuteCall".equals(requestFunName)) {
                    SobotCallOpenApi.unMuteCall(this, this);
                } else {
                    intent.putExtra("requestName", requestName);
                    intent.putExtra("requestFunName", requestFunName);
                    intent.putExtra("requestParamExample", jsonObject.toString());
                    intent.putExtra("requestParamExampleUrl", requestParamExampleUrl);
                    startActivity(intent);
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }


    private void initBrocastReceiver() {
        //收到 stomp 消息
        stompMsgObserver = new Observer<CallStompMsgModel>() {
            @Override
            public void onChanged(CallStompMsgModel stompMsgModel) {
                if (stompMsgModel == null) {
                    return;
                }
                SobotServiceInfoModel serviceVo = SobotLoginTools.getInstance().getServiceInfo();
                SobotLogUtils.i(" SobotCallInterfaceTestActivity 收到stomp 消息:" + SobotStringUtils.checkStringIsNull(stompMsgModel.getStompMessageID()));
                String stompMessageID = SobotStringUtils.checkStringIsNull(stompMsgModel.getStompMessageID());
                String stompMessageContent = SobotStringUtils.checkStringIsNull(stompMsgModel.getStompMessageContent());
                String agentStatusInfoStr = SobotStringUtils.checkStringIsNull(stompMsgModel.getAgentStatusInfo());//坐席信息
                String agentCallStatusInfo = SobotStringUtils.checkStringIsNull(stompMsgModel.getAgentCallStatusInfo());//坐席状态
                //当前连接客户端类型 系统-客服APP-Android端  : SysAppAndroid  ; 系统-客服APP-IOS端 : SysAppIos
                String clientType = SobotStringUtils.checkStringIsNull(stompMsgModel.getClientType());
                String errorMessage = SobotStringUtils.checkStringIsNull(stompMsgModel.getErrorMessage());
                if (!TextUtils.isEmpty(stompMessageContent) && !TextUtils.isEmpty(stompMessageID)) {
                    if (SobotStompEventConstant.EventAgentLogin.equals(stompMessageID)) {
                        SobotToastUtil.showToast(SobotCallInterfaceTestActivity.this, "签入成功");
                        //座席签入
                        SobotEventAgentLogin agentStatus = SobotGsonUtil.jsonToBean(stompMessageContent, SobotEventAgentLogin.class);
                        if (agentStatus != null) {
                            if (agentStatus.getAgentState() == 1) {
                                //空闲
                                SobotRegistrationListener.getInstance().isLogin = true;
                                CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.callLoginStatus, CallStatusUtils.V6_FREE);
                                SobotLogUtil.i(stompMessageID + " " + stompMessageContent);
                            } else if (agentStatus.getAgentState() == 2) {
                                //勿扰
                                CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.callLoginStatus, CallStatusUtils.V6_DO_NOT_DISTURB);
                                SobotLogUtil.i(stompMessageID + " " + stompMessageContent);
                            }
                        }
                    } else if (SobotStompEventConstant.EventAgentLogout.equals(stompMessageID)) {
                        //座席签出
                        SobotToastUtil.showToast(SobotCallInterfaceTestActivity.this, "签出成功");
                        SobotStompClient.getInstance(SobotCallInterfaceTestActivity.this).disconnect();
                        CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.callLoginStatus, CallStatusUtils.OFF_LINE);
                        SobotLogUtil.i(stompMessageID + " " + stompMessageContent);
                        int callWay = CallSharedPreferencesUtils.getInstance(getSobotActivity()).get(SobotCallConstant.SP_KEY_CALL_MODEL_TYPE_V6, SobotCallConstant.CALL_MODEL_PHONE);
                        if (callWay == SobotCallConstant.CALL_MODEL_SIP) {
                            //如果是sip 方式签出
                            SobotRegistrationListener.getInstance().isLogin = false;
                            if (serviceVo != null) {
                                SobotSipUtils.logoutUser(serviceVo.getCallV6Flag() == 1 ? true : false);
                                SobotSipUtils.stopService(serviceVo.getCallV6Flag() == 1 ? true : false, getSobotActivity());
                            }
                        }
                        if (serviceVo != null) {
                            SobotSipUtils.stopService(serviceVo.getCallV6Flag() == 1 ? true : false, getSobotActivity());
                        }
                    } else if (SobotStompEventConstant.EventAgentReady.equals(stompMessageID)) {
                        //座席置闲 sip 登录
                        SobotRegistrationListener.getInstance().isLogin = true;
                        CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.callLoginStatus, CallStatusUtils.V6_FREE);
                        SobotLogUtil.i(stompMessageID + " " + stompMessageContent);
                    } else if (SobotStompEventConstant.EventAgentNotReady.equals(stompMessageID)) {
                        //座席置忙
                        SobotEventAgentLogin agentStatus = SobotGsonUtil.jsonToBean(stompMessageContent, SobotEventAgentLogin.class);
                        if (agentStatus != null) {
                            CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.callLoginStatus, agentStatus.getReasonCode() + "");
                            SobotLogUtil.i(stompMessageID + " " + stompMessageContent);
                        }
                    } else if (stompMessageID.toLowerCase().contains("error")) {
                        //返回异常事件
                        SobotEventAgentLogin agentStatus = SobotGsonUtil.jsonToBean(stompMessageContent, SobotEventAgentLogin.class);

                        if (agentStatus != null) {
                            SobotToastUtil.showToast(getSobotActivity(), agentStatus.getErrorMessage());
                        }
                    } else if (SobotStompEventConstant.EventRinging.equals(stompMessageID)) {
                        //来电了
                    } else if (SobotStompEventConstant.EventWebSocketSession.equals(stompMessageID)) {
                        //恢复座席
                        if (!TextUtils.isEmpty(agentStatusInfoStr)) {
                            SobotAgentStatusInfo agentStatusInfo = SobotGsonUtil.jsonToBean(agentStatusInfoStr, SobotAgentStatusInfo.class);
                            if (agentStatusInfo != null && SobotStompEventConstant.clientType.equals(clientType)) {
                                //同端才处理
                                if ("webrtc".equals(agentStatusInfo.getPhoneType())) {
                                    //sip方式
                                    CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.SP_KEY_CALL_MODEL_TYPE_V6, SobotCallConstant.CALL_MODEL_SIP);
                                    //agentState 1-就绪，2-忙碌
                                    if ("1".equals(agentStatusInfo.getAgentState()) || "2".equals(agentStatusInfo.getAgentState())) {
                                        SobotCallOpenApi.queryUnusedExts(SobotCallInterfaceTestActivity.this, new SobotResultCallBack<List<SobotExtensionEntity>>() {
                                            @Override
                                            public void onSuccess(List<SobotExtensionEntity> extensionModelList) {
                                                if (extensionModelList != null) {
                                                    for (int i = 0; i < extensionModelList.size(); i++) {
                                                        SobotExtensionEntity extensionEntity = extensionModelList.get(i);
                                                        if (extensionEntity.getBindStatus() == 1) {
                                                            CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallBaseConstant.SipModel.SIP_NUMBER, extensionEntity.getExt());
                                                            CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallBaseConstant.SipModel.SIP_PWD, extensionEntity.getPassword());//sip账号密码先写死
                                                            CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallBaseConstant.SipModel.SIP_IP, extensionEntity.getDomain());
                                                            CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallBaseConstant.SipModel.SIP_SCHEME, SobotCallConstant.ServerScheme.FS);
                                                            CallSipModel sipModel = new CallSipModel();
                                                            sipModel.setAgentNumber(extensionEntity.getExt());
                                                            sipModel.setAgentPwd(extensionEntity.getPassword());
                                                            sipModel.setServerIP(extensionEntity.getDomain());
                                                            if ("1".equals(agentStatusInfo.getAgentState())) {
                                                                //先设置座席状态；janus 判断是否注册，没有的话注册；stomp 不会再次签入
                                                                CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.callLoginStatus, CallStatusUtils.V6_FREE);
                                                                if (!SobotJanusService.isServiceRunning() || !SobotJanusService.isRegistedSuccess()) {
                                                                }
                                                            } else if ("2".equals(agentStatusInfo.getAgentState())) {
                                                                //先设置座席状态；janus 判断是否注册，没有的话注册；stomp 不会再次签入
                                                                if (!SobotStringUtils.isEmpty(agentStatusInfo.getReasonCode())) {
                                                                    CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.callLoginStatus, agentStatusInfo.getReasonCode());
                                                                } else {
                                                                    CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.callLoginStatus, CallStatusUtils.V6_DO_NOT_DISTURB);
                                                                }
                                                                if (!SobotJanusService.isServiceRunning() || !SobotJanusService.isRegistedSuccess()) {
                                                                }
                                                            }
                                                            SobotLogUtil.i(stompMessageID + " " + stompMessageContent);
                                                            break;
                                                        }
                                                    }
                                                }
                                            }

                                            @Override
                                            public void onFailure(Exception e, String des) {

                                            }
                                        });
                                    }
                                }
                                if ("pstn".equals(agentStatusInfo.getPhoneType())) {
                                    //手机方式
                                    CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.SP_KEY_CALL_MODEL_TYPE_V6, SobotCallConstant.CALL_MODEL_PHONE);
                                    if ("1".equals(agentStatusInfo.getAgentState()) || "2".equals(agentStatusInfo.getAgentState())) {
                                        if ("1".equals(agentStatusInfo.getAgentState())) {
                                            //先设置状态，janus 只会注册，stomp 不会再次签入
                                            CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.callLoginStatus, CallStatusUtils.V6_FREE);
                                        } else if ("2".equals(agentStatusInfo.getAgentState())) {
                                            //先设置状态，janus 只会注册，stomp 不会再次签入
                                            CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.callLoginStatus, CallStatusUtils.V6_DO_NOT_DISTURB);
                                        }
                                        SobotLogUtil.i(stompMessageID + " " + stompMessageContent);
                                    }
                                }
                            }
                        }

                    } else if (SobotStompEventConstant.EventAgentConnectionChanged.equals(stompMessageID)) {
                        //座席在其它端登录，被挤下线的事件
                        SobotStompClient.getInstance(SobotCallInterfaceTestActivity.this).disconnect();
                        CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.callLoginStatus, CallStatusUtils.OFF_LINE);
                        int callWay = CallSharedPreferencesUtils.getInstance(getSobotActivity()).get(SobotCallConstant.SP_KEY_CALL_MODEL_TYPE_V6, SobotCallConstant.CALL_MODEL_PHONE);
                        if (callWay == SobotCallConstant.CALL_MODEL_SIP) {
                            //如果是sip 方式签出
                            SobotRegistrationListener.getInstance().isLogin = false;
                            if (serviceVo != null) {
                                SobotSipUtils.logoutUser(serviceVo.getCallV6Flag() == 1 ? true : false);
                                SobotSipUtils.stopService(serviceVo.getCallV6Flag() == 1 ? true : false, getSobotActivity());
                            }
                        }
                        SobotLogUtil.i(stompMessageID + " " + stompMessageContent);
                        //发送广播
                        Intent intent1 = new Intent();
                        intent1.setAction(SobotCallConstant.SOBOT_ACTION_CALL_EXIT_LOGIN);
                        getSobotActivity().sendBroadcast(intent1);
                    }
                }

            }
        };
        SobotLiveEventBus.get(SobotCallLiveDataBusKey.RECEIVE_STOMP_MSG, CallStompMsgModel.class)
                .observeForever(stompMsgObserver);
        SobotCallOpenApi.setRegistrationListener(new SobotVoipRegisterListener() {
            @Override
            public void registrationOK() {
                SobotLogUtils.d("SobotVoipRegisterListener == registrationOK");
            }

            @Override
            public void registrationFailed() {
                SobotLogUtils.d("SobotVoipRegisterListener == registrationFailed");
            }

            @Override
            public void registrationCleared() {
                SobotLogUtils.d("SobotVoipRegisterListener == registrationCleared");
            }
        });

        SobotCallOpenApi.setVoipCallListener(new SobotVoipCallListener() {
            @Override
            public void onCallIncoming(String jsep, boolean isCallPhone,String userPhoneNumber) {
                sessionDescription = jsep;
                SobotLogUtils.e("SobotVoipCallListener == onCallIncoming");
                if (isCallPhone) {
                    SobotCallOpenApi.answer(getSobotActivity(), jsep, new SobotResultBlock() {
                        @Override
                        public void resultBolok(SobotResultCode code, String msg, Object obj) {
                            sessionDescription = "";
                            SobotToastUtil.showToast(SobotCallInterfaceTestActivity.this, msg);
                        }
                    });
                }
            }

            @Override
            public void onCallConnected() {
                SobotLogUtils.e("SobotVoipCallListener == onCallConnected");
            }

            @Override
            public void onCallDisconnected() {
                SobotLogUtils.e("SobotVoipCallListener == onCallDisconnected");
            }
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (stompMsgObserver != null) {
            SobotLiveEventBus.get(SobotCallLiveDataBusKey.RECEIVE_STOMP_MSG, CallStompMsgModel.class).removeObserver(stompMsgObserver);
        }
    }

    @Override
    public void resultBolok(SobotResultCode code, String msg, Object obj) {
        SobotToastUtil.showToast(this, msg);
    }

    class LocalReceiver extends BroadcastReceiver {
        @Override
        public void onReceive(Context context, Intent intent) {
            SobotLogUtils.i("广播是 test:" + intent.getAction());
            SobotServiceInfoModel serviceVo = SobotLoginTools.getInstance().getServiceInfo();
            if (SobotCallConstant.SOBOT_BROADCAST_SESSION_TIMEOUT.equals(intent.getAction())) {
                int callWay = CallSharedPreferencesUtils.getInstance(getSobotActivity()).get(SobotCallConstant.SP_KEY_CALL_MODEL_TYPE_V6, SobotCallConstant.CALL_MODEL_PHONE);
                if (callWay == SobotCallConstant.CALL_MODEL_SIP) {
                    if (serviceVo != null && serviceVo.getCallV6Flag() == 1) {
                        SobotStompClient.getInstance(SobotCallInterfaceTestActivity.this).disconnect();
                    }
                    //如果是sip 方式签出
                    SobotRegistrationListener.getInstance().isLogin = false;
                    SobotSipUtils.logoutUser(serviceVo.getCallV6Flag() == 1 ? true : false);
                    SobotSipUtils.stopService(serviceVo.getCallV6Flag() == 1 ? true : false, getSobotActivity());
                }
                //弹出重新登录框
                Intent intent2 = new Intent();
                String httpinfo = intent.getStringExtra("httpinfo");
                intent2.putExtra("httpinfo", httpinfo);
                intent2.setAction("sobot_broadcast_session_timeout");
                getSobotActivity().sendBroadcast(intent2);
                new Handler().postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        CallSharedPreferencesUtils.getInstance(getSobotActivity()).clearAll();
                        //退出所有activity,如果集成到app中直接返回的登录页面
                        SobotGlobalContext.getInstance().finishAllActivity();
                    }
                }, 1000);
            }
        }
    }


    private Activity getSobotActivity() {
        return SobotCallInterfaceTestActivity.this;
    }

    public void setStomLog(String s) {
        new Handler().post(new Runnable() {
            @Override
            public void run() {
                String logStr = tv_stomp_log.getText().toString();
                tv_stomp_log.setText(String.format("%s \n%s", logStr, s));
            }
        });
    }
}