package com.sobot.calldemo;


import static com.sobot.callsdk.utils.SobotCallConstant.SOBOT_KEY_INIT;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

import androidx.annotation.Nullable;

import com.sobot.callsdk.ZCSobotCallApi;
import com.sobot.callsdk.model.SobotCallConfigEntity;
import com.sobot.callsdk.utils.SobotApplication;
import com.sobot.common.login.callback.SobotResultBlock;
import com.sobot.common.login.callback.SobotResultCode;
import com.sobot.widget.ui.toast.SobotToastUtil;


public class SobotCallStartActivity extends Activity implements View.OnClickListener {

    private TextView ac_demo_start_tv;
    private TextView ac_demo_init_tv;
    private TextView ac_demo_logout_tv;
    private TextView ac_demo_tnterface_tv;
    private EditText account;
    private EditText password;
    private EditText token;
    private EditText host;
    private EditText host2;
    private EditText host3;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_call_start_demo);
        ac_demo_start_tv = findViewById(R.id.ac_demo_start_tv);
        ac_demo_start_tv.setOnClickListener(this);
        ac_demo_init_tv = findViewById(R.id.ac_demo_init_tv);
        ac_demo_init_tv.setOnClickListener(this);
        ac_demo_logout_tv = findViewById(R.id.ac_demo_logout_tv);
        ac_demo_logout_tv.setOnClickListener(this);
        ac_demo_tnterface_tv = findViewById(R.id.ac_demo_tnterface_tv);
        ac_demo_tnterface_tv.setOnClickListener(this);
        account = findViewById(R.id.account);
        password = findViewById(R.id.password);
        host = findViewById(R.id.host);
        host2 = findViewById(R.id.host2);
        host3 = findViewById(R.id.host3);
        token = findViewById(R.id.token);
    }


    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.ac_demo_init_tv:
                ZCSobotCallApi.init(SobotApplicgtion.applicgtion);
                if (!TextUtils.isEmpty(host.getText().toString().trim()) && !TextUtils.isEmpty(host2.getText().toString().trim()) && !TextUtils.isEmpty(host3.getText().toString().trim())) {
                    //初始化方法由基础组件包提供，要使用 SDK，需要在宿主应用application.onCreate函数中调用基础组件包提供的初始化函数
                    if (host.getText().toString().trim().startsWith("http") && host2.getText().toString().trim().startsWith("http")) {
                        SobotCallConfigEntity config = new SobotCallConfigEntity();
                        config.setOpenApiHost(host.getText().toString().trim());
                        config.setCallApiHost(host2.getText().toString().trim());
                        config.setStompSocketUri(host3.getText().toString().trim());
                        config.setJanusSocketUri("wss://rtc.sobot.cc");
                        config.setSipProxy("sip:192.168.30.68:5060");
                        ZCSobotCallApi.setHost(SobotApplicgtion.applicgtion, config);
                    } else {
                        SobotToastUtil.showCustomToast(this, "请输入http或者https开头的域名");
                        return;
                    }
                }
                SobotToastUtil.showToast(this, "SDK初始化成功");
                break;
            case R.id.ac_demo_start_tv:
                Object obj = SobotApplication.getmInstance().get(SOBOT_KEY_INIT);
                if (obj != null) {
                    boolean isInit = (boolean) SobotApplication.getmInstance().get(SOBOT_KEY_INIT);
                    if (!isInit) {
                        SobotToastUtil.showToast(this, "请先初始化SDK后再启动");
                        return;
                    }
                } else {
                    SobotToastUtil.showToast(this, "请先初始化SDK后再启动");
                    return;
                }

                if (TextUtils.isEmpty(account.getText().toString().trim())) {
                    SobotToastUtil.showCustomToast(this, "账号不能为空");
                    return;
                }
                if (TextUtils.isEmpty(password.getText().toString().trim()) && TextUtils.isEmpty(token.getText().toString().trim())) {
                    SobotToastUtil.showCustomToast(this, "密码或者token至少一个不能为空");
                    return;
                }
                if (!TextUtils.isEmpty(password.getText().toString().trim())) {
                    ZCSobotCallApi.startWithAcount(SobotCallStartActivity.this, account.getText().toString().trim(), password.getText().toString().trim(), null);
                } else if (!TextUtils.isEmpty(token.getText().toString().trim())) {
                    ZCSobotCallApi.startWithToken(SobotCallStartActivity.this,account.getText().toString().trim(), token.getText().toString().trim(), null);
                }
                break;
            case R.id.ac_demo_logout_tv:
                if (TextUtils.isEmpty(account.getText().toString().trim())) {
                    SobotToastUtil.showCustomToast(this, "账号不能为空");
                    return;
                }
                ZCSobotCallApi.out(SobotCallStartActivity.this, account.getText().toString().trim(), new SobotResultBlock() {
                    @Override
                    public void resultBolok(SobotResultCode code, String msg, Object obj) {

                    }
                });
                break;
            case R.id.ac_demo_tnterface_tv:
                Intent intent = new Intent(SobotCallStartActivity.this, SobotCallInterfaceTestActivity.class);
                startActivity(intent);
                break;
        }
    }
}