package com.sobot.calldemo;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.text.ClipboardManager;
import android.view.View;
import android.widget.EditText;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.Nullable;

import com.sobot.callsdk.SobotCallOpenApi;
import com.sobot.callsdk.model.SobotCallConfigEntity;
import com.sobot.common.login.callback.SobotResultBlock;
import com.sobot.common.login.callback.SobotResultCode;
import com.sobot.gson.SobotGsonUtil;
import com.sobot.utils.SobotSoftKeyboardUtils;
import com.sobot.utils.SobotStringUtils;
import com.sobot.widget.ui.toast.SobotToastUtil;
import com.sobot.widget.ui.webview.SobotWebViewActivity;

import org.json.JSONException;
import org.json.JSONObject;


public class SobotSecondInterfaceActivity extends Activity implements View.OnClickListener, SobotResultBlock,View.OnLongClickListener {

    private RelativeLayout sobot_tv_left;
    private String requestName;//请求接口名称
    private String requestFunName;//请求方法名
    private String requestParamExample;//请求参数示例
    private String requestParamExampleUrl;//请求参数参考地址

    private TextView tv_interface_param_url,tv_interface_param,tv_interface_return,tv_interface_return_obj,sobot_tv_save;
    private EditText et_params;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_second_interface);

        if(getIntent()!=null) {
            requestName = getIntent().getStringExtra("requestName");
            requestFunName = getIntent().getStringExtra("requestFunName");
            requestParamExample = getIntent().getStringExtra("requestParamExample");
            requestParamExampleUrl = getIntent().getStringExtra("requestParamExampleUrl");
        }

        sobot_tv_left = (RelativeLayout) findViewById(R.id.sobot_demo_tv_left);
        sobot_tv_save = findViewById(R.id.sobot_tv_save);
        sobot_tv_save.setVisibility(View.VISIBLE);
        sobot_tv_save.setOnClickListener(this);
        TextView sobot_text_title = (TextView) findViewById(R.id.sobot_demo_tv_title);
        sobot_text_title.setText(requestName);
        sobot_tv_left.setOnClickListener(this);
        initView();

    }

    private void initView() {
        tv_interface_param_url =  findViewById(R.id.tv_interface_param_url);
        tv_interface_param =  findViewById(R.id.tv_interface_param);
        tv_interface_return =  findViewById(R.id.tv_interface_return);
        tv_interface_return_obj =  findViewById(R.id.tv_interface_return_obj);
        et_params =  findViewById(R.id.et_params);
        tv_interface_param.setOnLongClickListener(this);
        tv_interface_return.setOnLongClickListener(this);
        tv_interface_return_obj.setOnLongClickListener(this);
        tv_interface_param.setText(requestParamExample);
        tv_interface_param_url.setOnClickListener(this);
        if(!SobotStringUtils.isEmpty(requestParamExampleUrl)){
            tv_interface_param_url.setText(requestParamExampleUrl);
            tv_interface_param_url.setVisibility(View.VISIBLE);
        }else{
            tv_interface_param_url.setVisibility(View.GONE);
        }
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.sobot_demo_tv_left://返回
                finish();
                break;
            case R.id.tv_interface_param_url://跳转到网页
                if(!SobotStringUtils.isEmpty(requestParamExampleUrl)){
                    Intent intent = new Intent(SobotSecondInterfaceActivity.this, SobotWebViewActivity.class);
                    intent.putExtra("url",requestParamExampleUrl);
                    startActivity(intent);
                }
                break;
            case R.id.sobot_tv_save://保存
                SobotSoftKeyboardUtils.hideKeyboard(this);
                if("queryUnusedExts".equals(requestFunName)) {
                    SobotCallOpenApi.queryUnusedExts(this, this);
                }else if("queryPhoneType".equals(requestFunName)) {
                    SobotCallOpenApi.queryPhoneType(this, this);
                }else if("queryBusyStatus".equals(requestFunName)) {
                    SobotCallOpenApi.queryBusyStatus(this, this);
                }else if("queryLoginBindingInfo".equals(requestFunName)) {
                    SobotCallOpenApi.queryLoginBindingInfo(this, this);
                }else if("queryAvailableQueues".equals(requestFunName)) {
                    SobotCallOpenApi.queryAvailableQueues(this, this);
                }else if("queryAvailableExts".equals(requestFunName)) {
                    SobotCallOpenApi.queryAvailableExts(this, this);
                }else if("agentReady".equals(requestFunName)) {
                    SobotCallOpenApi.agentReady(this, this);
                }else if("agentLogout".equals(requestFunName)) {
                    SobotCallOpenApi.agentLogout(this, this);
                }else if("queryOutBoudRoutesRules".equals(requestFunName)) {
                    SobotCallOpenApi.queryOutBoudRoutesRules(this, this);
                }else if("finishCallAfterWork".equals(requestFunName)) {
                    SobotCallOpenApi.finishCallAfterWork(this, this);
                }else if("finishCallAfterWorkAndBusy".equals(requestFunName)) {
                    SobotCallOpenApi.finishCallAfterWorkAndBusy(this, this);
                }else if("answer".equals(requestFunName)) {
                    SobotCallOpenApi.answer(this, "",this);
                }else if("hangup".equals(requestFunName)) {
                    SobotCallOpenApi.hangup(this, this);
                }else {
                    //需要参数的请求
                    request();
                }
                break;
            default:
                break;
        }
    }
    public void request(){
        //请求接口
        String str_params = et_params.getText().toString();
        try {
            JSONObject object = new JSONObject(str_params);
            if(requestFunName.equals("initWithConfig")){
                SobotCallConfigEntity configEntity = new SobotCallConfigEntity();
                configEntity.setJanusSocketUri(object.optString("janusSocketUri"));
                configEntity.setSipProxy(object.optString("sipProxy"));
                configEntity.setStompSocketUri(object.optString("stompSocketUri"));
                configEntity.setOpenApiHost(object.optString("openApiHost"));
                configEntity.setCallApiHost(object.optString("callApiHost"));
                SobotCallOpenApi.initWithConfig(getApplication(), configEntity, this);
            }else if("loginWithAcount".equals(requestFunName)){
                SobotCallOpenApi.loginWithAcount(this,object.optString("loginUser"),object.optString("loginPwd"),this);
            }else if("agentLogin".equals(requestFunName)){
                SobotCallOpenApi.agentLogin(this,object.optString("agentState"),object.optString("phoneType"),object.optString("bindExt"),object.optString("bindMobile"),SobotGsonUtil.jsonToList(object.optString("thisQueues"),String.class) ,this);
            }else if("makeCall".equals(requestFunName)){
                SobotCallOpenApi.makeCall(this,object.optString("otherDN"),object.optString("privacyNumber"),object.optString("ANI"),object.optString("outboundPlanCode"),object.optString("agentANI"),this);
            }else if("switchOutBoudRoutesRules".equals(requestFunName)){
                SobotCallOpenApi.switchOutBoudRoutesRules(this,object.optString("explicitRule",""),object.optString("explicitCode",""),object.optString("explicitNumber",""),this);
            }else if("sendSatisfaction".equals(requestFunName)){
                SobotCallOpenApi.sendSatisfacion(this,object.optInt("autoSatisfy"),this);
            }else if("delayCallAfterWork".equals(requestFunName)){
                SobotCallOpenApi.delayCallAfterWork(this,object.optInt("delayTime"),this);
            }else if("agentNotReady".equals(requestFunName)){
                SobotCallOpenApi.agentNotReady(this,object.optString("reasonCode"),this);
            }else if("sendDtmf".equals(requestFunName)){
                SobotCallOpenApi.sendDtmf(this,object.optString("dtmfDigits"),this);
            }else if("holdCall".equals(requestFunName)){
                boolean isHold = object.optBoolean("isHold",false);
                if(isHold){
                    SobotCallOpenApi.holdCall(this,this);
                }else{
                    SobotCallOpenApi.retrieveCall(this,this);
                }
            }else if("muteCall".equals(requestFunName)){
                boolean isHold = object.optBoolean("isMute",false);
                if(isHold){
                    SobotCallOpenApi.muteCall(this,this);
                }else{
                    SobotCallOpenApi.unMuteCall(this,this);
                }

            } else if("changedPlayCategory".equals(requestFunName)) {
                boolean isSpeakerphoneOn = object.optBoolean("isSpeakerphoneOn",false);
                SobotCallOpenApi.changedPlayCategory(this, isSpeakerphoneOn,this);
            }
        } catch (JSONException e) {
            SobotToastUtil.showToast(this,"参数解析错误");
            e.printStackTrace();
        }

    }

    @Override
    public void resultBolok(SobotResultCode code, String msg, Object obj) {
        new Handler().post(new Runnable() {
            @Override
            public void run() {
                if(obj!=null){
                    tv_interface_return_obj.setText(SobotGsonUtil.beanToJson(obj));
                }
                tv_interface_return.setText(msg);
                if(code == SobotResultCode.CODE_SUCCEEDED){
                    tv_interface_return.setTextColor(getResources().getColor(R.color.sobot_textview_text_color));
                }else{
                    tv_interface_return.setTextColor(getResources().getColor(R.color.sobot_call_red_color));
                }
            }
        });

    }

    @Override
    public boolean onLongClick(View view) {
        String str ="";
        if(view.getId()==R.id.tv_interface_param) {
            str = requestParamExample;
        }else if(view.getId()==R.id.tv_interface_return_obj) {
             str = tv_interface_return_obj.getText().toString();
        }else if(view.getId()==R.id.tv_interface_return) {
             str = tv_interface_return.getText().toString();
        }
        if (!SobotStringUtils.isEmpty(str)) {
            ClipboardManager cmb = (ClipboardManager) SobotSecondInterfaceActivity.this.getSystemService(
                    Context.CLIPBOARD_SERVICE);
            cmb.setText(str);
            cmb.getText();
            SobotToastUtil.showToast(SobotSecondInterfaceActivity.this, "复制成功");
        }
        return true;
    }
}