package com.sobot.callsdk.dialog;

import android.annotation.SuppressLint;
import android.app.Dialog;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.Button;
import android.widget.TextView;

import androidx.fragment.app.DialogFragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.sobot.callsdk.R;

import java.lang.reflect.Field;

@SuppressLint("ValidFragment")
public class CallTipDialog extends DialogFragment {

    public CallTipDialog() {
    }

    /**
     * 标题文本视图
     */
    private TextView tv_message_top;
    /**
     * 提示信息文本视图
     */
    private TextView tv_message;
    /**
     * 左边按钮
     */
    private Button btn_cancel;

    /**
     * 标题
     */
    private String mMessageTop;
    /**
     * 提示信息
     */
    private String mMessage;


    /**
     * 构造一个进度条，提示的dialog
     *
     * @param msg 标题文本
     */
    public CallTipDialog(String msgTop, String msg) {
        mMessageTop = msgTop;
        mMessage = msg;
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.call_dialog_common_no_title_tip, container,
                false);

        initView(view);
        return view;
    }

    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        Dialog dialog = super.onCreateDialog(savedInstanceState);
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);

        dialog.setCancelable(true);

        Window dialogwWindow = dialog.getWindow();
        if (dialogwWindow != null) {
            dialogwWindow.setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        }
        return dialog;
    }


    /**
     * 初始化视图
     */
    private void initView(View view) {
        tv_message_top = (TextView) view.findViewById(R.id.tv_message_top);
        tv_message = (TextView) view.findViewById(R.id.tv_message);
        if (!TextUtils.isEmpty(mMessageTop)) {
            tv_message_top.setText(mMessageTop);
        }
        if (!TextUtils.isEmpty(mMessage)) {
            tv_message.setText(mMessage);
        }

        btn_cancel = (Button) view.findViewById(R.id.btn_cancel);
        btn_cancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                dismiss();
            }
        });
    }

    @Override
    public void show(FragmentManager manager, String tag) {
        if (manager.isStateSaved() || manager.isDestroyed()) {
            //这里可以做下日志记录
            return;
        }
        super.show(manager, tag);
    }

    //2.通过反射调用，将 commitAllowingStateLoss() 暴露出来调用
    public void showAllowingStateLoss(FragmentManager manager, String tag) {
        setBooleanField("mDismissed", false);
        setBooleanField("mShownByMe", true);
        FragmentTransaction ft = manager.beginTransaction();
        ft.add(this, tag);
        ft.commitAllowingStateLoss();
    }

    private void setBooleanField(String fieldName, boolean value) {
        try {
            Field field = DialogFragment.class.getDeclaredField(fieldName);
            field.setAccessible(true);
            field.setBoolean(this, value);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
