package com.sobot.callsdk.dialog;

import android.app.Activity;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callbase.model.QueueAgentCheckin;
import com.sobot.callsdk.R;
import com.sobot.callsdk.v6.adapter.CallGroupAdapter;

import java.util.ArrayList;
import java.util.List;

public class SelectGroupDialog extends SobotBottomDialog implements View.OnClickListener {
    private LinearLayout coustom_pop_layout,sobot_negativeButton;
    private RecyclerView rv_list;
    private Button btn_confirm;
    private GruopListener listener;
    private CallGroupAdapter adapter;
    private List<QueueAgentCheckin> data;
    private Activity activity;

    private TextView tv_nodata;
    private LinearLayout ll_have_data;

    public SelectGroupDialog(Activity context, GruopListener listener, List<QueueAgentCheckin> data){
        super(context);
        activity = context;
        this.listener = listener;
        this.data = data;
    }
    @Override
    protected int getLayout() {
        return R.layout.call_dialog_select_group;
    }

    @Override
    protected View getDialogContainer() {
        if (coustom_pop_layout == null) {
            coustom_pop_layout = findViewById(R.id.sobot_container);
        }
        return coustom_pop_layout;
    }

    @Override
    protected void initData() {
        if(data!= null  &&data.size()>0) {
            tv_nodata.setVisibility(View.GONE);
            ll_have_data.setVisibility(View.VISIBLE);
        }else{
            ll_have_data.setVisibility(View.GONE);
            tv_nodata.setVisibility(View.VISIBLE);
        }
    }

    public void setData(List<QueueAgentCheckin> data) {
        if(data!=null){
            this.data = data;
        }
        if(adapter!=null) {
            adapter.notifyDataSetChanged();
        }
    }

    @Override
    protected void initView() {
        sobot_negativeButton = findViewById(R.id.sobot_negativeButton);
        btn_confirm = findViewById(R.id.btn_confirm);
        tv_nodata = findViewById(R.id.tv_nodata);
        ll_have_data = findViewById(R.id.ll_have_data);
        rv_list = findViewById(R.id.rv_list);
        if(data== null) {
            data = new ArrayList<>();
        }
        adapter = new CallGroupAdapter(activity,data);
        LinearLayoutManager layoutManager = new LinearLayoutManager(activity, LinearLayoutManager.VERTICAL, false);
        // 设置RecyclerView的LayoutManager
        rv_list.setLayoutManager(layoutManager);
        rv_list.setAdapter(adapter);
        sobot_negativeButton.setOnClickListener(this);
        btn_confirm.setOnClickListener(this);
    }

    @Override
    public void onClick(View v) {
        if(v==sobot_negativeButton){
            //关闭
            dismiss();
        }else if(btn_confirm ==v){
            //回传手机号
            if(listener!=null){
                listener.selectGroup(data);
            }
            dismiss();
        }
    }
    @Override
    public void dismiss() {
        try {
            if (isShowing()) {
                super.dismiss();
            }
        } catch (Exception e) {
//            e.printStackTrace();
        }
    }
    public interface GruopListener {
        void selectGroup(List<QueueAgentCheckin> groups);
    }
}
