package com.sobot.callsdk.dialog;

import android.app.Activity;
import android.graphics.Typeface;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.sobot.callsdk.R;
import com.sobot.callsdk.model.SobotPhoneTypesEntity;
import com.sobot.callsdk.utils.SobotCallConstant;

import java.util.List;

public class SelectLoginTypeDialog extends SobotBottomDialog implements View.OnClickListener {
    private LinearLayout coustom_pop_layout,sobot_negativeButton;
    private RelativeLayout rl_app,rl_phone;
    private ImageView iv_app_type,iv_phone_type;
    private TextView tv_app,tv_phone;
    private TypeListener listener;
    private Activity activity;
    private int  type;
    private List<SobotPhoneTypesEntity> list;

    public SelectLoginTypeDialog(Activity context, TypeListener listener, int type, List<SobotPhoneTypesEntity> list){
        super(context);
        activity = context;
        this.listener = listener;
        this.type = type;
        this.list = list;
    }
    @Override
    protected int getLayout() {
        return R.layout.call_dialog_select_call_type;
    }

    @Override
    protected View getDialogContainer() {
        if (coustom_pop_layout == null) {
            coustom_pop_layout = findViewById(R.id.sobot_container);
        }
        return coustom_pop_layout;
    }

    @Override
    protected void initData() {
        if(type==SobotCallConstant.CALL_MODEL_SIP){
            iv_app_type.setVisibility(View.VISIBLE);
            iv_phone_type.setVisibility(View.GONE);
            tv_app.setTypeface(null, Typeface.BOLD);
            tv_phone.setTypeface(null, Typeface.NORMAL);
        }else if(type ==SobotCallConstant.CALL_MODEL_PHONE){
            tv_app.setTypeface(null, Typeface.NORMAL);
            tv_phone.setTypeface(null, Typeface.BOLD);
            iv_app_type.setVisibility(View.GONE);
            iv_phone_type.setVisibility(View.VISIBLE);
        }
    }

    @Override
    protected void initView() {
        sobot_negativeButton = findViewById(R.id.sobot_negativeButton);
        tv_app = findViewById(R.id.tv_app);
        tv_phone = findViewById(R.id.tv_phone);
        rl_app = findViewById(R.id.rl_app);
        rl_phone = findViewById(R.id.rl_phone);
        iv_app_type = findViewById(R.id.iv_app_type);
        iv_phone_type = findViewById(R.id.iv_phone_type);

        sobot_negativeButton.setOnClickListener(this);
        rl_app.setOnClickListener(this);
        rl_phone.setOnClickListener(this);
        rl_app.setVisibility(View.GONE);
        rl_phone.setVisibility(View.GONE);
        for (int i = 0; i < list.size(); i++) {
            if(list.get(i).getPhoneType().equals("pstn")){
                //显示手机
                rl_phone.setVisibility(View.VISIBLE);
            }else if("sip".equals(list.get(i).getPhoneType())||"wertc".equals(list.get(i).getPhoneType())){
                //显示app
                rl_app.setVisibility(View.VISIBLE);
            }

        }
    }

    @Override
    public void onClick(View v) {
        if(v==sobot_negativeButton){
            //关闭
            dismiss();
        }else if(rl_phone ==v){
            if(listener!=null){
                listener.setType(SobotCallConstant.CALL_MODEL_PHONE);
            }
            dismiss();
        }else if(rl_app ==v){
            if(listener!=null){
                listener.setType(SobotCallConstant.CALL_MODEL_SIP);
            }
            dismiss();
        }
    }
    @Override
    public void dismiss() {
        try {
            if (isShowing()) {
                super.dismiss();
            }
        } catch (Exception e) {
//            e.printStackTrace();
        }
    }
    public interface TypeListener {
        void setType(int type);
    }
}
