package com.sobot.callsdk.model;

import java.io.Serializable;

/**
 * @author: Sobot
 * v6 通话记录详情
 * 2022/7/22
 */
public class SobotCallRecordDetailEntity implements Serializable {
    private String callID; // callID
    private String partyId; //子话单ID 除客户外，每个party都是一个子话单
    private String agentUUID;
    private String agentDN;// 座席使用的话机号码 分机或者pstn号码
    private String gatewayNumber; // 座席腿外呼的中继号码; 分机号码，可为空字符串
    private String agentName;//李四",
    private String agentID;//座席工号
    private String DNIS;//18655668888", //
    private String platformId; //平台ID
    private String departmentId; //所属部门
    private String chargeDepartmentId; //计费组织
    private String companyId;//公司ID
    private String fromAgentUUID; // 呼叫的来源座席UUID
    private String fromAgentID; //呼叫的来源座席工号
    private String fromAgentName; //呼叫的来源座席姓名
    private String fromQueueID; //呼叫的来源技能组编码
    private String fromQueueName;  //呼叫的来源技能组名称
    private int callType;//呼叫类型: 2: 呼入 3: 呼出
    private int dialType;  //呼叫类型1.呼叫 2.转移 3.咨询 4.监听 5.抢接 6.强插
    private int agentType; //座席类型 0.工号 1.座席uuid
    private int phoneType; //接听设备1.webrtc 2.wechat 3.pstn 4.sip 5.sobotapp

    private int duration; // 座席腿 通话时长 单位:秒
    private int callResult; // 座席腿 呼叫结果 1.呼叫失败 2.呼叫成功-座席未接听 3.呼叫成功-座席已接听
    private int hangupDisposition;  // 挂机方向
    private String earlyDetectCause; //呼叫座席PSTN号码失败的回铃音; 默认为 0
    private int agentRole;  //  2: 人工座席  4:第三方PSTN  5: 虚拟座席
    private int numberType; // boss 提供的计费号码类型 1:固话号码 2:手机号码 3:95/96号码 4:1010号码 5:400号码 6:强显号码 7:虚拟号码 8:企业自有号码
    private int feeSeconds; //计费 单位:秒
    private int feeMinutes;//计费 单位:分钟
    private long startTime;  //座席腿开始时间 unix时间戳(毫秒)
    private long alertTime; //座席腿的振铃时间 unix时间戳(毫秒)
    private long answerTime; //座席腿的接通时间 unix时间戳(毫秒)
    private long bridgeTime; //客户和座席桥接时间 unix时间戳(毫秒)
    private long endTime; //座席腿的挂断时间 unix时间戳(毫秒)

    private double fee;    //计费 费用 小数点后两位
    private boolean lastAgentFlag;// 是否是最后一个服务座席

    public String getCallID() {
        return callID;
    }

    public void setCallID(String callID) {
        this.callID = callID;
    }

    public String getPartyId() {
        return partyId;
    }

    public void setPartyId(String partyId) {
        this.partyId = partyId;
    }

    public String getAgentUUID() {
        return agentUUID;
    }

    public void setAgentUUID(String agentUUID) {
        this.agentUUID = agentUUID;
    }

    public String getAgentDN() {
        return agentDN;
    }

    public void setAgentDN(String agentDN) {
        this.agentDN = agentDN;
    }

    public String getGatewayNumber() {
        return gatewayNumber;
    }

    public void setGatewayNumber(String gatewayNumber) {
        this.gatewayNumber = gatewayNumber;
    }

    public String getAgentName() {
        return agentName;
    }

    public void setAgentName(String agentName) {
        this.agentName = agentName;
    }

    public String getAgentID() {
        return agentID;
    }

    public void setAgentID(String agentID) {
        this.agentID = agentID;
    }

    public String getDNIS() {
        return DNIS;
    }

    public void setDNIS(String DNIS) {
        this.DNIS = DNIS;
    }

    public String getPlatformId() {
        return platformId;
    }

    public void setPlatformId(String platformId) {
        this.platformId = platformId;
    }

    public String getDepartmentId() {
        return departmentId;
    }

    public void setDepartmentId(String departmentId) {
        this.departmentId = departmentId;
    }

    public String getChargeDepartmentId() {
        return chargeDepartmentId;
    }

    public void setChargeDepartmentId(String chargeDepartmentId) {
        this.chargeDepartmentId = chargeDepartmentId;
    }

    public String getCompanyId() {
        return companyId;
    }

    public void setCompanyId(String companyId) {
        this.companyId = companyId;
    }

    public String getFromAgentUUID() {
        return fromAgentUUID;
    }

    public void setFromAgentUUID(String fromAgentUUID) {
        this.fromAgentUUID = fromAgentUUID;
    }

    public String getFromAgentID() {
        return fromAgentID;
    }

    public void setFromAgentID(String fromAgentID) {
        this.fromAgentID = fromAgentID;
    }

    public String getFromAgentName() {
        return fromAgentName;
    }

    public void setFromAgentName(String fromAgentName) {
        this.fromAgentName = fromAgentName;
    }

    public String getFromQueueID() {
        return fromQueueID;
    }

    public void setFromQueueID(String fromQueueID) {
        this.fromQueueID = fromQueueID;
    }

    public String getFromQueueName() {
        return fromQueueName;
    }

    public void setFromQueueName(String fromQueueName) {
        this.fromQueueName = fromQueueName;
    }

    public int getCallType() {
        return callType;
    }

    public void setCallType(int callType) {
        this.callType = callType;
    }

    public int getDialType() {
        return dialType;
    }

    public void setDialType(int dialType) {
        this.dialType = dialType;
    }

    public int getAgentType() {
        return agentType;
    }

    public void setAgentType(int agentType) {
        this.agentType = agentType;
    }

    public int getPhoneType() {
        return phoneType;
    }

    public void setPhoneType(int phoneType) {
        this.phoneType = phoneType;
    }

    public int getDuration() {
        return duration;
    }

    public void setDuration(int duration) {
        this.duration = duration;
    }

    public int getCallResult() {
        return callResult;
    }

    public void setCallResult(int callResult) {
        this.callResult = callResult;
    }

    public int getHangupDisposition() {
        return hangupDisposition;
    }

    public void setHangupDisposition(int hangupDisposition) {
        this.hangupDisposition = hangupDisposition;
    }

    public String getEarlyDetectCause() {
        return earlyDetectCause;
    }

    public void setEarlyDetectCause(String earlyDetectCause) {
        this.earlyDetectCause = earlyDetectCause;
    }

    public int getAgentRole() {
        return agentRole;
    }

    public void setAgentRole(int agentRole) {
        this.agentRole = agentRole;
    }

    public int getNumberType() {
        return numberType;
    }

    public void setNumberType(int numberType) {
        this.numberType = numberType;
    }

    public int getFeeSeconds() {
        return feeSeconds;
    }

    public void setFeeSeconds(int feeSeconds) {
        this.feeSeconds = feeSeconds;
    }

    public int getFeeMinutes() {
        return feeMinutes;
    }

    public void setFeeMinutes(int feeMinutes) {
        this.feeMinutes = feeMinutes;
    }

    public long getStartTime() {
        return startTime;
    }

    public void setStartTime(long startTime) {
        this.startTime = startTime;
    }

    public long getAlertTime() {
        return alertTime;
    }

    public void setAlertTime(long alertTime) {
        this.alertTime = alertTime;
    }

    public long getAnswerTime() {
        return answerTime;
    }

    public void setAnswerTime(long answerTime) {
        this.answerTime = answerTime;
    }

    public long getBridgeTime() {
        return bridgeTime;
    }

    public void setBridgeTime(long bridgeTime) {
        this.bridgeTime = bridgeTime;
    }

    public long getEndTime() {
        return endTime;
    }

    public void setEndTime(long endTime) {
        this.endTime = endTime;
    }

    public double getFee() {
        return fee;
    }

    public void setFee(double fee) {
        this.fee = fee;
    }

    public boolean isLastAgentFlag() {
        return lastAgentFlag;
    }

    public void setLastAgentFlag(boolean lastAgentFlag) {
        this.lastAgentFlag = lastAgentFlag;
    }
}
