package com.sobot.callsdk.model;

import java.io.Serializable;

/**
 * @author: Sobot
 * v6 通话记录显示
 * 2022/7/22
 */
public class SobotCallRecordEntity implements Serializable {
    //主话单
    private String callID;//通话记录简称为：主话单; 1通电话有且仅有1个主话单id
    private String customerId;//客户Id
    private long startTime; //开始时间 unix时间戳(毫秒)
    private int callType;//呼叫类型: 2: 呼入 3: 呼出
    //// callResult 1.呼叫失败 2.座席未接听 3.座席已接听
    private int callResult;//通话结果:1.其他原因无法应答 2.欠费 3.客户号码黑名单 4.未找到座席侧 5.客户速挂6.座席侧未接听 7.客户未接听 8.双方已接听 9.中继号码停用
    private String screenNumber;//显示屏幕的号码,脱敏后号码，取决于接口中[客户号码脱敏]
    private String encryptCustomerNumber;//加密后号码，取决于接口中[客户号码脱敏]
    private int feeSeconds;//计费时长(秒) 结束时间-接听时间
    private String customerNick;//客户姓名

    private int dialType;//呼叫类型: 1.呼叫 2.转移 3.咨询 4.监听 5.抢接 6.强插
    private String fromAgentName;
    private String areaCity;
    private String areaProvince;
    private long bridgeTime;//通话时长

    public String getAreaCity() {
        return areaCity;
    }

    public void setAreaCity(String areaCity) {
        this.areaCity = areaCity;
    }

    public String getAreaProvince() {
        return areaProvince;
    }

    public long getBridgeTime() {
        return bridgeTime;
    }

    public void setBridgeTime(long bridgeTime) {
        this.bridgeTime = bridgeTime;
    }

    public void setAreaProvince(String areaProvince) {
        this.areaProvince = areaProvince;
    }

    public String getCallID() {
        return callID;
    }

    public void setCallID(String callID) {
        this.callID = callID;
    }

    public String getCustomerId() {
        return customerId;
    }

    public void setCustomerId(String customerId) {
        this.customerId = customerId;
    }

    public long getStartTime() {
        return startTime;
    }

    public void setStartTime(long startTime) {
        this.startTime = startTime;
    }

    public int getCallType() {
        return callType;
    }

    public void setCallType(int callType) {
        this.callType = callType;
    }

    public int getCallResult() {
        return callResult;
    }

    public void setCallResult(int callResult) {
        this.callResult = callResult;
    }

    public String getScreenNumber() {
        return screenNumber;
    }

    public void setScreenNumber(String screenNumber) {
        this.screenNumber = screenNumber;
    }

    public String getEncryptCustomerNumber() {
        return encryptCustomerNumber;
    }

    public void setEncryptCustomerNumber(String encryptCustomerNumber) {
        this.encryptCustomerNumber = encryptCustomerNumber;
    }

    public int getFeeSeconds() {
        return feeSeconds;
    }

    public String getCustomerNick() {
        return customerNick;
    }

    public void setCustomerNick(String customerNick) {
        this.customerNick = customerNick;
    }

    public void setFeeSeconds(int feeSeconds) {
        this.feeSeconds = feeSeconds;
    }

    public int getDialType() {
        return dialType;
    }

    public void setDialType(int dialType) {
        this.dialType = dialType;
    }

    public String getFromAgentName() {
        return fromAgentName;
    }

    public void setFromAgentName(String fromAgentName) {
        this.fromAgentName = fromAgentName;
    }
}
