package com.sobot.callsdk.utils;


import android.content.Context;

import com.sobot.callsdk.R;


public class CallStatusUtils {
    //-----------------------v6 start------------------
    public static final String V6_OFFLINE = "0";//0：离线
    public static final String V6_FREE = "1";//1：空闲
    public static final String V6_DO_NOT_DISTURB = "2";//   2：勿扰
    public static final String V6_FINISHING = "4";//整理中（话务总结）
    public static final String V6_OUTBOUND_RINGING = "5";//外呼振铃
    public static final String V6_INCOMING_RING = "6";//呼入响铃
    public static final String V6_DURING = "7";//通话
    public static final String V6_HOLD = "8";//保持
    //    自定义状态：
    public static final String V6_LITTLE_HUGH = "11";// 11：小休
    public static final String V6_TRAIN = "12";//12：小休（培训
    public static final String V6_MEETING = "13";//小休（会议）
    public static final String V6_HAVE_MEALS = "14";//14：小休（用餐
    public static final String V6_ACTIVITY = "15";//小休（活动）
    public static final String V6_CUSTOM1 = "16";//小休（自定义1）
    public static final String V6_CUSTOM2 = "17";//小休（自定义2）
    public static final String V6_CUSTOM3 = "18";//小休（自定义3）

    public static final String V6_SYSYTEM_BUSY = "98";//98-系统置忙
    public static final String V6_LEADER_BUSY = "99";//99-班长置忙

    //-----------------------v6 end------------------
    //sip 异常
    public static final String ERROR_SIP = "-2";
    //    基本状态：
    public static final String OFF_LINE = "-1";//-1：离线
    public static final String FREE = "1";//1：空闲
    public static final String BUSY = "0";//0：忙碌
    public static final String RINGING = "2";//2：振铃中
    public static final String CALLING = "3";//3：通话中
    //    自定义状态：
    public static final String LITTLE_HUGH = "114";//            114：小休
    public static final String LITTLE_HUGH_ = "115";//115：后处理
    public static final String TRAIN = "116";//116：培训
    public static final String MEETING = "117";//117：会议
    public static final String HAVE_MEALS = "118";//118：用餐
    public static final String ACTIVITY = "119";//119：活动
    //


    public static final String listen_RINGING_IN = "12";//呼入振铃
    public static final String listen_RINGING_OUT = "13";//呼出振铃
    public static final String listen_CALLING_IN = "31";//呼入通话
    public static final String listen_CALLING_OUT = "32";//呼出通话
    public static final String interior_dialing = "34";//外乎中

    /**
     * 转接
     **/
    public static final String transfering = "311";//311：转接中           //通话中A座席发起咨询转接（转接功能）
    public static final String ringing_B = "421";//421：振铃中           //B座席空闲被咨询转接振铃（转接功能）;
    public static final String transfering_A = "331";//331：转接中           //A座席向B座席转接，B接听后，A处于咨询转接中（转接功能） "331";
    public static final String transfering_B = "341";//341：转接中          //A座席向B座席转接，B接听后，B处于咨询转接中（转接功能） "341";

    /**
     * 监听
     **/
    public static final String listen_RINGING_ = "412";//412：振铃中          //管理座席空闲发起监听振铃（监听强插强拆） "412";
    public static final String listen_CALLING = "362";//362：通话中          //通话中被监听|管理员振铃（监听强插强拆） "362";
    public static final String listenING = "322";//322：监听中          //管理座席接通后发起监听（监听强插强拆） "322";
    public static final String listen_CALLING_2 = "332";//332：通话中          //被监听座席，通话中被监听（监听强插强拆） "332";
    public static final String listen_THR_CALL = "342";//342：三方通话      //管理员强插通话成功（监听强插强拆） "342";
    public static final String listen_THR_CALL_2 = "352";//352：三方通话      //被监听座席被强插（监听强插强拆） "352";

    public static final String listen_keep = "316";//316： 保持中

    /**
     * 三方通话
     **/
    public static final String consulting = "314";//314：咨询中    //发起方发起三方咨询振铃中状态（被三方咨询座席振铃，发起方的状态码） "314";
    public static final String RINGING_THR = "424";//424：振铃中   //被发起方三方咨询振铃状态（被三方咨询座席振铃，被发起方的状态码） "424";
    public static final String THR_CALL = "334";//334：三方通话     //发起方三方咨询通话中状态（三方通话中，发起方的状态码） "334";
    public static final String THR_CALL_2 = "344";//344：三方通话      //被发起方三方咨询通话中状态（三方通话中，被发起方的状态码） "344";

    /**
     * 内部通话
     **/
    public static final String interior_dialing_a = "425";//425：拨号中        //空闲->A座席发起拨号 (内部呼) "425";
    public static final String interior_dialing_b = "435";//435：拨号中        //空闲->A座席振铃(内部呼) "435";
    public static final String interior_ringing_b = "445";//445：振铃中        //空闲->B座席振铃(内部呼) "445";
    public static final String interior_calling_a = "455";//455：内部通话     //振铃->A座席通话"455";
    public static final String interior_call_b = "465";//465：内部通话     //振铃->B座席通话 "465";


    /**
     * 获取
     *
     * @param status
     * @return
     */
    public static String getCallStatusString(Context context, String status) {
        if (status == null) {
            return "";
        }
        if (context == null) {
            return "";
        }
        switch (status) {
            case OFF_LINE:
            case ERROR_SIP:
                return context.getResources().getString(R.string.sobot_custom_offline);
            case FREE:
                return context.getResources().getString(R.string.sobot_custom_free);
            case BUSY:
                return context.getResources().getString(R.string.sobot_custom_busy);
            case RINGING:
            case listen_RINGING_:
            case RINGING_THR:
            case interior_ringing_b:
            case ringing_B:
            case listen_RINGING_IN:
            case listen_RINGING_OUT:
                return context.getResources().getString(R.string.sobot_call_ringing);
            case CALLING:
            case listen_CALLING:
            case listen_CALLING_2:
            case listen_CALLING_IN:
            case listen_CALLING_OUT:
                return context.getResources().getString(R.string.sobot_custom_tonghuazhong);
            case LITTLE_HUGH:
                return context.getResources().getString(R.string.sobot_custom_little_rest);
            case LITTLE_HUGH_:
                return context.getResources().getString(R.string.sobot_custom_houchuli);
            case TRAIN:
                return context.getResources().getString(R.string.sobot_custom_peixun);
            case MEETING:
                return context.getResources().getString(R.string.sobot_custom_huiyi);
            case HAVE_MEALS:
                return context.getResources().getString(R.string.sobot_custom_yongcan);
            case ACTIVITY:
                return context.getResources().getString(R.string.sobot_custom_huodong);
            case transfering:
            case transfering_A:
            case transfering_B:
                return context.getResources().getString(R.string.sobot_custom_transferring);
            case listenING:
                return context.getResources().getString(R.string.sobot_custom_listening);
            case listen_THR_CALL:
            case listen_THR_CALL_2:
            case THR_CALL:
            case THR_CALL_2:
                return context.getResources().getString(R.string.sobot_custom_three_party_call);
            case listen_keep:
                return context.getResources().getString(R.string.sobot_custom_keeping);
            case consulting:
                return context.getResources().getString(R.string.sobot_custom_in_consultation);
            case interior_dialing_a:
            case interior_dialing_b:
            case interior_dialing:
                return context.getResources().getString(R.string.sobot_call_dialing);
            case interior_calling_a:
            case interior_call_b:
                return context.getResources().getString(R.string.sobot_custom_tnternal_call);
        }
        return context.getResources().getString(R.string.sobot_custom_unknown);
    }

    /**
     * 是否可以改变状态
     *
     * @param status
     * @return
     */
    public static boolean canChange(String status) {
        if (status == null) {
            return true;
        }
        switch (status) {
            case ERROR_SIP:
            case OFF_LINE:
            case FREE:
            case BUSY:
            case LITTLE_HUGH:
            case LITTLE_HUGH_:
            case TRAIN:
            case MEETING:
            case HAVE_MEALS:
            case ACTIVITY:
                return true;
            case RINGING:
            case CALLING:
            case ringing_B:
            case transfering:
            case transfering_A:
            case transfering_B:

                return false;


        }
        return false;
    }

    /**
     * 是否在通话中/拨号/振铃/转接/保持
     *
     * @return
     */
    public static boolean isRinging(String status) {
        if (status == null) {
            return true;
        }
        switch (status) {
            case ERROR_SIP:
            case OFF_LINE:
            case FREE:
            case BUSY:
            case LITTLE_HUGH:
            case LITTLE_HUGH_:
            case TRAIN:
            case MEETING:
            case HAVE_MEALS:
            case ACTIVITY:

                return false;

            case RINGING:
            case CALLING:
            case ringing_B:
            case transfering:
            case transfering_A:
            case transfering_B:

                return true;


        }
        return true;

    }

    public static final String CALL_TYPE_IN = "2";
    public static final String CALL_TYPE_OUT = "3";
    //1是呼叫失败，2是坐席未接听 3是座席已接听
    public static final String CALL_STATUS_UNANSWERED = "2";
    public static final String CALL_STATUS_ANSWERED = "3";
    public static final String CALL_STATUS_REJECT = "1";
}
