package com.sobot.callsdk.v1.activity;

import android.content.Context;
import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.text.TextUtils;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.sobot.callsdk.R;
import com.sobot.callsdk.activity.SobotCallBaseActivity;
import com.sobot.callsdk.api.SobotCallBaseCodeGroup;
import com.sobot.callsdk.model.SobotCallInfo;
import com.sobot.callsdk.utils.CallSharedPreferencesUtils;
import com.sobot.callsdk.utils.SobotCallConstant;
import com.sobot.network.http.callback.SobotResultCallBack;
import com.sobot.widget.ui.toast.SobotToastUtil;

/**
 * 拨号键盘界面
 */
public class SobotCallNumberActivity extends SobotCallBaseActivity implements View.OnClickListener {

    private LinearLayout mLlNum1;
    private LinearLayout mLlNum2;
    private LinearLayout mLlNum3;
    private LinearLayout mLlNum4;
    private LinearLayout mLlNum5;
    private LinearLayout mLlNum6;
    private LinearLayout mLlNum7;
    private LinearLayout mLlNum8;
    private LinearLayout mLlNum9;
    private LinearLayout mLlNum10;//*号
    private LinearLayout mLlNum11;
    private LinearLayout mLlNum12;//#号
    private LinearLayout mLlCall;
    private LinearLayout mLlDelete;
    private TextView mTvPhoneNumber;//号码显示
    private TextView mTvUserNike;//昵称显示

    private SobotCallInfo callInfo;
    private String userPhoneNumber; //用户电话号码
    private String userNike;//用户昵称

    private String mGroupId;//技能组id

    public static Intent initIntent(Context context) {
        Intent intent = new Intent(context, SobotCallNumberActivity.class);
        return intent;
    }


    @Override
    protected int getContentViewResId() {
        return R.layout.activity_sobot_call_number;
    }

    @Override
    protected void initView() {
        setTitle(getResources().getString(R.string.sobot_call_teke));
        Drawable drawable = getResources().getDrawable(getResDrawableId("sobot_call_title_back_selector"));
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        getLeftMenu().setCompoundDrawables(drawable, null, null, null);

        mLlNum1 = findViewById(R.id.ll_num_1);
        mLlNum2 = findViewById(R.id.ll_num_2);
        mLlNum3 = findViewById(R.id.ll_num_3);
        mLlNum4 = findViewById(R.id.ll_num_4);
        mLlNum5 = findViewById(R.id.ll_num_5);
        mLlNum6 = findViewById(R.id.ll_num_6);
        mLlNum7 = findViewById(R.id.ll_num_7);
        mLlNum8 = findViewById(R.id.ll_num_8);
        mLlNum9 = findViewById(R.id.ll_num_9);
        mLlNum10 = findViewById(R.id.ll_num_10);
        mLlNum11 = findViewById(R.id.ll_num_11);
        mLlNum12 = findViewById(R.id.ll_num_12);
        mLlNum1.setOnClickListener(this);
        mLlNum2.setOnClickListener(this);
        mLlNum3.setOnClickListener(this);
        mLlNum4.setOnClickListener(this);
        mLlNum5.setOnClickListener(this);
        mLlNum6.setOnClickListener(this);
        mLlNum7.setOnClickListener(this);
        mLlNum8.setOnClickListener(this);
        mLlNum9.setOnClickListener(this);
        mLlNum10.setOnClickListener(this);
        mLlNum11.setOnClickListener(this);
        mLlNum12.setOnClickListener(this);
        mLlCall = findViewById(R.id.ll_call);
        mLlCall.setOnClickListener(this);
        mLlDelete = findViewById(R.id.ll_delete);
        mLlDelete.setOnClickListener(this);
        mTvPhoneNumber = findViewById(R.id.tv_user_phone_number);
        mTvUserNike = findViewById(R.id.tv_user_nike);
    }

    @Override
    protected void initData() {
        callInfo = (SobotCallInfo) getIntent().getSerializableExtra("callInfo");
        userPhoneNumber = getIntent().getStringExtra("userPhoneNumber");
        userNike = getIntent().getStringExtra("userNike");
        if (!TextUtils.isEmpty(userPhoneNumber)) {
            mTvPhoneNumber.setText(userPhoneNumber);
        }
        if (!TextUtils.isEmpty(userNike)) {
            mTvUserNike.setText(userNike);
            mTvUserNike.setVisibility(View.VISIBLE);
        } else {
            mTvUserNike.setVisibility(View.GONE);
        }
        if(!isCallV6()){
            queryGroupId();
        }
    }
    private void queryGroupId(){
        zhiChiApi.queryGroupListV1(SobotCallNumberActivity.this, SobotCallNumberActivity.this, new SobotResultCallBack<SobotCallBaseCodeGroup>() {
            @Override
            public void onSuccess(SobotCallBaseCodeGroup result) {
                if(result!=null){
                    mGroupId = result.getItem();
                    CallSharedPreferencesUtils.getInstance(getApplicationContext()).put(SobotCallConstant.SP_KEY_CALL_GROUP_ID, mGroupId);
                }
            }

            @Override
            public void onFailure(Exception e, String des) {

            }
        });
    }

    @Override
    public void onClick(View v) {
        if (mLlNum1.equals(v)) {
            addNum("1");
        } else if (mLlNum2.equals(v)) {
            addNum("2");
        } else if (mLlNum3.equals(v)) {
            addNum("3");
        } else if (mLlNum4.equals(v)) {
            addNum("4");
        } else if (mLlNum5.equals(v)) {
            addNum("5");
        } else if (mLlNum6.equals(v)) {
            addNum("6");
        } else if (mLlNum7.equals(v)) {
            addNum("7");
        } else if (mLlNum8.equals(v)) {
            addNum("8");
        } else if (mLlNum9.equals(v)) {
            addNum("9");
        } else if (mLlNum10.equals(v)) {
            addNum("*");
        } else if (mLlNum11.equals(v)) {
            addNum("0");
        } else if (mLlNum12.equals(v)) {
            addNum("#");
        } else if (mLlCall.equals(v)) {
            callNumber();
        } else if (mLlDelete.equals(v)) {
            onMLlDeleteClicked();
        }
    }

    // 添加号码
    private void addNum(String string) {
        mTvPhoneNumber.append(string);
        mTvUserNike.setText("");
        mTvUserNike.setVisibility(View.GONE);
    }


    // 开始外呼，跳转到通话界面
    private void callNumber() {
        String phoneNum = mTvPhoneNumber.getText().toString();
        if (!TextUtils.isEmpty(phoneNum)) {
            if(!isCallV6()) {
                if (TextUtils.isEmpty(mGroupId)) {
                    mGroupId = CallSharedPreferencesUtils.getInstance(getApplicationContext()).get( SobotCallConstant.SP_KEY_CALL_GROUP_ID, "");
                }
            }
            Intent intent = SobotCallStatusActivity.initIntent(SobotCallNumberActivity.this, phoneNum,mGroupId,phoneNum);
            intent.setFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP | Intent.FLAG_ACTIVITY_CLEAR_TOP |
                    Intent.FLAG_ACTIVITY_NEW_TASK);
            this.startActivity(intent);
        } else {
            SobotToastUtil.showCustomToast(getSobotBaseActivity(), getResources().getString(R.string.sobot_please_input_phone_number));
        }
    }

    // 删除号码
    public void onMLlDeleteClicked() {
        String str = mTvPhoneNumber.getText().toString();
        if (str.length() > 0) {
            str = str.substring(0, str.length() - 1);
        }
        mTvPhoneNumber.setText(str);
        mTvUserNike.setText("");
        mTvUserNike.setVisibility(View.GONE);
    }
}