package com.sobot.callsdk.v1.activity;

import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.text.TextUtils;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callsdk.R;
import com.sobot.callsdk.activity.SobotCallBaseActivity;
import com.sobot.callsdk.v1.adapter.SobotCallPlanRemindAdapter;
import com.sobot.callsdk.v1.entity.v1.SobotRemindInfo;

import java.util.ArrayList;
import java.util.List;

/**
 * 创建联系计划--选择提醒时间
 */
public class SobotCallPlanRemindActivity extends SobotCallBaseActivity implements SobotCallPlanRemindAdapter.OnItemClickListener {

    private RecyclerView recyclerView;

    private SobotCallPlanRemindAdapter adapter;
    private List<SobotRemindInfo> infoLists = new ArrayList<>();
    private String remindTime;

    @Override
    protected int getContentViewResId() {
        return R.layout.sobot_activity_call_plan_remind;
    }

    @Override
    protected void initView() {
        recyclerView = findViewById(R.id.contact_plan_remind_listview);
        Drawable drawable = getResources().getDrawable(R.drawable.sobot_call_title_back_selector);
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        getLeftMenu().setCompoundDrawables(drawable, null, null, null);
        setTitle(getResources().getString(R.string.sobot_plan_remind));
        remindTime = getIntent().getStringExtra("remindTime");
    }
    private void initTmpData() {
        SobotRemindInfo data1 = new SobotRemindInfo();
        data1.setChecked(false);
        data1.setDataName(getResources().getString(R.string.sobot_plan_remind_5m));
        data1.setDataStatus(5);
        SobotRemindInfo data2 = new SobotRemindInfo();
        data2.setChecked(false);
        data2.setDataName(getResources().getString(R.string.sobot_plan_remind_10m));
        data2.setDataStatus(10);
        SobotRemindInfo data3 = new SobotRemindInfo();
        data3.setChecked(false);
        data3.setDataName(getResources().getString(R.string.sobot_plan_remind_1h));
        data3.setDataStatus(60);
        SobotRemindInfo data4 = new SobotRemindInfo();
        data4.setChecked(false);
        data4.setDataName(getResources().getString(R.string.sobot_plan_remind_3h));
        data4.setDataStatus(180);

        if (!TextUtils.isEmpty(remindTime)) {
            if (data1.getDataName().equals(remindTime)) {
                data1.setChecked(true);
            } else if (data2.getDataName().equals(remindTime)) {
                data2.setChecked(true);
            } else if (data3.getDataName().equals(remindTime)) {
                data3.setChecked(true);
            } else if (data4.getDataName().equals(remindTime)) {
                data4.setChecked(true);
            }
        }

        infoLists.add(data1);
        infoLists.add(data2);
        infoLists.add(data3);
        infoLists.add(data4);
        adapter = new SobotCallPlanRemindAdapter(SobotCallPlanRemindActivity.this,infoLists,this);
        recyclerView.setLayoutManager(new LinearLayoutManager(getSobotBaseContext()));
        recyclerView.setAdapter(adapter);
//        recyclerView.addItemDecoration(new DividerItemDecoration(this, DividerItemDecoration.VERTICAL));
    }

    @Override
    protected void initData() {
        initTmpData();
    }

    @Override
    public void onItemClick(SobotRemindInfo info) {
        Intent intent = new Intent();
        intent.putExtra("remindModel", info);
        setResult(101, intent);
        finish();
    }
}