package com.sobot.callsdk.v1.activity;

import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.sobot.callbase.dialog.SobotActionItem;
import com.sobot.callsdk.R;
import com.sobot.callsdk.activity.SobotDialogBaseActivity;
import com.sobot.callsdk.model.SobotCallCenterStatus;
import com.sobot.callsdk.utils.CallSharedPreferencesUtils;
import com.sobot.callsdk.utils.CallStatusUtils;
import com.sobot.callsdk.utils.SobotCallConstant;
import com.sobot.common.login.SobotLoginTools;
import com.sobot.common.login.model.SobotServiceInfoModel;

import java.util.ArrayList;

//座席状态选择界面
public class SobotLoginStatusChooseActivity extends SobotDialogBaseActivity implements View.OnClickListener {
    private LinearLayout ll_cancle;//关闭界面返回
    private LinearLayout ll_login_status;//座席状态 父控件
    private ArrayList<SobotCallCenterStatus> data;//v1
    private ArrayList<SobotActionItem> arrayStatus;

    @Override
    protected int getContentViewResId() {
        return R.layout.sobot_dialog_login_status_choose;
    }

    @Override
    protected void initView() {
        ll_cancle = findViewById(R.id.ll_cancle);
        ll_login_status = findViewById(R.id.ll_login_status);
        ll_cancle.setOnClickListener(this);
    }

    @Override
    protected void initData() {
        arrayStatus = new ArrayList<>();
        String loginStatus = CallSharedPreferencesUtils.getInstance(getSobotBaseContext()).get(SobotCallConstant.callLoginStatus, CallStatusUtils.OFF_LINE);

        SobotServiceInfoModel serviceVo =  SobotLoginTools.getInstance().getServiceInfo();
        if (serviceVo != null) {
            if (serviceVo.getCallV6Flag() == 1) {
                //v6
                arrayStatus.add(new SobotActionItem(getResources().getString(R.string.sobot_custom_free), getDrawable(R
                        .drawable.custom_service_online), loginStatus.equals(CallStatusUtils.V6_FREE), CallStatusUtils.V6_FREE));
                arrayStatus.add(new SobotActionItem(getResources().getString(R.string.sobot_custom_do_not_disturb),
                        getDrawable(R.drawable.custom_service_busy), loginStatus.equals(CallStatusUtils.V6_DO_NOT_DISTURB), CallStatusUtils.V6_DO_NOT_DISTURB));
            } else {
                arrayStatus.add(new SobotActionItem(getResources().getString(R.string.sobot_custom_free), getDrawable(R
                        .drawable.custom_service_online), loginStatus.equals(CallStatusUtils.FREE), CallStatusUtils.FREE));
                arrayStatus.add(new SobotActionItem(getResources().getString(R.string.sobot_custom_busy),
                        getDrawable(R.drawable.custom_service_busy), loginStatus.equals(CallStatusUtils.BUSY), CallStatusUtils.BUSY));
            }
        }

        data = (ArrayList<SobotCallCenterStatus>) getIntent().getSerializableExtra("callStatusList");
        if (data != null) {
            for (int i = 0; i < data.size(); i++) {
                if (!"115".equals(data.get(i).getDictId())) {
                    arrayStatus.add(new SobotActionItem(data.get(i).getDictName(),
                            getDrawable(R.drawable.custom_service_other), loginStatus.equals(data.get(i).getDictId()), data.get(i).getDictId()));
                }
            }
        }

        for (int i = 0; i < arrayStatus.size(); i++) {
            SobotActionItem actionItem = arrayStatus.get(i);
            View view = LayoutInflater.from(getSobotBaseContext()).inflate(getResLayoutId("sobot_item_login_status_choose"), null);
            TextView tv_name = view.findViewById(getResId("tv_name"));
            ImageView iv_state = view.findViewById(getResId("iv_state"));
            tv_name.setText(actionItem.getmTitle());
            Drawable dra = actionItem.getmDrawable();
            dra.setBounds(0, 0, 40, 40);
            tv_name.setCompoundDrawables(dra, null, null, null);
            view.setTag(actionItem);
            iv_state.setVisibility(View.GONE);
            ll_login_status.addView(view);
            view.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    SobotActionItem actionItem = (SobotActionItem) v.getTag();
                    Intent resultIntent = new Intent();
                    resultIntent.putExtra("statusType", actionItem.getDicId() != null ? actionItem.getDicId() : "");
                    resultIntent.putExtra("statusTypeName", actionItem.getmTitle() != null ? actionItem.getmTitle() : "");
                    setResult(RESULT_OK, resultIntent);
                    finish();
                }
            });
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == ll_cancle.getId()) {
            finish();
        }
    }
}