package com.sobot.callsdk.v1.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callsdk.R;
import com.sobot.callsdk.v1.entity.v1.SobotRemindInfo;

import java.util.List;

/**
 * @author: Sobot
 * 选择提醒
 * 2022/7/12
 */
public class SobotCallPlanRemindAdapter extends RecyclerView.Adapter{
    private List<SobotRemindInfo> mDate;
    private Context mContext;
    private OnItemClickListener mListener;

    public SobotCallPlanRemindAdapter(Context mContext, List<SobotRemindInfo> mDate, OnItemClickListener listener){
        this.mContext = mContext;
        this.mDate = mDate;
        this.mListener = listener;
    }
    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup viewGroup, int i) {
        View v = LayoutInflater.from(mContext).inflate(R.layout.sobot_item_call_remind, viewGroup, false);
        RecyclerView.ViewHolder vh = new ViewHolder(v);
        return vh;
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder viewHolder, int i) {
        ViewHolder vh = (ViewHolder)viewHolder;
        SobotRemindInfo infoList = mDate.get(i);
        vh.sobot_txt_title.setText(infoList.getDataName());
        if(infoList.isChecked()){
            vh.sobot_txt_title.setTextColor(mContext.getResources().getColor(R.color.sobot_call_theme_color));
            vh.sobot_img_state.setVisibility(View.VISIBLE);
        }else{
            vh.sobot_txt_title.setTextColor(mContext.getResources().getColor(R.color.sobot_call_wenzi_gray1));
            vh.sobot_img_state.setVisibility(View.GONE);
        }
        vh.itemView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(mListener!=null)
                    mListener.onItemClick(infoList);
            }
        });
    }

    @Override
    public int getItemCount() {
        return mDate.size();
    }

    public interface OnItemClickListener {
        void onItemClick(SobotRemindInfo info);
    }
    class ViewHolder extends RecyclerView.ViewHolder{
        private TextView sobot_txt_title;
        private ImageView sobot_img_state;
        private View sobot_v_line;
        public ViewHolder(@NonNull View itemView) {
            super(itemView);
            sobot_txt_title = itemView.findViewById(R.id.sobot_txt_title);
            sobot_img_state =itemView.findViewById(R.id.sobot_img_state);
            sobot_v_line =itemView.findViewById(R.id.sobot_v_line);
        }
    }

}
