package com.sobot.callsdk.v1.adapter;

import android.annotation.SuppressLint;
import android.content.Context;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callsdk.R;
import com.sobot.callsdk.v1.entity.SobotCallTaskDetailsEntity;
import com.sobot.utils.SobotStringUtils;

import java.util.List;

/**
 * @author: Sobot
 * 通话任务-任务详情
 * 2022/7/12
 */
public class SobotCallTaskDetailAdapter extends RecyclerView.Adapter{
    private Context mContext;
    private List<Object> mData;
    private int status;
    private OnItemClickListener clickListener ;

    public SobotCallTaskDetailAdapter(Context mContext, List<Object> mData,int status,OnItemClickListener clickListener) {
        this.mContext = mContext;
        this.mData = mData;
        this.status = status;
        this.clickListener = clickListener;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup viewGroup, int i) {
        View v = LayoutInflater.from(mContext).inflate(R.layout.sobot_item_call_task_detail, viewGroup, false);
        RecyclerView.ViewHolder vh = new MyViewHolder(v);
        return vh;
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder vh, @SuppressLint("RecyclerView") int i) {
        MyViewHolder viewHolder = (MyViewHolder) vh;
        if(mData.get(i) instanceof SobotCallTaskDetailsEntity){
            SobotCallTaskDetailsEntity data = (SobotCallTaskDetailsEntity) mData.get(i);
            if (data != null && !TextUtils.isEmpty(data.getScreenNumber())) {
                viewHolder.call_task_phone.setText(data.getScreenNumber());
                viewHolder.call_task_call_num.setText(data.getDialCount() + "");
                viewHolder.call_contact_name.setText(SobotStringUtils.isEmpty(data.getContactName())?"--": data.getContactName());
            }
        }
        viewHolder.itemView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //拨号
                if (clickListener != null) {
                    clickListener.onItemClick(mData.get(i));
                }
            }
        });
    }

    @Override
    public int getItemCount() {
        return mData.size();
    }
    public interface OnItemClickListener {
        void onItemClick(Object info);
        void onItemDetail(Object info);
    }
    class MyViewHolder extends RecyclerView.ViewHolder{
        public TextView call_contact_name;
        public TextView call_task_call_num;
        public TextView call_task_phone;
        public MyViewHolder(@NonNull  View itemView) {
            super(itemView);
            call_contact_name = itemView.findViewById(R.id.call_contact_name);
            call_task_call_num = itemView.findViewById(R.id.call_task_call_num);
            call_task_phone = itemView.findViewById(R.id.call_task_phone);
        }
    }
}
