package com.sobot.callsdk.v6.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callbase.model.QueueAgentCheckin;
import com.sobot.callsdk.R;

import java.util.List;

public class CallGroupAdapter extends RecyclerView.Adapter {
    private List<QueueAgentCheckin> list;
    private Context mContext;
    public CallGroupAdapter(Context context,List<QueueAgentCheckin> list){
        this.mContext = context;
        this.list = list;
    }

    public List<QueueAgentCheckin> getList() {
        return list;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup viewGroup, int i) {
        View v = LayoutInflater.from(mContext).inflate(R.layout.sobot_item_select_group, viewGroup, false);
        return  new MyViewHolder(v);
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder viewHolder, int i) {
        QueueAgentCheckin checkin = list.get(i);
        MyViewHolder vh = (MyViewHolder) viewHolder;
        if(checkin!=null){
            vh.tv_group_name.setText(checkin.getQueueName());
            vh.cb_group.setChecked(checkin.isSelected());
            vh.itemView.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    checkin.setSelected(!checkin.isSelected());
                    vh.cb_group.setChecked(checkin.isSelected());
                }
            });
            vh.cb_group.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
                @Override
                public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                    checkin.setSelected(isChecked);
                }
            });
        }
    }

    @Override
    public int getItemCount() {
        return list.size();
    }
    class MyViewHolder extends RecyclerView.ViewHolder{
        private CheckBox cb_group;
        private TextView tv_group_name;

        public MyViewHolder(@NonNull View itemView) {
            super(itemView);
            tv_group_name = itemView.findViewById(R.id.tv_group_name);
            cb_group = itemView.findViewById(R.id.cb_group);

        }
    }
}
