package com.sobot.callsdk.v6.adapter;

import android.content.Context;
import android.graphics.Typeface;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callbase.model.SobotExplicitRuleEntity;
import com.sobot.callsdk.R;

import java.util.List;

public class CallRulesAdapter extends RecyclerView.Adapter {
    private List<SobotExplicitRuleEntity> list;
    private Context mContext;
    private ItemOnclickListener listener;
    private boolean isLeft;
    public interface ItemOnclickListener {
        void itemClick(SobotExplicitRuleEntity explicitRule);
    }
    public CallRulesAdapter(Context context, List<SobotExplicitRuleEntity> list ,boolean isLeft, ItemOnclickListener listener){
        this.mContext = context;
        this.isLeft = isLeft;
        this.list = list;
        this.listener = listener;
    }

    public List<SobotExplicitRuleEntity> getList() {
        return list;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup viewGroup, int i) {
        View v = LayoutInflater.from(mContext).inflate(R.layout.sobot_item_outbound_rules, viewGroup, false);
        return  new MyViewHolder(v);
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder viewHolder, int i) {
        SobotExplicitRuleEntity entity = list.get(i);
        MyViewHolder vh = (MyViewHolder) viewHolder;
        if(entity!=null){
            String text = "";
            if(isLeft &&!TextUtils.isEmpty(list.get(i).getName())){
                text = list.get(i).getName();
            }
            if(!TextUtils.isEmpty(list.get(i).getPlanName())){
                text = list.get(i).getPlanName();
            }
            if(!TextUtils.isEmpty(list.get(i).getNumber())){
                text = list.get(i).getNumber();
                if(!TextUtils.isEmpty(list.get(i).getNickName())){
                    text = list.get(i).getNumber()+"("+list.get(i).getNickName()+")";
                }
            }
            vh.call_rules_name.setText(text);
            if(entity.isHasSet()){
                vh.itemView.setSelected(true);
                vh.iv_exts.setVisibility(View.VISIBLE);
                vh.call_rules_name.setTypeface(null, Typeface.BOLD);
            }else{
                vh.itemView.setSelected(false);
                vh.iv_exts.setVisibility(View.GONE);
                vh.call_rules_name.setTypeface(null, Typeface.NORMAL);
            }
            if(isLeft){
                if(!TextUtils.isEmpty(entity.getCode()) && !"1".equals(entity.getCode())) {
                    vh.iv_exts.setVisibility(View.GONE);
                }
            }
            vh.itemView.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if(listener!=null){
                        listener.itemClick(entity);
                    }
                }
            });
        }
    }

    @Override
    public int getItemCount() {
        return list.size();
    }
    class MyViewHolder extends RecyclerView.ViewHolder{
        private ImageView iv_exts;
        private TextView call_rules_name;

        public MyViewHolder(@NonNull View itemView) {
            super(itemView);
            call_rules_name = itemView.findViewById(R.id.call_rules_name);
            iv_exts = itemView.findViewById(R.id.iv_exts);

        }
    }
}
