package com.sobot.callsdk.v6.callenum;

//通话状态表
public enum CallStage {
    Origination(1, "Origination", "发起电话者"),   // calling
    Destination(2, "Destination", "接电话者"),     // called
    AddedBy(3, "AddedBy", "加入会议者"),    // TServer conference call model, B role
    NewParty(4, "NewParty", "被加入会议中者"),    // Conference new party
    DeletedBy(5, "DeletedBy", "踢出会议者"),    // kick conference by
    DeletedParty(6, "DeletedParty", "退出会议者"),    // exit conference
    ObserveBy(7, "ObserveBy", "监听者"),    // Supervisor
    TransferBy(8, "TransferBy", "发起转接成功者"),    // Transfer by
    ConsultBy(9, "ConsultBy", "发起咨询者"),
    BargeinBy(10, "BargeinBy", "发起强插者"),    // bargein by
    BargeinTo(11, "BargeinTo", "被强插者"),    // bargedin to
    InterceptTo(12, "InterceptTo", "被抢接者"),    // intercepted agent
    TransferTo(13, "TransferTo", "被转接者"),    // Transfer to
    ObserveTo(14, "ObserveTo", "被监听者"),    // monitor agent
    InterceptBy(15, "InterceptBy", "发起抢接者"),
    ConferenceBy(16, "ConferenceBy", "咨询后会议");

    int num;
    String value;
    String des;

    CallStage(int num, String value, String des) {
        this.num = num;
        this.value = value;
        this.des = des;
    }

    public int getNum() {
        return num;
    }

    public void setNum(int num) {
        this.num = num;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String getDes() {
        return des;
    }

    public void setDes(String des) {
        this.des = des;
    }
}
