package com.sobot.callsdk.v6.dialog;

import android.app.Activity;
import android.text.TextUtils;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.sobot.callbase.model.CusFieldConfig;
import com.sobot.callsdk.R;
import com.sobot.callsdk.dialog.SobotBottomDialog;
import com.sobot.callsdk.model.SobotCallCustomerModel;
import com.sobot.callsdk.utils.CustomFieldsUtils;

import java.util.List;

public class CostomerDetailDialog extends SobotBottomDialog implements View.OnClickListener {
    private LinearLayout coustom_pop_layout,sobot_negativeButton;
    private TextView tv_title;
    private TextView tv_nick_value;
    //真实姓名
    private TextView tv_realname_value;
    //性别
//    private TextView tv_sex_value;
    private TextView tv_phone_value;
    //邮箱
//    private TextView tv_email_value;

    private RelativeLayout rl_call_user_country;//客户国家
    private TextView tv_country_value;//客户国家
    //城市
    private TextView tv_city_value;
    private TextView tv_company_value;//客户公司名称
    private TextView tv_qq_value;//客户QQ
    private TextView tv_wx_value;//客户微信
    private TextView tv_remark_value;//客户备注信息
    private TextView tv_is_vip;//是否是vip
    private TextView tv_source_value;//来源
    private TextView btn_save;
    private LinearLayout ll_cusfield;//显示客户自定义字段的布局
    private DialogItemOnClick listener;
    private Activity activity;
    private SobotCallCustomerModel customerModel;
    private List<CusFieldConfig> cusFieldConfigList;//所有自定义字段

    public CostomerDetailDialog(Activity context,SobotCallCustomerModel customer,List<CusFieldConfig> cusFieldConfigList, DialogItemOnClick listener){
        super(context);
        activity = context;
        customerModel = customer;
        this.listener = listener;
        this.cusFieldConfigList = cusFieldConfigList;
    }
    @Override
    protected int getLayout() {
        return R.layout.call_dialog_custom_detail;
    }

    @Override
    protected View getDialogContainer() {
        if (coustom_pop_layout == null) {
            coustom_pop_layout = findViewById(R.id.sobot_container);
        }

        return coustom_pop_layout;
    }

    @Override
    protected void initData() {
        if(customerModel!=null){
            tv_title.setText(getText(customerModel.getNick()));
            tv_nick_value.setText(getText(customerModel.getNick()));
            tv_realname_value.setText(getText(customerModel.getUname()));
            tv_source_value.setText(setSourceText(customerModel.getSource()));
            //性别
//            if (1 == customerModel.getSex()) {
//                tv_sex_value.setText(R.string.call_custom_male);
//            } else if (2 == customerModel.getSex()) {
//                tv_sex_value.setText(R.string.call_custom_female);
//            }

            tv_company_value.setText(customerModel.getEnterpriseName());
            tv_qq_value.setText(getText(customerModel.getQq()));
            tv_wx_value.setText(getText(customerModel.getWx()));
            tv_remark_value.setText(getText(customerModel.getRemark()));

            if (!TextUtils.isEmpty(customerModel.getTel())) {
                tv_phone_value.setText(customerModel.getTel());
            }
//            if (tmpUserEmail != null && tmpUserEmail.length > 1) {
//                tv_email_value.setText(tmpUserEmail[0]);
//                for (int i = 1; i < tmpUserEmail.length; i++) {
////                    addUserEmail(tmpUserEmail[i]);
//                }
//            } else {
//                tv_email_value.setText(customerModel.getEmail());
//            }

            if(!TextUtils.isEmpty(customerModel.getCountryName())) {
                tv_country_value.setText(customerModel.getCountryName());
                rl_call_user_country.setVisibility(View.VISIBLE);
            }else{
                rl_call_user_country.setVisibility(View.GONE);
            }
            if(!TextUtils.isEmpty(customerModel.getProviceName())) {
                tv_city_value.setText(customerModel.getProviceName());
            }
            if (!TextUtils.isEmpty(customerModel.getCityName())) {
                tv_city_value.setText(customerModel.getProviceName() + "-" + customerModel.getCityName());
            }
            if (!TextUtils.isEmpty(customerModel.getAreaName())) {
                tv_city_value.setText(customerModel.getProviceName() + "-" + customerModel.getCityName() + "-" + customerModel.getAreaName());
            }
            
            if ("1".equals(customerModel.getIsVip())) {
                tv_is_vip.setText(R.string.call_vip_customer);
            }else{
                tv_is_vip.setText(R.string.call_ordinary_customer);
            }
            if(cusFieldConfigList!=null && cusFieldConfigList.size()>0) {
                CustomFieldsUtils.showCusFields(activity, cusFieldConfigList, ll_cusfield);
            }
        }
    }
    private String getText(String text){
        return TextUtils.isEmpty(text)?"--":text;
    }
    private String setSourceText(String sourceType) {
        if(TextUtils.isEmpty(sourceType)){
            return "";
        }
        String sourceName;
        switch (sourceType) {
            case "1":
                sourceName = activity.getResources().getString(R.string.call_source_wechat);
                break;
            case "2":
                sourceName = activity.getResources().getString(R.string.call_source_app);
                break;
            case "3":
                sourceName = activity.getResources().getString(R.string.call_source_weibo);
                break;
            case "4":
                sourceName = activity.getResources().getString(R.string.call_source_mobile_web);
                break;
            case "5":
                sourceName = activity.getResources().getString(R.string.call_source_rong);
                break;
            case "6":
                sourceName = activity.getResources().getString(R.string.sobot_call_center);
                break;
            case "7":
                sourceName = activity.getResources().getString(R.string.call_source_work_order);
                break;
            case "8":
                sourceName = activity.getResources().getString(R.string.call_source_customer_center);
                break;
            case "34":
                sourceName = activity.getResources().getString(R.string.call_str_tm_center);
                break;
            default:
                sourceName = activity.getResources().getString(R.string.call_source_pc);
                break;
        }
        return sourceName;
    }
    @Override
    protected void initView() {
        rl_call_user_country =findViewById(R.id.rl_call_user_country);
        sobot_negativeButton =findViewById(R.id.sobot_negativeButton);
        tv_title =  findViewById(R.id.sobot_tv_title);
        tv_nick_value =  findViewById(R.id.work_order_user_nick);
        tv_realname_value =  findViewById(R.id.work_order_user_realname);
//        tv_sex_value =  findViewById(R.id.work_order_user_sex);
        tv_source_value =  findViewById(R.id.work_order_user_source);
//        tv_email_value =  findViewById(R.id.work_order_user_email);
        tv_phone_value =  findViewById(R.id.work_order_user_tel);
        tv_company_value =  findViewById(R.id.work_order_user_company);
        tv_country_value =  findViewById(R.id.tv_country_value);
        tv_city_value =  findViewById(R.id.create_work_order_user_city);
        tv_qq_value =  findViewById(R.id.work_order_user_qq);
        tv_wx_value =  findViewById(R.id.work_order_user_wechat);
        tv_remark_value =  findViewById(R.id.work_order_user_remark);
        tv_is_vip =  findViewById(R.id.tv_is_vip_value);
        btn_save =  findViewById(R.id.btn_save);
        ll_cusfield = findViewById(R.id.work_order_user_cusfield);
        ll_cusfield.setVisibility(View.GONE);
        btn_save.setOnClickListener(this);
        sobot_negativeButton.setOnClickListener(this);
    }


    @Override
    public void onClick(View v) {
        if(v==sobot_negativeButton){
            //关闭
            dismiss();
        }else if(v== btn_save){
            if(listener!=null && customerModel !=null){
                listener.selectItem(customerModel);
            }
            dismiss();
        }
    }
    @Override
    public void dismiss() {
        try {
            if (isShowing()) {
                super.dismiss();
            }
        } catch (Exception e) {
//            e.printStackTrace();
        }
    }
}
