package com.sobot.callsdk.v6.dialog;

import android.app.Activity;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callbase.model.SobotSummaryTemplate;
import com.sobot.callsdk.R;
import com.sobot.callsdk.dialog.SobotBottomDialog;
import com.sobot.callsdk.v6.adapter.CallTemplateAdapter;

import java.util.ArrayList;
import java.util.List;

public class SelectSumTemplateDialog extends SobotBottomDialog implements View.OnClickListener {
    private LinearLayout coustom_pop_layout,sobot_negativeButton;
    private RecyclerView rv_list;
    private LinearLayout ll_search;
    private DialogItemOnClick listener;
    private CallTemplateAdapter adapter;
    private List<SobotSummaryTemplate> data;
    private List<SobotSummaryTemplate> oldData;//初始数据
    private List<SobotSummaryTemplate> tempData;//搜索临时数据
    private Activity activity;
    private TextView sobot_tv_title;

    public SelectSumTemplateDialog(Activity context, DialogItemOnClick listener, List<SobotSummaryTemplate> list){
        super(context);
        activity = context;
        this.listener = listener;
        this.data = new ArrayList<>();
        this.oldData = new ArrayList<>();
        data.addAll(list);
        oldData.addAll(list);
        tempData = new ArrayList<>();
    }
    @Override
    protected int getLayout() {
        return R.layout.call_common_dialog_select;
    }

    @Override
    protected View getDialogContainer() {
        if (coustom_pop_layout == null) {
            coustom_pop_layout = findViewById(R.id.sobot_container);
        }
        return coustom_pop_layout;
    }

    @Override
    protected void initData() {
        adapter = new CallTemplateAdapter(activity,data,listener);
        rv_list.setAdapter(adapter);
    }

    @Override
    protected void initView() {
        sobot_negativeButton = findViewById(R.id.sobot_negativeButton);
        rv_list = findViewById(R.id.rv_list);
        sobot_tv_title = findViewById(R.id.sobot_tv_title);
        sobot_tv_title.setText(R.string.call_service_template);
        rv_list = findViewById(R.id.rv_list);
        ll_search = findViewById(R.id.ll_search);
        ll_search.setVisibility(View.GONE);

        LinearLayoutManager layoutManager = new LinearLayoutManager(activity, LinearLayoutManager.VERTICAL, false);
        // 设置RecyclerView的LayoutManager
        rv_list.setLayoutManager(layoutManager);

        sobot_negativeButton.setOnClickListener(this);
    }

    public void setData(List<SobotSummaryTemplate> list) {
        if (data == null) {
            data = new ArrayList<>();
        } else {
            data.clear();
            data.addAll(list);
        }
        if (oldData == null) {
            oldData = new ArrayList<>();
        } else {
            oldData.clear();
            oldData.addAll(list);
        }
        if (tempData == null) {
            tempData = new ArrayList<>();
        } else {
            tempData.clear();
        }
        if(adapter!=null) {
            adapter.notifyDataSetChanged();
        }
    }

    @Override
    public void onClick(View v) {
        if(v==sobot_negativeButton){
            //关闭
            dismiss();
        }
    }
    @Override
    public void dismiss() {
        try {
            if (isShowing()) {
                super.dismiss();
            }
        } catch (Exception e) {
//            e.printStackTrace();
        }
    }
}
