package com.sobot.callsdk.v6.fragment;

import android.os.Bundle;
import android.os.Handler;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.Nullable;

import com.sobot.callbase.CallPermissionManager;
import com.sobot.callbase.model.CallTaskContactModel;
import com.sobot.callbase.model.CallTemplateFieldEntity;
import com.sobot.callbase.model.CusFieldConfig;
import com.sobot.callbase.model.CusFieldDataInfoList;
import com.sobot.callbase.model.SobotCusFieldEntity;
import com.sobot.callsdk.R;
import com.sobot.callsdk.dialog.CallCommonDialog;
import com.sobot.callsdk.fargment.SobotBaseFragment;
import com.sobot.callsdk.utils.CustomFieldsUtils;
import com.sobot.callsdk.v6.constant.SobotCallLiveDataBusV6Key;
import com.sobot.callsdk.v6.listener.CallTaskStatusListener;
import com.sobot.common.login.permission.SobotPermissionManager;
import com.sobot.network.http.callback.SobotResultCallBack;
import com.sobot.utils.SobotStringUtils;
import com.sobot.widget.livedatabus.SobotLiveEventBus;
import com.sobot.widget.ui.toast.SobotToastUtil;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 任务详情
 */
public class CallTaskDetailFragment extends SobotBaseFragment implements View.OnClickListener {
    private List<CallTemplateFieldEntity> dataFields;
    private List<CusFieldConfig> cusFieldConfigList;//文档上传的字段
    private List<CusFieldConfig> cusFieldExecuteList;
    private Map<String, CusFieldConfig> allCusFields;
    private String campaignId;//任务id
    private String recordId;//任务明细id
    private View mRootView;
    private LinearLayout ll_work_order_user_cusfield;
    private View ll_show_line;
    private LinearLayout ll_call_detail;
    private LinearLayout ll_edit_s;
    private LinearLayout ll_normal_s;
    private TextView btn_cancel;
    private TextView btn_save;
    private boolean isEdit;//是否是编辑状态
    private CallTaskStatusListener statusListener;

    private int dialCount;//外呼次数 判断是否执行过
    private int taskFromType;//1 全部 2 未执行 3 已执行

    public void setStatusListener(CallTaskStatusListener statusListener) {
        this.statusListener = statusListener;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        mRootView = inflater.inflate(R.layout.fragment_call_task_detail, container, false);
        initView();
        return mRootView;
    }

    private void initView() {
        ll_work_order_user_cusfield = mRootView.findViewById(R.id.work_order_user_cusfield);
        ll_call_detail = mRootView.findViewById(R.id.ll_call_detail);
        ll_show_line = mRootView.findViewById(R.id.ll_show_line);
        ll_edit_s = mRootView.findViewById(R.id.ll_edit_s);
        ll_normal_s = mRootView.findViewById(R.id.ll_normal_s);
        ll_normal_s.setOnClickListener(this);
        btn_cancel = mRootView.findViewById(R.id.btn_cancel);
        btn_cancel.setOnClickListener(this);
        btn_save = mRootView.findViewById(R.id.btn_save);
        btn_save.setOnClickListener(this);
        //权限判断
        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_WHRW_RWXXBJ)) {
            ll_normal_s.setVisibility(View.VISIBLE);
        } else {
            ll_normal_s.setVisibility(View.GONE);
        }
        requestCusField();
    }

    private boolean refreshList = false;

    private void requestDate() {
        if (!TextUtils.isEmpty(campaignId) && !TextUtils.isEmpty(recordId) && zhiChiApi != null) {
            zhiChiApi.taskDetail(getSobotActivity(), campaignId, recordId, new SobotResultCallBack<CallTaskContactModel>() {
                @Override
                public void onSuccess(CallTaskContactModel callTaskContactModel) {
                    if (callTaskContactModel != null) {
                        dataFields = callTaskContactModel.getDataFields();
                        //添加地区
                        String province = "--";
                        if (!SobotStringUtils.isEmpty(callTaskContactModel.getAreaProvince()) && !SobotStringUtils.isEmpty(callTaskContactModel.getAreaCity())) {
                            province = callTaskContactModel.getAreaProvince() + "-" + callTaskContactModel.getAreaCity();
                        } else if (!SobotStringUtils.isEmpty(callTaskContactModel.getAreaProvince())) {
                            province = callTaskContactModel.getAreaProvince() + "--";
                        } else if (!SobotStringUtils.isEmpty(callTaskContactModel.getAreaCity())) {
                            province = "--" + callTaskContactModel.getAreaProvince();
                        }
                        cusFieldConfigList = CustomFieldsUtils.templateCheageCofig(dataFields, getResources().getString(R.string.call_task_phone_area), province);
                        for (int i = 0; i < cusFieldConfigList.size(); i++) {
                            CusFieldConfig temp = cusFieldConfigList.get(i);
                            if (temp != null && SobotStringUtils.isNoEmpty(temp.getFieldId()) && !temp.getFieldId().equals("compellation") && !temp.getFieldId().equals("number")
                                    && !temp.getTemplateFieldId().equals("contactCode") && !temp.getTemplateFieldId().equals("callingListId") && !temp.getTemplateFieldId().equals("guishudi_android")) {
                                boolean isDelete = true;
                                CusFieldConfig newConfig = allCusFields.get(temp.getFieldId());
                                if (newConfig != null) {
                                    isDelete = false;
                                    cusFieldConfigList.get(i).setFillFlag(newConfig.getFillFlag());//是否必填
                                    if (newConfig.getOpenFlag() != 1) {
                                        isDelete = true;
                                    }
                                    //是否有选项
                                    if (temp.getFieldType() == 6 || temp.getFieldType() == 7 || temp.getFieldType() == 8 || temp.getFieldType() == 9) {
                                        //重新赋值全量选项
                                        cusFieldConfigList.get(i).setCusFieldDataInfoList(newConfig.getCusFieldDataInfoList());
                                        //检查选项是否删除
                                        if (SobotStringUtils.isNoEmpty(temp.getFieldValue())) {

                                            String[] valus = temp.getFieldValue().split(",");
                                            for (int j = 0; j < valus.length; j++) {
                                                boolean isValueDelete = true;
//                                                6、7、8 :dataId 9:dataValue
                                                if (newConfig.getCusFieldDataInfoList() != null) {
                                                    for (int k = 0; k < newConfig.getCusFieldDataInfoList().size(); k++) {
                                                        if (temp.getFieldType() == 9) {
                                                            if (valus[j].equals(newConfig.getCusFieldDataInfoList().get(k).getDataValue())) {
                                                                isValueDelete = false;
                                                            }
                                                        } else {
                                                            if (valus[j].equals(newConfig.getCusFieldDataInfoList().get(k).getDataId())) {
                                                                isValueDelete = false;
                                                            }
                                                        }
                                                    }
                                                    if (isValueDelete) {
                                                        cusFieldConfigList.get(i).setFieldValueDelete(isValueDelete);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                                cusFieldConfigList.get(i).setFieldDelete(isDelete);
                            }
                        }

                        List<CallTemplateFieldEntity> executeFields = callTaskContactModel.getExecuteFields();//外呼次数、接听次数
                        List<CallTemplateFieldEntity> executeFields_2 = new ArrayList<>();
                        if (executeFields != null && executeFields.size() > 0) {
                            for (int i = 0; i < executeFields.size(); i++) {
                                if (executeFields.get(i).getTemplateFieldId().equals("dialCount")) {
                                    executeFields_2.add(executeFields.get(i));
                                }
                                if (executeFields.get(i).getTemplateFieldId().equals("answerCount")) {
                                    executeFields_2.add(executeFields.get(i));
                                }
                            }
                        }
                        if (executeFields_2.size() > 0) {
                            cusFieldExecuteList = CustomFieldsUtils.templateCheageCofig(executeFields_2);
                        }
                        if (refreshList) {
                            statusListener.refreshList(callTaskContactModel.getContactName(), callTaskContactModel.getScreenNumber(), callTaskContactModel.getPhoneNumber());
                            refreshList = false;
                        }
                    }
                    new Handler().post(new Runnable() {
                        @Override
                        public void run() {
                            showView(isEdit);
                        }
                    });

                }

                @Override
                public void onFailure(Exception e, String des) {

                }
            });
        }
    }

    /**
     * 请求自定义字段
     */
    private void requestCusField() {
        allCusFields = new HashMap<>();
        zhiChiApi.getCusFieldInfoList(getContext(), 3, new SobotResultCallBack<List<SobotCusFieldEntity>>() {
            @Override
            public void onSuccess(List<SobotCusFieldEntity> cusFieldConfigs) {
                if (null != cusFieldConfigs) {
                    for (int i = 0; i < cusFieldConfigs.size(); i++) {
                        CusFieldConfig cusFieldConfig = cusFieldConfigs.get(i).getCusFieldConfig();
                        if (cusFieldConfig != null) {
                            if (null != cusFieldConfigs.get(i).getCusFieldDataInfoList()) {
                                cusFieldConfig.setCusFieldDataInfoList(cusFieldConfigs.get(i).getCusFieldDataInfoList());
                            }
                            allCusFields.put(cusFieldConfig.getFieldId(), cusFieldConfig);
                        }
                    }
                }
                requestDate();
            }

            @Override
            public void onFailure(Exception e, String des) {
                requestDate();
            }
        });
    }

    @Override
    public void setArguments(@Nullable Bundle args) {
        super.setArguments(args);
        if (args != null) {
            campaignId = args.getString("campaignId");
            recordId = args.getString("recordId");
            dialCount = args.getInt("dialCount");
            taskFromType = args.getInt("taskFromType");
        }
    }

    public void refreshDate(String cId, String rId) {
        campaignId = cId;
        recordId = rId;
        requestDate();
    }

    //防止重复点击
    private long lastClickTime = 0;

    @Override
    public void onClick(View v) {
        if (v == ll_normal_s) {
            showView(true);
            if (statusListener != null) {
                statusListener.editStatus();
            }
        } else if (v == btn_cancel) {
            if (statusListener != null) {
                statusListener.normalStatus();
            }
            showView(false);
        } else if (v == btn_save && isEdit) {
            if (System.currentTimeMillis() - lastClickTime > 1000) {
                lastClickTime = System.currentTimeMillis();
                save();
            }
        }
    }

    public boolean isEdit() {
        return isEdit;
    }

    public void setEdit(boolean edit) {
        isEdit = edit;
    }

    private void save() {
        String list = setCustomerFieldValue();
        if (cusFieldConfigList != null && cusFieldConfigList.size() > 0) {
            if (!checkCusFieldRequired()) {
                return;
            }

            zhiChiApi.editTaskDetail(getSobotActivity(), campaignId, recordId, list, new SobotResultCallBack() {
                @Override
                public void onSuccess(Object o) {
                    showView(false);
                    refreshList = true;
                    requestDate();
                    if (statusListener != null) {
                        statusListener.normalStatus();
                    }
                    //发送广播
                    SobotLiveEventBus.get(SobotCallLiveDataBusV6Key.SOBOT_ACTION_REFRESH_ALL_TASK).post(true);
                    if (taskFromType == 1) {
                        //全部
                        if (dialCount > 0) {
                            //已执行
                            SobotLiveEventBus.get(SobotCallLiveDataBusV6Key.SOBOT_ACTION_REFRESH_EXECUTED_TASK).post(true);
                        } else {
                            //未执行
                            SobotLiveEventBus.get(SobotCallLiveDataBusV6Key.SOBOT_ACTION_REFRESH_UNEXECUTED_TASK).post(true);
                        }

                    } else if (taskFromType == 2) {
                        //未执行
                        SobotLiveEventBus.get(SobotCallLiveDataBusV6Key.SOBOT_ACTION_REFRESH_UNEXECUTED_TASK).post(true);
                    } else if (taskFromType == 3) {
                        //已执行
                        SobotLiveEventBus.get(SobotCallLiveDataBusV6Key.SOBOT_ACTION_REFRESH_EXECUTED_TASK).post(true);
                    }
                }

                @Override
                public void onFailure(Exception e, String des) {
                    if (!TextUtils.isEmpty(des) && null != getActivity()) {
                        Toast.makeText(getActivity(), des, Toast.LENGTH_SHORT).show();
                    }
                }
            });
        }
    }

    /**
     * 获取自定义字段的值
     */
    private String setCustomerFieldValue() {
        JSONArray array = new JSONArray();
        if (cusFieldConfigList != null && cusFieldConfigList.size() != 0) {
            for (int i = 0; i < cusFieldConfigList.size(); i++) {
                if (cusFieldConfigList.get(i).getOpenFlag() != 1 || cusFieldConfigList.get(i).isFieldDelete()) {
                    continue;
                }
                String value = "";
                String ids = "";
                View view = ll_work_order_user_cusfield.findViewWithTag(cusFieldConfigList.get(i).getFieldId());
                if (view != null) {
                    if (cusFieldConfigList.get(i).getFieldType() == 1) {
                        //单行文本
                        EditText singleLine = (EditText) view.findViewById(R.id.call_customer_field_text_single);
                        cusFieldConfigList.get(i).setFieldValue(singleLine.getText().toString());
                        value = singleLine.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 2) {
                        //多行文本
                        EditText moreContent = (EditText) view.findViewById(R.id.call_customer_field_text_more_content);
                        cusFieldConfigList.get(i).setFieldValue(moreContent.getText().toString());
                        value = moreContent.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 3) {
                        //日期
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        value = textClick.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 4) {
                        //时间
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        value = textClick.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 5) {
                        //数值
                        EditText numberContent = (EditText) view.findViewById(R.id.call_customer_field_text_number);
                        cusFieldConfigList.get(i).setFieldValue(numberContent.getText().toString());
                        value = numberContent.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 6) {
                        //下拉列表
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        if (textClick.getTag() != null && textClick.getTag() instanceof CusFieldDataInfoList) {
                            CusFieldDataInfoList selectItem = (CusFieldDataInfoList) textClick.getTag();
                            value = selectItem.getDataId();
                        }
                    } else if (cusFieldConfigList.get(i).getFieldType() == 7) {
                        //复选框
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        if (textClick.getTag() != null && textClick.getTag() instanceof List) {
                            List<CusFieldDataInfoList> infoList = (List<CusFieldDataInfoList>) textClick.getTag();
                            StringBuffer sb = new StringBuffer();
                            if (infoList != null && infoList.size() > 0) {
                                for (int j = 0; j < infoList.size(); j++) {
                                    if (sb.length() > 0) {
                                        sb.append(",");
                                    }
                                    sb.append(infoList.get(j).getDataId());
                                }
                            }
                            value = sb.toString();
                        }
                    } else if (cusFieldConfigList.get(i).getFieldType() == 8) {
                        //单选框
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        if (textClick.getTag() != null && textClick.getTag() instanceof CusFieldDataInfoList) {
                            CusFieldDataInfoList selectItem = (CusFieldDataInfoList) textClick.getTag();
                            value = selectItem.getDataId();
                        }
                    } else if (cusFieldConfigList.get(i).getFieldType() == 9) {
                        //级联
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        if (textClick.getTag() != null && textClick.getTag() instanceof List) {
                            List<CusFieldDataInfoList> infoList = (List<CusFieldDataInfoList>) textClick.getTag();
                            StringBuffer sb = new StringBuffer();
                            if (infoList != null && infoList.size() > 0) {
                                for (int j = 0; j < infoList.size(); j++) {
                                    if (sb.length() > 0) {
                                        sb.append(",");
                                    }
                                    sb.append(infoList.get(j).getDataValue());
                                }
                            }
                            value = sb.toString();
                        }
                    }
                }
                CallTemplateFieldEntity entity = new CallTemplateFieldEntity();
                entity.setTemplateFieldId(cusFieldConfigList.get(i).getTemplateFieldId());
                entity.setFieldValue(value);
                entity.setFieldType(cusFieldConfigList.get(i).getFieldType());
                entity.setFieldName(cusFieldConfigList.get(i).getFieldName());
                if (cusFieldConfigList.get(i).getTemplateFieldId().equals("contactCode") || cusFieldConfigList.get(i).getTemplateFieldId().equals("callingListId")) {
                    continue;
                }
                try {
                    JSONObject object = new JSONObject();
                    object.put("templateFieldId", cusFieldConfigList.get(i).getTemplateFieldId());
                    object.put("fieldName", cusFieldConfigList.get(i).getFieldName());
                    object.put("fieldType", cusFieldConfigList.get(i).getFieldType());
                    object.put("fieldValue", SobotStringUtils.isEmpty(value) ? null : value);//任务信息和任务总结，当是选项类型时：6、7、8保存:dataId,9保存:dataValue
                    array.put(object);
                } catch (JSONException e) {
                    throw new RuntimeException(e);
                }
            }
        }
        return array.toString();
    }

    //检测自定义字段是否必填并提示
    private boolean checkCusFieldRequired() {
        if (cusFieldConfigList != null && cusFieldConfigList.size() > 0) {
            for (int i = 0; i < cusFieldConfigList.size(); i++) {
                CusFieldConfig fieldConfig = cusFieldConfigList.get(i);
                if (1 == fieldConfig.getOpenFlag() && 1 == fieldConfig.getFillFlag()) {
                    if (TextUtils.isEmpty(fieldConfig.getFieldValue())) {
                        String s = getResources().getString(R.string.call_retcode_500042);
                        SobotToastUtil.showToast(getSobotActivity(), String.format(s, fieldConfig.getFieldName()));
                        return false;
                    }
                }
            }
        }
        return true;
    }

    private void showView(boolean isEdit) {
        if (cusFieldConfigList == null) return;
        this.isEdit = isEdit;
        if (isEdit) {
            //编辑
            boolean isDelete = false;
            for (int i = 0; i < cusFieldConfigList.size(); i++) {
                if (cusFieldConfigList.get(i).isFieldDelete() || cusFieldConfigList.get(i).isFieldValueDelete()) {
                    isDelete = true;
                }
            }
            if (isDelete) {
                //弹框提示
                CallCommonDialog tipDialog = new CallCommonDialog(getString(R.string.call_cus_field_deleted_edit_hide), new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {
                        //过滤已删除的字段
                        for (int i = 0; i < cusFieldConfigList.size(); i++) {
                            if (cusFieldConfigList.get(i).getTemplateFieldId().equals("contactCode") || cusFieldConfigList.get(i).getTemplateFieldId().equals("callingListId") || cusFieldConfigList.get(i).getTemplateFieldId().equals("guishudi_android")) {
                                cusFieldConfigList.get(i).setOpenFlag(0);
                            }
                        }
                        if (dataFields != null && dataFields.size() > 0) {
                            //设置自定义字段
                            CustomFieldsUtils.addWorkOrderUserCusFields(getSobotActivity(), cusFieldConfigList, ll_work_order_user_cusfield);
                        }
                        ll_call_detail.setVisibility(View.GONE);
                        ll_show_line.setVisibility(View.GONE);
                        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_WHRW_RWXXBJ)) {
                            ll_edit_s.setVisibility(View.VISIBLE);
                        }
                        ll_normal_s.setVisibility(View.GONE);
                    }
                });
                tipDialog.setCancelable(true);
                tipDialog.show(getChildFragmentManager(), "tipDialog");
            } else {
                //直接编辑
                for (int i = 0; i < cusFieldConfigList.size(); i++) {
                    if (cusFieldConfigList.get(i).getTemplateFieldId().equals("contactCode") || cusFieldConfigList.get(i).getTemplateFieldId().equals("callingListId") || cusFieldConfigList.get(i).getTemplateFieldId().equals("guishudi_android")) {
                        cusFieldConfigList.get(i).setOpenFlag(0);
                    }
                }
                if (dataFields != null && dataFields.size() > 0) {
                    //设置自定义字段
                    CustomFieldsUtils.addWorkOrderUserCusFields(getSobotActivity(), cusFieldConfigList, ll_work_order_user_cusfield);
                }
                ll_call_detail.setVisibility(View.GONE);
                ll_show_line.setVisibility(View.GONE);
                if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_WHRW_RWXXBJ)) {
                    ll_edit_s.setVisibility(View.VISIBLE);
                }
                ll_normal_s.setVisibility(View.GONE);
            }
        } else {

            for (int i = 0; i < cusFieldConfigList.size(); i++) {
                if (cusFieldConfigList.get(i).getTemplateFieldId().equals("contactCode") || cusFieldConfigList.get(i).getTemplateFieldId().equals("callingListId") || cusFieldConfigList.get(i).getTemplateFieldId().equals("guishudi_android")) {
                    cusFieldConfigList.get(i).setOpenFlag(1);
                }
            }
            ll_edit_s.setVisibility(View.GONE);
            if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_WHRW_RWXXBJ)) {
                ll_normal_s.setVisibility(View.VISIBLE);
            }
//            非编辑
            if (dataFields != null && dataFields.size() > 0) {
                CustomFieldsUtils.showCusFieldsNew(getSobotActivity(), cusFieldConfigList, ll_work_order_user_cusfield);
            }
            if (cusFieldExecuteList != null && cusFieldExecuteList.size() > 0) {
                ll_call_detail.setVisibility(View.VISIBLE);
                ll_show_line.setVisibility(View.VISIBLE);
                CustomFieldsUtils.showCusFieldsNew(getSobotActivity(), cusFieldExecuteList, ll_call_detail);
            } else {
                ll_call_detail.setVisibility(View.GONE);
                ll_show_line.setVisibility(View.GONE);
            }
        }
    }

}