package com.sobot.callsdk.v6.fragment;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Typeface;
import android.graphics.drawable.Drawable;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.text.Editable;
import android.text.InputFilter;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.view.inputmethod.EditorInfo;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.Nullable;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callbase.CallPermissionManager;
import com.sobot.callbase.dialog.SobotActionItem;
import com.sobot.callbase.model.CallEncryptTel;
import com.sobot.callbase.model.CusFieldConfig;
import com.sobot.callbase.model.CusFieldDataInfoList;
import com.sobot.callbase.model.EnterPriseModel;
import com.sobot.callbase.model.SobotCusFieldEntity;
import com.sobot.callbase.model.placename.CountryModel;
import com.sobot.callbase.utils.SobotStringUtils;
import com.sobot.callsdk.R;
import com.sobot.callsdk.fargment.SobotBaseFragment;
import com.sobot.callsdk.model.SobotCallCustomerModel;
import com.sobot.callsdk.utils.CustomFieldsUtils;
import com.sobot.callsdk.utils.SobotCallConstant;
import com.sobot.callsdk.v6.adapter.CallSearchCustomAdapter;
import com.sobot.callsdk.v6.dialog.CostomerDetailDialog;
import com.sobot.callsdk.v6.dialog.DialogItemOnClick;
import com.sobot.callsdk.v6.dialog.SelectCityDialog;
import com.sobot.callsdk.v6.dialog.SelectCommonDialog;
import com.sobot.callsdk.v6.dialog.SelectCompanyDialog;
import com.sobot.callsdk.v6.dialog.SobotMoreMenuPop;
import com.sobot.callsdk.v6.widget.swipeItem.SwipeItemDeleteLayout;
import com.sobot.common.login.SobotLoginTools;
import com.sobot.common.login.model.SobotServiceInfoModel;
import com.sobot.common.login.permission.SobotPermissionManager;
import com.sobot.network.http.callback.SobotResultCallBack;
import com.sobot.utils.SobotDensityUtil;
import com.sobot.utils.SobotLogUtils;
import com.sobot.widget.ui.toast.SobotToastUtil;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 客户详情
 */
public class CustomInfoFragment extends SobotBaseFragment implements View.OnClickListener {
    private View mRootView;
    private View ll_customer;
    private RelativeLayout ll_search_custom;
    private LinearLayout ll_search;
    private TextView tv_edit_custom;
    private TextView tv_custom_name;
    //昵称
    private TextView tv_nick_value;
    private EditText ed_nick_value;
    private TextView tv_nick_must;
    //真实姓名
    private TextView tv_realname_value;
    private EditText ed_realname_value;
    //性别
    private LinearLayout ll_sex;
    private TextView tv_sex_value;
    private TextView tv_phone_value;
    private EditText ed_phone_value;
    private ImageView iv_copy;
    private ImageView iv_email_copy;
    private ImageView iv_phone_add;
    //邮箱
    private RelativeLayout rl_email;
    private TextView tv_email_value;
    private EditText ed_email_value;
    private ImageView iv_email_add;

    private RelativeLayout rl_call_user_country;//客户国家
    private TextView tv_country_value;//客户国家
    //城市
    private TextView tv_city_value;
    private SelectCityDialog cityDialog;
    private TextView tv_company_value;//客户公司名称
    private TextView tv_qq_value;//客户QQ
    private EditText ed_qq_value;//客户QQ
    private TextView tv_wx_value;//客户微信
    private EditText ed_wx_value;//客户微信
    private TextView tv_remark_value;//客户备注信息
    private EditText ed_remark_value;//客户备注信息
    private LinearLayout ll_isvip;//是否是vip
    private TextView tv_is_vip_value;//是否是vip
    private TextView menuMore;
    private TextView menuEdit;
    private TextView tv_source_value;//来源

    //搜索客户
    private TextView tv_search_type;
    private EditText et_search_input;
    //输入后0.5s去搜索
    private long inputTime = 0;
    private ImageView iv_clear, iv_search;
    private RecyclerView rv_customer;
    private CallSearchCustomAdapter customAdapter;
    private List<SobotCallCustomerModel> customerList;
    private TextView btn_association_cancel;
    private TextView btn_association_save;
    private String searchType = "4";//4:号码，1：客户

    private LinearLayout ll_cusfield;//显示客户自定义字段的布局

    private LinearLayout ll_vip_level;
    private TextView tv_vip_level_value;//客户VIP等级
//    private LinearLayout ll_fuze;//负责人
//    private TextView tv_fuze_value;//负责人
//    private EditText ed_fuze_value;//负责人
    private List<CountryModel> countryList;//所有国家
    private int countryIndex = -1;

    private String tels = "";//所有的手机号码
    private List<CallEncryptTel> encryptTels;//返回的加密号码
    private String emails = "";//所有的邮箱
    LinearLayout ll_add_email;//用来添加用户邮箱的布局
    LinearLayout ll_add_phone;//用来添加用户电话的布局

    private List<CusFieldConfig> cusFieldConfigList;//所有自定义字段
    private List<CusFieldDataInfoList> vipList;//vip的选项
    private LinearLayout ll_edit_menu, ll_menu;
    private TextView btn_cancel;
    private TextView btn_save;
    private LinearLayout ll_more, ll_edit;
    private View v_edit_line, v_show_menu_line;

    private SobotCallCustomerModel customerModel;
    private String provinceName = "";
    private String cityName = "";
    private String areaName = "";
    private String provinceId = "";
    private String cityId = "";
    private String areaId = "";
    //国家名
    private String countryName = "";
    //国家id
    private String countryId = "";
    private String encryptCustomerNumber;
    private String callID = "";//通话id
    private List<SwipeItemDeleteLayout> listEmailView = new ArrayList<>();
    private List<SwipeItemDeleteLayout> listPhoneView = new ArrayList<>();
    private String customerId;
    private String selectCustomerId = "";
    private String customerNick;
    private List<String> sexList;
    private List<String> isVipList;

    //座席信息
    private SobotServiceInfoModel serviceVo;
    private PopupWindow popupWindow;
    private List<SobotActionItem> editItems;
    private List<SobotActionItem> searchItems;

    private String callNumber;
    private int userInfoType = -1;//客户资料点击查看类型 0：新建客户 1客户资料 2关联客户,3编辑，4未关联客户,5关联的客户已失效
    private int olduserInfoType = -1;//客户资料点击查看类型 0：新建客户 1客户资料 2关联客户,3编辑，4未关联客户,5关联的客户已失效
    public static int TYPE_ADD = 0;
    public static int TYPE_EDIT = 3;
    public static int TYPE_SHOW = 1;
    public static int TYPE_RELA = 2;
    public static int TYPE_NO_RELA = 4;
    public static int TYPE_EXPIRE = 5;
    private String fromPage;

    private View ll_no_data;
    private ImageView iv_no_data_icon;
    private TextView tv_no_data_title, tv_no_data_desc, tv_new_custom, tv_relaty_custom;

    private SelectCompanyDialog companyDialog;
    private EnterPriseModel selectCompany;
    private TextView tv_nick,tv_realname,tv_sex,tv_source,tv_phone,tv_email,tv_country,tv_city,tv_company,tv_qq,tv_wx,tv_remark,tv_is_vip,tv_vip_level;
    private View v_nick,v_realname,v_sex,v_source,v_phone,v_email,v_country,v_city,v_company,v_qq,v_wx,v_remark,v_is_vip,v_vip_level;

    private TextView tv_customer_nodata;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        mRootView = inflater.inflate(R.layout.fragment_custom_info, container, false);
        cusFieldConfigList = new ArrayList<>();
        initView();
        return mRootView;
    }

    @Override
    public void setArguments(@Nullable Bundle args) {
        super.setArguments(args);
        customerId = args.getString("customerId", "");
        customerNick = args.getString("customerNick", "");
        callNumber = args.getString("callNumber", "");
        fromPage = args.getString("fromPage", "");
        encryptCustomerNumber = args.getString("encryptCustomerNumber", "");
        callID = args.getString("callID", "");
        userInfoType = args.getInt("userInfoType", -1);
        SobotLogUtils.d("==========userInfoType==" + userInfoType +"=========="+callNumber);
        if (SobotStringUtils.isEmpty(customerId)) {
            if (!TextUtils.isEmpty(fromPage) && "callStatus".equals(fromPage)) {
                if (!TextUtils.isEmpty(callNumber) && userInfoType == 2) {
                    userInfoType = TYPE_RELA;
                } else {
                    //从通话页面过来的，显示新建编辑态
                    userInfoType = TYPE_ADD;
                }
            } else {
                //其他页面过来的显示新建和关联
                userInfoType = TYPE_NO_RELA;
            }
        } else if (userInfoType == 2) {
            userInfoType = TYPE_RELA;
        } else if (userInfoType == 0) {
            userInfoType = TYPE_EDIT;
        } else {
            userInfoType = TYPE_SHOW;
        }
    }

    private void initView() {
        tv_nick = mRootView.findViewById(R.id.tv_nick);
        tv_realname = mRootView.findViewById(R.id.tv_realname);
        tv_sex = mRootView.findViewById(R.id.tv_sex);
        tv_source = mRootView.findViewById(R.id.tv_source);
        tv_phone = mRootView.findViewById(R.id.tv_phone);
        tv_email = mRootView.findViewById(R.id.tv_email);
        tv_country = mRootView.findViewById(R.id.tv_country);
        tv_city = mRootView.findViewById(R.id.tv_city);
        tv_company = mRootView.findViewById(R.id.tv_company);
        tv_qq = mRootView.findViewById(R.id.tv_qq);
        tv_wx = mRootView.findViewById(R.id.tv_wx);
        tv_remark = mRootView.findViewById(R.id.tv_remark);
        tv_is_vip = mRootView.findViewById(R.id.tv_is_vip);
        tv_vip_level = mRootView.findViewById(R.id.tv_vip_level);

        v_nick = mRootView.findViewById(R.id.v_nick);
        v_realname = mRootView.findViewById(R.id.v_realname);
        v_sex = mRootView.findViewById(R.id.v_sex);
        v_source = mRootView.findViewById(R.id.v_source);
        v_phone = mRootView.findViewById(R.id.v_phone);
        v_email = mRootView.findViewById(R.id.v_email);
        v_country = mRootView.findViewById(R.id.v_country);
        v_city = mRootView.findViewById(R.id.v_city);
        v_company = mRootView.findViewById(R.id.v_company);
        v_qq = mRootView.findViewById(R.id.v_qq);
        v_wx = mRootView.findViewById(R.id.v_wx);
        v_remark = mRootView.findViewById(R.id.v_remark);
        v_is_vip = mRootView.findViewById(R.id.v_is_vip);
        v_vip_level = mRootView.findViewById(R.id.v_vip_level);

        ll_no_data = mRootView.findViewById(R.id.ll_no_data);
        iv_no_data_icon = mRootView.findViewById(R.id.iv_no_data_icon);
        tv_no_data_title = mRootView.findViewById(R.id.tv_no_data_title);
        tv_no_data_desc = mRootView.findViewById(R.id.tv_no_data_desc);
        tv_new_custom = mRootView.findViewById(R.id.tv_new_custom);
        tv_relaty_custom = mRootView.findViewById(R.id.tv_relaty_custom);
        tv_new_custom.setOnClickListener(this);
        tv_relaty_custom.setOnClickListener(this);
        if(CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_GLKH)) {
            tv_relaty_custom.setVisibility(View.VISIBLE);
        }else{
            tv_relaty_custom.setVisibility(View.GONE);
        }
        if(CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_XZKH)) {
            tv_new_custom.setVisibility(View.VISIBLE);
        }else{
            tv_new_custom.setVisibility(View.GONE);
        }

//        ed_fuze_value = mRootView.findViewById(R.id.ed_fuze_value);
//        tv_fuze_value = mRootView.findViewById(R.id.tv_fuze_value);
//        ll_fuze = mRootView.findViewById(R.id.ll_fuze);
        ll_more = mRootView.findViewById(R.id.ll_more);
        ll_edit = mRootView.findViewById(R.id.ll_edit);
        v_edit_line = mRootView.findViewById(R.id.v_edit_line);
        ll_search_custom = mRootView.findViewById(R.id.ll_search_custom);
        ll_search = mRootView.findViewById(R.id.ll_search);
        rv_customer = mRootView.findViewById(R.id.rv_customer);
        tv_customer_nodata = mRootView.findViewById(R.id.tv_customer_nodata);
        iv_clear = mRootView.findViewById(R.id.iv_clear);
        tv_search_type = mRootView.findViewById(R.id.tv_search_type);
        et_search_input = mRootView.findViewById(R.id.et_search_input);
        iv_search = mRootView.findViewById(R.id.iv_search);
        btn_association_cancel = mRootView.findViewById(R.id.btn_association_cancel);
        btn_association_save = mRootView.findViewById(R.id.btn_association_save);
        btn_association_cancel.setOnClickListener(this);
        btn_association_save.setOnClickListener(this);
        iv_clear.setOnClickListener(this);
        iv_search.setOnClickListener(this);
        tv_search_type.setOnClickListener(this);
        rv_customer.setLayoutManager(new LinearLayoutManager(getContext()));
        customerList = new ArrayList<>();
        customAdapter = new CallSearchCustomAdapter(getSobotActivity(), customerList, new CallSearchCustomAdapter.OnItemClick() {
            @Override
            public void onItemClick(SobotCallCustomerModel user) {
                selectCustomerId = user.getId();
            }

            @Override
            public void onItemDetail(SobotCallCustomerModel user) {
                showCustomerDetail(user);
            }
        });
        rv_customer.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                if (event.getAction() == MotionEvent.ACTION_MOVE) {
                    et_search_input.clearFocus();
                }
                return false;
            }
        });
        rv_customer.setAdapter(customAdapter);

        et_search_input.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if (hasFocus) {
                    CustomFieldsUtils.showKeyboard(getContext(), et_search_input);
                    ll_search.setBackgroundResource(R.drawable.sobot_call_v6_bg_search_f);
                } else {
                    CustomFieldsUtils.hideKeyboard(getContext(), v);
                    ll_search.setBackgroundResource(R.drawable.sobot_call_v6_bg_search);
                }
            }
        });
        et_search_input.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView textView, int i, KeyEvent keyEvent) {
                if (i == EditorInfo.IME_ACTION_SEARCH) {
                    //搜索
                    searchCustomByType();
                    return true;
                }
                return false;
            }
        });
        et_search_input.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                int inputCount = s.length();
                if (inputCount > 0) {
                    iv_clear.setVisibility(View.VISIBLE);
                } else {
                    iv_clear.setVisibility(View.GONE);
                    if ("4".equals(searchType)) {
                        //搜索历史记录
                        et_search_input.setHint(getString(R.string.sobot_call_search_tip));
                    } else {
                        //搜索客户
                        et_search_input.setHint(getString(R.string.sobot_nickname_hide_string));
                    }
                }
                inputTime = System.currentTimeMillis();
                new Handler().postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        searchCustomByType();
                    }
                }, 500);
            }
        });
        ll_customer = mRootView.findViewById(R.id.ll_customer);
        ll_search_custom.setVisibility(View.GONE);
        tv_edit_custom = (TextView) mRootView.findViewById(R.id.tv_edit_custom);
        btn_cancel = mRootView.findViewById(R.id.btn_cancel);
        ll_edit_menu = mRootView.findViewById(R.id.ll_edit_menu);
        ll_menu = mRootView.findViewById(R.id.ll_menu);
        v_show_menu_line = mRootView.findViewById(R.id.v_show_menu_line);
        btn_save = mRootView.findViewById(R.id.btn_save);
        tv_custom_name = (TextView) mRootView.findViewById(R.id.custom_name);
        tv_nick_value = (TextView) mRootView.findViewById(R.id.work_order_user_nick);
        tv_realname_value = (TextView) mRootView.findViewById(R.id.work_order_user_realname);
        tv_sex_value = (TextView) mRootView.findViewById(R.id.work_order_user_sex);
        ll_sex = mRootView.findViewById(R.id.ll_sex);
        tv_source_value = (TextView) mRootView.findViewById(R.id.work_order_user_source);
        rl_email = mRootView.findViewById(R.id.rl_email);
        tv_email_value = (TextView) mRootView.findViewById(R.id.work_order_user_email);
        tv_phone_value = (TextView) mRootView.findViewById(R.id.work_order_user_tel);
        tv_company_value = (TextView) mRootView.findViewById(R.id.work_order_user_company);
        tv_city_value = (TextView) mRootView.findViewById(R.id.create_work_order_user_city);
        tv_qq_value = (TextView) mRootView.findViewById(R.id.work_order_user_qq);
        tv_wx_value = (TextView) mRootView.findViewById(R.id.work_order_user_wechat);
        ll_cusfield = (LinearLayout) mRootView.findViewById(R.id.work_order_user_cusfield);
        ll_cusfield.setVisibility(View.GONE);

        ll_vip_level = mRootView.findViewById(R.id.ll_vip_level);
        tv_vip_level_value = mRootView.findViewById(R.id.tv_vip_level_value);
        menuMore = mRootView.findViewById(R.id.tv_menu_more);
        menuEdit = mRootView.findViewById(R.id.tv_menu_edit);
        tv_remark_value = mRootView.findViewById(R.id.work_order_user_remark);

        ed_nick_value = mRootView.findViewById(R.id.ed_nick_value);
        tv_nick_must = mRootView.findViewById(R.id.tv_nick_must);
        ed_realname_value = mRootView.findViewById(R.id.ed_realname_value);
        ed_phone_value = mRootView.findViewById(R.id.ed_phone_value);
        iv_copy = mRootView.findViewById(R.id.iv_copy);
        iv_email_copy = mRootView.findViewById(R.id.iv_email_copy);
        iv_phone_add = mRootView.findViewById(R.id.iv_phone_add);
        ed_email_value = mRootView.findViewById(R.id.ed_email_value);
        iv_email_add = mRootView.findViewById(R.id.iv_email_add);
        rl_call_user_country = mRootView.findViewById(R.id.rl_call_user_country);
        tv_country_value = mRootView.findViewById(R.id.tv_country_value);
        ed_qq_value = mRootView.findViewById(R.id.ed_qq_value);
        ed_wx_value = mRootView.findViewById(R.id.ed_wx_value);
        ed_remark_value = mRootView.findViewById(R.id.ed_remark_value);
        ll_isvip = mRootView.findViewById(R.id.ll_isvip);
        tv_is_vip_value = mRootView.findViewById(R.id.tv_is_vip_value);
        ll_add_email = mRootView.findViewById(R.id.ll_add_email);
        ll_add_phone = mRootView.findViewById(R.id.ll_add_phone);
        iv_phone_add.setOnClickListener(this);
        iv_email_add.setOnClickListener(this);

        List<String> list = new ArrayList<>();
        list.add(getContext().getResources().getString(R.string.call_custom_relevance_new));
        list.add(getContext().getResources().getString(R.string.call_custom_relevance));
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(getContext(), R.layout.sobot_pop_search_history, list);//合上的样式
        adapter.setDropDownViewResource(R.layout.sobot_pop_search_history_select);//下拉打开的样式
        SobotActionItem sobot_call_search_number = new SobotActionItem(getResources().getString(R.string.sobot_call_search_number), false);
        SobotActionItem sobot_nickname_string = new SobotActionItem(getResources().getString(R.string.sobot_nickname_string), false);
        SobotActionItem call_custom_relevance_new = new SobotActionItem(getResources().getString(R.string.call_custom_relevance_new), false);
        SobotActionItem call_custom_relevance = new SobotActionItem(getResources().getString(R.string.call_custom_relevance), false);
        editItems = new ArrayList<>();
        if(CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_XZKH)){
            editItems.add(call_custom_relevance_new);
        }
        if(CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_GLKH)) {
            editItems.add(call_custom_relevance);
        }
        searchItems = new ArrayList<>();
        searchItems.add(sobot_call_search_number);
        searchItems.add(sobot_nickname_string);
        menuMore.setOnClickListener(this);
        iv_copy.setOnClickListener(this);
        iv_email_copy.setOnClickListener(this);
        menuEdit.setOnClickListener(this);
        btn_save.setOnClickListener(this);
        btn_cancel.setOnClickListener(this);
        initDate();

        if (!TextUtils.isEmpty(customerNick)) {
            tv_nick_value.setText(customerNick);
        }
    }

    private void requestCusField() {
        zhiChiApi.getCusFieldInfoList(getContext(), 1, new SobotResultCallBack<List<SobotCusFieldEntity>>() {
            @Override
            public void onSuccess(List<SobotCusFieldEntity> cusFieldConfigs) {
                if (null != cusFieldConfigs) {
                    //"operateType": 11,12固定字段，不要放到自定义字段中
                    for (int i = 0; i < cusFieldConfigs.size(); i++) {
                        CusFieldConfig cusFieldConfig = cusFieldConfigs.get(i).getCusFieldConfig();
                        if (cusFieldConfig != null) {
                            if (null != cusFieldConfigs.get(i).getCusFieldDataInfoList()) {
                                cusFieldConfig.setCusFieldDataInfoList(cusFieldConfigs.get(i).getCusFieldDataInfoList());
                            }
                            if (cusFieldConfig.getFieldVariable().equals("countryName")) {
                                rl_call_user_country.setVisibility(View.VISIBLE);
                                requestCountry();
                            }
                            if (cusFieldConfig.getFieldVariable().equals("email")) {
                                rl_email.setVisibility(View.VISIBLE);
                            }
                            if (cusFieldConfig.getFieldVariable().equals("sex")) {
                                ll_sex.setVisibility(View.VISIBLE);
                            }
                            if (cusFieldConfig.getFieldVariable().equals("vipLevel")) {
                                ll_isvip.setVisibility(View.VISIBLE);
                                //vip选项
                                vipList = cusFieldConfigs.get(i).getCusFieldDataInfoList();
                            }

                            //负责人
//                            if(cusFieldConfig.getFieldVariable().equals("liableServiceName")){
//                                ll_fuze.setVisibility(View.VISIBLE);
//                            }
                            if (cusFieldConfig.getOperateType() == 1 ) {
                                cusFieldConfigList.add(cusFieldConfig);
                            }
                        }
                    }
                    if (cusFieldConfigList.size() > 0) {
                        if (customerModel != null && customerModel.getCusList() != null) {
                            Map<String, String> map = customerModel.getCusList();
                            for (int i = 0; i < cusFieldConfigList.size(); i++) {
                                for (int j = 0; j < map.size(); j++) {
                                    String value = map.get(cusFieldConfigList.get(i).getFieldVariable());
                                    if (!TextUtils.isEmpty(value)) {
                                        if (cusFieldConfigList.get(i).getFieldType() < 6) {
                                            cusFieldConfigList.get(i).setFieldValue(value);
                                        } else {
                                            try {
                                                JSONObject object = new JSONObject(value);
                                                String id = object.optString("id");
                                                String value1 = object.optString("value");
                                                cusFieldConfigList.get(i).setFieldText(value1);
                                                cusFieldConfigList.get(i).setFieldValue(id);
                                            } catch (JSONException e) {
                                                throw new RuntimeException(e);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        //设置自定义字段
                        if (userInfoType == TYPE_ADD || userInfoType == TYPE_EDIT) {
                            CustomFieldsUtils.addWorkOrderUserCusFields(getSobotActivity(), cusFieldConfigList, ll_cusfield);
                        } else {
                            CustomFieldsUtils.showCusFields(getSobotActivity(), cusFieldConfigList, ll_cusfield);
                        }
                    }
                }
            }

            @Override
            public void onFailure(Exception e, String des) {

            }
        });
    }

    private void initDate() {
        serviceVo = SobotLoginTools.getInstance().getServiceInfo();
        if (serviceVo == null) {
            getSobotActivity().finish();
        }
        sexList = new ArrayList<>();
        isVipList = new ArrayList<>();
        countryList = new ArrayList<>();
        sexList.add(getResources().getString(R.string.call_custom_male));
        sexList.add(getResources().getString(R.string.call_custom_female));
        isVipList.add(getResources().getString(R.string.call_ordinary_customer));
        isVipList.add(getResources().getString(R.string.call_vip_customer));
        if (serviceVo.getRegion() == 1) {
            //国外的账户，显示国家
            rl_call_user_country.setVisibility(View.VISIBLE);
            requestCountry();
        } else {
            rl_call_user_country.setVisibility(View.GONE);
        }
        if (!TextUtils.isEmpty(customerId)) {
            searchCustomById();
        } else {
            requestCusField();
        }
        if (!TextUtils.isEmpty(callNumber)) {
            ed_phone_value.setText(callNumber);
        }
        showView();
    }

    /**
     * 判断显示的view:新建、编辑、查看、关联
     */
    private void showView() {
        if (userInfoType == TYPE_ADD) {
            //新建用户
            ll_no_data.setVisibility(View.GONE);
            updateUI(true);
        } else if (userInfoType == TYPE_EDIT) {
            ll_no_data.setVisibility(View.GONE);
            updateUI(true);
        } else if (userInfoType == TYPE_SHOW) {
            ll_no_data.setVisibility(View.GONE);
            //查看用户
            updateUI(false);
        } else if (userInfoType == TYPE_RELA) {
            ll_no_data.setVisibility(View.GONE);
            //关联用户
            showRelevanceView();
            if (!TextUtils.isEmpty(callNumber)) {
                //号码搜索
                et_search_input.setText(callNumber);
                searchType = "4";
                searchCustomByType();
            } else if (customerModel != null && !TextUtils.isEmpty(customerModel.getTel())) {
                et_search_input.setText(customerModel.getTel());
                searchType = "4";
                searchCustomByType();
            }
        } else if (userInfoType == TYPE_NO_RELA) {
            //未关联客户
            ll_no_data.setVisibility(View.VISIBLE);
            iv_no_data_icon.setImageResource(R.drawable.call_custom_no_data);
            tv_no_data_title.setText(R.string.sobot_custom_no_data);
            tv_no_data_desc.setVisibility(View.GONE);
        } else if (userInfoType == TYPE_EXPIRE) {
            //关联客户已失效
            ll_edit_menu.setVisibility(View.GONE);
            ll_no_data.setVisibility(View.VISIBLE);
            iv_no_data_icon.setImageResource(R.drawable.call_custom_expire);
            tv_no_data_title.setText(R.string.sobot_custom_expired);
            tv_no_data_desc.setVisibility(View.VISIBLE);
            tv_no_data_desc.setText(R.string.sobot_custom_expired_reason);
        }
    }

    private void updateUI(boolean isEdit) {
        if (isEdit) {
            if (userInfoType == TYPE_ADD) {
                //新建用户
                tv_edit_custom.setText(getResources().getString(R.string.call_str_new_customer));
                tv_source_value.setText(R.string.sobot_call_center);
            } else if (userInfoType == TYPE_EDIT) {
                btn_cancel.setVisibility(View.VISIBLE);
                tv_edit_custom.setText(getResources().getString(R.string.sobot_edit_user_string));
            }
            tv_nick_must.setVisibility(View.VISIBLE);
            if (customerModel == null) {
                if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_XZKH)) {
                    //新建客户
                    btn_save.setVisibility(View.VISIBLE);
                } else {
                    btn_save.setVisibility(View.GONE);
                }
            } else {
                if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_BJKH)) {
                    //编辑客户
                    btn_save.setVisibility(View.VISIBLE);
                } else {
                    btn_save.setVisibility(View.GONE);
                }
            }
            if (TextUtils.isEmpty(countryId)) {
                tv_country_value.setText("");
            }
            if (TextUtils.isEmpty(provinceId) && TextUtils.isEmpty(cityId) && TextUtils.isEmpty(areaId)) {
                tv_city_value.setText("");
            }
//            ed_fuze_value.setVisibility(View.VISIBLE);
//            tv_fuze_value.setVisibility(View.GONE);
            tv_edit_custom.setVisibility(View.VISIBLE);
            tv_custom_name.setVisibility(View.GONE);
            ll_edit_menu.setVisibility(View.VISIBLE);
            ll_menu.setVisibility(View.GONE);
            v_show_menu_line.setVisibility(View.GONE);
            ed_nick_value.setVisibility(View.VISIBLE);
            tv_nick_value.setVisibility(View.GONE);
            ed_realname_value.setVisibility(View.VISIBLE);
            tv_realname_value.setVisibility(View.GONE);
            Drawable drawable = getResources().getDrawable(R.drawable.call_item_arrow);
            drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
            tv_phone_value.setVisibility(View.GONE);
            ed_phone_value.setVisibility(View.VISIBLE);
            ll_add_phone.removeAllViews();
            listPhoneView.clear();
            String[] tmpUserPhone = null;
            if (!TextUtils.isEmpty(tels)) {
                tmpUserPhone = tels.split(";");
            }
            if (tmpUserPhone != null && tmpUserPhone.length > 0) {
                for (int i = 1; i < tmpUserPhone.length; i++) {
                    addUserPhone(tmpUserPhone[i]);
                }
            }
            iv_copy.setVisibility(View.GONE);
            iv_email_copy.setVisibility(View.GONE);
            iv_phone_add.setVisibility(View.VISIBLE);
            tv_email_value.setVisibility(View.GONE);
            ed_email_value.setVisibility(View.VISIBLE);
            ll_add_email.removeAllViews();
            listEmailView.clear();
            String[] tmpUserEmail = null;
            if (!TextUtils.isEmpty(emails)) {
                tmpUserEmail = emails.split(";");
            }
            if (tmpUserEmail != null && tmpUserEmail.length > 1) {
                for (int i = 1; i < tmpUserEmail.length; i++) {
                    addUserEmail(tmpUserEmail[i]);
                }
            }
            if (selectCompany != null && !TextUtils.isEmpty(selectCompany.getEnterpriseName())) {
                tv_company_value.setText(selectCompany.getEnterpriseName());
            } else {
                tv_company_value.setText("");
            }
            if (tv_sex_value.getTag() == null) {
                tv_sex_value.setText("");
            }
            if (null!=customerModel&&"1".equals(customerModel.getIsVip())) {
                tv_is_vip_value.setText(R.string.call_vip_customer);
                if(vipList!=null && vipList.size()>0){
                    ll_vip_level.setVisibility(View.VISIBLE);
                }else{
                    ll_vip_level.setVisibility(View.GONE);
                }
            }else{
                tv_is_vip_value.setText(R.string.call_ordinary_customer);
            }
            iv_email_add.setVisibility(View.VISIBLE);
            tv_sex_value.setCompoundDrawables(null, null, drawable, null);
            tv_company_value.setCompoundDrawables(null, null, drawable, null);
            tv_is_vip_value.setCompoundDrawables(null, null, drawable, null);
            tv_vip_level_value.setCompoundDrawables(null, null, drawable, null);
            tv_country_value.setCompoundDrawables(null, null, drawable, null);
            tv_city_value.setCompoundDrawables(null, null, drawable, null);
            tv_qq_value.setVisibility(View.GONE);
            ed_qq_value.setVisibility(View.VISIBLE);
            tv_wx_value.setVisibility(View.GONE);
            ed_wx_value.setVisibility(View.VISIBLE);
            tv_remark_value.setVisibility(View.GONE);
            ed_remark_value.setVisibility(View.VISIBLE);
            tv_sex_value.setOnClickListener(this);
            tv_company_value.setOnClickListener(this);
            tv_is_vip_value.setOnClickListener(this);
            tv_country_value.setOnClickListener(this);
            tv_city_value.setOnClickListener(this);
            tv_vip_level_value.setOnClickListener(this);
            if (cusFieldConfigList != null && cusFieldConfigList.size() > 0) {
                CustomFieldsUtils.addWorkOrderUserCusFields(getSobotActivity(), cusFieldConfigList, ll_cusfield);
            }
            ll_add_email.setVisibility(View.VISIBLE);
            ll_add_phone.setVisibility(View.VISIBLE);
            tv_nick.setTypeface(null, Typeface.BOLD);
            tv_realname.setTypeface(null, Typeface.BOLD);
            tv_sex.setTypeface(null, Typeface.BOLD);
            tv_source.setTypeface(null, Typeface.BOLD);
            tv_phone.setTypeface(null, Typeface.BOLD);
            tv_email.setTypeface(null, Typeface.BOLD);
            tv_country.setTypeface(null, Typeface.BOLD);
            tv_city.setTypeface(null, Typeface.BOLD);
            tv_company.setTypeface(null, Typeface.BOLD);
            tv_qq.setTypeface(null, Typeface.BOLD);
            tv_wx.setTypeface(null, Typeface.BOLD);
            tv_remark.setTypeface(null, Typeface.BOLD);
            tv_is_vip.setTypeface(null, Typeface.BOLD);
            tv_vip_level.setTypeface(null, Typeface.BOLD);
            tv_nick.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_realname.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_sex.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_source.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_phone.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_email.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_country.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_city.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_company.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_qq.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_wx.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_remark.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_is_vip.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            tv_vip_level.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
            v_nick.setVisibility(View.VISIBLE);
            v_realname.setVisibility(View.VISIBLE);
            v_sex.setVisibility(View.VISIBLE);
            v_source.setVisibility(View.VISIBLE);
            v_phone.setVisibility(View.VISIBLE);
            v_email.setVisibility(View.VISIBLE);
            v_country.setVisibility(View.VISIBLE);
            v_city.setVisibility(View.VISIBLE);
            v_company.setVisibility(View.VISIBLE);
            v_qq.setVisibility(View.VISIBLE);
            v_wx.setVisibility(View.VISIBLE);
            v_remark.setVisibility(View.VISIBLE);
            v_is_vip.setVisibility(View.VISIBLE);
            v_vip_level.setVisibility(View.VISIBLE);
        } else {
            tv_vip_level.setTypeface(null, Typeface.NORMAL);
            ll_add_email.setVisibility(View.GONE);
            ll_add_phone.setVisibility(View.GONE);
            if (cusFieldConfigList != null && cusFieldConfigList.size() > 0) {
                CustomFieldsUtils.showCusFields(getSobotActivity(), cusFieldConfigList, ll_cusfield);
            }
            if (TextUtils.isEmpty(countryId)) {
                tv_country_value.setText("--");
            }
            if (TextUtils.isEmpty(provinceId) && TextUtils.isEmpty(cityId) && TextUtils.isEmpty(areaId)) {
                tv_city_value.setText("--");
            }
            if (selectCompany != null && !TextUtils.isEmpty(selectCompany.getEnterpriseName())) {
                tv_company_value.setText(selectCompany.getEnterpriseName());
            } else {
                tv_company_value.setText("--");
            }
            tv_nick_must.setVisibility(View.GONE);
            if (tv_sex_value.getTag() == null) {
                tv_sex_value.setText("--");
            }
            if (null!=customerModel&&"1".equals(customerModel.getIsVip())) {
                tv_is_vip_value.setText(R.string.call_vip_customer);
                if(SobotStringUtils.isEmpty(tv_vip_level_value.getText().toString())){
                    ll_vip_level.setVisibility(View.GONE);
                }else{
                    ll_vip_level.setVisibility(View.VISIBLE);
                }
            }else{
                tv_is_vip_value.setText(R.string.call_ordinary_customer);
            }
//            ed_fuze_value.setVisibility(View.GONE);
//            tv_fuze_value.setVisibility(View.VISIBLE);
            tv_edit_custom.setVisibility(View.GONE);
            tv_custom_name.setVisibility(View.VISIBLE);
            ll_edit_menu.setVisibility(View.GONE);
            ll_menu.setVisibility(View.VISIBLE);
            v_show_menu_line.setVisibility(View.VISIBLE);
            ed_nick_value.setVisibility(View.GONE);
            tv_nick_value.setVisibility(View.VISIBLE);
            ed_realname_value.setVisibility(View.GONE);
            tv_realname_value.setVisibility(View.VISIBLE);
            tv_sex_value.setCompoundDrawables(null, null, null, null);
            tv_phone_value.setVisibility(View.VISIBLE);
            ed_phone_value.setVisibility(View.GONE);
            ll_add_phone.removeAllViews();
            String[] tmpUserPhone = null;
            if (!TextUtils.isEmpty(tels)) {
                tmpUserPhone = tels.split(";");
            }
            if (tmpUserPhone != null && tmpUserPhone.length > 0) {
                for (int i = 1; i < tmpUserPhone.length; i++) {
                    addUserPhoneView(tmpUserPhone[i]);
                }
            }
            iv_copy.setVisibility(View.VISIBLE);
            iv_email_copy.setVisibility(View.VISIBLE);
            iv_phone_add.setVisibility(View.GONE);
            tv_email_value.setVisibility(View.VISIBLE);
            ed_email_value.setVisibility(View.GONE);
            ll_add_email.removeAllViews();
            String[] tmpUserEmail = null;
            if (!TextUtils.isEmpty(emails)) {
                tmpUserEmail = emails.split(";");
            }else{
                iv_email_copy.setVisibility(View.GONE);
            }
            if (tmpUserEmail != null && tmpUserEmail.length > 1) {
                for (int i = 1; i < tmpUserEmail.length; i++) {
                    addUserEmailView(tmpUserEmail[i]);
                }
            }
            iv_email_add.setVisibility(View.GONE);
            tv_company_value.setCompoundDrawables(null, null, null, null);
            tv_source_value.setCompoundDrawables(null, null, null, null);
            tv_is_vip_value.setCompoundDrawables(null, null, null, null);
            tv_country_value.setCompoundDrawables(null, null, null, null);
            tv_city_value.setCompoundDrawables(null, null, null, null);
            tv_qq_value.setVisibility(View.VISIBLE);
            ed_qq_value.setVisibility(View.GONE);
            tv_wx_value.setVisibility(View.VISIBLE);
            ed_wx_value.setVisibility(View.GONE);
            tv_remark_value.setVisibility(View.VISIBLE);
            ed_remark_value.setVisibility(View.GONE);
            tv_sex_value.setOnClickListener(null);
            tv_company_value.setOnClickListener(null);
            tv_is_vip_value.setOnClickListener(null);
            tv_country_value.setOnClickListener(null);
            tv_city_value.setOnClickListener(null);
            tv_vip_level_value.setOnClickListener(null);
//
//           新增客户、关联客户和编辑客户权限
            if ((CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_XZKH)||CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_GLKH)) && CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_BJKH)) {
                ll_menu.setVisibility(View.VISIBLE);
                v_show_menu_line.setVisibility(View.VISIBLE);
                ll_edit.setVisibility(View.VISIBLE);
                ll_more.setVisibility(View.VISIBLE);
                v_edit_line.setVisibility(View.VISIBLE);
            } else if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_XZKH)||CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_GLKH)) {
                ll_menu.setVisibility(View.VISIBLE);
                v_show_menu_line.setVisibility(View.VISIBLE);
                ll_edit.setVisibility(View.GONE);
                ll_more.setVisibility(View.VISIBLE);
                v_edit_line.setVisibility(View.GONE);
            } else if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_BJKH)) {
                ll_menu.setVisibility(View.VISIBLE);
                v_show_menu_line.setVisibility(View.VISIBLE);
                ll_edit.setVisibility(View.VISIBLE);
                ll_more.setVisibility(View.GONE);
                v_edit_line.setVisibility(View.GONE);
            } else {
                ll_menu.setVisibility(View.GONE);
                v_show_menu_line.setVisibility(View.GONE);
            }

            tv_nick.setTypeface(null, Typeface.NORMAL);
            tv_realname.setTypeface(null, Typeface.NORMAL);
            tv_sex.setTypeface(null, Typeface.NORMAL);
            tv_source.setTypeface(null, Typeface.NORMAL);
            tv_phone.setTypeface(null, Typeface.NORMAL);
            tv_email.setTypeface(null, Typeface.NORMAL);
            tv_country.setTypeface(null, Typeface.NORMAL);
            tv_city.setTypeface(null, Typeface.NORMAL);
            tv_company.setTypeface(null, Typeface.NORMAL);
            tv_qq.setTypeface(null, Typeface.NORMAL);
            tv_wx.setTypeface(null, Typeface.NORMAL);
            tv_remark.setTypeface(null, Typeface.NORMAL);
            tv_is_vip.setTypeface(null, Typeface.NORMAL);
            tv_vip_level.setTypeface(null, Typeface.NORMAL);
            tv_nick.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_realname.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_sex.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_source.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_phone.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_email.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_country.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_city.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_company.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_qq.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_wx.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_remark.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_is_vip.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_vip_level.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            v_nick.setVisibility(View.GONE);
            v_realname.setVisibility(View.GONE);
            v_sex.setVisibility(View.GONE);
            v_source.setVisibility(View.GONE);
            v_phone.setVisibility(View.GONE);
            v_email.setVisibility(View.GONE);
            v_country.setVisibility(View.GONE);
            v_city.setVisibility(View.GONE);
            v_company.setVisibility(View.GONE);
            v_qq.setVisibility(View.GONE);
            v_wx.setVisibility(View.GONE);
            v_remark.setVisibility(View.GONE);
            v_is_vip.setVisibility(View.GONE);
            v_vip_level.setVisibility(View.GONE);

        }
    }

    //显示关联用户
    private void showRelevanceView() {
        tv_edit_custom.setText(getResources().getString(R.string.call_choice_relevance));
        tv_edit_custom.setVisibility(View.VISIBLE);
        tv_custom_name.setVisibility(View.GONE);
        ll_customer.setVisibility(View.GONE);
        ll_menu.setVisibility(View.GONE);
        v_show_menu_line.setVisibility(View.GONE);
        ll_search_custom.setVisibility(View.VISIBLE);
        if(CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_GLKH)) {
            btn_association_save.setVisibility(View.VISIBLE);
        } else {
            btn_association_save.setVisibility(View.GONE);
        }
    }

    //显示查看用户
    private void showCustomerView() {
        new Handler().post(new Runnable() {
            @Override
            public void run() {
                if (userInfoType == TYPE_ADD) {
                    tv_edit_custom.setText(getContext().getResources().getString(R.string.sobot_edit_user_string));
                } else {
                    tv_edit_custom.setText(getContext().getResources().getString(R.string.call_str_new_customer));
                }
                tv_edit_custom.setVisibility(View.GONE);
                tv_custom_name.setVisibility(View.VISIBLE);
                ll_customer.setVisibility(View.VISIBLE);
                ll_menu.setVisibility(View.VISIBLE);
                v_show_menu_line.setVisibility(View.VISIBLE);
                ll_search_custom.setVisibility(View.GONE);
            }
        });

    }

    private void requestAssociationCustom(boolean isUpdate) {
        zhiChiApi.associationCustom(getSobotActivity(), callID, selectCustomerId, new SobotResultCallBack() {
            @Override
            public void onSuccess(Object o) {
                SobotToastUtil.showToast(getSobotActivity(), getSobotActivity().getResources().getString(R.string.sobot_call_relateve_success));
                if (isUpdate) {
                    //返回后刷新通话记录
                    getSobotActivity().setResult(SobotCallConstant.ACTIVITY_RESULT_DETAIL);
                    showCustomerView();
                    customerId = selectCustomerId;
                    searchCustomById();
                }
            }

            @Override
            public void onFailure(Exception e, String des) {
                if (!TextUtils.isEmpty(des)) {
                    Toast.makeText(getContext(), des, Toast.LENGTH_SHORT).show();
                }
            }
        });
    }

    private void initCustomer() {
        if (customerModel != null) {
            tv_custom_name.setText(getText(customerModel.getNick()));
            tv_nick_value.setText(getText(customerModel.getNick()));
            ed_nick_value.setText(getText(customerModel.getNick()));
            tv_realname_value.setText(getText(customerModel.getUname()));
            ed_realname_value.setText(customerModel.getUname());
            tv_source_value.setText(setSourceText(customerModel.getSource()));
            tv_source_value.setTag(customerModel.getSource());

            String[] tmpUserPhone = null;
            if (!TextUtils.isEmpty(customerModel.getTel())) {
                tels = customerModel.getTel();
                tmpUserPhone = customerModel.getTel().split(";");
                tv_phone_value.setText(customerModel.getTel());
            } else {
                tv_phone_value.setText("--");
            }

            if (tmpUserPhone != null && tmpUserPhone.length > 0) {
                ll_add_phone.removeAllViews();
                ed_phone_value.setText(tmpUserPhone[0]);
                if (tmpUserPhone.length > 1) {
                    for (int i = 1; i < tmpUserPhone.length; i++) {
                        addUserPhoneView(tmpUserPhone[i]);
                    }
                }
            }
            if (customerModel.getTelList() != null && customerModel.getTelList().size() > 0) {
                encryptTels = customerModel.getTelList();
            }
            String[] tmpUserEmail = null;
            if (!TextUtils.isEmpty(customerModel.getEmail())) {
                emails = customerModel.getEmail();
                tmpUserEmail = customerModel.getEmail().split(";");
                tv_email_value.setText(customerModel.getEmail());
                if(userInfoType == TYPE_SHOW){
                    iv_email_copy.setVisibility(View.VISIBLE);
                }
            } else {
                tv_email_value.setText("--");
                iv_email_copy.setVisibility(View.GONE);
            }
            if (tmpUserEmail != null && tmpUserEmail.length > 0) {
                ed_email_value.setText(tmpUserEmail[0]);
                ll_add_email.removeAllViews();
                if (tmpUserEmail.length > 1) {
                    for (int i = 1; i < tmpUserEmail.length; i++) {
                        addUserEmailView(tmpUserEmail[i]);
                    }
                }
            }

            tv_country_value.setText(getText(customerModel.getCountryName()));
            if (!TextUtils.isEmpty(customerModel.getCountryName())) {
                countryName = customerModel.getCountryName();
                countryId = customerModel.getCountryId();
                tv_country_value.setTag(customerModel.getCountryId());
            }

            if (!TextUtils.isEmpty(customerModel.getProviceName())) {
                provinceName = customerModel.getProviceName();
                provinceId = customerModel.getProviceId();
            }
            if (!TextUtils.isEmpty(customerModel.getCityName())) {
                cityName = customerModel.getCityName();
                cityId = customerModel.getCityId();
            }
            if (!TextUtils.isEmpty(customerModel.getAreaName())) {
                areaName = customerModel.getAreaName();
                areaId = customerModel.getAreaId();
            }
            String city = provinceName;
            if(!TextUtils.isEmpty(cityName)){
                city = provinceName+ "-" + cityName + "-" + areaName;
            }
            tv_city_value.setText(city);

            if (!TextUtils.isEmpty(customerModel.getEnterpriseId())) {
                if (selectCompany == null) {
                    selectCompany = new EnterPriseModel();
                }
                selectCompany.setEnterpriseId(customerModel.getEnterpriseId());
                selectCompany.setEnterpriseName(customerModel.getEnterpriseName());
            }
            tv_company_value.setText(getText(customerModel.getEnterpriseName()));

            //QQ
            tv_qq_value.setText(getText(customerModel.getQq()));
            if (!TextUtils.isEmpty(customerModel.getQq())) {
                ed_qq_value.setText(customerModel.getQq());
            }

            //负责人
//            if (!TextUtils.isEmpty(customerModel.getPartnerId())) {
//                tv_fuze_value.setText(customerModel.getPartnerId());
//                ed_fuze_value.setText(customerModel.getPartnerId());
//            } else {
//                tv_fuze_value.setText("--");
//                ed_fuze_value.setText("");
//            }
            if ("1".equals(customerModel.getIsVip())) {
                tv_is_vip_value.setText(R.string.call_vip_customer);
                if( null!=vipList && vipList.size()>0){
                    ll_vip_level.setVisibility(View.VISIBLE);
                }
                if (!TextUtils.isEmpty(customerModel.getVipLevel())) {
                    try {
                        JSONObject vipLevel = new JSONObject(customerModel.getVipLevel());
                        String id = vipLevel.optString("id", "");
                        String value = vipLevel.optString("value", "");
                        if (!TextUtils.isEmpty(value)) {
                            tv_vip_level_value.setText(value);
                            tv_vip_level_value.setTag(id);
                            ll_vip_level.setVisibility(View.VISIBLE);
                        }
                    } catch (JSONException e) {
                        throw new RuntimeException(e);
                    }

                } else if (!TextUtils.isEmpty(customerModel.getVipLevelName())) {
                    tv_vip_level_value.setText(customerModel.getVipLevelName());
                    tv_vip_level_value.setTag(customerModel.getVipLevel());
                }
            } else {
                ll_vip_level.setVisibility(View.GONE);
                tv_is_vip_value.setText(R.string.call_ordinary_customer);
            }
            //微信
            if (!TextUtils.isEmpty(customerModel.getWx())) {
                ed_wx_value.setText(customerModel.getWx());
            }
            tv_wx_value.setText(getText(customerModel.getWx()));
            //性别
            if (1 == customerModel.getSex()) {
                tv_sex_value.setText(R.string.call_custom_male);
                tv_sex_value.setTag(customerModel.getSex());
            } else if (2 == customerModel.getSex()) {
                tv_sex_value.setText(R.string.call_custom_female);
                tv_sex_value.setTag(customerModel.getSex());
            } else {
                tv_sex_value.setText("--");
            }
            tv_remark_value.setText(getText(customerModel.getRemark()));
            ed_remark_value.setText(customerModel.getRemark());
        } else {
            tv_custom_name.setText("--");
            tv_nick_value.setText("--");
            tv_realname_value.setText("--");
            tv_source_value.setText(R.string.sobot_call_center);
            tv_company_value.setText("--");
            tv_qq_value.setText("--");
            tv_wx_value.setText("--");
            tv_remark_value.setText(customerModel.getRemark());
        }
    }

    private String getText(String text) {
        return TextUtils.isEmpty(text) ? "--" : text;
    }

    /**
     * 查询客户
     */
    private void searchCustomById() {
        zhiChiApi.searchCustomById(getSobotActivity(), customerId, new SobotResultCallBack<SobotCallCustomerModel>() {
            @Override
            public void onSuccess(SobotCallCustomerModel sobotCallCustomerModel) {
                if (sobotCallCustomerModel != null && !TextUtils.isEmpty(sobotCallCustomerModel.getId())) {
                    customerModel = sobotCallCustomerModel;
                    initCustomer();
                } else {
                    userInfoType = TYPE_EXPIRE;
                    showView();
                }
                requestCusField();
            }

            @Override
            public void onFailure(Exception e, String des) {

            }
        });
    }


    /**
     * 添加邮箱
     *
     * @param userEmail
     */
    private void addUserEmail(String userEmail) {
        if (listEmailView.size() >= 9) {
            return;
        }

        if (listEmailView != null && listEmailView.size() > 0) {
            if (TextUtils.isEmpty(listEmailView.get(listEmailView.size() - 1).getEdittext_add_user_info().getText())) {
                return;
            }
        }

        final SwipeItemDeleteLayout view = (SwipeItemDeleteLayout) View.inflate(getSobotActivity(), R.layout.call_item_swipe, null);
        listEmailView.add(view);
        view.getEdittext_add_user_info().setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                view.close();
            }
        });
        view.getEdittext_add_user_info().setHint(getString(R.string.call_input_hint));
        view.getTextView_delete().setText(getString(R.string.sobot_call_delete));
        view.getEdittext_add_user_info().requestFocus();
        if (!TextUtils.isEmpty(userEmail)) {
            view.getEdittext_add_user_info().setText(userEmail);
        }

        view.setOnMenuClickListener(new SwipeItemDeleteLayout.OnMenuClickListener() {
            @Override
            public void onDeleteClick(View v, SwipeItemDeleteLayout swipeItemDeleteLayout) {
                ll_add_email.removeView(swipeItemDeleteLayout);
                listEmailView.remove(swipeItemDeleteLayout);
                if (listEmailView.size() == 0) {
                }
            }
        });

        view.setOnMenuDelClickListener(new SwipeItemDeleteLayout.OnMenuDelClickListener() {
            @Override
            public void onImgDelClick(SwipeItemDeleteLayout swipeItemDeleteLayout) {
                if (listPhoneView != null && listPhoneView.size() > 0) {
                    for (int i = 0; i < listPhoneView.size(); i++) {
                        listPhoneView.get(i).close();
                    }
                }

                if (listEmailView != null && listEmailView.size() > 0) {
                    for (int i = 0; i < listEmailView.size(); i++) {
                        if (swipeItemDeleteLayout != listEmailView.get(i)) {
                            listEmailView.get(i).close();
                        }
                    }
                }
            }
        });

        ll_add_email.addView(view);
    }

    /**
     * 显示邮箱
     *
     * @param userEmail
     */
    private void addUserEmailView(String userEmail) {
        if (TextUtils.isEmpty(userEmail)) {
            return;
        }
        View view = View.inflate(getSobotActivity(), R.layout.call_item_swipe_copy, null);
        TextView tv = view.findViewById(R.id.tv_add_user_info);
        tv.setText(userEmail);
        ImageView iv_copy = view.findViewById(R.id.iv_copy);
        iv_copy.setVisibility(View.VISIBLE);
        iv_copy.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                copyStr(userEmail);
            }
        });
        ll_add_email.addView(view);
    }

    public void addUserPhone(String userPhone) {
        if (listPhoneView.size() >= 9) {
            return;
        }

        if (listPhoneView != null && listPhoneView.size() > 0) {
            if (TextUtils.isEmpty(listPhoneView.get(listPhoneView.size() - 1).getEdittext_add_user_info().getText())) {
                return;
            }
        }

        final SwipeItemDeleteLayout view = (SwipeItemDeleteLayout) View.inflate(getSobotActivity(), R.layout.call_item_swipe, null);
        listPhoneView.add(view);
        view.getTextView_delete().setText(getString(R.string.sobot_call_delete));
        view.getEdittext_add_user_info().setHint(getString(R.string.call_input_hint));
        view.getEdittext_add_user_info().setInputType(EditorInfo.TYPE_CLASS_NUMBER);
        view.getEdittext_add_user_info().setFilters(new InputFilter[]{new InputFilter.LengthFilter(11)});//
        if (!TextUtils.isEmpty(userPhone)) {
            view.getEdittext_add_user_info().setTag(userPhone);
            view.getEdittext_add_user_info().setText(userPhone);
        }

        view.setOnMenuClickListener(new SwipeItemDeleteLayout.OnMenuClickListener() {
            @Override
            public void onDeleteClick(View v, SwipeItemDeleteLayout swipeItemDeleteLayout) {
                ll_add_phone.removeView(swipeItemDeleteLayout);
                listPhoneView.remove(swipeItemDeleteLayout);
                if (listPhoneView.size() == 0) {
                }
            }
        });

        view.setOnMenuDelClickListener(new SwipeItemDeleteLayout.OnMenuDelClickListener() {
            @Override
            public void onImgDelClick(SwipeItemDeleteLayout swipeItemDeleteLayout) {
                if (listEmailView != null && listEmailView.size() > 0) {
                    for (int i = 0; i < listEmailView.size(); i++) {
                        listEmailView.get(i).close();
                    }
                }

                if (listPhoneView != null && listPhoneView.size() > 0) {
                    for (int i = 0; i < listPhoneView.size(); i++) {
                        if (swipeItemDeleteLayout != listPhoneView.get(i)) {
                            listPhoneView.get(i).close();
                        }
                    }
                }
            }
        });

        ll_add_phone.addView(view);
    }

    public void addUserPhoneView(String userPhone) {
        if (TextUtils.isEmpty(userPhone)) {
            return;
        }
        View view = View.inflate(getSobotActivity(), R.layout.call_item_swipe_copy, null);
        TextView tv = view.findViewById(R.id.tv_add_user_info);
        tv.setText(userPhone);
        ImageView iv_copy = view.findViewById(R.id.iv_copy);
        iv_copy.setVisibility(View.VISIBLE);
        iv_copy.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                copyStr(userPhone);
            }
        });
        ll_add_phone.addView(view);
    }

    @Override
    public void onClick(View v) {
        if (v == iv_clear) {
            et_search_input.setText("");
        } else if (v == tv_relaty_custom) {
            olduserInfoType = userInfoType;
            userInfoType = TYPE_RELA;
            showView();
        } else if (v == tv_new_custom) {
            userInfoType = TYPE_ADD;
            showView();
        } else if (v == iv_email_add) {
            addUserEmail("");
        } else if (v == iv_phone_add) {
            addUserPhone("");
        } else if (v == tv_search_type) {
            //pop
            if ("4".equals(searchType)) {
                searchItems.get(0).setChecked(true);
                searchItems.get(1).setChecked(false);
            } else {
                searchItems.get(0).setChecked(false);
                searchItems.get(1).setChecked(true);
            }
            SobotMoreMenuPop pop = new SobotMoreMenuPop(getSobotActivity(), searchItems, false, true, new SobotMoreMenuPop.PopItemClick() {
                @Override
                public void onPopItemClick(SobotActionItem item, int index) {
                    popupWindow.dismiss();
                    //4:号码，1：客户
                    if (index == 0) {
                        searchType = "4";
                        tv_search_type.setText(getResources().getString(R.string.sobot_call_search_number));
                        et_search_input.setHint(getResources().getString(R.string.sobot_call_search_tip));
                    } else {
                        searchType = "1";
                        tv_search_type.setText(getResources().getString(R.string.sobot_nickname_string));
                        et_search_input.setHint(getResources().getString(R.string.sobot_nickname_hide_string));
                    }
                }
            });

            popupWindow = pop.getPopWindow();
            //弹窗出现外部为阴影
            WindowManager.LayoutParams attributes = getActivity().getWindow().getAttributes();
            attributes.alpha = 1f;
            getActivity().getWindow().setAttributes(attributes);
            //弹窗取消监听 取消之后恢复阴影
            popupWindow.setOnDismissListener(new PopupWindow.OnDismissListener() {
                @Override
                public void onDismiss() {
                    WindowManager.LayoutParams attributes = getActivity().getWindow().getAttributes();
                    attributes.alpha = 1;
                    getActivity().getWindow().setAttributes(attributes);
                }
            });
            int offsetY = -(SobotDensityUtil.dp2px(getSobotActivity(), 56 * 2) + ll_menu.getHeight());
            popupWindow.showAsDropDown(ll_search, 0, 0);
        } else if (v == iv_search) {
            //搜索
            iv_search.requestFocus();
            searchCustomByType();
        } else if (v == btn_association_cancel) {
            CustomFieldsUtils.hideKeyboard(getContext(), et_search_input);
            if (olduserInfoType > 0) {
                userInfoType = olduserInfoType;
                showView();
            } else {
                showCustomerView();
            }
        } else if (v == btn_association_save) {
            if (!TextUtils.isEmpty(selectCustomerId)) {
                requestAssociationCustom(true);
            }

        } else if (menuEdit == v) {
            userInfoType = TYPE_EDIT;
            updateUI(true);
        } else if (menuMore == v) {
            //弹框
            SobotMoreMenuPop pop = new SobotMoreMenuPop(getSobotActivity(), editItems, new SobotMoreMenuPop.PopItemClick() {
                @Override
                public void onPopItemClick(SobotActionItem item, int index) {
                    popupWindow.dismiss();
                    if (index == 0) {
                        userInfoType = TYPE_ADD;
                        showView();
                    } else {
                        //关联用户
                        userInfoType = TYPE_RELA;
                        showView();
                    }
                }
            });
            popupWindow = pop.getPopWindow();
            //弹窗出现外部为阴影
            WindowManager.LayoutParams attributes = getActivity().getWindow().getAttributes();
            attributes.alpha = 1f;
            getActivity().getWindow().setAttributes(attributes);
            //弹窗取消监听 取消之后恢复阴影
            popupWindow.setOnDismissListener(new PopupWindow.OnDismissListener() {
                @Override
                public void onDismiss() {
                    WindowManager.LayoutParams attributes = getActivity().getWindow().getAttributes();
                    attributes.alpha = 1;
                    getActivity().getWindow().setAttributes(attributes);
                }
            });
            popupWindow.showAtLocation(menuMore, Gravity.LEFT | Gravity.BOTTOM, 0,ll_menu.getHeight());
        } else if (btn_cancel == v) {
            if(!SobotStringUtils.isEmpty(customerId)&&customerModel!=null){
                updateUI(false);
            }else {
                userInfoType = TYPE_NO_RELA;
                showView();
            }
            ll_edit_menu.setVisibility(View.GONE);
        } else if (btn_save == v) {
            saveCustom();
        } else if (tv_sex_value == v) {
            //男：1，女2
            int index = -1;
            if (tv_sex_value.getTag() != null) {
                int sex = (int) tv_sex_value.getTag();
                if (sex == 1) {
                    index = 0;
                } else if (sex == 2) {
                    index = 1;
                }
            }
            SelectCommonDialog dialog = new SelectCommonDialog(getSobotActivity(), getResources().getString(R.string.call_custom_sex), sexList, index, new DialogItemOnClick() {
                @Override
                public void selectItem(Object selectObj) {
                    int selectIndex = (int) selectObj;
                    if (selectIndex >= 0) {
                        tv_sex_value.setText(sexList.get(selectIndex));
                        tv_sex_value.setTag(selectIndex == 0 ? 1 : 2);
                    }
                }
            });
            dialog.show();
        } else if (tv_company_value == v) {
            companyDialog = new SelectCompanyDialog(getSobotActivity(), selectCompany, new DialogItemOnClick() {
                @Override
                public void selectItem(Object selectObj) {
                    companyDialog.dismiss();

                    if (null != selectObj) {
                        EnterPriseModel model = (EnterPriseModel) selectObj;
                        if(selectCompany==null){
                            selectCompany = new EnterPriseModel();
                        }
                        selectCompany.setEnterpriseName(model.getEnterpriseName());
                        selectCompany.setEnterpriseId(model.getId());
                        tv_company_value.setText(selectCompany.getEnterpriseName());
                    }
                }
            });
            companyDialog.show();
        } else if (tv_is_vip_value == v) {
            int index = -1;
            String isVip = tv_is_vip_value.getText().toString();
            if (!TextUtils.isEmpty(isVip)) {
                if (isVip.equals(getResources().getString(R.string.call_ordinary_customer))) {
                    index = 0;
                } else if (isVip.equals(getResources().getString(R.string.call_vip_customer))) {
                    index = 1;
                }
            }
            SelectCommonDialog dialog = new SelectCommonDialog(getSobotActivity(), getResources().getString(R.string.call_custom_grade), isVipList, index, new DialogItemOnClick() {
                @Override
                public void selectItem(Object selectObj) {
                    int selectIndex = (int) selectObj;
                    if (selectIndex >= 0) {
                        if (selectIndex == 0) {
                            tv_is_vip_value.setText(getResources().getString(R.string.call_ordinary_customer));
                            ll_vip_level.setVisibility(View.GONE);
                        } else if (selectIndex == 1) {
                            ll_vip_level.setVisibility(View.VISIBLE);
                            tv_is_vip_value.setText(getResources().getString(R.string.call_vip_customer));
                        }
                    }
                }
            });
            dialog.show();
        } else if (tv_vip_level_value == v) {
            //vip列表
            int index = -1;
            List<String> levelList = new ArrayList<>();
            if(vipList!=null && vipList.size()>0) {
                for (int i = 0; i < vipList.size(); i++) {
                    levelList.add(vipList.get(i).getDataName());
                    if (tv_vip_level_value.getText().toString().equals(vipList.get(i).getDataName())) {
                        index = i;
                    }
                }
                SelectCommonDialog dialog = new SelectCommonDialog(getSobotActivity(), getResources().getString(R.string.call_custom_grade), levelList, index, new DialogItemOnClick() {
                    @Override
                    public void selectItem(Object selectObj) {
                        int index = (int) selectObj;
                        if (index >= 0) {
                            CusFieldDataInfoList enterPriseModel = vipList.get(index);
                            tv_vip_level_value.setText(enterPriseModel.getDataName());
                            tv_vip_level_value.setTag(enterPriseModel.getDataValue());
                        }
                    }
                });
                dialog.show();
            }else{

            }
        } else if (tv_country_value == v) {
            List<String> countryStr = new ArrayList<>();
            for (int i = 0; i < countryList.size(); i++) {
                countryStr.add(countryList.get(i).getCountryName());
            }
            SelectCommonDialog dialog = new SelectCommonDialog(getSobotActivity(), getResources().getString(R.string.call_custom_country), countryStr, countryIndex, new DialogItemOnClick() {
                @Override
                public void selectItem(Object selectObj) {
                    countryIndex = (int) selectObj;
                    if (countryIndex >= 0) {
                        CountryModel countryModel = countryList.get(countryIndex);
                        countryId = countryModel.getCountryId();
                        countryName = countryModel.getCountryName();
                        tv_country_value.setText(countryModel.getCountryName());
                        tv_country_value.setTag(countryModel.getCountryId());
                        if(!TextUtils.isEmpty(provinceId)){
                            provinceId="";
                            provinceName="";
                            cityId="";
                            cityName="";
                            areaId="";
                            areaName="";
                            tv_city_value.setText("");
                        }
                    }
                }
            });
            dialog.show();
        } else if (tv_city_value == v) {
            //选择城市
            SobotServiceInfoModel serviceInfoModel = SobotLoginTools.getInstance().getServiceInfo();
            if (serviceInfoModel != null && serviceInfoModel.getRegion() == 1 && TextUtils.isEmpty(countryId)) {
                SobotToastUtil.showToast(getContext(), getResources().getString(R.string.call_costomer_country_hint));
            } else {
                cityDialog = new SelectCityDialog(getSobotActivity(), countryId, provinceId, provinceName, cityId, cityName, areaId, areaName, new SelectCityDialog.CityListener() {
                    @Override
                    public void selectCity(String pId, String pName, String cId, String cName, String aId, String aName) {
                        provinceId = pId;
                        provinceName = pName;
                        cityId = cId;
                        cityName = cName;
                        areaId = aId;
                        areaName = aName;
                        if(!TextUtils.isEmpty(cityName)){
                            tv_city_value.setText(provinceName + "-" + cityName + "-" + areaName);
                        }else{
                            tv_city_value.setText(provinceName);
                        }
                    }
                },serviceInfoModel.getRegion() == 1);
                cityDialog.show();
            }
        } else if (iv_copy == v) {
            copyStr(tv_phone_value.getText().toString());
        } else if (iv_email_copy == v) {
            copyStr(tv_email_value.getText().toString());
        }
    }

    /**
     * 获取国家
     */
    private void requestCountry() {
        zhiChiApi.getCountryList(getSobotActivity(), new SobotResultCallBack<List<CountryModel>>() {
            @Override
            public void onSuccess(List<CountryModel> countryModels) {
                if (countryModels != null) {
                    countryList.addAll(countryModels);
                }
            }

            @Override
            public void onFailure(Exception e, String des) {

            }
        });
    }

    private void copyStr(String copyString) {
        if (Build.VERSION.SDK_INT >= 11) {
            SobotLogUtils.i("API是大于11");
            android.content.ClipboardManager cmb = (android.content.ClipboardManager) getSobotActivity().getSystemService(Context.CLIPBOARD_SERVICE);
            cmb.setText(copyString);
            cmb.getText();
        } else {
            SobotLogUtils.i("API是小于11");
            android.text.ClipboardManager cmb = (android.text.ClipboardManager) getSobotActivity().getSystemService(Context.CLIPBOARD_SERVICE);
            cmb.setText(copyString);
            cmb.getText();
        }

        SobotToastUtil.showToast(getSobotActivity(), getResources().getString(R.string.sobot_ctrl_v_success));
    }

    /**
     * 保存客户
     */
    private void saveCustom() {
        if (customerModel == null) {
            customerModel = new SobotCallCustomerModel();
        }
        String nick = ed_nick_value.getText().toString().trim();
        String realName = ed_realname_value.getText().toString().trim();

        if (TextUtils.isEmpty(nick)) {
            SobotToastUtil.showCustomToast(getSobotActivity(), getResources().getString(R.string.sobot_call_customer_name_tip));
            return;
        } else {
            tv_nick_value.setText(nick);
            tv_custom_name.setText(nick);
        }
        if (TextUtils.isEmpty(realName)) {
            tv_realname_value.setText("--");
        } else {
            tv_realname_value.setText(realName);
        }
        customerModel.setNick(nick);
        customerModel.setUname(realName);
        String sex = tv_sex_value.getText().toString().trim();
        if (!TextUtils.isEmpty(sex) && null != tv_sex_value.getTag()) {
            customerModel.setSex((Integer) tv_sex_value.getTag());
        }
        //默认是6 呼叫中心
        String source = tv_source_value.getText().toString();
        if (!TextUtils.isEmpty(source)) {
            if (tv_source_value.getTag() != null) {
                customerModel.setSource((String) tv_source_value.getTag());
            }
        } else {
            customerModel.setSource("6");
        }
        //手机号
        StringBuilder phoneSubmitSb = new StringBuilder();
        String tel = ed_phone_value.getText().toString();
        StringBuilder phoneSb = new StringBuilder(tel);
        if (!TextUtils.isEmpty(tel)) {
            if (tel.contains("*")) {
                if (encryptTels != null && encryptTels.size() > 0) {
                    for (int i = 0; i < encryptTels.size(); i++) {
                        if (encryptTels.get(i).getTel().equals(tel)) {
                            phoneSubmitSb.append(encryptTels.get(i).getEncrypt());
                        }
                    }
                } else if (!TextUtils.isEmpty(encryptCustomerNumber)) {
                    phoneSubmitSb.append(encryptCustomerNumber);
                }
            } else {
                phoneSubmitSb.append(tel);
            }
        }
        if (listPhoneView != null && listPhoneView.size() > 0) {
            SwipeItemDeleteLayout view;
            for (int i = 0; i < listPhoneView.size(); i++) {
                view = listPhoneView.get(i);
                String phoneValue = view.getEdittext_add_user_info().getText().toString();
                if (!TextUtils.isEmpty(phoneValue)) {
                    if (phoneSubmitSb.length() > 1) {
                        phoneSubmitSb.append(";");
                        phoneSb.append(";");
                    }
                    if (phoneValue.contains("*")) {
                        if (encryptTels != null && encryptTels.size() > 0) {
                            for (int j = 0; i < encryptTels.size(); i++) {
                                if (encryptTels.get(j).getTel().equals(phoneValue)) {
                                    phoneSubmitSb.append(encryptTels.get(j).getEncrypt());
                                }
                            }
                        } else if (!TextUtils.isEmpty(encryptCustomerNumber)) {
                            phoneSubmitSb.append(encryptCustomerNumber);
                        }
                    } else {
                        phoneSubmitSb.append(phoneValue);
                    }
                    phoneSb.append(phoneValue);
                }
            }
        }
        tels = phoneSb.toString();
        tv_phone_value.setText(getText(phoneSb.toString()));
        customerModel.setTel(phoneSb.toString());
        customerModel.setEncryptCustomerNumber(phoneSubmitSb.toString());

        StringBuilder emailSb = new StringBuilder();
        String email = ed_email_value.getText().toString();
        if (!TextUtils.isEmpty(email)) {
            emailSb.append(email);
        }
        if (listEmailView != null && listEmailView.size() > 0) {
            SwipeItemDeleteLayout view;
            for (int i = 0; i < listEmailView.size(); i++) {
                view = listEmailView.get(i);
                if (emailSb.length() > 1) {
                    emailSb.append(";");
                }
                emailSb.append(view.getEdittext_add_user_info().getText());
            }
        }
        emails = emailSb.toString();
        customerModel.setEmail(emails);
        tv_email_value.setText(getText(emails));

        String country = tv_country_value.getText().toString();
        if (!TextUtils.isEmpty(country)) {
            customerModel.setCountryName(countryName);
            customerModel.setCountryId((String) tv_country_value.getTag());
        }
        customerModel.setProviceName(provinceName);
        customerModel.setProviceId(provinceId);
        customerModel.setCityName(cityName);
        customerModel.setCityId(cityId);
        customerModel.setAreaName(areaName);
        customerModel.setAreaId(areaId);
        if (selectCompany != null && !TextUtils.isEmpty(selectCompany.getEnterpriseName())) {
            customerModel.setEnterpriseName(selectCompany.getEnterpriseName());
            customerModel.setEnterpriseId(selectCompany.getEnterpriseId());
        }
        String qq = ed_qq_value.getText().toString();
        if (!TextUtils.isEmpty(qq)) {
            tv_qq_value.setText(qq);
            customerModel.setQq(qq);
        } else {
            tv_qq_value.setText("--");
            customerModel.setQq("");
        }
        String wx = ed_wx_value.getText().toString();
        if (!TextUtils.isEmpty(wx)) {
            tv_wx_value.setText(wx);
            customerModel.setWx(wx);
        } else {
            tv_wx_value.setText("--");
            customerModel.setWx("");
        }
        String remark = ed_remark_value.getText().toString();
        if (!TextUtils.isEmpty(remark)) {
            tv_remark_value.setText(remark);
            customerModel.setRemark(remark);
        } else {
            tv_remark_value.setText("--");
            customerModel.setRemark("");
        }
        //
        int isVip = 0;
        if (!TextUtils.isEmpty(tv_is_vip_value.getText().toString()) && tv_is_vip_value.getText().toString().equals(getResources().getString(R.string.call_vip_customer))) {
            isVip = 1;
            if(tv_vip_level_value.getTag()!=null && !TextUtils.isEmpty((String) tv_vip_level_value.getTag())){
                customerModel.setVipLevel((String) tv_vip_level_value.getTag());
            }else{
                SobotToastUtil.showCustomToast(getSobotActivity(), getResources().getString(R.string.app_customer_vip_level_hint));
                return;
            }
        }
        customerModel.setIsVip(isVip + "");
        Map<String, String> fiels = setCustomerFieldValue();
        if (!checkCusFieldRequired()) {
            return;
        }
        if (userInfoType == TYPE_ADD) {
            customerModel.setSource("6");
            zhiChiApi.saveCustom(getSobotActivity(), customerModel, fiels, new SobotResultCallBack<SobotCallCustomerModel>() {
                @Override
                public void onSuccess(SobotCallCustomerModel sobotCallCustomerModel) {
                    if (sobotCallCustomerModel != null) {
                        //失败
                        if (sobotCallCustomerModel.getTotalCount() > 0) {
                            if (sobotCallCustomerModel.getType() == 1) {
                                if (sobotCallCustomerModel.getData() != null && !TextUtils.isEmpty(sobotCallCustomerModel.getData().getNick())) {
                                    SobotToastUtil.showToast(getSobotActivity(), String.format(getContext().getResources().getString(R.string.call_add_custom_repet_email_tip2), sobotCallCustomerModel.getData().getNick()));
                                } else {
                                    SobotToastUtil.showToast(getSobotActivity(), getContext().getResources().getString(R.string.call_add_custom_repet_email_tip));
                                }
                            } else if (sobotCallCustomerModel.getType() == 2) {
                                if (sobotCallCustomerModel.getData() != null && !TextUtils.isEmpty(sobotCallCustomerModel.getData().getNick())) {
                                    SobotToastUtil.showToast(getSobotActivity(), String.format(getContext().getResources().getString(R.string.call_add_custom_repet_phone_tip2), sobotCallCustomerModel.getData().getNick()));
                                } else {
                                    SobotToastUtil.showToast(getSobotActivity(), getContext().getResources().getString(R.string.call_add_custom_repet_phone_tip));
                                }
                            } else {
                                SobotToastUtil.showToast(getSobotActivity(), getContext().getResources().getString(R.string.sobot_call_save_failed));
                            }
                        } else {
                            userInfoType = TYPE_SHOW;
                            getSobotActivity().setResult(SobotCallConstant.ACTIVITY_RESULT_DETAIL);
                            SobotToastUtil.showToast(getSobotActivity(), getContext().getResources().getString(R.string.sobot_call_add_success));
                            //成功
                            updateUI(false);
                            customerModel.setId(sobotCallCustomerModel.getId());
                            //关联
                            selectCustomerId = sobotCallCustomerModel.getId();
                            if (!TextUtils.isEmpty(selectCustomerId)) {
                                new Handler().postDelayed(new Runnable() {
                                    @Override
                                    public void run() {
                                        requestAssociationCustom(false);
                                    }
                                }, 2000);
                            }
                        }
                    }

                }

                @Override
                public void onFailure(Exception e, String des) {
                    if (!TextUtils.isEmpty(des)) {
                        SobotToastUtil.showCustomToast(getSobotActivity(), des);
                    }
                }
            });

        } else {
            zhiChiApi.updateCustom(getSobotActivity(), customerModel, setCustomerFieldValue(), new SobotResultCallBack<SobotCallCustomerModel>() {
                @Override
                public void onSuccess(SobotCallCustomerModel sobotCallCustomerModel) {
                    if (sobotCallCustomerModel.getTotalCount() > 0) {
                        if (sobotCallCustomerModel.getType() == 1) {
                            if (sobotCallCustomerModel.getData() != null && !TextUtils.isEmpty(sobotCallCustomerModel.getData().getNick())) {
                                SobotToastUtil.showToast(getSobotActivity(), String.format(getContext().getResources().getString(R.string.call_add_custom_repet_email_tip2), sobotCallCustomerModel.getData().getNick()));
                            } else {
                                SobotToastUtil.showToast(getSobotActivity(), getContext().getResources().getString(R.string.call_add_custom_repet_email_tip));
                            }
                        } else if (sobotCallCustomerModel.getType() == 2) {
                            if (sobotCallCustomerModel.getData() != null && !TextUtils.isEmpty(sobotCallCustomerModel.getData().getNick())) {
                                SobotToastUtil.showToast(getSobotActivity(), String.format(getContext().getResources().getString(R.string.call_add_custom_repet_phone_tip2), sobotCallCustomerModel.getData().getNick()));
                            } else {
                                SobotToastUtil.showToast(getSobotActivity(), getContext().getResources().getString(R.string.call_add_custom_repet_phone_tip));
                            }
                        } else {
                            SobotToastUtil.showToast(getSobotActivity(), getContext().getResources().getString(R.string.sobot_call_edit_fail));
                        }
                    } else {
                        getSobotActivity().setResult(SobotCallConstant.ACTIVITY_RESULT_DETAIL);
                        SobotToastUtil.showToast(getSobotActivity(), getContext().getResources().getString(R.string.sobot_call_edit_success));
                        //成功
                        updateUI(false);
                    }
                }

                @Override
                public void onFailure(Exception e, String des) {
                    if (!TextUtils.isEmpty(des)) {
                        SobotToastUtil.showCustomToast(getSobotActivity(), des);
                    }
                }
            });
        }
    }

    /**
     * 客户来源转换成文字
     *
     * @param sourceType
     * @return
     */
    private String setSourceText(String sourceType) {
        if (TextUtils.isEmpty(sourceType)) {
            return "";
        }
        String sourceName;
        switch (sourceType) {
            case "0":
                sourceName = getContext().getResources().getString(R.string.call_source_pc);
                break;
            case "1":
                sourceName = getContext().getResources().getString(R.string.call_source_wechat);
                break;
            case "2":
                sourceName = getContext().getResources().getString(R.string.call_source_app);
                break;
            case "3":
                sourceName = getContext().getResources().getString(R.string.call_source_weibo);
                break;
            case "4":
                sourceName = getContext().getResources().getString(R.string.call_source_mobile_web);
                break;
            case "5":
                sourceName = getContext().getResources().getString(R.string.call_source_rong);
                break;
            case "6":
                sourceName = getContext().getResources().getString(R.string.sobot_call_center);
                break;
            case "7":
                sourceName = getContext().getResources().getString(R.string.call_source_work_order);
                break;
            case "8":
                sourceName = getContext().getResources().getString(R.string.call_source_customer_center);
                break;
            case "34":
                sourceName = getContext().getResources().getString(R.string.call_str_tm_center);
                break;
            default:
                sourceName = getContext().getResources().getString(R.string.call_source_pc);
                break;
        }
        return sourceName;
    }

    /**
     * 根据类型搜索
     */
    protected void searchCustomByType() {
        if (System.currentTimeMillis() - inputTime < 500) {
            return;
        }
        String inputSearchText = et_search_input.getText().toString();
        String searchText = inputSearchText;
        if (!TextUtils.isEmpty(callNumber) && inputSearchText.equals(callNumber) && !TextUtils.isEmpty(encryptCustomerNumber)) {
            searchText = encryptCustomerNumber;
        }
        //搜索客户
        zhiChiApi.searchCustom(getSobotActivity(), searchType, searchText, new SobotResultCallBack<List<SobotCallCustomerModel>>() {

            @SuppressLint("NotifyDataSetChanged")
            @Override
            public void onSuccess(List<SobotCallCustomerModel> sobotCallCustomerModels) {
                customerList.clear();
                if (null != sobotCallCustomerModels && sobotCallCustomerModels.size()>0) {
                    customerList.addAll(sobotCallCustomerModels);
                    tv_customer_nodata.setVisibility(View.GONE);
                }else{
                    tv_customer_nodata.setVisibility(View.VISIBLE);
                }
                customAdapter.setDate(inputSearchText);
            }

            @Override
            public void onFailure(Exception e, String des) {

            }
        });
    }

    /**
     * 客户信息弹框
     *
     * @param user
     */
    private void showCustomerDetail(SobotCallCustomerModel user) {
        List<CusFieldConfig> cusFieldList = new ArrayList<>();
        cusFieldList.addAll(cusFieldConfigList);
        if (cusFieldList.size() > 0) {
            if (user != null && user.getExtendFields() != null) {
                Map<String, String> map = user.getExtendFields();
                for (int i = 0; i < cusFieldList.size(); i++) {
                    for (int j = 0; j < map.size(); j++) {
                        String value = map.get(cusFieldList.get(i).getFieldVariable());
                        if (!TextUtils.isEmpty(value)) {
                            cusFieldList.get(i).setFieldValue(value);
                        }
                    }
                }
            }
        }
        CostomerDetailDialog costomerDetailDialog = new CostomerDetailDialog(getSobotActivity(), user, cusFieldList, new DialogItemOnClick() {
            @Override
            public void selectItem(Object selectObj) {
                selectCustomerId = user.getId();
                requestAssociationCustom(true);
            }
        });
        costomerDetailDialog.show();
    }

    /**
     * 获取自定义字段的值
     */
    private Map<String, String> setCustomerFieldValue() {
        Map<String, String> map = new HashMap<>();
        JSONArray array = new JSONArray();
        if (cusFieldConfigList != null && cusFieldConfigList.size() != 0) {
            for (int i = 0; i < cusFieldConfigList.size(); i++) {
                if (cusFieldConfigList.get(i).getOpenFlag() != 1) {
                    continue;
                }
                String value = "";
                String ids = "";
                View view = ll_cusfield.findViewWithTag(cusFieldConfigList.get(i).getFieldId());
                if (view != null) {
                    if (cusFieldConfigList.get(i).getFieldType() == 1) {
                        //单行文本
                        EditText singleLine = (EditText) view.findViewById(R.id.call_customer_field_text_single);
                        cusFieldConfigList.get(i).setFieldValue(singleLine.getText().toString());
                        value = singleLine.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 2) {
                        //多行文本
                        EditText moreContent = (EditText) view.findViewById(R.id.call_customer_field_text_more_content);
                        cusFieldConfigList.get(i).setFieldValue(moreContent.getText().toString());
                        value = moreContent.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 3) {
                        //日期
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        value = textClick.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 4) {
                        //时间
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        value = textClick.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 5) {
                        //数值
                        EditText numberContent = (EditText) view.findViewById(R.id.call_customer_field_text_number);
                        cusFieldConfigList.get(i).setFieldValue(numberContent.getText().toString());
                        value = numberContent.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 6) {
                        //下拉列表
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        if(textClick.getTag()!=null && textClick.getTag() instanceof CusFieldDataInfoList){
                            CusFieldDataInfoList infoList = (CusFieldDataInfoList)textClick.getTag();
                            ids = infoList.getDataValue();
                            JSONObject object = new JSONObject();
                            try {
                                object.put("id", infoList.getDataValue());
                                object.put("value", textClick.getText().toString());
                            } catch (JSONException e) {
                                throw new RuntimeException(e);
                            }
                            value = object.toString();
                        }

                    } else if (cusFieldConfigList.get(i).getFieldType() == 7) {
                        //复选框
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        if(textClick.getTag()!=null && textClick.getTag() instanceof List){
                            List<CusFieldDataInfoList> infoList = (List<CusFieldDataInfoList>)textClick.getTag();
                            StringBuilder sb= new StringBuilder();
                            if(infoList!=null && infoList.size()>0){
                                for (int j = 0; j < infoList.size(); j++) {
                                    if (sb.length() > 0) {
                                        sb.append(",");
                                    }
                                    sb.append(infoList.get(j).getDataValue());
                                }
                            }
                            ids = sb.toString();
                            JSONObject object = new JSONObject();
                            try {
                                object.put("id", ids);
                                object.put("value", textClick.getText().toString());
                            } catch (JSONException e) {
                                throw new RuntimeException(e);
                            }
                            value = object.toString();

                        }
                    } else if (cusFieldConfigList.get(i).getFieldType() == 8) {
                        //单选框
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        if(textClick.getTag()!=null && textClick.getTag() instanceof CusFieldDataInfoList){
                            CusFieldDataInfoList infoList = (CusFieldDataInfoList)textClick.getTag();
                            ids = infoList.getDataValue();
                            JSONObject object = new JSONObject();
                            try {
                                object.put("id", infoList.getDataValue());
                                object.put("value", textClick.getText().toString());
                            } catch (JSONException e) {
                                throw new RuntimeException(e);
                            }
                            value = object.toString();
                        }
                    } else if (cusFieldConfigList.get(i).getFieldType() == 9) {
                        //级联
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        if(textClick.getTag()!=null && textClick.getTag() instanceof List){
                            List<CusFieldDataInfoList> infoList = (List<CusFieldDataInfoList>)textClick.getTag();
                            StringBuilder sb= new StringBuilder();
                            if(infoList!=null && infoList.size()>0){
                                for (int j = 0; j < infoList.size(); j++) {
                                    if (sb.length() > 0) {
                                        sb.append(",");
                                    }
                                    sb.append(infoList.get(j).getDataValue());
                                }
                            }
                            ids = sb.toString();
                            JSONObject object = new JSONObject();
                            try {
                                object.put("id", ids);
                                object.put("value", textClick.getText().toString());
                            } catch (JSONException e) {
                                throw new RuntimeException(e);
                            }
                            value = object.toString();

                        }
                    }
                }

                try {
                    JSONObject object = new JSONObject();
                    object.put("id", cusFieldConfigList.get(i).getFieldId());
                    object.put("value", !TextUtils.isEmpty(ids) ? ids : cusFieldConfigList.get(i).getFieldValue());
                    array.put(object);
                } catch (JSONException e) {
                    throw new RuntimeException(e);
                }

                map.put(cusFieldConfigList.get(i).getFieldVariable(), value);
            }
        }
        customerModel.setExFieldStr(array.toString());
        return map;
    }
    //检测自定义字段是否必填并提示
    private boolean checkCusFieldRequired() {
        if (cusFieldConfigList != null && cusFieldConfigList.size() > 0) {
            for (int i = 0; i < cusFieldConfigList.size(); i++) {
                CusFieldConfig fieldConfig = cusFieldConfigList.get(i);
                if (1 == fieldConfig.getOpenFlag() && 1 == fieldConfig.getFillFlag()) {
                    if (TextUtils.isEmpty(fieldConfig.getFieldValue())) {
                        String s = getResources().getString(R.string.call_retcode_500042);
                        SobotToastUtil.showToast(getSobotActivity(), String.format(s,fieldConfig.getFieldName()));
                        return false;
                    }
                }
            }
        }
        return true;
    }

    @Override
    public void onDestroyView() {
        if (companyDialog != null && companyDialog.isShowing()) {
            companyDialog.dismiss();
        }
        super.onDestroyView();
    }
}