package com.sobot.callsdk.activity;

import android.os.Bundle;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.sobot.callsdk.R;
import com.sobot.callsdk.utils.SobotCallConstant;
import com.sobot.callsdk.v1.fragment.SobotCallFragment;
import com.sobot.callsdk.v6.fragment.SobotCallV6Fragment;

public class SobotCallActivity extends SobotCallBaseActivity {

    private SobotCallFragment callFragment;

    private SobotCallV6Fragment callV6Fragment;
    //账号判断是否是v6， 1 是v6；其它是v1
    private int callV6Flag;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        initBundleData(savedInstanceState);
        super.onCreate(savedInstanceState);
    }

    @Override
    protected int getContentViewResId() {
        return R.layout.sobot_activity_call_main;
    }

    @Override
    protected void initView() {
        callV6Flag = getIntent().getIntExtra("callV6Flag", 0);
        if (callV6Flag == 1) {
            callV6Fragment = (SobotCallV6Fragment) getSupportFragmentManager()
                    .findFragmentById(getResId("sobot_call_contentFrame"));
            if (callV6Fragment == null) {
                callV6Fragment = SobotCallV6Fragment.newInstance(SobotCallConstant.STARTUP_MODE_ACTIVITY);
                addFragmentToActivity(getSupportFragmentManager(),
                        callV6Fragment, getResId("sobot_call_contentFrame"));
            }
        } else {
            callFragment = (SobotCallFragment) getSupportFragmentManager()
                    .findFragmentById(getResId("sobot_call_contentFrame"));
            if (callFragment == null) {
                callFragment = SobotCallFragment.newInstance(SobotCallConstant.STARTUP_MODE_ACTIVITY);
                addFragmentToActivity(getSupportFragmentManager(),
                        callFragment, getResId("sobot_call_contentFrame"));
            }
        }
    }

    @Override
    protected void initData() {
    }

    public void addFragmentToActivity(FragmentManager fragmentManager,
                                      Fragment fragment, int frameId) {
        FragmentTransaction transaction = fragmentManager.beginTransaction();
        transaction.replace(frameId, fragment);
        transaction.commit();
    }

}