package com.sobot.callsdk.api;

public interface SobotCallUrlApi {

    // 退出系统
    String api_logout = "basic-login/serviceLogOut/4";

    // 创建客户信息
    String api_call_add_customer_info = "crm-user-service/appUser/addAppUserInfo";

    // 编辑客户信息
    String api_call_update_customer_info = "crm-user-service/appUser/updateAppUserInfo";

    // 查询客户信息（通过手机号）
    String api_call_get_customer_info = "crm-user-service/appUser/getAppUserInfoByPhoneNo/4";


    //------------ v6 接口 ------------
    // 获取access_token
    String api_get_access_token = "tokens/getToken";
    // 查询座席接听方式
    String api_phone_types_v6 = "callservice/v6/cc-config/agents/phoneTypes";
    // 查询登录状态字典
    String api_login_status_v6 = "callservice/v6/cc-config/work-benchs/login-status";
    // 查询分机帐号
    String api_get_extension_list = "callservice/v6/cc-config/exts/idle/search";
    // 查询分机帐号,分页
    String api_get_extension_list_page = "callservice/v6/cc-config/exts/idle/page/search";
    //修改分机语言编码
    String api_ext_langCode = "callservice/v6/cc-config/exts/langCode";
    //呼叫记录--所有主话单
//    String api_get_record_list_v6 = "callservice/v6/cc-reports/statistics/maincdrs/_search";
    //呼叫记录--所有子话单
    String api_get_record_list_v6 = "callservice/v6/cc-console/party/agents/list";
    //搜索客户
    String api_get_search_user = "crm-user-service/user/listByPage";
    //呼叫记录--主话单下的子话单
    String api_get_record_one_v6 = "callservice/v6/cc-reports/maincdrs/{callID}/partycdrs";
    //座席任务列表 post
    String api_tasklist_v6 = "callservice/v6/cc-outbound/agents/campaigns";
    //查询客服工作台任务明细列表 post
    String api_tast_detail_v6 = "callservice/v6/cc-outbound/console/campaigns/{campaignId}/contacts";
    //活动名单外呼 post
    String api_tast_call_v6 = "callservice/v6/cc-outbound/campaigns/_makecall";
    // 重连恢复话务状态
    String api_recover_agent_call_status_v6 = "callservice/v6/webmsg/reconnect/recover-agent-call-status";
    //重连恢复座席状态
    String api_recover_agent_status_v6 = "callservice/v6/webmsg/reconnect/recover-agent-status";
    //查询座席的外呼路由规则
//    String api_call_query_outboud_routes_rules = "callservice/v6/cc-config/api/agents/outbound-routes/rules";
    String api_call_query_outboud_routes_rules = "callservice/v6/cc-config/agents/%s/outbound-routes/rules?agentType=%s";
    //切换座席的外呼路由规则
    String api_call_switch_outboud_routes_rules = "callservice/v6/cc-config/api/agents/outbound-routes/rules";
    //查询座席可用的置忙原因
    String api_call_busy_statuses = "callservice/v6/cc-config/api/agent/busy-statuses";
    //查询座席可使用分机帐号
    String api_call_available_exts = "callservice/v6/cc-config/api/agent/available-exts";
    //查询座席可签入的技能组
    String api_call_available_queues = "callservice/v6/cc-config/api/agent/available-login-queues";
    //查询座席的签入信息
    String api_call_login_binding_info = "callservice/v6/cc-config/api/agent/login-binding-info";


    //查询电话区号
    String searchCallingCodeV6 = "callservice/v6/cc-config/regionalGroup/callingCode/_search";
    //查询电话区号列表
    String searchAreaListV6 = "callservice/v6/cc-config/regionalGroup/area/search/list";
    //修改电话区号
    String updateAreaV6 = "callservice/v6/cc-config/regionalGroup/callingCode/_update";

    //通话详情
    String api_call_details = "callservice/v6/cc-reports/statistics/{callID}/details/_search";
    //回拨
    String api_callbacks = "callservice/v6/cc-console/callbacks";
    //查询通话是否可以提交服务总结
    String api_can_submit_summary = "callservice/v6/cc-console/workbench-screen/main/cdr/agent?callID=%s";


    //------------ v1 接口 ------------
    // 查询座席自定义状态列表
    String api_get_call_service_status_v1 = "basic-set/getCallServiceStatus/4";
    // 查询座席接听方式
    String api_phone_types_v1 = "call-data/getAppCallModelFlag/4";
    // 获取座席状态
    String api_get_agent_status_v1 = "call-data/appGetAgentStatusNew";
    //根据号码获取呼叫中心的客户
    String getAppUserList = "crm-user-service/appUser/getAppUserList";
    //设置座席状态
    String api_app_set_agent_status_v1 = "call-data/appSetAgentStatus";
    //电话条登出
    String api_app_agent_logout_v1 = "call-data/appAgentLogout";
    //电话条登陆
    String api_app_agent_login_v1 = "call-data/appAgentLogin";
    //获取SIP账号注册信息
    String api_app_agent_number_v1 = "call-data/getAppAgentNumber/4";
    //查询呼叫用户的技能组
    String api_app_query_group_v1 = "basic/queryGroupListByServiceId/4";
    //获取    我的呼叫任务列表
    String api_all_task_v1 = "call-data/getAppAllTaskDetails/4";
    //查询任务详情
    String api_task_details_v1 = "call-data/getAppOneTaskDetails/4";
    //通话记录
    String api_call_record_v1 = "call-data/getAppServiceCallRecord";
    //通话记录详情
    String api_call_record_detail_v1 = "call-data/getAppServiceCallRecordByPhone";
    //获取联系计划
    String api_get_call_contact_planList_v1 = "call-data/getAppCallContactPlanList/4";
    //新增联系计划
    String api_add_call_contact_planinfo_v1 = "call-data/addAppCallContactPlanInfo/4";
    //更新联系计划
    String api_update_call_contact_planinfo_v1 = "call-data/updateAppCallContactPlanInfo/4";
    //删除联系计划
    String api_delete_call_contact_planinfo_v1 = "call-data/deleteAppCallContactPlanInfo/4";
    //外呼
    String api_call_out = "call-data/appAgentCallOut";
    //挂断
    String api_call_hungup = "call-data/appAgentReleaseCall";
    //获取服务总结--分类
    String api_call_summary_classifies = "callservice/v6/cc-config/summary-classifies";
    //获取服务总结--处理状态
    String api_call_summary_config = "callservice/v6/cc-config/summary/config";
    //获取服务总结--所有模板
    String api_call_summary_templates = "callservice/v6/cc-config/templates";
    //获取服务总结--获取自定义字段
    String api_call_custom_field = "basic-config-service/customField/queryFieldInfoList?clientType=2";

    // 提交会话总结
    String api_call_submit_summary = "callservice/v6/cc-console/workbench-screen/cdr/service-summary";
    // 处理进度
    String api_call_handleprogress = "callservice/v6/cc-config/summary/handleProgress";
    // 查询总结
    String api_call_search_summary = "callservice/v6/cc-console/workbench-screen/cdr/#CALLID#/service-summary?clientType=2";
    //查询客户信息
    String api_call_search_custom = "crm-user-service/user/detail/";
    //保存客户信息
    String api_call_save_custom = "crm-user-service/user/save";
    //保存客户信息
    String api_call_update_custom = "crm-user-service/user/update/%s";
    //合并客户信息
    String api_call_merge_custom = "crm-user-service/user/merge";
    //关联客户
    String api_call_association_custom = "callservice/v6/cc-console/workbench-screen/cdrinfo?callID=%s&customerID=%s";
    //获取国家信息
    String api_call_country = "basic-config-service/customField/getCountryList";
    //通过国家id查询州/省信息
    String api_call_province = "basic-config-service/customField/getProvinceListByCountryId";
    //通过省id查询城市
    String api_call_city = "basic-config-service/customField/getCityList";
    //通过城市id查询地区
    String api_call_area = "basic-config-service/customField/getAreaList";
    //获取公司列表
    String api_call_enterprise = "crm-user-service/appEnterprise/getAppEnterpriseList";
    //是否显示技能组
    String api_call_queue_checkin = "callservice/v6/cc-config/work-benchs/call-function/queue-checkin";
    //查询手机号归属地
    String api_call_number_info = "callservice/v6/cc-console/call/%s/customer/number/info";

    //任务详情查询get,任务详情修改 patch
    String api_call_task_detail = "callservice/v6/cc-outbound/campaigns/%s/details/%s?clientType=2";
    //查询任务总结get,更新任务总结patch
    String api_call_task_detail_edit = "callservice/v6/cc-outbound/campaigns/%s/template-summary/%s?clientType=2";
    //外呼任务通话记录查询post
    String api_call_task_record= "callservice/v6/cc-reports/campaigns/maincdrs/_search";
}