package com.sobot.callsdk.dialog;

import android.app.Activity;
import android.graphics.Typeface;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.sobot.callbase.model.SobotLoginStatusEntity;
import com.sobot.callsdk.R;
import com.sobot.callsdk.utils.CallStatusUtils;

import java.util.List;

public class SelectLoginStatusDialog extends SobotBottomDialog implements View.OnClickListener {
    private LinearLayout coustom_pop_layout,sobot_negativeButton;
    private RelativeLayout rl_online,rl_busy;
    private TextView tv_online,tv_busy;
    private ImageView iv_online,iv_busy;
    private StatusListener listener;
    private Activity activity;
    private String status;
    //状态
    private List<SobotLoginStatusEntity> data;

    public SelectLoginStatusDialog(Activity context, StatusListener listener,String status,List<SobotLoginStatusEntity> data){
        super(context);
        activity = context;
        this.status = status;
        this.listener = listener;
        this.data = data;
    }
    @Override
    protected int getLayout() {
        return R.layout.call_dialog_select_call_status;
    }

    @Override
    protected View getDialogContainer() {
        if (coustom_pop_layout == null) {
            coustom_pop_layout = findViewById(R.id.sobot_container);
        }
        return coustom_pop_layout;
    }

    @Override
    protected void initData() {
        if(status.equals(CallStatusUtils.V6_FREE)){
            iv_online.setVisibility(View.VISIBLE);
            iv_busy.setVisibility(View.GONE);
            tv_online.setTypeface(null, Typeface.BOLD);
        }else if(status.equals(CallStatusUtils.V6_DO_NOT_DISTURB)){
            tv_busy.setTypeface(null, Typeface.BOLD);
            iv_online.setVisibility(View.GONE);
            iv_busy.setVisibility(View.VISIBLE);
        }
    }

    @Override
    protected void initView() {
        sobot_negativeButton = findViewById(R.id.sobot_negativeButton);
        rl_online = findViewById(R.id.rl_online);
        rl_busy = findViewById(R.id.rl_busy);
        iv_online = findViewById(R.id.iv_online);
        iv_busy = findViewById(R.id.iv_busy);
        tv_online = findViewById(R.id.tv_online);
        tv_busy = findViewById(R.id.tv_busy);

        sobot_negativeButton.setOnClickListener(this);
        rl_online.setOnClickListener(this);
        rl_busy.setOnClickListener(this);

        for (int i = 0; i < data.size(); i++) {
            if(data.get(i).getCode().equals(CallStatusUtils.V6_FREE)){
                tv_online.setText(data.get(i).getName());
            }
            if(data.get(i).getCode().equals(CallStatusUtils.V6_DO_NOT_DISTURB)){
                tv_busy.setText(data.get(i).getName());
            }
        }
    }

    @Override
    public void onClick(View v) {
        if(v==sobot_negativeButton){
            //关闭
            dismiss();
        }else if(rl_online ==v){
            if(listener!=null){
                listener.setStatus(CallStatusUtils.V6_FREE);
            }
            dismiss();
        }else if(rl_busy ==v){
            if(listener!=null){
                listener.setStatus(CallStatusUtils.V6_DO_NOT_DISTURB);
            }
            dismiss();
        }
    }
    @Override
    public void dismiss() {
        try {
            if (isShowing()) {
                super.dismiss();
            }
        } catch (Exception e) {
//            e.printStackTrace();
        }
    }
    public interface StatusListener {
        void setStatus(String status);
    }
}
