package com.sobot.callsdk.dialog;

import android.app.Activity;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;

import com.sobot.callsdk.R;

public class SelectSpeechCodeDialog extends SobotBottomDialog implements View.OnClickListener {
    private LinearLayout coustom_pop_layout,sobot_negativeButton;
    private RelativeLayout rl_opus,rl_alaw,rl_ulaw;
    private ImageView iv_opus_type,iv_alaw_type,iv_ulaw_type;
    private SpeechCodeListener listener;
    private Activity activity;
    private String code;

    public SelectSpeechCodeDialog(Activity context, SpeechCodeListener listener, String type){
        super(context);
        activity = context;
        this.listener = listener;
        this.code = type;
    }
    @Override
    protected int getLayout() {
        return R.layout.call_dialog_select_speech_code;
    }

    public void setCode(String code) {
        this.code = code;
        if(rl_opus!=null) {
            initData();
        }
    }

    @Override
    protected View getDialogContainer() {
        if (coustom_pop_layout == null) {
            coustom_pop_layout = findViewById(R.id.sobot_container);
        }
        return coustom_pop_layout;
    }

    @Override
    protected void initData() {
        if(code.equals("Opus")){
            iv_opus_type.setVisibility(View.VISIBLE);
            iv_alaw_type.setVisibility(View.INVISIBLE);
            iv_ulaw_type.setVisibility(View.INVISIBLE);
        }else if(code.equals("G.711 alaw")){
            iv_opus_type.setVisibility(View.INVISIBLE);
            iv_alaw_type.setVisibility(View.VISIBLE);
            iv_ulaw_type.setVisibility(View.INVISIBLE);
        }else if(code.equals("G.711 ulaw")){
            iv_opus_type.setVisibility(View.INVISIBLE);
            iv_alaw_type.setVisibility(View.INVISIBLE);
            iv_ulaw_type.setVisibility(View.VISIBLE);
        }
    }

    @Override
    protected void initView() {
        sobot_negativeButton = findViewById(R.id.sobot_negativeButton);
        rl_opus = findViewById(R.id.rl_opus);
        rl_alaw = findViewById(R.id.rl_alaw);
        rl_ulaw = findViewById(R.id.rl_ulaw);
        iv_opus_type = findViewById(R.id.iv_opus_type);
        iv_alaw_type = findViewById(R.id.iv_alaw_type);
        iv_ulaw_type = findViewById(R.id.iv_ulaw_type);

        sobot_negativeButton.setOnClickListener(this);
        rl_opus.setOnClickListener(this);
        rl_alaw.setOnClickListener(this);
        rl_ulaw.setOnClickListener(this);

    }

    @Override
    public void onClick(View v) {
        if(v==sobot_negativeButton){
            //关闭
            dismiss();
        }else if(rl_opus ==v){
            if(listener!=null){
                listener.setType("Opus");
            }
            dismiss();
        }else if(rl_alaw ==v){
            if(listener!=null){
                listener.setType("G.711 alaw");
            }
            dismiss();
        }else if(rl_ulaw ==v){
            if(listener!=null){
                listener.setType("G.711 ulaw");
            }
            dismiss();
        }
    }
    @Override
    public void dismiss() {
        try {
            if (isShowing()) {
                super.dismiss();
            }
        } catch (Exception e) {
//            e.printStackTrace();
        }
    }
    public interface SpeechCodeListener {
        void setType(String code);
    }
}
