package com.sobot.callsdk.dialog;


import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.WindowManager;
import android.widget.TextView;

import androidx.annotation.NonNull;

import com.sobot.callsdk.R;


/**
 * Created by jinxl on 2017/4/10.
 */

public class SobotCallLoadingDialog extends Dialog {


    private static final String TAG = "SobotLoadingDialog";

    private String mMessage;
    private boolean mCancelable=true;
    private TextView tv_loading;

    public SobotCallLoadingDialog(@NonNull Context context, String message) {
        this(context, R.style.sobot_call_custom_dialog, message, true);
    }

    public SobotCallLoadingDialog(@NonNull Context context, int themeResId, String message, boolean cancelable) {
        super(context, themeResId);
        mMessage = message;
        mCancelable = cancelable;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.d(TAG, "onCreate: ");
        initView();
    }

    private void initView() {
        setContentView(R.layout.sobot_call_dialog_loading);
        // 设置窗口大小
        WindowManager.LayoutParams attributes = getWindow().getAttributes();
        attributes.gravity= Gravity.CENTER;
        getWindow().setAttributes(attributes);
        setCancelable(mCancelable);

        tv_loading = findViewById(R.id.id_tv_loadingmsg);
        tv_loading.setText(mMessage);
    }

    @Override
    public void dismiss() {
        super.dismiss();
    }

    @Override
    public boolean onKeyDown(int keyCode, @NonNull KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            // 屏蔽返回键
            return mCancelable;
        }
        return super.onKeyDown(keyCode, event);
    }

    public String getmMessage() {
        return mMessage;
    }

    public void setmMessage(String mMessage) {
        this.mMessage = mMessage;
        tv_loading.setText(mMessage);
    }
}
