package com.sobot.callsdk.dialog;

import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.graphics.Rect;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.DisplayMetrics;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.LinearLayout;

import com.sobot.callbase.api.utils.SobotCallUtils;
import com.sobot.callsdk.R;
import com.sobot.callsdk.v1.entity.SobotCallTaskDetailsEntity;
import com.sobot.callsdk.v1.entity.v1.SobotCallTaskDetailsModel;
import com.sobot.utils.SobotDensityUtil;

/**
 * Created by Administrator on 2016/9/22.
 */
@SuppressWarnings("ALL")
public class SobotCallTaskDialog extends Dialog {

    protected Button btn_customer, btn_plan, btn_cancel;
    protected Button btn_call_up_task_tel;//这个button是呼叫任务详情页面右边控件的点击传过来的电话号码
    protected View btn_call_up_task_tel_line;
    protected LinearLayout coustom_pop_layout;
    protected View.OnClickListener itemsOnClick;
    protected final int screenHeight;
    private String userTel;
    private Context mContext;
    private Object data;

    public SobotCallTaskDialog(Activity context, View.OnClickListener itemsOnClick,Object data) {
        super(context, R.style.sobot_bottm_dialog_style);
        this.itemsOnClick = itemsOnClick;
        this.mContext = context;
        this.data =data;
        if(data instanceof SobotCallTaskDetailsModel){
            SobotCallTaskDetailsModel model = (SobotCallTaskDetailsModel) data;
            String phoneNum = model.getCallNO();
            this.userTel = SobotCallUtils.hidePhone(phoneNum, model.getHiddenFlag());
        }else if(data instanceof SobotCallTaskDetailsEntity){
            SobotCallTaskDetailsEntity detailsEntity = (SobotCallTaskDetailsEntity) data;
            this.userTel = detailsEntity.getScreenNumber();
        }
        screenHeight = SobotDensityUtil.getScreenHeight(context);
        // 修改Dialog(Window)的弹出位置
        Window window = getWindow();
        if (window != null) {
            WindowManager.LayoutParams layoutParams = window.getAttributes();
            layoutParams.gravity = Gravity.BOTTOM | Gravity.CENTER_HORIZONTAL;
            setParams(context, layoutParams);
            window.setAttributes(layoutParams);
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.sobot_popup_bottom_task);
        initView();
    }

    public boolean onTouchEvent(MotionEvent event) {
        if (event.getAction() == MotionEvent.ACTION_DOWN) {
            if (!(event.getX() >= -10 && event.getY() >= -10)
                    || event.getY() <= (screenHeight - coustom_pop_layout.getHeight() - 20)) {//如果点击位置在当前View外部则销毁当前视图,其中10与20为微调距离
                dismiss();
            }
        }
        return true;
    }

    private void setParams(Context context, WindowManager.LayoutParams lay) {
        DisplayMetrics dm = new DisplayMetrics();
        WindowManager wm = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
        wm.getDefaultDisplay().getMetrics(dm);
        Rect rect = new Rect();
        if (getWindow() != null) {
            View view = getWindow().getDecorView();
            view.getWindowVisibleDisplayFrame(rect);
        }
        lay.width = dm.widthPixels;
    }

    protected void initView() {
        btn_customer = (Button) findViewById(R.id.sobot_btn_custom);
        btn_plan = (Button) findViewById(R.id.sobot_btn_plan);
        btn_cancel = (Button) findViewById(R.id.btn_cancel);
        btn_call_up_task_tel = (Button) findViewById(R.id.btn_call_up_task_tel);
        btn_call_up_task_tel_line = (View) findViewById(R.id.btn_call_up_task_tel_line);
        coustom_pop_layout = (LinearLayout) findViewById(R.id.pop_layout);

        btn_customer.setOnClickListener(itemsOnClick);
        btn_plan.setOnClickListener(itemsOnClick);
        btn_cancel.setOnClickListener(itemsOnClick);

        btn_customer.setText(R.string.sobot_create_contact_customer);
        btn_plan.setText(R.string.sobot_create_contact_plan);
        if(data instanceof SobotCallTaskDetailsEntity){
            btn_plan.setVisibility(View.GONE);
            SobotCallTaskDetailsEntity entity = (SobotCallTaskDetailsEntity)data;
        }else{
            btn_plan.setVisibility(View.VISIBLE);
        }
        if (!TextUtils.isEmpty(userTel)) {
            btn_call_up_task_tel.setText(userTel);
        }
        btn_call_up_task_tel.setVisibility(View.VISIBLE);
        btn_call_up_task_tel_line.setVisibility(View.VISIBLE);
    }
}