package com.sobot.callsdk.model;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.Serializable;
import java.util.List;

public class SobotAgentEntity implements Serializable {

    //座席ID
    private String serviceId;
    //座席工号
    private String agentID;
    //座席名字
    private String agentName;
    //座席手机号
    private String phone;
    //当前接听模式 默认 webrtc 网页
    private String currentPhoneType;
    //绑定分机账号
    private String ext;
    //接听方式
    private List<SobotPhoneTypesEntity> phoneTypes;

    public String getAgentID() {
        return agentID;
    }

    public void setAgentID(String agentID) {
        this.agentID = agentID;
    }

    public String getAgentName() {
        return agentName;
    }

    public void setAgentName(String agentName) {
        this.agentName = agentName;
    }

    public String getCurrentPhoneType() {
        return currentPhoneType;
    }

    public void setCurrentPhoneType(String currentPhoneType) {
        this.currentPhoneType = currentPhoneType;
    }

    public String getServiceId() {
        return serviceId;
    }

    public void setServiceId(String serviceId) {
        this.serviceId = serviceId;
    }

    public String getExt() {
        return ext;
    }

    public void setExt(String ext) {
        this.ext = ext;
    }

    public List<SobotPhoneTypesEntity> getPhoneTypes() {
        return phoneTypes;
    }

    public void setPhoneTypes(List<SobotPhoneTypesEntity> phoneTypes) {
        this.phoneTypes = phoneTypes;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }
    public JSONObject getJson(){
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("serviceId",serviceId);
            jsonObject.put("agentID",agentID);
            jsonObject.put("ext",ext);
            jsonObject.put("agentName",agentName);
            jsonObject.put("phone",phone);
            jsonObject.put("currentPhoneType",currentPhoneType);
            JSONArray array = new JSONArray();
            if(phoneTypes!=null) {
                for (int i = 0; i < phoneTypes.size(); i++) {
                    array.put(phoneTypes.get(i).getJson());
                }
            }
            jsonObject.put("phoneTypes",array);
        } catch (JSONException e) {
            e.printStackTrace();
        }
        return jsonObject;
    }
}
