package com.sobot.callsdk.v1.activity;

import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.sobot.callbase.dialog.SobotActionItem;
import com.sobot.callbase.model.SobotExtensionEntity;
import com.sobot.callsdk.R;
import com.sobot.callsdk.activity.SobotDialogBaseActivity;

import java.util.ArrayList;

//分机账号选择界面
public class SobotExtensionNumberChooseActivity extends SobotDialogBaseActivity implements View.OnClickListener {

    private TextView tv_title;//头部标题
    private LinearLayout ll_cancle;//关闭界面返回
    private LinearLayout ll_login_status;//座席状态 父控件
    //上个界面选中的分机号
    private String selectedExt;
    private ArrayList<SobotExtensionEntity> data;
    private ArrayList<SobotActionItem> arrayStatus;

    @Override
    protected int getContentViewResId() {
        return R.layout.sobot_dialog_login_status_choose;
    }

    @Override
    protected void initView() {
        tv_title = findViewById(R.id.tv_title);
        ll_cancle = findViewById(R.id.ll_cancle);
        ll_login_status = findViewById(R.id.ll_login_status);
        ll_cancle.setOnClickListener(this);
        tv_title.setText(getResources().getString(R.string.sobot_please_choose_extension_account));
    }

    @Override
    protected void initData() {
        arrayStatus = new ArrayList<>();
        data = (ArrayList<SobotExtensionEntity>) getIntent().getSerializableExtra("extensionList");
        selectedExt = getIntent().getStringExtra("selectedExt");
        if (TextUtils.isEmpty(selectedExt)) {
            selectedExt = "";
        }
        if (data != null) {
            for (int i = 0; i < data.size(); i++) {
                arrayStatus.add(new SobotActionItem<SobotExtensionEntity>(data.get(i).getExt(), selectedExt.equals(data.get(i).getExt()), data.get(i)));
            }
        }

        for (int i = 0; i < arrayStatus.size(); i++) {
            SobotActionItem actionItem = arrayStatus.get(i);
            View view = LayoutInflater.from(getSobotBaseContext()).inflate(getResLayoutId("sobot_item_login_status_choose"), null);
            TextView tv_name = view.findViewById(getResId("tv_name"));
            ImageView iv_state = view.findViewById(getResId("iv_state"));
            tv_name.setText(actionItem.getmTitle());
            view.setTag(actionItem);
            if (actionItem.isChecked()) {
                iv_state.setVisibility(View.VISIBLE);
            } else {
                iv_state.setVisibility(View.GONE);
            }
            ll_login_status.addView(view);
            view.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    SobotActionItem actionItem = (SobotActionItem) v.getTag();
                    Intent resultIntent = new Intent();
                    Bundle bundle = new Bundle();
                    bundle.putSerializable("extension", (SobotExtensionEntity) actionItem.getObj());
                    resultIntent.putExtras(bundle);
                    setResult(RESULT_OK, resultIntent);
                    finish();
                }
            });
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == ll_cancle.getId()) {
            finish();
        }
    }
}