package com.sobot.callsdk.v1.sipphonelibrary;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;

import org.linphone.core.LinphoneCore;


public class SobotKeepAliveReceiver extends BroadcastReceiver {
    @Override
    public void onReceive(Context context, Intent intent) {
        if (!SobotPhoneService.isReady()) {
            return;
        } else {
            LinphoneCore lc = SobotPhoneManager.getLcIfManagerNotDestroyOrNull();
            if (lc == null) return;

            String action = intent.getAction();
            if (action == null) {
                SobotLogUtil.i("[KeepAlive] Refresh registers");
                lc.refreshRegisters();
                //make sure iterate will have enough time, device will not sleep until exit from this method
                try {
                    Thread.sleep(2000);
                } catch (InterruptedException e) {
                    SobotLogUtil.i("Cannot sleep for 2s", e);
                } finally {
                    //make sure the application will at least wakes up every 10 mn
                }
            } else if (action.equalsIgnoreCase(Intent.ACTION_SCREEN_ON)) {
                SobotLogUtil.i("[KeepAlive] Screen is on, enable");
                lc.enableKeepAlive(true);
            } else if (action.equalsIgnoreCase(Intent.ACTION_SCREEN_OFF)) {
                SobotLogUtil.i("[KeepAlive] Screen is off, disable");
                lc.enableKeepAlive(true);
            }
        }
    }
}
