package com.sobot.callsdk.v6.activity;

import android.content.Intent;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.sobot.callbase.model.SobotCountryRegion;
import com.sobot.callbase.model.SobotOutboundRoutesEntity;
import com.sobot.callbase.utils.CommonUtils;
import com.sobot.callbase.widget.floatwindow.SobotFloatWindow;
import com.sobot.callsdk.R;
import com.sobot.callsdk.activity.SobotCallBaseActivity;
import com.sobot.callsdk.model.SobotCallInfo;
import com.sobot.callsdk.utils.CallSharedPreferencesUtils;
import com.sobot.callsdk.utils.CallStatusUtils;
import com.sobot.callsdk.utils.SobotCallConstant;
import com.sobot.callsdk.v6.dialog.SelectCountryDialog;
import com.sobot.common.login.SobotLoginTools;
import com.sobot.common.login.model.SobotServiceInfoModel;
import com.sobot.network.http.callback.SobotResultCallBack;
import com.sobot.widget.ui.permission.SobotPermissionListenerImpl;
import com.sobot.widget.ui.toast.SobotToastUtil;

import java.util.List;

/**
 * 拨号键盘界面
 */
public class CallNumberActivity extends SobotCallBaseActivity implements View.OnClickListener {

    private LinearLayout mLlNum1;
    private LinearLayout mLlNum2;
    private LinearLayout mLlNum3;
    private LinearLayout mLlNum4;
    private LinearLayout mLlNum5;
    private LinearLayout mLlNum6;
    private LinearLayout mLlNum7;
    private LinearLayout mLlNum8;
    private LinearLayout mLlNum9;
    private LinearLayout mLlNum10;//*号
    private LinearLayout mLlNum11;
    private LinearLayout mLlNum12;//#号
    private ImageView iv_accept;
    private ImageView iv_delete_num;
    private ImageView iv_retract;
    private EditText mTvPhoneNumber;//号码显示

    private LinearLayout ll_code;
    private TextView tv_code;//区域编码

    private LinearLayout ll_logined;//登录后如果有切换外显号权限,则显示,否则只显示标题
    private TextView tv_mobile;
    //外呼规则
    private SobotOutboundRoutesEntity outboundRoutes;
    private PopupWindow popupWindow;

    private SobotCallInfo callInfo;
    private String userPhoneNumber; //用户电话号码
    private String userNike;//用户昵称

    private String mGroupId;//技能组id


    private SobotServiceInfoModel serviceVo;

    private SelectCountryDialog countryDialog;//选国家编码的对话框
    private List<SobotCountryRegion> countryRegionList;//选国家编码列表
    private String callingCode;//坐席选择外呼时得国际编码

    @Override
    protected int getContentViewResId() {
        return R.layout.activity_call_number;
    }

    @Override
    protected void initView() {
        setUpToolBarLeftMenu();
        mLlNum1 = findViewById(R.id.ll_num_1);
        mLlNum2 = findViewById(R.id.ll_num_2);
        mLlNum3 = findViewById(R.id.ll_num_3);
        mLlNum4 = findViewById(R.id.ll_num_4);
        mLlNum5 = findViewById(R.id.ll_num_5);
        mLlNum6 = findViewById(R.id.ll_num_6);
        mLlNum7 = findViewById(R.id.ll_num_7);
        mLlNum8 = findViewById(R.id.ll_num_8);
        mLlNum9 = findViewById(R.id.ll_num_9);
        mLlNum10 = findViewById(R.id.ll_num_10);
        mLlNum11 = findViewById(R.id.ll_num_11);
        mLlNum12 = findViewById(R.id.ll_num_12);
        mLlNum1.setOnClickListener(this);
        mLlNum2.setOnClickListener(this);
        mLlNum3.setOnClickListener(this);
        mLlNum4.setOnClickListener(this);
        mLlNum5.setOnClickListener(this);
        mLlNum6.setOnClickListener(this);
        mLlNum7.setOnClickListener(this);
        mLlNum8.setOnClickListener(this);
        mLlNum9.setOnClickListener(this);
        mLlNum10.setOnClickListener(this);
        mLlNum11.setOnClickListener(this);
        mLlNum12.setOnClickListener(this);
        iv_accept = findViewById(R.id.iv_accept);
        iv_accept.setOnClickListener(this);
        iv_delete_num = findViewById(R.id.iv_delete_num);
        iv_delete_num.setOnClickListener(this);
        iv_retract = findViewById(R.id.iv_retract);
        iv_retract.setOnClickListener(this);
        mTvPhoneNumber = findViewById(R.id.tv_user_phone_number);
        mTvPhoneNumber.setShowSoftInputOnFocus(false);
        tv_code = findViewById(R.id.tv_code);
        ll_code = findViewById(R.id.ll_code);
        ll_code.setOnClickListener(this);

        ll_logined = findViewById(R.id.ll_logined);
        tv_mobile = findViewById(R.id.tv_mobile);
        ll_logined.setOnClickListener(this);

        mTvPhoneNumber.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                if (s.length() > 0) {
                    iv_delete_num.setVisibility(View.VISIBLE);
                } else {
                    iv_delete_num.setVisibility(View.GONE);
                }
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
    }

    @Override
    protected void initData() {
        serviceVo = SobotLoginTools.getInstance().getServiceInfo();
        if (serviceVo != null) {
            //请求外显规则
            getOutboudRoutesRules(false, ll_logined, tv_mobile);
            int region = serviceVo.getRegion();
            // region（0国内  1国外）
            if (region == 1) {
                ll_code.setVisibility(View.VISIBLE);
                callingCode = CallSharedPreferencesUtils.getInstance(getSobotBaseActivity()).get(SobotCallConstant.CALLING_CODE);
                if (TextUtils.isEmpty(callingCode)) {
                    zhiChiApi.searchCallingCodeV6(getSobotBaseActivity(), new SobotResultCallBack<String>() {
                        @Override
                        public void onSuccess(String s) {
                            if (!TextUtils.isEmpty(s)) {
                                CallSharedPreferencesUtils.getInstance(getSobotBaseActivity()).put(SobotCallConstant.CALLING_CODE, s);
                                callingCode = s;
                            }
                            zhiChiApi.searchAreaListV6(getSobotBaseActivity(), new SobotResultCallBack<List<SobotCountryRegion>>() {
                                @Override
                                public void onSuccess(List<SobotCountryRegion> sobotCountryRegions) {
                                    if (sobotCountryRegions != null) {
                                        if (countryRegionList == null) {
                                            countryRegionList = sobotCountryRegions;
                                        } else {
                                            countryRegionList.clear();
                                            countryRegionList.addAll(sobotCountryRegions);
                                        }
                                        if (!TextUtils.isEmpty(s)) {
                                            for (int i = 0; i < sobotCountryRegions.size(); i++) {
                                                if (s.equals(sobotCountryRegions.get(i).getCallingCode())) {
                                                    tv_code.setText(sobotCountryRegions.get(i).getCallingCode() + " " + sobotCountryRegions.get(i).getName());
                                                }
                                            }
                                        }

                                    }
                                }

                                @Override
                                public void onFailure(Exception e, String des) {

                                }
                            });
                        }

                        @Override
                        public void onFailure(Exception e, String des) {

                        }
                    });
                } else {
                    zhiChiApi.searchAreaListV6(getSobotBaseActivity(), new SobotResultCallBack<List<SobotCountryRegion>>() {
                        @Override
                        public void onSuccess(List<SobotCountryRegion> sobotCountryRegions) {
                            if (sobotCountryRegions != null) {
                                if (countryRegionList == null) {
                                    countryRegionList = sobotCountryRegions;
                                } else {
                                    countryRegionList.clear();
                                    countryRegionList.addAll(sobotCountryRegions);
                                }
                                if (!TextUtils.isEmpty(callingCode)) {
                                    for (int i = 0; i < sobotCountryRegions.size(); i++) {
                                        if (callingCode.equals(sobotCountryRegions.get(i).getCallingCode())) {
                                            tv_code.setText(sobotCountryRegions.get(i).getCallingCode() + " " + sobotCountryRegions.get(i).getName());
                                        }
                                    }
                                }

                            }
                        }

                        @Override
                        public void onFailure(Exception e, String des) {

                        }
                    });
                }
            } else {
                ll_code.setVisibility(View.GONE);
            }
        }

        callInfo = (SobotCallInfo) getIntent().getSerializableExtra("callInfo");
        userPhoneNumber = getIntent().getStringExtra("userPhoneNumber");
        userNike = getIntent().getStringExtra("userNike");
        if (!TextUtils.isEmpty(userPhoneNumber)) {
            mTvPhoneNumber.setText(userPhoneNumber);
        }
    }

    @Override
    public void onClick(View v) {
        if (ll_logined.equals(v)) {
            //弹窗,打开切换外显号
            getOutboudRoutesRules(true, ll_logined, tv_mobile);
        } else if (mLlNum1.equals(v)) {
            addNum("1");
        } else if (mLlNum2.equals(v)) {
            addNum("2");
        } else if (mLlNum3.equals(v)) {
            addNum("3");
        } else if (mLlNum4.equals(v)) {
            addNum("4");
        } else if (mLlNum5.equals(v)) {
            addNum("5");
        } else if (mLlNum6.equals(v)) {
            addNum("6");
        } else if (mLlNum7.equals(v)) {
            addNum("7");
        } else if (mLlNum8.equals(v)) {
            addNum("8");
        } else if (mLlNum9.equals(v)) {
            addNum("9");
        } else if (mLlNum10.equals(v)) {
            addNum("*");
        } else if (mLlNum11.equals(v)) {
            addNum("0");
        } else if (mLlNum12.equals(v)) {
            addNum("#");
        } else if (iv_accept.equals(v)) {
            if (!CommonUtils.isNetWorkConnected(getSobotBaseActivity())) {
                SobotToastUtil.showToast(getSobotBaseActivity(), getString(R.string.sobot_call_net_error_string));
            } else {
                permissionListener = new SobotPermissionListenerImpl() {
                    @Override
                    public void onPermissionSuccessListener() {
                        callNumber();
                    }
                };

                //判断是否有权限
                if (checkIsShowPermissionPop(getResources().getString(R.string.sobot_microphone), getResources().getString(R.string.sobot_microphone_yongtu), 2, 3)) {
                    return;
                }
                if (isHasAudioPermission()) {
                    callNumber();
                }
            }
        } else if (iv_delete_num.equals(v)) {
            onDeleteClicked();
        } else if (iv_retract.equals(v)) {
            finish();
            //该方法的参数：前者是将要进入activity的进入动画，后者是正要退出activity的动画
            overridePendingTransition(-1, R.anim.anim_activity_slide_out_top);
        } else if (ll_code.equals(v)) {
            if (serviceVo != null) {
                int region = serviceVo.getRegion();
                // region（0国内  1国外）
                if (region == 1) {
                    if (countryRegionList == null) {
                        zhiChiApi.searchAreaListV6(getSobotBaseActivity(), new SobotResultCallBack<List<SobotCountryRegion>>() {
                            @Override
                            public void onSuccess(List<SobotCountryRegion> sobotCountryRegions) {
                                if (sobotCountryRegions != null) {
                                    if (countryRegionList == null) {
                                        countryRegionList = sobotCountryRegions;
                                    } else {
                                        countryRegionList.clear();
                                        countryRegionList.addAll(sobotCountryRegions);
                                    }
                                    if (countryDialog == null) {
                                        countryDialog = new SelectCountryDialog(CallNumberActivity.this, new SelectCountryDialog.CountryRegionListener() {
                                            @Override
                                            public void selectCountryRegion(SobotCountryRegion checkin) {
                                                countryDialog.dismiss();
                                                for (int i = 0; i < countryRegionList.size(); i++) {
                                                    if (countryRegionList.get(i).getCode().equals(checkin.getCode())) {
                                                        countryRegionList.get(i).setSelect(true);
                                                        tv_code.setText(checkin.getCallingCode() + " " + checkin.getName());
                                                        CallSharedPreferencesUtils.getInstance(getSobotBaseActivity()).put(SobotCallConstant.CALLING_CODE, countryRegionList.get(i).getCallingCode());
                                                        callingCode = countryRegionList.get(i).getCallingCode();
                                                    } else {
                                                        countryRegionList.get(i).setSelect(false);
                                                    }
                                                }
                                            }
                                        }, countryRegionList);
                                    } else {
                                        countryDialog.setData(countryRegionList);
                                    }
                                    countryDialog.show();
                                }
                            }

                            @Override
                            public void onFailure(Exception e, String des) {

                            }
                        });

                    } else {
                        if (countryDialog == null) {
                            countryDialog = new SelectCountryDialog(CallNumberActivity.this, new SelectCountryDialog.CountryRegionListener() {
                                @Override
                                public void selectCountryRegion(SobotCountryRegion checkin) {
                                    countryDialog.dismiss();
                                    for (int i = 0; i < countryRegionList.size(); i++) {
                                        if (countryRegionList.get(i).getCode().equals(checkin.getCode())) {
                                            countryRegionList.get(i).setSelect(true);
                                            tv_code.setText(checkin.getCallingCode() + " " + checkin.getName());
                                            CallSharedPreferencesUtils.getInstance(getSobotBaseActivity()).put(SobotCallConstant.CALLING_CODE, countryRegionList.get(i).getCallingCode());
                                            callingCode = countryRegionList.get(i).getCallingCode();
                                        } else {
                                            countryRegionList.get(i).setSelect(false);
                                        }
                                    }
                                }
                            }, countryRegionList);
                        } else {
                            countryDialog.setData(countryRegionList);
                        }
                        countryDialog.show();
                    }
                }
            }
        }
    }

    // 添加号码
    private void addNum(String string) {
        mTvPhoneNumber.setCursorVisible(false);
        mTvPhoneNumber.append(string);
        iv_delete_num.setVisibility(View.VISIBLE);
    }


    // 开始外呼，跳转到通话界面
    private void callNumber() {
        //判断是否登录
        String call_loingStatus = CallSharedPreferencesUtils.getInstance(getSobotBaseActivity()).get(SobotCallConstant.callLoginStatus, CallStatusUtils.V6_OFFLINE);
        if (call_loingStatus.equals(CallStatusUtils.V6_FINISHING)) {
            //判断是否正在整理中
            SobotToastUtil.showToast(getSobotBaseActivity(), getResources().getString(R.string.sobot_error_switch_status));
        } else if (call_loingStatus.equals(CallStatusUtils.V6_SYSYTEM_BUSY)) {
            SobotToastUtil.showToast(getSobotBaseActivity(), getResources().getString(R.string.call_str_system_Lock_toast));
        } else if (call_loingStatus.equals(CallStatusUtils.V6_OFFLINE)) {
            SobotToastUtil.showToast(getSobotBaseActivity(), getResources().getString(R.string.sobot_call_error_hint));
        } else if (SobotFloatWindow.get(SobotCallConstant.CALL_STATUS_FLOAT) != null && SobotFloatWindow.get(SobotCallConstant.CALL_STATUS_FLOAT).isShowing()) {
            //通话没结束，不能拨号
            SobotToastUtil.showCustomToast(getApplicationContext(), getString(R.string.call_retcode_330035));
        } else {
            String phoneNum = mTvPhoneNumber.getText().toString();
            if (!TextUtils.isEmpty(phoneNum)) {
                //检验长度 3-16 不带区号
                if (phoneNum.trim().length() > 16 || phoneNum.trim().length() < 3) {
                    SobotToastUtil.showCustomToast(getSobotBaseActivity(), getString(R.string.call_login_phone_length_hint));
                    return;
                }
                Intent intent = CallStatusActivity.initIntent(CallNumberActivity.this, "", (TextUtils.isEmpty(callingCode) ? "" : callingCode) + phoneNum);
                intent.setFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP | Intent.FLAG_ACTIVITY_CLEAR_TOP |
                        Intent.FLAG_ACTIVITY_NEW_TASK);
                this.startActivity(intent);
            } else {
                SobotToastUtil.showCustomToast(getSobotBaseActivity(), getResources().getString(R.string.sobot_please_input_phone_number));
            }
        }
    }

    // 删除号码
    public void onDeleteClicked() {
        String str = mTvPhoneNumber.getText().toString();
        if (str.length() > 0) {
            str = str.substring(0, str.length() - 1);
        }
        mTvPhoneNumber.setText(str);
        String str2 = mTvPhoneNumber.getText().toString();
        if (str2.length() > 0) {
            iv_delete_num.setVisibility(View.VISIBLE);
            mTvPhoneNumber.setSelection(str2.length());
            mTvPhoneNumber.setCursorVisible(false);
        } else {
            iv_delete_num.setVisibility(View.GONE);
            mTvPhoneNumber.setCursorVisible(true);
        }
    }


}