package com.sobot.callsdk.v6.activity;

import androidx.lifecycle.Observer;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.provider.Settings;

import androidx.annotation.Nullable;

import android.text.TextUtils;
import android.view.View;
import android.view.animation.BounceInterpolator;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TableLayout;
import android.widget.TextView;

import com.sobot.callbase.CallPermissionManager;
import com.sobot.callbase.api.utils.SobotStompEventConstant;
import com.sobot.callbase.constant.SobotCallLiveDataBusKey;
import com.sobot.callbase.model.CallCurrentStatusModel;
import com.sobot.callbase.model.CallNumberCity;
import com.sobot.callbase.model.CallStompMsgModel;
import com.sobot.callbase.model.CallTaskDetailsModel;
import com.sobot.callbase.model.SobotAgentStatusInfo;
import com.sobot.callbase.model.SobotCallEvent;
import com.sobot.callbase.model.SobotCallStatusEntity;
import com.sobot.callbase.model.SobotEventAgentLogin;
import com.sobot.callbase.stomp.SobotStompClient;
import com.sobot.callbase.utils.CallFastClickUtils;
import com.sobot.callbase.utils.HomeWatcher;
import com.sobot.callbase.widget.floatwindow.FloatingWindowPermissionUtil;
import com.sobot.callbase.widget.floatwindow.IFloatWindow;
import com.sobot.callbase.widget.floatwindow.MoveType;
import com.sobot.callbase.widget.floatwindow.Screen;
import com.sobot.callbase.widget.floatwindow.SobotFloatWindow;
import com.sobot.callsdk.R;
import com.sobot.callsdk.SobotCallOpenApi;
import com.sobot.callsdk.activity.SobotCallBaseActivity;
import com.sobot.callsdk.janus.SobotJanusSipPhoneUtils;
import com.sobot.callsdk.model.SobotCallCustomerModel;
import com.sobot.callsdk.sip.SobotSipUtils;
import com.sobot.callsdk.utils.CallSharedPreferencesUtils;
import com.sobot.callsdk.utils.CallStatusUtils;
import com.sobot.callsdk.utils.SobotCallConstant;
import com.sobot.callsdk.v6.callenum.CallStage;
import com.sobot.common.login.SobotLoginTools;
import com.sobot.common.login.callback.SobotResultBlock;
import com.sobot.common.login.callback.SobotResultCode;
import com.sobot.common.login.model.SobotServiceInfoModel;
import com.sobot.common.login.permission.SobotPermissionManager;
import com.sobot.gson.SobotGsonUtil;
import com.sobot.network.http.callback.SobotResultCallBack;
import com.sobot.utils.SobotLogUtils;
import com.sobot.utils.SobotStringUtils;
import com.sobot.widget.livedatabus.SobotLiveEventBus;
import com.sobot.widget.ui.permission.SobotPermissionTipDialog;
import com.sobot.widget.ui.statusbar.SobotStatusBarUtils;
import com.sobot.widget.ui.toast.SobotToastUtil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

//通话界面
public class CallStatusActivity extends SobotCallBaseActivity implements View.OnClickListener {

    private ImageView iv_retract;//界面收起
    private TextView mTvNick;//通话人昵称
    private TextView mTvNum;//通话号码
    private View v_num_split;//通话号码和所属地 分割线
    private TextView tv_address;//通话号码 所属地
    private TextView mTvStatus;//未接通-通话状态，接通后-显示时间
    private String mStatus;//通话状态

    private TextView tv_transfer_from_nick;//转移自
    private TextView tv_consult_you;//正向您咨询

    private TextView tv_phone_call_you;//手机方式打电话


    private LinearLayout ll_seats;//被咨询和被转移  三方坐席卡片区域
    private TextView tv_seats_nick;//昵称
    private TextView tv_seats_status;//状态
    private TextView tv_seats_time;//时间

    private LinearLayout ll_user_card;//被咨询和被转移 用户卡片区域
    private TextView tv_user_card_nick;//昵称
    private TextView tv_user_card_status;//状态
    private TextView tv_user_card_time;//时间
    private TextView tv_user_card_num;//手机号
    private TextView tv_user_card_address;//地址

    private LinearLayout ll_hung_accept;//来电 接听挂断区域
    private LinearLayout call_hang_up_ll;//挂断
    private LinearLayout call_accept_ll;//接听

    private TextView tv_exit;//咨询中退出
    private ImageView iv_exit;//挂断

    private LinearLayout ll_meau;//呼叫功能菜单
    private LinearLayout ll_meau_first;//第一排菜单
    private LinearLayout ll_hang_up;//挂断
    private TextView tv_mute;//静音
    private TextView tv_hold;//保持
    private TextView tv_hung_invite;//挂机邀评
    private TextView tv_on_speakerphone;//免提
    private TextView tv_keyword;//键盘显示隐藏切换

    private LinearLayout ll_userinfo_summary_bg;//客户资料和服务总结 背景色
    private View v_service_summary_split;//客户资料和服务总结 分割线
    private LinearLayout ll_user_info;//客户资料
    private TextView tv_user_info;
    private int userInfoType = -1;//客户资料点击查看类型 0：新建客户 1客户资料 2关联客户
    private LinearLayout ll_service_summary;//服务总结
    private TextView tv_service_summary;

    private LinearLayout ll_head;//上一部分界面
    private TableLayout tl_keyword;//键盘区域
    private TextView tv_keyword_number;//键盘输入内容
    private LinearLayout mLlNum1;
    private LinearLayout mLlNum2;
    private LinearLayout mLlNum3;
    private LinearLayout mLlNum4;
    private LinearLayout mLlNum5;
    private LinearLayout mLlNum6;
    private LinearLayout mLlNum7;
    private LinearLayout mLlNum8;
    private LinearLayout mLlNum9;
    private LinearLayout mLlNum10;//*号
    private LinearLayout mLlNum11;
    private LinearLayout mLlNum12;//#号


    private String mNum = "";//加密号，用于拨号
    private String mScreenNum = "";//屏显号码
    private boolean isCall;
    private String sourceType;//外呼来源类型
    private String sourceId;//外呼来源id
    private long callDuration = 0;//通话状态（振铃中、通话中、保持中。。。）
    private long userDuration = 0;//咨询 用户通话 计时器
    private long thirdDuration = 0;//三方坐席 通话  计时器

    //任务呼叫
    private String recordId, campaignId, contactName;
    private int dialCount, status, taskFromType;
    private ArrayList<CallTaskDetailsModel> taskRecordList;

    private boolean callRunning;
    private Handler mHandler;

    private SobotServiceInfoModel serviceVo;


    //点击通话浮层刷新界面的需要信息
    private String callId;
    private String customerId = "";//用户id
    private String customerAddress = "";//用户地址
    private String customerNick = "";//用户昵称
    private String customerPhone = "";//用户手机号
    private String privacyNumber = "";//用户手机号 加密，有值优先显示
    private String _otherAgentName = "";//用户 昵称
    private String _thirdAgentName = "";//转移自  坐席昵称
    private boolean isShowKeywordOn = false;//是否显示键盘按键 默认不显示
    private boolean isSpeakerphoneOn = false;//免提
    private boolean isHoldOn = false;//保持
    private boolean isMuteOn = false;//静音

    private long currentCallDuration = 0;//最小化时 当前通话时间
    private long currentUserDuration = 0;//最小化时 咨询 用户通话
    private long currentThirdDuration = 0;//最小化时 三方坐席 通话
    private int currentStatus = -1;//-1，不处理，0 来电-振铃， 1 外呼-振铃， 2 被咨询-振铃，3 被转移-振铃， 4 普通-通话中， 5咨询中， 6 咨询后三方，7 咨询后转移，8 手机通话 来电 9强插

    private String callType;// 呼叫类型  Inbound:呼入; Outbound:呼出; Internal:内部; Consult:咨询

    //手机来电用到
    private String mStompMessageID;
    private String mStompMessageContent;
    private int inComingcallType;

    private boolean call_service_summary_flag;//服务总结开关

    int callWay;//坐席登录方式 sip 手机

    HomeWatcher mHomeWatcher;//home监听

    /**
     * @param context
     * @param num       必填  外呼电话
     * @param screenNum 必填  外呼电话
     * @return
     */
    public static Intent initIntent(Context context, String num, String screenNum) {
        Intent intent = new Intent(context, CallStatusActivity.class);
        intent.putExtra("num", num);
        intent.putExtra("screenNum", screenNum);
        intent.putExtra("isCallOut", true);
        return intent;
    }

    /**
     * @param context
     * @param num
     * @param screenNum
     * @param sourceType 外呼来源类型
     * @param sourceId   外呼来源id
     * @param customerId 客户id
     * @return
     */
    public static Intent initIntent(Context context, String num, String screenNum, String sourceType, String sourceId, String customerId) {
        Intent intent = new Intent(context, CallStatusActivity.class);
        intent.putExtra("num", num);
        intent.putExtra("screenNum", screenNum);
        intent.putExtra("isCallOut", true);
        intent.putExtra("sourceType", sourceType);
        intent.putExtra("sourceId", sourceId);
        intent.putExtra("customerId", customerId);
        return intent;
    }

    public static Intent initCallMeIntent(Context context, String num) {
        Intent intent = new Intent(context, CallStatusActivity.class);
        intent.putExtra("num", num);
        intent.putExtra("isCallOut", false);
        return intent;

    }

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        try {
            SobotStatusBarUtils.setStatusBarColor(this, getResources().getColor(R.color.call_status_gradient_start));
        } catch (Exception e) {
            //请传入正确的颜色值
        }
    }

    @Override
    protected int getContentViewResId() {
        return R.layout.activity_call_status;
    }

    String incomimgJsep;

    boolean isAutoAccept = false;//是否自动接听 调用accept

    long callDurationStart;//来电响铃开始时间

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        setIntent(intent);
        incomimgJsep = getIntent().getStringExtra("incomimgJsep");
        isAutoAccept = getIntent().getBooleanExtra("isAutoAccept", false);
        callDurationStart = getIntent().getLongExtra("callDurationStart", 0);
        init(false);
    }

    @Override
    protected void initView() {
        if (mHomeWatcher == null) {
            mHomeWatcher = new HomeWatcher(this);
        }
        mHomeWatcher.setOnHomePressedListener(new HomeWatcher.OnHomePressedListener() {
            @Override
            public void onHomePressed() {
                //按了HOME键
                closeBack();
            }

            @Override
            public void onHomeLongPressed() {
                //长按HOME键
            }
        });
        mHomeWatcher.startWatch();

        call_service_summary_flag = CallSharedPreferencesUtils.getInstance(getSobotBaseActivity()).get(SobotCallConstant.CALL_SERVICE_SUMMARY_FLAG, false);
        mStatus = getString(R.string.call_in_call);
        mHandler = new Handler();
        serviceVo = SobotLoginTools.getInstance().getServiceInfo();
        iv_retract = findViewById(R.id.iv_retract);
        iv_retract.setOnClickListener(this);

        mTvNick = findViewById(R.id.tv_nick);
        mTvNum = findViewById(R.id.tv_num);
        v_num_split = findViewById(R.id.v_num_split);
        tv_address = findViewById(R.id.tv_address);
        mTvStatus = findViewById(R.id.tv_status);
        tv_transfer_from_nick = findViewById(R.id.tv_transfer_from_nick);
        tv_consult_you = findViewById(R.id.tv_consult_you);
        tv_phone_call_you = findViewById(R.id.tv_phone_call_you);
        ll_seats = findViewById(R.id.ll_seats);
        tv_seats_nick = findViewById(R.id.tv_seats_nick);
        tv_seats_status = findViewById(R.id.tv_seats_status);
        tv_seats_time = findViewById(R.id.tv_seats_time);

        ll_user_card = findViewById(R.id.ll_user_card);
        tv_user_card_nick = findViewById(R.id.tv_user_card_nick);
        tv_user_card_status = findViewById(R.id.tv_user_card_status);
        tv_user_card_time = findViewById(R.id.tv_user_card_time);
        tv_user_card_num = findViewById(R.id.tv_user_card_num);
        tv_user_card_address = findViewById(R.id.tv_user_card_address);

        ll_hung_accept = findViewById(R.id.ll_hung_accept);
        call_hang_up_ll = findViewById(R.id.call_hang_up_ll);
        call_accept_ll = findViewById(R.id.call_accept_ll);
        call_accept_ll.setOnClickListener(this);
        call_hang_up_ll.setOnClickListener(this);

        tv_exit = findViewById(R.id.tv_exit);
        iv_exit = findViewById(R.id.iv_exit);

        ll_head = findViewById(R.id.ll_head);
        tl_keyword = findViewById(R.id.tl_keyword);
        tv_keyword_number = findViewById(R.id.tv_keyword_number);
        mLlNum1 = findViewById(R.id.ll_num_1);
        mLlNum2 = findViewById(R.id.ll_num_2);
        mLlNum3 = findViewById(R.id.ll_num_3);
        mLlNum4 = findViewById(R.id.ll_num_4);
        mLlNum5 = findViewById(R.id.ll_num_5);
        mLlNum6 = findViewById(R.id.ll_num_6);
        mLlNum7 = findViewById(R.id.ll_num_7);
        mLlNum8 = findViewById(R.id.ll_num_8);
        mLlNum9 = findViewById(R.id.ll_num_9);
        mLlNum10 = findViewById(R.id.ll_num_10);
        mLlNum11 = findViewById(R.id.ll_num_11);
        mLlNum12 = findViewById(R.id.ll_num_12);
        mLlNum1.setOnClickListener(this);
        mLlNum2.setOnClickListener(this);
        mLlNum3.setOnClickListener(this);
        mLlNum4.setOnClickListener(this);
        mLlNum5.setOnClickListener(this);
        mLlNum6.setOnClickListener(this);
        mLlNum7.setOnClickListener(this);
        mLlNum8.setOnClickListener(this);
        mLlNum9.setOnClickListener(this);
        mLlNum10.setOnClickListener(this);
        mLlNum11.setOnClickListener(this);
        mLlNum12.setOnClickListener(this);

        ll_meau = findViewById(R.id.ll_meau);
        ll_meau_first = findViewById(R.id.ll_meau_first);
        ll_hang_up = findViewById(R.id.ll_hang_up);
        ll_hang_up.setOnClickListener(this);
        tv_mute = findViewById(R.id.tv_mute);
        tv_mute.setOnClickListener(this);
        tv_mute.setClickable(false);
        tv_mute.setEnabled(false);
        tv_hold = findViewById(R.id.tv_hold);
        tv_hold.setOnClickListener(this);
        tv_hold.setClickable(false);
        tv_hold.setEnabled(false);
        tv_hung_invite = findViewById(R.id.tv_hung_invite);
        tv_hung_invite.setOnClickListener(this);
        tv_hung_invite.setClickable(false);
        tv_hung_invite.setEnabled(false);
        tv_on_speakerphone = findViewById(R.id.tv_on_speakerphone);
        tv_on_speakerphone.setOnClickListener(this);
        tv_keyword = findViewById(R.id.tv_keyword);
        tv_keyword.setOnClickListener(this);
        tv_keyword.setClickable(false);
        tv_keyword.setEnabled(false);

        ll_userinfo_summary_bg = findViewById(R.id.ll_userinfo_summary_bg);
        v_service_summary_split = findViewById(R.id.v_service_summary_split);
        ll_user_info = findViewById(R.id.ll_user_info);
        tv_user_info = findViewById(R.id.tv_user_info);
        tv_service_summary = findViewById(R.id.tv_service_summary);
        ll_service_summary = findViewById(R.id.ll_service_summary);
        ll_user_info.setOnClickListener(this);
        ll_service_summary.setOnClickListener(this);

        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_DHT_BCHBCQX)) {
            tv_hold.setVisibility(View.VISIBLE);
        } else {
            tv_hold.setVisibility(View.GONE);
        }
        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_DHT_JYHJYQX)) {
            tv_mute.setVisibility(View.VISIBLE);
        } else {
            tv_mute.setVisibility(View.GONE);
        }
        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_DHT_FSMYD)) {
            tv_hung_invite.setVisibility(View.VISIBLE);
        } else {
            tv_hung_invite.setVisibility(View.GONE);
        }

        //没有服务总结和客户信息权限
        if (!CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_XZKH) && !(call_service_summary_flag && CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_FWZJ))) {
            ll_userinfo_summary_bg.setBackgroundColor(Color.TRANSPARENT);
        } else {
            ll_userinfo_summary_bg.setBackgroundColor(getResources().getColor(R.color.call_userinfo_summary_bg));
        }
    }

    //最小化
    private void minimize() {
        if (currentStatus == -1) {
            //还没收到来电事件，不能最小化
            return;
        }
        //界面最小化（关闭界面）
        IFloatWindow iFloatWindow = SobotFloatWindow.get(SobotCallConstant.CALL_STATUS_FLOAT);
        currentCallDuration = System.currentTimeMillis() - callDuration * 1000;//最小化时 当前通话时间
        currentUserDuration = System.currentTimeMillis() - userDuration * 1000;//最小化时 咨询 用户通话
        currentThirdDuration = System.currentTimeMillis() - thirdDuration * 1000;//最小化时 三方坐席 通话
        CallCurrentStatusModel callCurrentStatusModel = new CallCurrentStatusModel();
        callCurrentStatusModel.setCustomerAddress(customerAddress);
        callCurrentStatusModel.setCustomerId(customerId);
        callCurrentStatusModel.setCustomerNick(customerNick);
        callCurrentStatusModel.setIncomimgJsep(incomimgJsep);
        callCurrentStatusModel.setCustomerPhone(customerPhone);
        callCurrentStatusModel.setPrivacyNumber(privacyNumber);
        callCurrentStatusModel.set_otherAgentName(_otherAgentName);
        callCurrentStatusModel.setCurrentCallDuration(currentCallDuration);
        callCurrentStatusModel.setCurrentUserDuration(currentUserDuration);
        callCurrentStatusModel.setCurrentThirdDuration(currentThirdDuration);
        callCurrentStatusModel.setCurrentStatus(currentStatus);
        callCurrentStatusModel.setStompMessageID(mStompMessageID);
        callCurrentStatusModel.setStompMessageContent(mStompMessageContent);
        callCurrentStatusModel.setInComingcallType(inComingcallType);
        callCurrentStatusModel.setSpeakerphoneOn(isSpeakerphoneOn);
        callCurrentStatusModel.setHoldOn(isHoldOn);
        callCurrentStatusModel.setMuteOn(isMuteOn);
        callCurrentStatusModel.setCallId(callId);
        callCurrentStatusModel.setCallType(callType);
        callCurrentStatusModel.setRecordId(recordId);
        callCurrentStatusModel.setCampaignId(campaignId);
        callCurrentStatusModel.setDialCount(dialCount);
        callCurrentStatusModel.setStatus(status);
        callCurrentStatusModel.setTaskFromType(taskFromType);
        callCurrentStatusModel.setContactName(contactName);
        callCurrentStatusModel.setTaskRecordList(taskRecordList);
        callCurrentStatusModel.setSourceId(sourceId);
        callCurrentStatusModel.setSourceType(sourceType);
        String callCurrentStatusModelStr = SobotGsonUtil.beanToJson(callCurrentStatusModel);

        if (iFloatWindow == null) {
            SobotFloatWindow.B floatWindow = SobotFloatWindow
                    .with(getApplicationContext())
                    .setView(R.layout.call_float_window)
                    .setTag(SobotCallConstant.CALL_STATUS_FLOAT)
                    .setX(Screen.width, 0.73f)
                    .setY(Screen.height, 0.2f)
                    .setMoveType(MoveType.slide)
                    .setMoveStyle(500, new BounceInterpolator())
                    .setDesktopShow(true);
            floatWindow.build();
            SobotFloatWindow.get(SobotCallConstant.CALL_STATUS_FLOAT).show();
        } else {
            iFloatWindow.show();
        }
        View statusFloatView = SobotFloatWindow.get(SobotCallConstant.CALL_STATUS_FLOAT).getView();
        TextView tv_data = statusFloatView.findViewById(R.id.tv_data);
        if (tv_data != null && !SobotStringUtils.isEmpty(callCurrentStatusModelStr)) {
            tv_data.setText(callCurrentStatusModelStr);
        }
        TextView fStatusTV = statusFloatView.findViewById(R.id.tv_call_statue);
        fStatusTV.setText(mStatus);
        statusFloatView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //最小化后再次打开发个空的消息，防止通话页面黏性事件再次收到最后一个stomp事件
                SobotLiveEventBus.get(SobotCallLiveDataBusKey.RECEIVE_STOMP_MSG).post(new CallStompMsgModel());
                Intent intent = CallStatusActivity.initCallMeIntent(getSobotBaseActivity(), "");
                intent.setFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP | Intent.FLAG_ACTIVITY_CLEAR_TOP |
                        Intent.FLAG_ACTIVITY_NEW_TASK);
                TextView tv_data = statusFloatView.findViewById(R.id.tv_data);
                if (tv_data != null && !SobotStringUtils.isEmpty(tv_data.getText().toString())) {
                    CallCurrentStatusModel callCurrentStatusModel = SobotGsonUtil.jsonToBean(tv_data.getText().toString(), CallCurrentStatusModel.class);
                    if (callCurrentStatusModel != null) {
                        customerAddress = callCurrentStatusModel.getCustomerAddress();
                        customerId = callCurrentStatusModel.getCustomerId();
                        customerNick = callCurrentStatusModel.getCustomerNick();
                        incomimgJsep = callCurrentStatusModel.getIncomimgJsep();
                        customerPhone = callCurrentStatusModel.getCustomerPhone();
                        privacyNumber = callCurrentStatusModel.getPrivacyNumber();
                        _otherAgentName = callCurrentStatusModel.get_otherAgentName();
                        currentCallDuration = callCurrentStatusModel.getCurrentCallDuration();
                        currentUserDuration = callCurrentStatusModel.getCurrentUserDuration();
                        currentThirdDuration = callCurrentStatusModel.getCurrentThirdDuration();
                        currentStatus = callCurrentStatusModel.getCurrentStatus();
                        mStompMessageID = callCurrentStatusModel.getStompMessageID();
                        mStompMessageContent = callCurrentStatusModel.getStompMessageContent();
                        inComingcallType = callCurrentStatusModel.getInComingcallType();
                        callCurrentStatusModel.isSpeakerphoneOn();
                        callCurrentStatusModel.isHoldOn();
                        callCurrentStatusModel.isMuteOn();
                        callId = callCurrentStatusModel.getCallId();
                        callType = callCurrentStatusModel.getCallType();
                        recordId = callCurrentStatusModel.getRecordId();
                        campaignId = callCurrentStatusModel.getCampaignId();
                        dialCount = callCurrentStatusModel.getDialCount();
                        status = callCurrentStatusModel.getStatus();
                        taskFromType = callCurrentStatusModel.getTaskFromType();
                        contactName = callCurrentStatusModel.getContactName();
                        taskRecordList = callCurrentStatusModel.getTaskRecordList();
                        sourceType = callCurrentStatusModel.getSourceType();
                        sourceId = callCurrentStatusModel.getSourceId();
                    }
                }
                intent.putExtra("customerAddress", customerAddress);
                intent.putExtra("customerId", customerId);
                intent.putExtra("customerNick", customerNick);
                intent.putExtra("incomimgJsep", incomimgJsep);
                intent.putExtra("customerPhone", customerPhone);
                intent.putExtra("privacyNumber", privacyNumber);
                intent.putExtra("_otherAgentName", _otherAgentName);
                intent.putExtra("currentCallDuration", currentCallDuration);
                intent.putExtra("currentUserDuration", currentUserDuration);
                intent.putExtra("currentThirdDuration", currentThirdDuration);
                intent.putExtra("currentStatus", currentStatus);
                intent.putExtra("stompMessageID", mStompMessageID);
                intent.putExtra("stompMessageContent", mStompMessageContent);
                intent.putExtra("inComingcallType", inComingcallType);
                intent.putExtra("isSpeakerphoneOn", isSpeakerphoneOn);
                intent.putExtra("isHoldOn", isHoldOn);
                intent.putExtra("isMuteOn", isMuteOn);
                intent.putExtra("callId", callId);
                intent.putExtra("callType", callType);
                intent.putExtra("recordId", recordId);
                intent.putExtra("campaignId", campaignId);
                intent.putExtra("dialCount", dialCount);
                intent.putExtra("status", status);
                intent.putExtra("taskFromType", taskFromType);
                intent.putExtra("contactName", contactName);
                intent.putExtra("sourceType", sourceType);
                intent.putExtra("sourceId", sourceId);
                Bundle bundle = new Bundle();
                bundle.putSerializable("taskRecordList", taskRecordList);
                intent.putExtras(bundle);
                SobotLogUtils.i("点击通话浮层时 currentStatus=======" + currentStatus);
                startActivity(intent);
                if (SobotFloatWindow.get(SobotCallConstant.CALL_STATUS_FLOAT) != null) {
                    SobotFloatWindow.destroy(SobotCallConstant.CALL_STATUS_FLOAT);
                }
            }
        });
        finish();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.ll_user_info) {
            if (!FloatingWindowPermissionUtil.hasSuspendedWindowPermission(getSobotBaseActivity())) {
                SobotPermissionTipDialog dialog = new SobotPermissionTipDialog(getSobotBaseActivity(), getString(R.string.call_str_floating_permissions), getString(R.string.call_str_floating_tip), new SobotPermissionTipDialog.ClickViewListener() {
                    @Override
                    public void clickRightView(Context context, SobotPermissionTipDialog dialog) {
                        dialog.dismiss();
                        Intent intent = new Intent(Settings.ACTION_MANAGE_OVERLAY_PERMISSION);
                        intent.setData(Uri.parse("package:" + getSobotBaseActivity().getPackageName()));
                        startActivityForResult(intent, SobotCallConstant.SOBOT_REQUEST_FLOATING_WINDOW_CODE);
                    }

                    @Override
                    public void clickLeftView(Context context, SobotPermissionTipDialog dialog) {
                        dialog.dismiss();
                    }
                });
                dialog.show();
            } else {
                minimize();
                if (!SobotStringUtils.isEmpty(recordId)) {
                    Intent intent = new Intent(CallStatusActivity.this, CallTaskContactDetailActivity.class);
                    intent.putExtra("recordId", recordId);//任务明细id
                    intent.putExtra("campaignId", campaignId);//公司id
                    intent.putExtra("dialCount", dialCount);//外出次数 判断是否执行过
                    intent.putExtra("status", status);//任务状态（未开始、进行中..）
                    intent.putExtra("taskFromType", taskFromType);//1 全部 2 未执行 3 已执行
                    intent.putExtra("defaultIndex", 0);//任务信息
                    intent.putExtra("fromCall", 1);//是否从呼叫页面跳转过去
                    Bundle bundle = new Bundle();
                    bundle.putSerializable("taskRecordList", taskRecordList);
                    intent.putExtras(bundle);
                    startActivity(intent);
                } else {
                    Intent intent = new Intent(CallStatusActivity.this, CallDetailsActivity.class);
                    intent.putExtra("callID", callId);
                    intent.putExtra("customerId", customerId);
                    intent.putExtra("callNumber", customerPhone);
                    intent.putExtra("encryptCustomerNumber", privacyNumber);
                    intent.putExtra("userInfoType", userInfoType);
                    intent.putExtra("defaultIndex", 2);
                    intent.putExtra("fromPage", "callStatus");
                    startActivity(intent);
                }
            }
        } else if (v.getId() == R.id.ll_service_summary) {
            if (!FloatingWindowPermissionUtil.hasSuspendedWindowPermission(getSobotBaseActivity())) {
                SobotPermissionTipDialog dialog = new SobotPermissionTipDialog(getSobotBaseActivity(), getString(R.string.call_str_floating_permissions), getString(R.string.call_str_floating_tip), new SobotPermissionTipDialog.ClickViewListener() {
                    @Override
                    public void clickRightView(Context context, SobotPermissionTipDialog dialog) {
                        dialog.dismiss();
                        Intent intent = new Intent(Settings.ACTION_MANAGE_OVERLAY_PERMISSION);
                        intent.setData(Uri.parse("package:" + getSobotBaseActivity().getPackageName()));
                        startActivityForResult(intent, SobotCallConstant.SOBOT_REQUEST_FLOATING_WINDOW_CODE);
                    }

                    @Override
                    public void clickLeftView(Context context, SobotPermissionTipDialog dialog) {
                        dialog.dismiss();
                    }
                });
                dialog.show();
            } else {
                minimize();
                if (!SobotStringUtils.isEmpty(recordId)) {
                    Intent intent = new Intent(CallStatusActivity.this, CallTaskContactDetailActivity.class);
                    intent.putExtra("recordId", recordId);//任务明细id
                    intent.putExtra("campaignId", campaignId);//公司id
                    intent.putExtra("dialCount", dialCount);//外出次数 判断是否执行过
                    intent.putExtra("status", status);//任务状态（未开始、进行中..）
                    intent.putExtra("taskFromType", taskFromType);//1 全部 2 未执行 3 已执行
                    intent.putExtra("defaultIndex", 1);//任务总结
                    intent.putExtra("fromCall", 1);//是否从呼叫页面跳转过去
                    Bundle bundle = new Bundle();
                    bundle.putSerializable("taskRecordList", taskRecordList);
                    intent.putExtras(bundle);
                    startActivity(intent);
                } else {
                    Intent intent = new Intent(CallStatusActivity.this, CallDetailsActivity.class);
                    intent.putExtra("callID", callId);
                    intent.putExtra("customerId", customerId);
                    intent.putExtra("callNumber", customerPhone);
                    intent.putExtra("encryptCustomerNumber", privacyNumber);
                    intent.putExtra("fromPage", "callStatus");
                    intent.putExtra("userInfoType", userInfoType);
                    intent.putExtra("defaultIndex", 1);
                    startActivity(intent);
                }
            }
        } else if (v.getId() == R.id.call_hang_up_ll) {
            hangUp();
        } else if (v.getId() == R.id.call_accept_ll) {
            accept();
        }

        if (iv_retract.equals(v)) {
            closeBack();
        } else if (mLlNum1.equals(v)) {
            clickNum("1");
        } else if (mLlNum2.equals(v)) {
            clickNum("2");
        } else if (mLlNum3.equals(v)) {
            clickNum("3");
        } else if (mLlNum4.equals(v)) {
            clickNum("4");
        } else if (mLlNum5.equals(v)) {
            clickNum("5");
        } else if (mLlNum6.equals(v)) {
            clickNum("6");
        } else if (mLlNum7.equals(v)) {
            clickNum("7");
        } else if (mLlNum8.equals(v)) {
            clickNum("8");
        } else if (mLlNum9.equals(v)) {
            clickNum("9");
        } else if (mLlNum10.equals(v)) {
            clickNum("*");
        } else if (mLlNum11.equals(v)) {
            clickNum("0");
        } else if (mLlNum12.equals(v)) {
            clickNum("#");
        } else if (ll_hang_up.equals(v)) {
            hangUp();
        } else if (tv_mute.equals(v)) {
            if (isMuteOn) {
                //解除静音
                SobotCallOpenApi.unMuteCall(getSobotBaseActivity(), null);
                Drawable drawable = getResources().getDrawable(R.drawable.icon_mute);
                drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
                tv_mute.setCompoundDrawables(null, drawable, null, null);
                tv_mute.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
            } else {
                //静音
                SobotCallOpenApi.muteCall(getSobotBaseActivity(), null);
                Drawable drawable = getResources().getDrawable(R.drawable.icon_mute_activation);
                drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
                tv_mute.setCompoundDrawables(null, drawable, null, null);
                tv_mute.setTextColor(getResources().getColor(R.color.call_wenzi_yellow));
            }
            isMuteOn = !isMuteOn;
        } else if (tv_hold.equals(v)) {
            if (isHoldOn) {
                //解除保持
                mStatus = getResources().getString(R.string.sobot_custom_tonghuazhong);
                SobotCallOpenApi.retrieveCall(getSobotBaseActivity(), null);
                Drawable drawable = getResources().getDrawable(R.drawable.icon_hold);
                drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
                tv_hold.setCompoundDrawables(null, drawable, null, null);
                tv_hold.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
            } else {
                //保持
                mStatus = getResources().getString(R.string.sobot_custom_keeping);
                SobotCallOpenApi.holdCall(getSobotBaseActivity(), null);
                Drawable drawable = getResources().getDrawable(R.drawable.icon_hold_activation);
                drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
                tv_hold.setCompoundDrawables(null, drawable, null, null);
                tv_hold.setTextColor(getResources().getColor(R.color.call_wenzi_yellow));
            }
            isHoldOn = !isHoldOn;
        } else if (tv_hung_invite.equals(v)) {
            //挂断邀请评价
            SobotCallOpenApi.sendSatisfacion(getSobotBaseActivity(), 1, new SobotResultBlock() {
                @Override
                public void resultBolok(SobotResultCode code, String msg, Object obj) {
                    finish();
                }
            });
        } else if (tv_on_speakerphone.equals(v)) {
            if (CallFastClickUtils.isCanClick(1000)) {
                if (!isSpeakerphoneOn) {
                    tv_on_speakerphone.setTextColor(getResources().getColor(R.color.call_wenzi_yellow));
                } else {
                    tv_on_speakerphone.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
                }
                //免提
                SobotCallOpenApi.changedPlayCategory(this, !isSpeakerphoneOn, new SobotResultBlock() {
                    @Override
                    public void resultBolok(SobotResultCode code, String msg, Object obj) {
                        isSpeakerphoneOn = !isSpeakerphoneOn;
                    }
                });
            }
        } else if (tv_keyword.equals(v)) {
            //切换键盘和通话功能菜单区域
            if (isShowKeywordOn) {
                //显示第一排菜单、隐藏键盘按钮区域
                ll_meau_first.setVisibility(View.VISIBLE);
                tl_keyword.setVisibility(View.GONE);
                tv_keyword_number.setVisibility(View.GONE);
                ll_head.setVisibility(View.VISIBLE);
                tv_keyword.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
            } else {
                //隐藏第一排菜单、显示键盘按钮区域
                ll_meau_first.setVisibility(View.GONE);
                tl_keyword.setVisibility(View.VISIBLE);
                tv_keyword_number.setVisibility(View.VISIBLE);
                ll_head.setVisibility(View.GONE);
                tv_keyword.setTextColor(getResources().getColor(R.color.call_wenzi_yellow));
            }
            isShowKeywordOn = !isShowKeywordOn;
        }
    }

    //最小化 或者返回
    private void closeBack() {
        if (!FloatingWindowPermissionUtil.hasSuspendedWindowPermission(getSobotBaseActivity())) {
            SobotPermissionTipDialog dialog = new SobotPermissionTipDialog(getSobotBaseActivity(), getString(R.string.call_str_floating_permissions), getString(R.string.call_str_floating_tip), new SobotPermissionTipDialog.ClickViewListener() {
                @Override
                public void clickRightView(Context context, SobotPermissionTipDialog dialog) {
                    dialog.dismiss();
                    Intent intent = new Intent(Settings.ACTION_MANAGE_OVERLAY_PERMISSION);
                    intent.setData(Uri.parse("package:" + getSobotBaseActivity().getPackageName()));
                    startActivityForResult(intent, SobotCallConstant.SOBOT_REQUEST_FLOATING_WINDOW_CODE);
                }

                @Override
                public void clickLeftView(Context context, SobotPermissionTipDialog dialog) {
                    dialog.dismiss();
                }
            });
            dialog.show();
        } else {
            minimize();
        }
    }

    // 点击发送键盘号码事件
    private void clickNum(String str) {
        SobotCallOpenApi.sendDtmf(getSobotBaseActivity(), str, null);
        String tempStr = tv_keyword_number.getText().toString();
        tv_keyword_number.setText(tempStr + str);
    }

    @Override
    protected void initData() {
        callWay = CallSharedPreferencesUtils.getInstance(getSobotBaseActivity()).get(SobotCallConstant.SP_KEY_CALL_MODEL_TYPE_V6, SobotCallConstant.CALL_MODEL_PHONE);
        incomimgJsep = getIntent().getStringExtra("incomimgJsep");
        isAutoAccept = getIntent().getBooleanExtra("isAutoAccept", false);
        callDurationStart = getIntent().getLongExtra("callDurationStart", 0);
        //判断是否登录
        String call_loingStatus = CallSharedPreferencesUtils.getInstance(getSobotBaseActivity()).get(SobotCallConstant.callLoginStatus, CallStatusUtils.V6_OFFLINE);
        if (call_loingStatus.equals(CallStatusUtils.V6_FINISHING)) {
            //判断是否正在整理中
            SobotToastUtil.showToast(getSobotBaseActivity(), getString(R.string.sobot_error_switch_status));
            finish();
        } else if (call_loingStatus.equals(CallStatusUtils.V6_SYSYTEM_BUSY)) {
            SobotToastUtil.showToast(getSobotBaseActivity(), getResources().getString(R.string.call_str_system_Lock_toast));
            finish();
        } else if (call_loingStatus.equals(CallStatusUtils.V6_OFFLINE)) {
            SobotToastUtil.showToast(getSobotBaseActivity(), getString(R.string.sobot_call_error_hint));
            finish();
        } else {
            receiveStompMsg();
            if (getIntent() != null) {
                mNum = getIntent().getStringExtra("num");
                mScreenNum = getIntent().getStringExtra("screenNum");
                isCall = getIntent().getBooleanExtra("isCallOut", true);
                sourceType = getIntent().getStringExtra("sourceType");
                sourceId = getIntent().getStringExtra("sourceId");
                customerId = getIntent().getStringExtra("customerId");
                recordId = getIntent().getStringExtra("recordId");
                campaignId = getIntent().getStringExtra("campaignId");
                dialCount = getIntent().getIntExtra("dialCount", 0);
                status = getIntent().getIntExtra("status", 0);
                taskFromType = getIntent().getIntExtra("taskFromType", 1);
                contactName = getIntent().getStringExtra("contactName");
                taskRecordList = (ArrayList<CallTaskDetailsModel>) getIntent().getSerializableExtra("taskRecordList");
            }
            mTvNum.setVisibility(View.VISIBLE);
            if (SobotStringUtils.isEmpty(mScreenNum)) {
                mScreenNum = mNum;
            }
            if (SobotStringUtils.isNoEmpty(sourceId) && SobotStringUtils.isNoEmpty(sourceType) && "2".equals(sourceType)) {
                //如果是外呼来源是工单回复里边的电话回复，就不显示底部服务总结客户信息、挂机邀评
                ll_userinfo_summary_bg.setVisibility(View.GONE);
                tv_hung_invite.setVisibility(View.GONE);
            }
            if (!SobotStringUtils.isEmpty(recordId)) {
                tv_user_info.setText(getResources().getString(R.string.call_str_task_info));
                tv_service_summary.setText(getResources().getString(R.string.call_str_task_summary));
                //有任务明细 直接显示底部任务信息和任务总结
                ll_user_info.setVisibility(View.VISIBLE);
                ll_service_summary.setVisibility(View.VISIBLE);
                ll_userinfo_summary_bg.setBackgroundColor(getResources().getColor(R.color.call_userinfo_summary_bg));
            }
            mTvNum.setText(mScreenNum);
            //判断是否有权限
            if (checkIsShowPermissionPop(getResources().getString(R.string.sobot_microphone), getResources().getString(R.string.sobot_microphone_yongtu), 2, 3)) {
            }
            init(true);
        }
    }

    private void requestNumber(String callId) {
        zhiChiApi.queueNumberInfo(this, callId, new SobotResultCallBack<CallNumberCity>() {
            @Override
            public void onSuccess(CallNumberCity numberCity) {
                if (null != numberCity) {
                    String customerProvince = "", customerCity = "";
                    if (!TextUtils.isEmpty(numberCity.getAreaProvince())) {
                        customerProvince = numberCity.getAreaProvince();
                    }
                    if (!TextUtils.isEmpty(numberCity.getAreaCity())) {
                        customerCity = numberCity.getAreaCity();
                    }

                    if (!TextUtils.isEmpty(customerProvince) && !TextUtils.isEmpty(customerCity)) {
                        tv_address.setText(customerProvince + "-" + customerCity);
                        tv_user_card_address.setText(customerProvince + "-" + customerCity);
                        customerAddress = customerProvince + "-" + customerCity;
                    } else if (!TextUtils.isEmpty(customerProvince)) {
                        tv_address.setText(customerProvince);
                        tv_user_card_address.setText(customerProvince);
                        customerAddress = customerProvince;
                    } else if (!TextUtils.isEmpty(customerCity)) {
                        tv_address.setText(customerCity);
                        tv_user_card_address.setText(customerCity);
                        customerAddress = customerCity;
                    } else {
                        customerAddress = "";
                        v_num_split.setVisibility(View.GONE);
                        tv_address.setVisibility(View.GONE);
                    }
                }
            }

            @Override
            public void onFailure(Exception e, String des) {

            }
        });
    }

    /**
     * 是否首次初始化（外呼）
     *
     * @param isFirst
     */
    private void init(boolean isFirst) {
        callType = getIntent().getStringExtra("callType");
        callId = getIntent().getStringExtra("callId");
        customerNick = getIntent().getStringExtra("customerNick");
        incomimgJsep = getIntent().getStringExtra("incomimgJsep");
        customerAddress = getIntent().getStringExtra("customerAddress");
        customerId = getIntent().getStringExtra("customerId");
        customerPhone = getIntent().getStringExtra("customerPhone");
        privacyNumber = getIntent().getStringExtra("privacyNumber");
        SobotLogUtils.d("====698=customerPhone=" + customerPhone + "===========" + privacyNumber);
        _otherAgentName = getIntent().getStringExtra("_otherAgentName");
        currentCallDuration = getIntent().getLongExtra("currentCallDuration", 0);
        currentUserDuration = getIntent().getLongExtra("currentUserDuration", 0);
        currentThirdDuration = getIntent().getLongExtra("currentThirdDuration", 0);
        mStompMessageID = getIntent().getStringExtra("stompMessageID");
        mStompMessageContent = getIntent().getStringExtra("stompMessageContent");
        inComingcallType = getIntent().getIntExtra("inComingcallType", 0);
        isSpeakerphoneOn = getIntent().getBooleanExtra("isSpeakerphoneOn", false);
        isHoldOn = getIntent().getBooleanExtra("isHoldOn", false);
        isMuteOn = getIntent().getBooleanExtra("isMuteOn", false);
        currentStatus = getIntent().getIntExtra("currentStatus", -1);
        SobotLogUtils.i("currentStatus=======" + currentStatus);
        SobotLogUtils.i("inComingcallType=======" + inComingcallType);
        SobotLogUtils.i("mStompMessageID=======" + mStompMessageID);
        SobotLogUtils.i("mStompMessageContent=======" + mStompMessageContent);
        SobotLogUtils.i("incomimgJsep=======" + incomimgJsep);
        if (!SobotStringUtils.isEmpty(callId)) {
            requestNumber(callId);
        }
        if (currentStatus > -1) {
            searchCustomByType();
            //通话所属地
            v_num_split.setVisibility(View.VISIBLE);
            tv_address.setVisibility(View.VISIBLE);

            //用户昵称
            if (!TextUtils.isEmpty(customerNick)) {
                mTvNick.setText(customerNick);
                tv_user_card_nick.setText(customerNick);
            } else {
                customerNick = getString(R.string.call_unknown_customer);
                mTvNick.setText(getString(R.string.call_unknown_customer));
                tv_user_card_nick.setText(getString(R.string.call_unknown_customer));
            }
            if (!SobotStringUtils.isEmpty(contactName)) {
                mTvNick.setText(contactName);
            }
            //用户手机号
            if (!TextUtils.isEmpty(customerPhone)) {
                mTvNum.setText(customerPhone);
                tv_user_card_num.setText(customerPhone);
            }
            if (!TextUtils.isEmpty(customerAddress)) {
                tv_address.setText(customerAddress);
                tv_user_card_address.setText(customerAddress);
            } else {
                v_num_split.setVisibility(View.GONE);
                tv_address.setVisibility(View.GONE);
            }
            long currentTimeMillis = System.currentTimeMillis();
            callDuration = (currentTimeMillis - currentCallDuration) / 1000;
            userDuration = (currentTimeMillis - currentUserDuration) / 1000;
            thirdDuration = (currentTimeMillis - currentThirdDuration) / 1000;
            mTvStatus.setVisibility(View.VISIBLE);
            ll_user_card.setVisibility(View.GONE);
            ll_seats.setVisibility(View.GONE);
            //-1，不处理，0 来电-振铃， 1 外呼-振铃， 2 被咨询-振铃，3 被转移-振铃， 4 普通-通话中， 5通话中-咨询中， 6 咨询后三方，7 咨询后转移,8 手机来电 9 强插 三方
            if (currentStatus == 0) {
                ll_hung_accept.setVisibility(View.VISIBLE);
                ringingOrDialing(mStompMessageContent, mStompMessageID, currentCallDuration);
            } else if (currentStatus == 1) {
                ringingOrDialing(mStompMessageContent, mStompMessageID, currentCallDuration);
            } else if (currentStatus == 2) {
                beingConsultedUI();
            } else if (currentStatus == 3) {
                singleSteptransferUI();
            } else if (currentStatus == 4) {
                duringCallUI(callType);
            } else if (currentStatus == 5) {
                beingConsultedUI();
                duringCallUI(callType);
                acceptConsultationUI();
            } else if (currentStatus == 6) {
                beingConsultedUI();
                duringCallUI(callType);
                acceptConsultationUI();
                meetingAfterConsultationUI();
            } else if (currentStatus == 7) {
                beingConsultedUI();
                duringCallUI(callType);
                acceptConsultationUI();
                transferAfterConsultationUI();
            } else if (currentStatus == 8) {
                mStatus = getResources().getString(R.string.sobot_call_ringing);
                phoneUI();
            } else if (currentStatus == 9) {
                intrusionUI();
            }
            mHandler.postDelayed(timeRunnable, 0);

            if (isSpeakerphoneOn) {
                tv_on_speakerphone.setTextColor(getResources().getColor(R.color.call_wenzi_yellow));
            }
            if (isHoldOn) {
                Drawable drawable = getResources().getDrawable(R.drawable.icon_hold_activation);
                drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
                tv_hold.setCompoundDrawables(null, drawable, null, null);
                tv_hold.setTextColor(getResources().getColor(R.color.call_wenzi_yellow));
            }
            if (isMuteOn) {
                Drawable drawable = getResources().getDrawable(R.drawable.icon_mute_activation);
                drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
                tv_mute.setCompoundDrawables(null, drawable, null, null);
                tv_mute.setTextColor(getResources().getColor(R.color.call_wenzi_yellow));
            }
        } else {
            if (isCall) {//打电话
                String call_loingStatus = CallSharedPreferencesUtils.getInstance(getSobotBaseActivity()).get(SobotCallConstant.callLoginStatus, CallStatusUtils.V6_OFFLINE);
                if (call_loingStatus.equals(CallStatusUtils.V6_FINISHING)) {
                    SobotToastUtil.showToast(getSobotBaseActivity(), getString(R.string.sobot_error_switch_status));
                    return;
                }
//            mTvStatus.setText(getString(R.string.sobot_call_dialing));
                callout(isFirst);
            } else {//来电
//            mTvStatus.setText(getString(R.string.sobot_call_ringing));
                initCallInData();
            }

            if (isAutoAccept) {
                //自动接听
                accept();
            }
        }
    }

    private void receiveStompMsg() {
        //收到 stomp 消息
        SobotLiveEventBus.get(SobotCallLiveDataBusKey.RECEIVE_STOMP_MSG, CallStompMsgModel.class)
                .observeSticky(this, new Observer<CallStompMsgModel>() {
                    @Override
                    public void onChanged(CallStompMsgModel stompMsgModel) {
                        if (stompMsgModel != null) {
                            SobotLogUtils.i("CallStatusActivity 收到stomp 消息:" + SobotStringUtils.checkStringIsNull(stompMsgModel.getStompMessageID()));
                            String stompMessageID = SobotStringUtils.checkStringIsNull(stompMsgModel.getStompMessageID());
                            String stompMessageContent = SobotStringUtils.checkStringIsNull(stompMsgModel.getStompMessageContent());
                            String agentStatusInfoStr = SobotStringUtils.checkStringIsNull(stompMsgModel.getAgentStatusInfo());//坐席信息
                            String agentCallStatusInfo = SobotStringUtils.checkStringIsNull(stompMsgModel.getAgentCallStatusInfo());//坐席状态
                            //当前连接客户端类型 系统-客服APP-Android端  : SysAppAndroid  ; 系统-客服APP-IOS端 : SysAppIos
                            String clientType = SobotStringUtils.checkStringIsNull(stompMsgModel.getClientType());
                            String errorMessage = SobotStringUtils.checkStringIsNull(stompMsgModel.getErrorMessage());
                            if (!TextUtils.isEmpty(stompMessageContent) && !TextUtils.isEmpty(stompMessageID)) {
                                mStompMessageID = stompMessageID;
                                mStompMessageContent = stompMessageContent;
                                if (SobotStompEventConstant.EventRinging.equals(stompMessageID) || SobotStompEventConstant.EventDialing.equals(stompMessageID)) {
                                    //呼入座席响铃事件 ||     外呼返回振铃事件
                                    ringingOrDialing(stompMessageContent, stompMessageID, 0);
                                } else if (SobotStompEventConstant.EventWebSocketSession.equals(stompMessageID)) {
                                    //恢复话务状态
                                    if (SobotStompEventConstant.clientType.equals(clientType)) {
                                        if (!TextUtils.isEmpty(agentStatusInfoStr)) {
                                            SobotAgentStatusInfo agentStatusInfo = SobotGsonUtil.jsonToBean(agentStatusInfoStr, SobotAgentStatusInfo.class);
                                            if (agentStatusInfo != null) {
                                                String statusId;//1-就绪；2-忙碌；4-话后小结；5-外呼振铃；6-呼入响铃；7-通话；8-保持；98-系统锁定
                                                if (!SobotStringUtils.isEmpty(agentStatusInfo.getWorkStatus())) {
                                                    statusId = agentStatusInfo.getWorkStatus();
                                                } else {
                                                    statusId = agentStatusInfo.getAgentState();
                                                }
                                                if (!SobotStringUtils.isEmpty(statusId)) {
//                                        V6_OUTBOUND_RINGING = "5";//外呼振铃
//                                        V6_INCOMING_RING = "6";//呼入响铃
//                                        V6_DURING = "7";//通话
//                                        String V6_HOLD = "8";//保持
                                                    if (CallStatusUtils.V6_OUTBOUND_RINGING.equals(statusId) || CallStatusUtils.V6_INCOMING_RING.equals(statusId)) {
                                                        //振铃中
                                                    } else if (CallStatusUtils.V6_DURING.equals(statusId) || CallStatusUtils.V6_HOLD.equals(statusId)) {
                                                        //通话中
                                                        if (!TextUtils.isEmpty(agentCallStatusInfo)) {
                                                            SobotCallStatusEntity callStatusEntity = SobotGsonUtil.jsonToBean(agentCallStatusInfo, SobotCallStatusEntity.class);
                                                            if (callStatusEntity != null) {

                                                            } else {
                                                                finish();
                                                            }
                                                        } else {
                                                            finish();
                                                        }
                                                        currentStatus = 4;
                                                        duringCallUI(callType);
                                                    } else {
                                                        finish();
                                                    }
                                                } else {
                                                    finish();
                                                }
                                            } else {
                                                finish();
                                            }
                                        }
                                    } else {
                                        //直接关闭
                                        finish();
                                    }
                                } else if (SobotStompEventConstant.EventEstablished.equals(stompMessageID)) {
                                    currentStatus = 4;
                                    //通话接通了
                                    callDuration = 0;
                                    userDuration = 0;//咨询 用户通话 重新开始计时
                                    thirdDuration = 0;//三方坐席 通话  重新开始计时
                                    SobotCallEvent event = SobotGsonUtil.jsonToBean(stompMessageContent, SobotCallEvent.class);
                                    if (event != null) {
                                        callType = event.getCallType();
                                        callId = event.getCallID();
                                        if (!SobotStringUtils.isEmpty(callId)) {
                                            requestNumber(callId);
                                        }
                                        duringCallUI(callType);
                                        Map<String, String> attachedDataMap = event.getAttachedData();
                                        _otherAgentName = "";
                                        if (attachedDataMap != null) {
                                            for (Map.Entry<String, String> entry : attachedDataMap.entrySet()) {
                                                if ("_otherAgentName".equals(entry.getKey())) {
                                                    _otherAgentName = entry.getValue();
                                                }
                                            }
                                        }
                                        String otherDNRole = event.getOtherDNRole();
                                        if (!TextUtils.isEmpty(otherDNRole)) {
                                            if (otherDNRole.equals(CallStage.ConsultBy.getValue())) {
                                                mStatus = getResources().getString(R.string.sobot_custom_tonghuazhong);
                                                currentStatus = 5;
                                                thirdDuration = 0;//三方坐席 通话  开始计时
                                                //被咨询 接通了
                                                acceptConsultationUI();
                                            }
                                        }
                                    }
                                } else if (SobotStompEventConstant.EventAgentConnectionChanged.equals(stompMessageID)) {
                                    //座席在其它端登录，被挤下线的事件
                                    finish();
                                } else if (SobotStompEventConstant.EventPartyError.equals(stompMessageID)) {
                                    //某些话务异常异常时关闭界面
                                    SobotEventAgentLogin agentStatus = SobotGsonUtil.jsonToBean(stompMessageContent, SobotEventAgentLogin.class);
                                    if (agentStatus != null && !SobotStringUtils.isEmpty(agentStatus.getErrorCode()) && !" 302005, 301029, 301033, 301034".contains(agentStatus.getErrorCode())) {
                                        finish();
                                    }
                                } else if (SobotStompEventConstant.EventAgentError.equals(stompMessageID)) {
                                    //某些座席异常异常时关闭界面
                                    SobotEventAgentLogin agentStatus = SobotGsonUtil.jsonToBean(stompMessageContent, SobotEventAgentLogin.class);
                                    if (agentStatus != null && !SobotStringUtils.isEmpty(agentStatus.getErrorCode()) && "302006".contains(agentStatus.getErrorCode())) {
                                        finish();
                                    }
                                } else if (SobotStompEventConstant.EventReleased.equals(stompMessageID)) {
                                    //通话释放事件
                                    finish();
                                } else if (SobotStompEventConstant.EventPartyChanged.equals(stompMessageID)) {
                                    ll_seats.setVisibility(View.GONE);
                                    tv_consult_you.setVisibility(View.GONE);
                                    SobotCallEvent event = SobotGsonUtil.jsonToBean(stompMessageContent, SobotCallEvent.class);
                                    if (event != null) {
                                        callId = event.getCallID();
                                        if (!SobotStringUtils.isEmpty(callId)) {
                                            requestNumber(callId);
                                        }
                                        String thirdDNRole = event.getThirdDNRole();
                                        if (!TextUtils.isEmpty(thirdDNRole)) {
                                            if (thirdDNRole.equals(CallStage.ConferenceBy.getValue())) {
                                                currentStatus = 6;
                                                //咨询后会议（三方）
                                                SobotToastUtil.showCustomToast(getSobotBaseActivity(), getString(R.string.call_add_third_party));
                                                meetingAfterConsultationUI();
                                            }
                                            if (thirdDNRole.equals(CallStage.TransferBy.getValue())) {
                                                //咨询后转移
                                                currentStatus = 7;
                                                SobotToastUtil.showCustomToast(getSobotBaseActivity(), getString(R.string.call_transfer_to_you));
                                                transferAfterConsultationUI();
                                            }
                                        }
                                    }

                                } else if (SobotStompEventConstant.EventPartyDeleted.equals(stompMessageID)) {
                                    ll_seats.setVisibility(View.GONE);
                                    tv_consult_you.setVisibility(View.GONE);
                                    SobotCallEvent event = SobotGsonUtil.jsonToBean(stompMessageContent, SobotCallEvent.class);
                                    if (event != null) {
                                        callId = event.getCallID();
                                        if (!SobotStringUtils.isEmpty(callId)) {
                                            requestNumber(callId);
                                        }
                                        String thirdDNRole = event.getThirdDNRole();
                                        if (!TextUtils.isEmpty(thirdDNRole)) {
                                            if (thirdDNRole.equals(CallStage.DeletedBy.getValue())) {
                                                //三方后转移
                                                currentStatus = 7;
                                                SobotToastUtil.showCustomToast(getSobotBaseActivity(), getString(R.string.call_transfer_to_you));
                                                transferAfterConsultationUI();
                                            } else if (thirdDNRole.equals(CallStage.BargeinTo.getValue())) {
                                                currentStatus = 4;//恢复通话中
                                                //强插着 离开 恢复通话中
                                                transferAfterConsultationUI();
                                            }
                                        }
                                    }
                                } else if (SobotStompEventConstant.EventSystemError.equals(stompMessageID)) {
                                    //系统错误
                                    if (!SobotStringUtils.isEmpty(errorMessage)) {
                                        SobotToastUtil.showToast(getApplicationContext(), errorMessage);
                                    }
                                    finish();
                                } else if (SobotStompEventConstant.EventDialOriginated.equals(stompMessageID)) {
                                    //座席振铃 call ringing
                                    SobotJanusSipPhoneUtils.callRingin(CallStatusActivity.this);
                                } else if (SobotStompEventConstant.EventPartyAdded.equals(stompMessageID)) {
                                    //强插 三方
                                    SobotCallEvent event = SobotGsonUtil.jsonToBean(stompMessageContent, SobotCallEvent.class);
                                    if (event != null) {
                                        Map<String, String> attachedDataMap = event.getAttachedData();
                                        if (attachedDataMap != null) {
                                            for (Map.Entry<String, String> entry : attachedDataMap.entrySet()) {
                                                if ("_otherAgentName".equals(entry.getKey())) {
                                                    _otherAgentName = entry.getValue();
                                                }
                                            }
                                        }
                                    }
                                    thirdDuration = 0;//三方坐席 通话  开始计时
                                    currentStatus = 9;
                                    intrusionUI();
                                } else if (SobotStompEventConstant.EventAgentLogout.equals(stompMessageID)) {
                                    //签出
                                    finish();
                                }
                            }
                        }
                    }
                });
    }

    //外呼
    private void callout(boolean isFirst) {
        tv_phone_call_you.setVisibility(View.GONE);
        ll_hung_accept.setVisibility(View.GONE);
        ll_meau.setVisibility(View.VISIBLE);
        serviceVo = SobotLoginTools.getInstance().getServiceInfo();
        if (callWay == SobotCallConstant.CALL_MODEL_PHONE) {
            //免提置灰，不能点击
            tv_on_speakerphone.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
            tv_on_speakerphone.setClickable(false);
            tv_on_speakerphone.setEnabled(false);
        }
        if (serviceVo != null && isFirst) {
            if (!TextUtils.isEmpty(mScreenNum)) {
                if (!SobotStringUtils.isEmpty(recordId) && !SobotStringUtils.isEmpty(campaignId)) {
                    //调用呼叫接口打电话
                    zhiChiApi.taskCallV6(CallStatusActivity.this, CallStatusActivity.this, recordId, campaignId, new SobotResultCallBack<String>() {
                        @Override
                        public void onSuccess(String msg) {
                            if (!SobotStringUtils.isEmpty(msg)) {
                                SobotToastUtil.showCustomToast(CallStatusActivity.this, msg);
                            }
                        }

                        @Override
                        public void onFailure(Exception e, String des) {
                            SobotToastUtil.showCustomToast(CallStatusActivity.this, SobotStringUtils.isEmpty(des) ? getString(R.string.sobot_call_net_error_string) : des);
                            finish();
                        }
                    });
                } else {
                    String userData = "";
                    String num = mScreenNum;
                    Map<String, String> map = new HashMap<>();
                    if (SobotStringUtils.isNoEmpty(sourceType)) {
                        map.put("__sourceType", SobotStringUtils.checkStringIsNull(sourceType));
                    }
                    if (SobotStringUtils.isNoEmpty(sourceId)) {
                        map.put("__sourceId", SobotStringUtils.checkStringIsNull(sourceId));
                    }
                    if (SobotStringUtils.isNoEmpty(mNum)) {
                        map.put("privacyNumber", SobotStringUtils.checkStringIsNull(mNum));
                        num = mNum;
                    }
                    if (map != null && map.size() > 0) {
                        userData = "    \"userData\": " + SobotGsonUtil.beanToJson(map) + ",\n";
                    }
                    String currentTime = System.currentTimeMillis() + "";
                    SobotStompClient.getInstance(getSobotBaseActivity()).send("/cc/app/request", "{\n" +
                            "    \"messageID\": \"" + SobotStompEventConstant.RequestMakeCall + "\",\n" +
                            "    \"referenceID\": " + currentTime + "," +
                            "    \"companyId\": \"" + serviceVo.getCompanyId() + "\",\n" +
                            "    \"agentID\": \"" + serviceVo.getServiceId() + "\",\n" +
                            "    \"agentType\": \"1\",\n" +
                            "    \"otherDN\": \"" + SobotStringUtils.checkStringIsNull(num) + "\",\n" +
                            userData +
                            "    \"creationTime\": " + currentTime + ",\n" +
                            "    \"customerId\": \"" + SobotStringUtils.checkStringIsNull(customerId) + "\"\n" +
                            "}\n").subscribe();
                }
            } else {
                SobotToastUtil.showToast(getSobotBaseActivity(), getString(R.string.sobot_call_error1_hint));
                finish();
            }
        }
    }

    /**
     * 呼进来的电话
     */
    protected void initCallInData() {
        serviceVo = SobotLoginTools.getInstance().getServiceInfo();
        mStompMessageID = getIntent().getStringExtra("stompMessageID");
        mStompMessageContent = getIntent().getStringExtra("stompMessageContent");
        inComingcallType = getIntent().getIntExtra("inComingcallType", 0);
        if (inComingcallType == 1 && !SobotStringUtils.isEmpty(mStompMessageID) && !SobotStringUtils.isEmpty(mStompMessageID)) {
            //手机方式
            if (SobotStompEventConstant.EventEstablished.equals(mStompMessageID)) {
                phoneUI();
                currentStatus = 4;
                duringCallUI(callType);
                if (timeRunnable != null) {
                    mHandler.postDelayed(timeRunnable, 10);
                }
            } else {
                ringingOrDialing(mStompMessageContent, mStompMessageID, callDurationStart);
            }
        }
    }

    @Override
    protected void onResume() {
        if (SobotFloatWindow.get(SobotCallConstant.CALL_FLOAT_INCOMING_NOTICE) != null) {
            SobotFloatWindow.destroy(SobotCallConstant.CALL_FLOAT_INCOMING_NOTICE);
            SobotLogUtils.i("----------onResume-------销毁浮窗来电-");
        }
        super.onResume();
    }

    //接听
    public void accept() {
        callRunning = true;
        SobotSipUtils.accept(true, this, incomimgJsep);//接听
        ll_hung_accept.setVisibility(View.GONE);
    }

    Runnable timeRunnable = new Runnable() {
        @Override
        public void run() {
            mHandler.postDelayed(this, 1000);
            tv_user_card_time.setText(formatCallTimeDuration(userDuration++));
            tv_seats_time.setText(formatCallTimeDuration(thirdDuration++));
            mTvStatus.setText(TextUtils.isEmpty(mStatus) ? "" : mStatus + " " + formatCallTimeDuration(callDuration++));
        }
    };

    // 挂断
    public void hangUp() {
        if (SobotStompClient.getInstance(getSobotBaseActivity()).isConnected()) {
            SobotCallOpenApi.rejectCall(getSobotBaseActivity(), null);
        } else {
            SobotSipUtils.hangUp(true);
        }
        callRunning = false;
        finish();
    }

    @Override
    public void onBackPressed() {
        closeBack();
        return;
    }


    /**
     * 获取通话时长
     *
     * @param seconds
     * @return
     */
    public static String formatCallTimeDuration(long seconds) {
        if (seconds <= 0) return "00:00";
        StringBuffer sb = new StringBuffer();
        if ((seconds / 60 / 60) > 0) {
            sb.append(String.format("%02d", seconds / 60 / 60)).append(":");
        }
        sb.append(String.format("%02d", (seconds / 60) % 60));
        sb.append(":").append(String.format("%02d", seconds % 60));
        return sb.toString();

    }

    @Override
    protected void onDestroy() {
        if (mHomeWatcher != null) {
            mHomeWatcher.stopWatch();// 在销毁时停止监听，不然会报错的。
        }
        if (mHandler != null) {
            mHandler.removeCallbacks(timeRunnable);
        }
        super.onDestroy();
    }


    //来电ui
    private void ringingOrDialing(String stompMessageContent, String stompMessageID, long callDurationStart) {
        //呼入座席响铃事件 ||     外呼返回振铃事件
        mStatus = getResources().getString(R.string.sobot_call_ringing);
        callDuration = 0;
        if (callDurationStart > 0) {
            long currentTimeMillis = System.currentTimeMillis();
            callDuration = (currentTimeMillis - callDurationStart) / 1000;
        }
        userDuration = 0;//咨询 用户通话 开始计时
        thirdDuration = 0;//三方坐席 通话  开始计时
        if (SobotStompEventConstant.EventRinging.equals(stompMessageID)) {
            //呼入座席响铃事件
            currentStatus = 0;
            ll_hung_accept.setVisibility(View.VISIBLE);
        } else {
            //外呼返回振铃事件
            currentStatus = 1;
            tv_phone_call_you.setVisibility(View.GONE);
            ll_hung_accept.setVisibility(View.GONE);
            ll_meau.setVisibility(View.VISIBLE);
        }
        mHandler.postDelayed(timeRunnable, 10);
        SobotCallEvent event = SobotGsonUtil.jsonToBean(stompMessageContent, SobotCallEvent.class);
        if (event != null) {
            callType = event.getCallType();
            callId = event.getCallID();
            if (!SobotStringUtils.isEmpty(callId)) {
                requestNumber(callId);
            }
            Map<String, String> attachedDataMap = event.getAttachedData();
            String customerProvince = "";
            String customerCity = "";
            customerNick = "";
            customerId = "";
            _otherAgentName = "";
            privacyNumber = "";
            if (attachedDataMap != null) {
                for (Map.Entry<String, String> entry : attachedDataMap.entrySet()) {
                    if ("customerProvince".equals(entry.getKey())) {
                        customerProvince = entry.getValue();
                    }
                    if ("customerCity".equals(entry.getKey())) {
                        customerCity = entry.getValue();
                    }
                    if ("customerNick".equals(entry.getKey())) {
                        customerNick = entry.getValue();
                    }
                    if ("customerId".equals(entry.getKey())) {
                        customerId = entry.getValue();
                    }
                    if ("_otherAgentName".equals(entry.getKey())) {
                        _otherAgentName = entry.getValue();
                    }
                    if ("_thirdAgentName".equals(entry.getKey())) {
                        _thirdAgentName = entry.getValue();
                    }
                    if ("privacyNumber".equals(entry.getKey())) {
                        privacyNumber = entry.getValue();
                    }

                }
            }
            //通话所属地
            v_num_split.setVisibility(View.VISIBLE);
            tv_address.setVisibility(View.VISIBLE);

            if (!SobotStringUtils.isEmpty(contactName)) {
                mTvNick.setText(contactName);
            } else {
                //用户昵称
                if (!TextUtils.isEmpty(customerNick)) {
                    mTvNick.setText(customerNick);
                    tv_user_card_nick.setText(customerNick);
                    tv_user_info.setText(getString(R.string.call_str_user_info));
                } else {
                    customerNick = getString(R.string.call_unknown_customer);
                    mTvNick.setText(getString(R.string.call_unknown_customer));
                    tv_user_card_nick.setText(getString(R.string.call_unknown_customer));
                }
            }
            if (!SobotStringUtils.isEmpty(recordId)) {
                tv_user_info.setText(getResources().getString(R.string.call_str_task_info));
                tv_service_summary.setText(getResources().getString(R.string.call_str_task_summary));
            }
            //用户手机号
            if (!TextUtils.isEmpty(event.getOtherDN())) {
                mTvNum.setText(event.getOtherDN());
                tv_user_card_num.setText(event.getOtherDN());
                customerPhone = event.getOtherDN();
            }
            if (!TextUtils.isEmpty(customerProvince) && !TextUtils.isEmpty(customerCity)) {
                tv_address.setText(customerProvince + "-" + customerCity);
                tv_user_card_address.setText(customerProvince + "-" + customerCity);
                customerAddress = customerProvince + "-" + customerCity;
            } else if (!TextUtils.isEmpty(customerProvince)) {
                tv_address.setText(customerProvince);
                tv_user_card_address.setText(customerProvince);
                customerAddress = customerProvince;
            } else if (!TextUtils.isEmpty(customerCity)) {
                tv_address.setText(customerCity);
                tv_user_card_address.setText(customerCity);
                customerAddress = customerCity;
            } else {
                customerAddress = "";
                v_num_split.setVisibility(View.GONE);
                tv_address.setVisibility(View.GONE);
            }
            mTvStatus.setVisibility(View.VISIBLE);
            ll_user_card.setVisibility(View.GONE);
            ll_seats.setVisibility(View.GONE);
            String otherDNRole = event.getOtherDNRole();
            String thirdDNRole = event.getThirdDNRole();
            if (!TextUtils.isEmpty(otherDNRole) && otherDNRole.equals(CallStage.ConsultBy.getValue())) {
                currentStatus = 2;
                //被咨询
                beingConsultedUI();
                if (!TextUtils.isEmpty(event.getThirdDN())) {
                    mTvNum.setText(event.getThirdDN());
                    tv_user_card_num.setText(event.getThirdDN());
                    customerPhone = event.getThirdDN();
                }
            }
            if (!TextUtils.isEmpty(thirdDNRole) && thirdDNRole.equals(CallStage.TransferBy.getValue())) {
                //单步转移
                currentStatus = 3;
                singleSteptransferUI();
            }
            if ("Internal".equals(SobotStringUtils.checkStringIsNull(event.getCallType()))) {
                currentStatus = 0;
                //内部来电
                internalCallUI(callType);
            }
            callWay = CallSharedPreferencesUtils.getInstance(getSobotBaseActivity()).get(SobotCallConstant.SP_KEY_CALL_MODEL_TYPE_V6, SobotCallConstant.CALL_MODEL_PHONE);
            if (callWay == SobotCallConstant.CALL_MODEL_PHONE) {
                //手机方式
                currentStatus = 8;
                phoneUI();
                customerPhone = SobotStringUtils.checkStringIsNull(event.getANI());
                mTvNum.setText(customerPhone);
            }
            searchCustomByType();
        }
        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_FWZJ) && call_service_summary_flag) {
            ll_service_summary.setVisibility(View.VISIBLE);
            v_service_summary_split.setVisibility(View.VISIBLE);
        } else {
            ll_service_summary.setVisibility(View.GONE);
            v_service_summary_split.setVisibility(View.GONE);
        }

        if (!SobotStringUtils.isEmpty(recordId)) {
            //有任务明细 直接显示底部任务总结
            ll_service_summary.setVisibility(View.VISIBLE);
            v_service_summary_split.setVisibility(View.VISIBLE);
        }
    }

    //内部来电
    private void internalCallUI(String callType) {
        if ("Internal".equals(SobotStringUtils.checkStringIsNull(callType))) {
            mStatus = getResources().getString(R.string.sobot_call_ringing);
            tv_phone_call_you.setVisibility(View.GONE);
            tv_transfer_from_nick.setText(getString(R.string.sobot_custom_tnternal_call));
            tv_transfer_from_nick.setVisibility(View.VISIBLE);
            tv_consult_you.setVisibility(View.GONE);
            mTvNick.setVisibility(View.VISIBLE);
            mTvNick.setText(_otherAgentName);
            mTvNum.setVisibility(View.VISIBLE);
            v_num_split.setVisibility(View.GONE);
            tv_address.setVisibility(View.GONE);
            mTvStatus.setVisibility(View.VISIBLE);
            ll_user_card.setVisibility(View.GONE);
            ll_seats.setVisibility(View.GONE);
            ll_meau.setVisibility(View.GONE);
            ll_hung_accept.setVisibility(View.VISIBLE);
            v_service_summary_split.setVisibility(View.GONE);
            ll_service_summary.setVisibility(View.GONE);
            ll_userinfo_summary_bg.setVisibility(View.GONE);
        }
    }


    //刷新 ui  通话中
    private void duringCallUI(String callType) {
        tv_phone_call_you.setVisibility(View.GONE);
        mStatus = getResources().getString(R.string.sobot_custom_tonghuazhong);
        tv_transfer_from_nick.setVisibility(View.GONE);
        tv_consult_you.setVisibility(View.GONE);
        ll_hung_accept.setVisibility(View.GONE);
        ll_user_card.setVisibility(View.GONE);
        ll_seats.setVisibility(View.GONE);
        mTvStatus.setText(mStatus);

        ll_meau.setVisibility(View.VISIBLE);
        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_XZKH)) {
            v_service_summary_split.setVisibility(View.VISIBLE);
        } else {
            v_service_summary_split.setVisibility(View.GONE);
        }
        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_FWZJ) && call_service_summary_flag) {
            ll_service_summary.setVisibility(View.VISIBLE);
            v_service_summary_split.setVisibility(View.VISIBLE);
        } else {
            ll_service_summary.setVisibility(View.GONE);
            v_service_summary_split.setVisibility(View.GONE);
        }

        if (!SobotStringUtils.isEmpty(recordId)) {
            //有任务明细 直接显示底部任务总结
            ll_service_summary.setVisibility(View.VISIBLE);
            v_service_summary_split.setVisibility(View.VISIBLE);
        }

        tv_mute.setClickable(true);
        tv_mute.setEnabled(true);
        Drawable drawable = getResources().getDrawable(R.drawable.icon_mute);
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv_mute.setCompoundDrawables(null, drawable, null, null);
        tv_mute.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));

        if ("Internal".equals(SobotStringUtils.checkStringIsNull(callType))) {
            //内部来电
            ll_userinfo_summary_bg.setVisibility(View.GONE);
            tv_transfer_from_nick.setText(getString(R.string.sobot_custom_tnternal_call));
            tv_transfer_from_nick.setVisibility(View.VISIBLE);
            mTvNick.setVisibility(View.VISIBLE);
            mTvNick.setText(_otherAgentName);
            tv_hold.setClickable(false);
            tv_hold.setEnabled(false);
            Drawable holeDrawable = getResources().getDrawable(R.drawable.icon_hold_disable);
            holeDrawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
            tv_hold.setCompoundDrawables(null, holeDrawable, null, null);
            tv_hold.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
            tv_hung_invite.setClickable(false);
            tv_hung_invite.setEnabled(false);
            Drawable hungInviteDrawable = getResources().getDrawable(R.drawable.icon_hung_invite_disable);
            hungInviteDrawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
            tv_hung_invite.setCompoundDrawables(null, hungInviteDrawable, null, null);
            tv_hung_invite.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
            tv_keyword.setClickable(false);
            tv_keyword.setEnabled(false);
            tv_keyword.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
        } else {
            tv_hold.setClickable(true);
            tv_hold.setEnabled(true);
            Drawable holeDrawable = getResources().getDrawable(R.drawable.icon_hold);
            holeDrawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
            tv_hold.setCompoundDrawables(null, holeDrawable, null, null);
            tv_hold.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
            tv_hung_invite.setClickable(true);
            tv_hung_invite.setEnabled(true);
            Drawable hungInviteDrawable = getResources().getDrawable(R.drawable.icon_hung_invite);
            hungInviteDrawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
            tv_hung_invite.setCompoundDrawables(null, hungInviteDrawable, null, null);
            tv_hung_invite.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
            tv_keyword.setClickable(true);
            tv_keyword.setEnabled(true);
            tv_keyword.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        }
        if (callWay == SobotCallConstant.CALL_MODEL_PHONE) {
            //免提置灰，不能点击
            tv_on_speakerphone.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
            tv_on_speakerphone.setClickable(false);
            tv_on_speakerphone.setEnabled(false);
        }
    }

    //手机方式来电 ui
    private void phoneUI() {
        //免提置灰，不能点击
        tv_on_speakerphone.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
        tv_on_speakerphone.setClickable(false);
        tv_on_speakerphone.setEnabled(false);
        tv_phone_call_you.setVisibility(View.VISIBLE);
        tv_consult_you.setVisibility(View.GONE);
        tv_transfer_from_nick.setVisibility(View.GONE);
        mTvNick.setVisibility(View.VISIBLE);
        mTvNick.setText(customerNick);
        mTvNum.setVisibility(View.VISIBLE);
        mTvNum.setText(customerPhone);
        v_num_split.setVisibility(View.VISIBLE);
        tv_address.setVisibility(View.VISIBLE);
        tv_address.setText(customerAddress);
        mTvStatus.setVisibility(View.VISIBLE);
        mTvStatus.setText(mStatus);
        ll_user_card.setVisibility(View.GONE);
        ll_seats.setVisibility(View.GONE);
        ll_meau.setVisibility(View.GONE);
        ll_hung_accept.setVisibility(View.GONE);
        tv_phone_call_you.setVisibility(View.VISIBLE);

        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_FWZJ) && call_service_summary_flag) {
            ll_service_summary.setVisibility(View.VISIBLE);
            v_service_summary_split.setVisibility(View.VISIBLE);
        } else {
            ll_service_summary.setVisibility(View.GONE);
            v_service_summary_split.setVisibility(View.GONE);
        }

        if (!SobotStringUtils.isEmpty(recordId)) {
            //有任务明细 直接显示底部任务总结
            ll_service_summary.setVisibility(View.VISIBLE);
            v_service_summary_split.setVisibility(View.VISIBLE);
        }
    }

    //刷新 ui  被咨询
    private void beingConsultedUI() {
        tv_phone_call_you.setVisibility(View.GONE);
        tv_consult_you.setVisibility(View.VISIBLE);
        tv_transfer_from_nick.setVisibility(View.GONE);
        mTvNick.setVisibility(View.VISIBLE);
        mTvNick.setText(_otherAgentName);
        mTvNum.setVisibility(View.GONE);
        v_num_split.setVisibility(View.GONE);
        tv_address.setVisibility(View.GONE);
        mTvStatus.setVisibility(View.VISIBLE);
        ll_user_card.setVisibility(View.VISIBLE);
        tv_user_card_status.setText(getString(R.string.sobot_custom_keeping));
        ll_seats.setVisibility(View.GONE);
        ll_meau.setVisibility(View.GONE);
        ll_hung_accept.setVisibility(View.VISIBLE);
        v_service_summary_split.setVisibility(View.GONE);
        ll_service_summary.setVisibility(View.GONE);
    }

    //刷新 ui 单步转移
    private void singleSteptransferUI() {
        tv_phone_call_you.setVisibility(View.GONE);
        tv_transfer_from_nick.setText(getString(R.string.call_transfer_from) + "：" + _thirdAgentName);
        tv_transfer_from_nick.setVisibility(View.VISIBLE);
        tv_consult_you.setVisibility(View.GONE);
        mTvNick.setVisibility(View.VISIBLE);
        mTvNum.setVisibility(View.VISIBLE);
        v_num_split.setVisibility(View.VISIBLE);
        tv_address.setVisibility(View.VISIBLE);
        mTvStatus.setVisibility(View.VISIBLE);
        ll_user_card.setVisibility(View.GONE);
        ll_seats.setVisibility(View.GONE);
        ll_meau.setVisibility(View.GONE);
        ll_hung_accept.setVisibility(View.VISIBLE);
        if (callWay == SobotCallConstant.CALL_MODEL_PHONE) {
            //免提置灰，不能点击
            tv_on_speakerphone.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
            tv_on_speakerphone.setClickable(false);
            tv_on_speakerphone.setEnabled(false);
        }
    }

    //刷新 ui 咨询接通
    private void acceptConsultationUI() {
        tv_phone_call_you.setVisibility(View.GONE);
        mStatus = getResources().getString(R.string.sobot_custom_tonghuazhong);
        tv_consult_you.setVisibility(View.GONE);
        tv_transfer_from_nick.setVisibility(View.GONE);
        ll_user_card.setVisibility(View.VISIBLE);
        tv_user_card_status.setText(getString(R.string.sobot_custom_keeping));
        ll_seats.setVisibility(View.VISIBLE);
        tv_seats_nick.setText(TextUtils.isEmpty(_otherAgentName) ? "" : _otherAgentName);
        tv_seats_status.setText(getString(R.string.call_consult));
        mTvNick.setVisibility(View.GONE);
        mTvNum.setVisibility(View.GONE);
        v_num_split.setVisibility(View.GONE);
        tv_address.setVisibility(View.GONE);
        mTvStatus.setVisibility(View.GONE);
        ll_hung_accept.setVisibility(View.GONE);
        v_service_summary_split.setVisibility(View.GONE);
        ll_service_summary.setVisibility(View.GONE);

        tv_exit.setVisibility(View.VISIBLE);
        iv_exit.setVisibility(View.GONE);

        ll_meau.setVisibility(View.VISIBLE);
        tv_mute.setClickable(true);
        tv_mute.setEnabled(true);
        Drawable drawable = getResources().getDrawable(R.drawable.icon_mute);
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv_mute.setCompoundDrawables(null, drawable, null, null);
        tv_mute.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        tv_hold.setClickable(false);
        tv_hold.setEnabled(false);
        Drawable holeDrawable = getResources().getDrawable(R.drawable.icon_hold_disable);
        holeDrawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv_hold.setCompoundDrawables(null, holeDrawable, null, null);
        tv_hold.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
        tv_hung_invite.setClickable(false);
        tv_hung_invite.setEnabled(false);
        Drawable hungInviteDrawable = getResources().getDrawable(R.drawable.icon_hung_invite_disable);
        hungInviteDrawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv_hung_invite.setCompoundDrawables(null, hungInviteDrawable, null, null);
        tv_hung_invite.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
        tv_keyword.setClickable(false);
        tv_keyword.setEnabled(false);
        tv_keyword.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
    }

    //刷新 ui 咨询后会议（三方）
    private void meetingAfterConsultationUI() {
        tv_phone_call_you.setVisibility(View.GONE);
        mStatus = getResources().getString(R.string.sobot_custom_tonghuazhong);
        tv_consult_you.setVisibility(View.GONE);
        tv_transfer_from_nick.setVisibility(View.GONE);
        mTvNick.setVisibility(View.GONE);
        mTvNum.setVisibility(View.GONE);
        v_num_split.setVisibility(View.GONE);
        tv_address.setVisibility(View.GONE);
        mTvStatus.setVisibility(View.GONE);
        ll_hung_accept.setVisibility(View.GONE);
        ll_seats.setVisibility(View.VISIBLE);
        ll_user_card.setVisibility(View.VISIBLE);
        v_service_summary_split.setVisibility(View.GONE);
        ll_service_summary.setVisibility(View.GONE);
        tv_user_card_status.setText(getString(R.string.call_third_party));
        tv_user_card_status.setTextColor(getResources().getColor(R.color.call_wenzi_yellow));
        tv_user_card_time.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        tv_user_card_nick.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        tv_seats_status.setText(getString(R.string.call_third_party));
        tv_seats_nick.setText(_otherAgentName);
        tv_exit.setVisibility(View.VISIBLE);
        iv_exit.setVisibility(View.GONE);

        ll_meau.setVisibility(View.VISIBLE);
        tv_mute.setClickable(true);
        tv_mute.setEnabled(true);
        Drawable drawable = getResources().getDrawable(R.drawable.icon_mute);
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv_mute.setCompoundDrawables(null, drawable, null, null);
        tv_mute.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        tv_hold.setClickable(false);
        tv_hold.setEnabled(false);
        Drawable holeDrawable = getResources().getDrawable(R.drawable.icon_hold_disable);
        holeDrawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv_hold.setCompoundDrawables(null, holeDrawable, null, null);
        tv_hold.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
        tv_hung_invite.setClickable(false);
        tv_hung_invite.setEnabled(false);
        Drawable hungInviteDrawable = getResources().getDrawable(R.drawable.icon_hung_invite_disable);
        hungInviteDrawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv_hung_invite.setCompoundDrawables(null, hungInviteDrawable, null, null);
        tv_hung_invite.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
        tv_keyword.setClickable(false);
        tv_keyword.setEnabled(false);
        tv_keyword.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
        if (callWay == SobotCallConstant.CALL_MODEL_PHONE) {
            //免提置灰，不能点击
            tv_on_speakerphone.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
            tv_on_speakerphone.setClickable(false);
            tv_on_speakerphone.setEnabled(false);
        }
    }

    //刷新 ui 强插（三方）
    private void intrusionUI() {
        tv_phone_call_you.setVisibility(View.GONE);
        mStatus = getResources().getString(R.string.sobot_custom_tonghuazhong);
        tv_consult_you.setVisibility(View.GONE);
        tv_transfer_from_nick.setVisibility(View.GONE);
        mTvNick.setVisibility(View.GONE);
        mTvNum.setVisibility(View.GONE);
        v_num_split.setVisibility(View.GONE);
        tv_address.setVisibility(View.GONE);
        mTvStatus.setVisibility(View.GONE);
        ll_hung_accept.setVisibility(View.GONE);
        ll_seats.setVisibility(View.VISIBLE);
        ll_user_card.setVisibility(View.VISIBLE);
        v_service_summary_split.setVisibility(View.GONE);
        ll_service_summary.setVisibility(View.GONE);
        tv_user_card_status.setText(getString(R.string.call_third_party));
        tv_user_card_status.setTextColor(getResources().getColor(R.color.call_wenzi_yellow));
        tv_user_card_time.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        tv_user_card_nick.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        tv_seats_status.setText(getString(R.string.call_third_party));
        tv_seats_nick.setText(_otherAgentName);
        tv_exit.setVisibility(View.GONE);
        iv_exit.setVisibility(View.VISIBLE);

        ll_meau.setVisibility(View.VISIBLE);
        tv_mute.setClickable(true);
        tv_mute.setEnabled(true);
        Drawable drawable = getResources().getDrawable(R.drawable.icon_mute);
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv_mute.setCompoundDrawables(null, drawable, null, null);
        tv_mute.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        tv_hold.setClickable(false);
        tv_hold.setEnabled(false);
        Drawable holeDrawable = getResources().getDrawable(R.drawable.icon_hold_disable);
        holeDrawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv_hold.setCompoundDrawables(null, holeDrawable, null, null);
        tv_hold.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
        tv_hung_invite.setClickable(true);
        tv_hung_invite.setEnabled(true);
        Drawable hungInviteDrawable = getResources().getDrawable(R.drawable.icon_hung_invite);
        hungInviteDrawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv_hung_invite.setCompoundDrawables(null, hungInviteDrawable, null, null);
        tv_hung_invite.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        tv_keyword.setClickable(false);
        tv_keyword.setEnabled(false);
        tv_keyword.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
        if (callWay == SobotCallConstant.CALL_MODEL_PHONE) {
            //免提置灰，不能点击
            tv_on_speakerphone.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
            tv_on_speakerphone.setClickable(false);
            tv_on_speakerphone.setEnabled(false);
        }
    }


    //刷新 咨询后转移 ui
    private void transferAfterConsultationUI() {
        tv_phone_call_you.setVisibility(View.GONE);
        mStatus = getResources().getString(R.string.sobot_custom_tonghuazhong);
        tv_transfer_from_nick.setVisibility(View.GONE);
        tv_consult_you.setVisibility(View.GONE);
        mTvNick.setVisibility(View.VISIBLE);
        mTvNick.setText(customerNick);
        mTvNum.setVisibility(View.VISIBLE);
        mTvNum.setText(customerPhone);
        v_num_split.setVisibility(View.VISIBLE);
        tv_address.setVisibility(View.VISIBLE);
        mTvStatus.setVisibility(View.VISIBLE);
        ll_user_card.setVisibility(View.GONE);
        ll_seats.setVisibility(View.GONE);
        ll_hung_accept.setVisibility(View.GONE);
        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_XZKH)) {
            v_service_summary_split.setVisibility(View.VISIBLE);
        } else {
            v_service_summary_split.setVisibility(View.GONE);
        }
        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_FWZJ) && call_service_summary_flag) {
            ll_service_summary.setVisibility(View.VISIBLE);
            v_service_summary_split.setVisibility(View.VISIBLE);
        } else {
            ll_service_summary.setVisibility(View.GONE);
            v_service_summary_split.setVisibility(View.GONE);
        }
        tv_exit.setVisibility(View.GONE);
        iv_exit.setVisibility(View.VISIBLE);
        ll_meau.setVisibility(View.VISIBLE);
        tv_mute.setClickable(true);
        tv_mute.setEnabled(true);
        Drawable drawable = getResources().getDrawable(R.drawable.icon_mute);
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv_mute.setCompoundDrawables(null, drawable, null, null);
        tv_mute.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        tv_hold.setClickable(true);
        tv_hold.setEnabled(true);
        Drawable holeDrawable = getResources().getDrawable(R.drawable.icon_hold);
        holeDrawable.setBounds(0, 0, holeDrawable.getMinimumWidth(), holeDrawable.getMinimumHeight());
        tv_hold.setCompoundDrawables(null, holeDrawable, null, null);
        tv_hold.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        tv_hung_invite.setClickable(true);
        tv_hung_invite.setEnabled(true);
        Drawable hungInviteDrawable = getResources().getDrawable(R.drawable.icon_hung_invite);
        hungInviteDrawable.setBounds(0, 0, hungInviteDrawable.getMinimumWidth(), hungInviteDrawable.getMinimumHeight());
        tv_hung_invite.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        tv_hung_invite.setCompoundDrawables(null, hungInviteDrawable, null, null);
        tv_keyword.setClickable(true);
        tv_keyword.setEnabled(true);
        tv_keyword.setTextColor(getResources().getColor(R.color.call_wenzi_white_to_white));
        if (callWay == SobotCallConstant.CALL_MODEL_PHONE) {
            //免提置灰，不能点击
            tv_on_speakerphone.setTextColor(getResources().getColor(R.color.call_wenzi_gray2));
            tv_on_speakerphone.setClickable(false);
            tv_on_speakerphone.setEnabled(false);
        }
    }

    //根据手机号搜索返回的数量判断显示的  1客户资料 0新建客户 2 关联客户
    protected void searchCustomByType() {
        if (!SobotStringUtils.isEmpty(recordId)) {
            tv_user_info.setText(getResources().getString(R.string.call_str_task_info));
            Drawable userInfoDrawable = getResources().getDrawable(R.drawable.icon_call_user_info);
            userInfoDrawable.setBounds(0, 0, userInfoDrawable.getMinimumWidth(), userInfoDrawable.getMinimumHeight());
            tv_user_info.setCompoundDrawables(userInfoDrawable, null, null, null);
            tv_user_info.setTextColor(getResources().getColor(R.color.call_wenzi_gray3));
            tv_service_summary.setText(getResources().getString(R.string.call_str_task_summary));
            //有任务明细 直接显示底部任务信息
            return;
        }
        if (!TextUtils.isEmpty(customerId)) {
            if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_KHXX)) {
                ll_user_info.setVisibility(View.VISIBLE);
            } else {
                ll_user_info.setVisibility(View.GONE);
            }
            tv_user_info.setText(getString(R.string.call_str_user_info));
            Drawable userInfoDrawable = getResources().getDrawable(R.drawable.icon_call_user_info);
            userInfoDrawable.setBounds(0, 0, userInfoDrawable.getMinimumWidth(), userInfoDrawable.getMinimumHeight());
            tv_user_info.setCompoundDrawables(userInfoDrawable, null, null, null);
            tv_user_info.setTextColor(getResources().getColor(R.color.call_wenzi_gray3));
            userInfoType = 1;
            return;
        }
        if (!TextUtils.isEmpty(customerPhone) || !TextUtils.isEmpty(privacyNumber)) {
            String tempPhone = "";
            if (!TextUtils.isEmpty(privacyNumber)) {
                tempPhone = privacyNumber;
            } else {
                tempPhone = customerPhone;
            }
            zhiChiApi.searchCustom(getSobotBaseActivity(), "4", tempPhone, new SobotResultCallBack<List<SobotCallCustomerModel>>() {
                @Override
                public void onSuccess(List<SobotCallCustomerModel> sobotCallCustomerModels) {
                    if (null != sobotCallCustomerModels) {
                        if (sobotCallCustomerModels.size() == 0) {
                            if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_XZKH)) {
                                ll_user_info.setVisibility(View.VISIBLE);
                            } else {
                                ll_user_info.setVisibility(View.GONE);
                            }
                            tv_user_info.setText(getString(R.string.call_str_new_customer));
                            Drawable userInfoDrawable = getResources().getDrawable(R.drawable.call_icon_new_customer);
                            userInfoDrawable.setBounds(0, 0, userInfoDrawable.getMinimumWidth(), userInfoDrawable.getMinimumHeight());
                            tv_user_info.setCompoundDrawables(userInfoDrawable, null, null, null);
                            tv_user_info.setTextColor(getResources().getColor(R.color.call_wenzi_yellow));
                            userInfoType = 0;
                        } else if (sobotCallCustomerModels.size() == 1) {
                            if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_KHXX)) {
                                ll_user_info.setVisibility(View.VISIBLE);
                            } else {
                                ll_user_info.setVisibility(View.GONE);
                            }
                            tv_user_info.setText(getString(R.string.call_str_user_info));
                            Drawable userInfoDrawable = getResources().getDrawable(R.drawable.icon_call_user_info);
                            userInfoDrawable.setBounds(0, 0, userInfoDrawable.getMinimumWidth(), userInfoDrawable.getMinimumHeight());
                            tv_user_info.setCompoundDrawables(userInfoDrawable, null, null, null);
                            tv_user_info.setTextColor(getResources().getColor(R.color.call_wenzi_gray3));
                            userInfoType = 1;
                        } else if (sobotCallCustomerModels.size() > 1) {
                            if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_GLKH)) {
                                ll_user_info.setVisibility(View.VISIBLE);
                            } else {
                                ll_user_info.setVisibility(View.GONE);
                            }
                            Drawable userInfoDrawable = getResources().getDrawable(R.drawable.call_icon_relevance);
                            userInfoDrawable.setBounds(0, 0, userInfoDrawable.getMinimumWidth(), userInfoDrawable.getMinimumHeight());
                            tv_user_info.setCompoundDrawables(userInfoDrawable, null, null, null);
                            tv_user_info.setText(getString(R.string.call_str_relevance));
                            tv_user_info.setTextColor(getResources().getColor(R.color.call_wenzi_yellow));
                            userInfoType = 2;
                        }
                    }
                }

                @Override
                public void onFailure(Exception e, String des) {

                }
            });
        }
    }
}