package com.sobot.callsdk.v6.activity;

import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.text.TextUtils;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.TextView;

import androidx.viewpager.widget.ViewPager;

import com.sobot.callbase.dialog.SobotCallCommonDialog;
import com.sobot.callbase.model.CallTaskDetailsModel;
import com.sobot.callbase.model.SobotOutboundRoutesEntity;
import com.sobot.callbase.widget.floatwindow.SobotFloatWindow;
import com.sobot.callbase.widget.tab.SobotCallSlidingTab;
import com.sobot.callsdk.R;
import com.sobot.callsdk.activity.SobotCallBaseActivity;
import com.sobot.callsdk.fargment.SobotBaseFragment;
import com.sobot.callsdk.utils.CallSharedPreferencesUtils;
import com.sobot.callsdk.utils.CallStatusUtils;
import com.sobot.callsdk.utils.SobotCallConstant;
import com.sobot.callsdk.v6.constant.SobotCallLiveDataBusV6Key;
import com.sobot.callsdk.v6.fragment.CallTaskDetailFragment;
import com.sobot.callsdk.v6.fragment.CallTaskRocordFragment;
import com.sobot.callsdk.v6.fragment.CallTaskSummaryFragment;
import com.sobot.callsdk.v6.listener.CallTaskStatusListener;
import com.sobot.callsdk.widget.SobotViewPagerAdapter;
import com.sobot.common.login.SobotLoginTools;
import com.sobot.common.login.model.SobotServiceInfoModel;
import com.sobot.widget.livedatabus.SobotLiveEventBus;
import com.sobot.widget.ui.toast.SobotToastUtil;

import java.util.ArrayList;
import java.util.List;

/**
 * 任务明细详情
 */

public class CallTaskContactDetailActivity extends SobotCallBaseActivity implements View.OnClickListener, CallTaskStatusListener {
    private SobotCallSlidingTab sobot_call_tab;
    private ViewPager vp_call_viewpager;
    private SobotViewPagerAdapter adapter;

    //外呼规则
    private SobotOutboundRoutesEntity outboundRoutes;
    private PopupWindow popupWindow;
    private LinearLayout ll_waixian;//切换外显号
    private TextView tv_mobile;//外显规则


    private CallTaskDetailFragment detailFragment;
    private CallTaskSummaryFragment summaryFragment;
    private CallTaskRocordFragment rocordFragment;
    private int defaultIndex = 0;//默认打开fragment的位置
    private String campaignId;//任务id
    private String recordId;//任务明细id
    private int status; // 1："未开始", 2："进行中",3:"暂停中", (4:"已过期"),(5："已完成"),(6:"已归档"),(7:"已删除")
    private int dialCount;//外呼次数 判断是否执行过
    private int taskFromType;//1 全部 2 未执行 3 已执行
    private ArrayList<CallTaskDetailsModel> taskRecordList;//上页的数据
    private SobotServiceInfoModel serviceVo;
    private ImageView iv_right, iv_left, iv_call_btn;
    private View v_shape;
    private LinearLayout ll_bottom;
    private CallTaskDetailsModel detailsModel;
    private int taskIndex;

    private int fromCall;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        serviceVo = SobotLoginTools.getInstance().getServiceInfo();
        if (getIntent() != null) {
            campaignId = getIntent().getStringExtra("campaignId");
            recordId = getIntent().getStringExtra("recordId");
            dialCount = getIntent().getIntExtra("dialCount", 0);
            taskFromType = getIntent().getIntExtra("taskFromType", 0);
            status = getIntent().getIntExtra("status", 0);
            fromCall = getIntent().getIntExtra("fromCall", 0);
            defaultIndex = getIntent().getIntExtra("defaultIndex", 0);
            taskRecordList = (ArrayList<CallTaskDetailsModel>) getIntent().getSerializableExtra("taskRecordList");
            if (taskRecordList != null && taskRecordList.size() > 0 && !TextUtils.isEmpty(recordId)) {
                for (int i = 0; i < taskRecordList.size(); i++) {
                    if (recordId.equals(taskRecordList.get(i).getRecordId())) {
                        detailsModel = taskRecordList.get(i);
                        taskIndex = i;
                        break;
                    }
                }
            }
            initTab();
            //底部显示
            if(fromCall==1){
                ll_bottom.setVisibility(View.GONE);
            }else{
                ll_bottom.setVisibility(View.VISIBLE);
            }
            if (taskRecordList != null && taskRecordList.size() > 0) {
                if (taskIndex == 0) {
                    iv_left.setImageResource(R.drawable.call_icon_disable_left);
                    iv_left.setOnClickListener(null);
                } else {
                    iv_left.setImageResource(R.drawable.call_icon_able_left);
                    iv_left.setOnClickListener(this);
                }
                if (taskIndex >= taskRecordList.size()-1) {
                    iv_right.setImageResource(R.drawable.call_icon_disable_right);
                    iv_right.setOnClickListener(null);
                } else {
                    iv_right.setImageResource(R.drawable.call_icon_able_right);
                    iv_right.setOnClickListener(this);
                }
            } else {
                iv_left.setImageResource(R.drawable.call_icon_disable_left);
                iv_left.setOnClickListener(null);
                iv_right.setImageResource(R.drawable.call_icon_disable_right);
                iv_right.setOnClickListener(null);
            }
            if (status == 2) {
                iv_call_btn.setVisibility(View.VISIBLE);
            } else {
                iv_call_btn.setVisibility(View.GONE);
            }
        }
    }

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        if (intent == null) return;
        recordId = intent.getStringExtra("recordId");
        int index = intent.getIntExtra("defaultIndex", 0);
        fromCall = intent.getIntExtra("fromCall", 0);
        campaignId = intent.getStringExtra("campaignId");
        dialCount = intent.getIntExtra("dialCount", 0);
        taskFromType = intent.getIntExtra("taskFromType", 0);
        status = intent.getIntExtra("status", 0);
        taskRecordList = (ArrayList<CallTaskDetailsModel>) intent.getSerializableExtra("taskRecordList");
        detailsModel = null;

        if (defaultIndex != index) {
            defaultIndex = index;
            vp_call_viewpager.setCurrentItem(defaultIndex, false);
        }
        if (taskRecordList != null && taskRecordList.size() > 0 && !TextUtils.isEmpty(recordId)) {
            for (int i = 0; i < taskRecordList.size(); i++) {
                if (recordId.equals(taskRecordList.get(i).getRecordId())) {
                    detailsModel = taskRecordList.get(i);
                    taskIndex = i;
                    break;
                }
            }
        }
        //底部显示
        if(fromCall==1){
            ll_bottom.setVisibility(View.GONE);
        }else{
            ll_bottom.setVisibility(View.VISIBLE);
        }
        if (taskRecordList != null && taskRecordList.size() > 0) {
            if (taskIndex == 0) {
                iv_left.setImageResource(R.drawable.call_icon_disable_left);
                iv_left.setOnClickListener(null);
            } else {
                iv_left.setImageResource(R.drawable.call_icon_able_left);
                iv_left.setOnClickListener(this);
            }
            if (taskIndex >= taskRecordList.size()-1) {
                iv_right.setImageResource(R.drawable.call_icon_disable_right);
                iv_right.setOnClickListener(null);
            } else {
                iv_right.setImageResource(R.drawable.call_icon_able_right);
                iv_right.setOnClickListener(this);
            }
        } else {
            iv_left.setImageResource(R.drawable.call_icon_disable_left);
            iv_left.setOnClickListener(null);
            iv_right.setImageResource(R.drawable.call_icon_disable_right);
            iv_right.setOnClickListener(null);
        }
        refreshFragment();
    }

    @Override
    protected int getContentViewResId() {
        return R.layout.activity_call_task_contact_detail;
    }

    @Override
    protected void initView() throws InterruptedException {
        findViewById(R.id.sobot_tv_left).setOnClickListener(this);

        ll_waixian = findViewById(R.id.ll_waixian);
        tv_mobile = findViewById(R.id.tv_mobile);
        sobot_call_tab = findViewById(R.id.call_fragment_tab);
        vp_call_viewpager = findViewById(R.id.vp_call_viewpager);
        serviceVo = SobotLoginTools.getInstance().getServiceInfo();
        //上下翻页
        iv_right = findViewById(R.id.iv_right);
        iv_left = findViewById(R.id.iv_left);
        iv_call_btn = findViewById(R.id.iv_call_btn);
        v_shape = findViewById(R.id.v_shape);
        ll_bottom = findViewById(R.id.ll_bottom);
        ll_waixian.setOnClickListener(this);

        iv_call_btn.setOnClickListener(this);

        if (serviceVo != null) {
            //请求外显规则
            getOutboudRoutesRules(false, ll_waixian, tv_mobile);
        }
        //判断是否登录
        String call_loingStatus = CallSharedPreferencesUtils.getInstance(getSobotBaseActivity()).get(SobotCallConstant.callLoginStatus, CallStatusUtils.V6_OFFLINE);

        if (call_loingStatus.equals(CallStatusUtils.V6_OFFLINE)) {
            //座席未登录
            ll_waixian.setVisibility(View.GONE);
        } else {
            ll_waixian.setVisibility(View.VISIBLE);
        }
        sobot_call_tab.setOnPageChangeListener(new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageScrolled(int i, float v, int i1) {
            }

            @Override
            public void onPageSelected(int i) {
                defaultIndex = i;
                if (i == 0 && detailFragment != null) {
                    if (detailFragment.isEdit()) {
                        editStatus();
                    } else {
                        normalStatus();
                    }
                } else if (i == 1 && summaryFragment != null) {
                    summaryFragment.refresh();
                    if (summaryFragment.isEdit()) {
                        editStatus();
                    } else {
                        normalStatus();
                    }
                } else if (i == 2) {
                    normalStatus();
                }

            }

            @Override
            public void onPageScrollStateChanged(int i) {
            }
        });

    }

    @Override
    protected void initData() {

    }

    private void initTab() {
        Bundle bundle = new Bundle();
        bundle.putString("campaignId", campaignId);
        bundle.putString("recordId", recordId);
        bundle.putInt("dialCount", dialCount);
        bundle.putInt("taskFromType", taskFromType);
        detailFragment = new CallTaskDetailFragment();
        summaryFragment = new CallTaskSummaryFragment();
        rocordFragment = new CallTaskRocordFragment();
        detailFragment.setStatusListener(this);
        summaryFragment.setStatusListener(this);
        rocordFragment.setStatusListener(this);
        detailFragment.setArguments(bundle);
        summaryFragment.setArguments(bundle);
        rocordFragment.setArguments(bundle);
        List<SobotBaseFragment> fragments = new ArrayList<>();
        List<String> titleList = new ArrayList<>();
        titleList.add(getString(R.string.call_task_info));
        fragments.add(detailFragment);
        titleList.add(getString(R.string.call_task_summary));
        fragments.add(summaryFragment);
        titleList.add(getString(R.string.call_task_call_record));
        fragments.add(rocordFragment);
        String[] titleStr = new String[titleList.size()];
        for (int i = 0; i < titleList.size(); i++) {
            titleStr[i] = titleList.get(i);
        }
        adapter = new SobotViewPagerAdapter(this, getSupportFragmentManager(), titleStr, fragments);
        vp_call_viewpager.setAdapter(adapter);
        vp_call_viewpager.setOffscreenPageLimit(3);
        sobot_call_tab.setViewPager(vp_call_viewpager);
        vp_call_viewpager.setCurrentItem(defaultIndex, false);
    }


    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.sobot_tv_left) {
            finish();
        } else if (v == iv_left) {
            if (checkEdit(-1)) {
                return;
            }
            leftClick();
        } else if (v == iv_right) {
            if (checkEdit(1)) {
                return;
            }
            rightClick();
        } else if (v == iv_call_btn) {
            makeCall();
        } else if (ll_waixian == v) {
            //弹窗,打开切换外显号
            getOutboudRoutesRules(true, ll_waixian, tv_mobile);
        }
    }

    /**
     * 左边点击
     */
    private void leftClick() {
        taskIndex--;
        if (taskIndex < 0) {
            taskIndex = 0;
        }
        if (taskIndex == 0) {
            //左边不可点
            iv_left.setImageResource(R.drawable.call_icon_disable_left);
            iv_left.setOnClickListener(null);
        } else {
            iv_left.setImageResource(R.drawable.call_icon_able_left);
            iv_left.setOnClickListener(this);
        }
        if (taskIndex < taskRecordList.size()) {
            iv_right.setImageResource(R.drawable.call_icon_able_right);
            iv_right.setOnClickListener(this);
        }
        refreshFragment();
    }

    /**
     * 右边点击
     */
    private void rightClick() {
        taskIndex++;
        if (taskRecordList != null && taskRecordList.size() > 0) {
            if (taskIndex >= taskRecordList.size() - 1) {
                taskIndex = taskRecordList.size() - 1;
            }
            if (taskIndex == taskRecordList.size() - 1) {
                //右边不可点
                iv_right.setImageResource(R.drawable.call_icon_disable_right);
                iv_right.setOnClickListener(null);
            } else {
                iv_right.setImageResource(R.drawable.call_icon_able_right);
                iv_right.setOnClickListener(this);
            }
            if (taskIndex > 0) {
                iv_left.setImageResource(R.drawable.call_icon_able_left);
                iv_left.setOnClickListener(this);
            }
        }
        refreshFragment();
    }

    /**
     * 检测是否是在编辑状态
     *
     * @return
     */
    private boolean checkEdit(int turnIndex) {
        boolean isEdit = false;
        int currentItem = vp_call_viewpager.getCurrentItem();
        if (currentItem == 0) {
            if (detailFragment != null && detailFragment.isEdit()) {
                isEdit = true;
            }
        }
        if (currentItem == 1) {
            if (summaryFragment != null && summaryFragment.isEdit()) {
                isEdit = true;
            }
        }
        if (isEdit) {
            SobotCallCommonDialog dialog = new SobotCallCommonDialog(getResources().getString(R.string.call_task_edit_no_save),
                    getResources().getString(R.string.call_task_edit_change), new SobotCallCommonDialog.OnBtnClickListener() {
                @Override
                public void onClick() {
                    //选择
                    detailFragment.setEdit(false);
                    summaryFragment.setEdit(false);
                    if (turnIndex == -1) {
                        leftClick();
                    } else if (turnIndex == 1) {
                        rightClick();
                    } else if (turnIndex == 0) {
                        finish();
                    }
                }
            }, getResources().getString(R.string.sobot_btn_cancle), null);
            dialog.show(getSupportFragmentManager(), "dialog");
        }
        return isEdit;
    }

    private void refreshFragment() {
        if (taskRecordList != null && taskRecordList.size() > 0 && taskIndex >= 0 && taskIndex < taskRecordList.size()) {
            detailsModel = taskRecordList.get(taskIndex);
            if (detailsModel != null) {
                detailFragment.refreshDate(detailsModel.getCampaignId(), detailsModel.getRecordId());
                summaryFragment.refreshDate(detailsModel.getCampaignId(), detailsModel.getRecordId());
                rocordFragment.refreshDate(detailsModel.getCampaignId(), detailsModel.getRecordId());
            }
        }
    }

    private void makeCall() {
        //判断是否登录
        String call_loingStatus = CallSharedPreferencesUtils.getInstance(this).get(SobotCallConstant.callLoginStatus, CallStatusUtils.V6_OFFLINE);
        if (call_loingStatus.equals(CallStatusUtils.V6_FINISHING)) {
            //判断是否正在整理中
            SobotToastUtil.showToast(this, getResources().getString(R.string.sobot_error_switch_status));
        } else if (call_loingStatus.equals(CallStatusUtils.V6_SYSYTEM_BUSY)) {
            SobotToastUtil.showToast(this, getResources().getString(R.string.call_str_system_Lock_toast));
        } else if (call_loingStatus.equals(CallStatusUtils.V6_OFFLINE)) {
            SobotToastUtil.showToast(this, getResources().getString(R.string.sobot_call_error_hint));
        } else if (SobotFloatWindow.get(SobotCallConstant.CALL_STATUS_FLOAT) != null && SobotFloatWindow.get(SobotCallConstant.CALL_STATUS_FLOAT).isShowing()) {
            //通话没结束，不能切换坐席状态
            SobotToastUtil.showCustomToast(this, getString(R.string.call_retcode_330035));
            return;
        } else {
            //调用呼叫接口打电话
            Intent intent = CallStatusActivity.initIntent(this, detailsModel.getEncryptCustomerNumber(), detailsModel.getScreenNumber());
            intent.putExtra("recordId", detailsModel.getRecordId());//任务明细id
            intent.putExtra("campaignId", detailsModel.getCampaignId());//公司id
            intent.putExtra("dialCount", detailsModel.getDialCount());//外出次数 判断是否执行过
            intent.putExtra("status", status);//任务状态（未开始、进行中..）
            intent.putExtra("contactName", detailsModel.getContactName());//联系人姓名
            Bundle bundle = new Bundle();
            bundle.putSerializable("taskRecordList", taskRecordList);
            intent.putExtras(bundle);
            intent.setFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP | Intent.FLAG_ACTIVITY_CLEAR_TOP |
                    Intent.FLAG_ACTIVITY_NEW_TASK);
            startActivity(intent);
            if (detailsModel.getDialCount() == 0) {
                SobotLiveEventBus.get(SobotCallLiveDataBusV6Key.SOBOT_ACTION_REFRESH_UNEXECUTED_TASK_TAG).post(true);
            }
            SobotLiveEventBus.get(SobotCallLiveDataBusV6Key.SOBOT_ACTION_REFRESH_EXECUTED_TASK_TAG).post(true);
            SobotLiveEventBus.get(SobotCallLiveDataBusV6Key.SOBOT_ACTION_REFRESH_ALL_TASK_TAG).post(true);
            SobotLiveEventBus.get(SobotCallLiveDataBusV6Key.SOBOT_ACTION_REFRESH_LAST_CALL).post(detailsModel);

        }
    }

    public void editStatus() {
        new Handler().post(new Runnable() {
            @Override
            public void run() {
                iv_call_btn.setImageResource(R.drawable.call_white_call_btn);
            }
        });
    }

    public void normalStatus() {
        new Handler().post(new Runnable() {
            @Override
            public void run() {
                iv_call_btn.setImageResource(R.drawable.call_green_call_btn);
            }
        });
    }

    @Override
    public void refreshList(String name, String phoneNum, String ePhoneNum) {
        if(detailsModel!=null) {
            detailsModel.setContactName(name);
            detailsModel.setScreenNumber(phoneNum);
            detailsModel.setEncryptCustomerNumber(ePhoneNum);
        }
    }
}