package com.sobot.callsdk.v6.adapter;

import android.content.Context;
import android.graphics.Color;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.TextUtils;
import android.text.style.ForegroundColorSpan;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callbase.model.EnterPriseModel;
import com.sobot.callsdk.R;
import com.sobot.callsdk.v6.dialog.DialogItemOnClick;

import java.util.List;

public class CallCompanyAdapter extends RecyclerView.Adapter {
    private List<EnterPriseModel> list;
    private Context mContext;
    private DialogItemOnClick listener;
    private EnterPriseModel selectCompany;
    private String select = "";

    public CallCompanyAdapter(Context context, List<EnterPriseModel> list, EnterPriseModel selectCompany, DialogItemOnClick listener) {
        this.mContext = context;
        this.list = list;
        this.listener = listener;
        this.selectCompany = selectCompany;
    }

    public void setDate(String select) {
        this.select = select;
        notifyDataSetChanged();
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup viewGroup, int i) {
        View v = LayoutInflater.from(mContext).inflate(R.layout.sobot_item_select_exts, viewGroup, false);
        return new MyViewHolder(v);
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder viewHolder, int i) {
        EnterPriseModel checkin = list.get(i);
        MyViewHolder vh = (MyViewHolder) viewHolder;
        if (checkin != null) {
            if (!TextUtils.isEmpty(checkin.getEnterpriseName())) {
                String name = checkin.getEnterpriseName();
                SpannableString spannableString = new SpannableString(name);
                if (name.contains(select)) {
                    spannableString.setSpan(new ForegroundColorSpan(Color.parseColor("#09AEB0")), name.indexOf(select), name.indexOf(select) + select.length(), Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
                }
                vh.tv_ext.setText(spannableString);
            }
            if (null != selectCompany && selectCompany.getEnterpriseId().equals(checkin.getEnterpriseId())) {
                vh.iv_exts.setVisibility(View.VISIBLE);
            } else {
                vh.iv_exts.setVisibility(View.GONE);
            }
            vh.itemView.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (listener != null) {
                        selectCompany = checkin;
                        listener.selectItem(checkin);
                    }
                }
            });
        }
    }

    @Override
    public int getItemCount() {
        return list.size();
    }

    class MyViewHolder extends RecyclerView.ViewHolder {
        private ImageView iv_exts;
        private TextView tv_ext;

        public MyViewHolder(@NonNull View itemView) {
            super(itemView);
            tv_ext = itemView.findViewById(R.id.tv_ext);
            iv_exts = itemView.findViewById(R.id.iv_exts);

        }
    }
}
