package com.sobot.callsdk.v6.adapter;

import android.content.Context;
import android.graphics.Color;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.TextUtils;
import android.text.style.ForegroundColorSpan;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callsdk.R;
import com.sobot.callsdk.model.SobotCallCustomerModel;

import java.util.List;

public class CallCustomAdapter extends RecyclerView.Adapter {
    private List<SobotCallCustomerModel> list;
    private Context mContext;
    private OnItemClick listener;
    private String select ="";
    public CallCustomAdapter(Context context, List<SobotCallCustomerModel> list, OnItemClick listener){
        this.mContext = context;
        this.list = list;
        this.listener = listener;
    }

    public void setDate(String select) {
        this.select = select;
        notifyDataSetChanged();
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup viewGroup, int i) {
        View v = LayoutInflater.from(mContext).inflate(R.layout.sobot_item_call_search_custom, viewGroup, false);
        return  new MyViewHolder(v);
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder viewHolder, int i) {
        SobotCallCustomerModel checkin = list.get(i);
        MyViewHolder vh = (MyViewHolder) viewHolder;
        if(checkin!=null){
            if(!TextUtils.isEmpty(checkin.getNick())) {
                String name = checkin.getNick();
                SpannableString spannableString = new SpannableString(name);
                if(name.contains(select)){
                    spannableString.setSpan(new ForegroundColorSpan(Color.parseColor("#09AEB0")), name.indexOf(select),name.indexOf(select)+select.length(), Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
                }
                vh.tv_call_custom_name.setText(spannableString);
            }else{
                vh.tv_call_custom_name.setText(mContext.getResources().getString(R.string.call_unknown_customer));
            }
            if(checkin.isSelected()){
            }else{
            }
            vh.itemView.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if(listener!=null){
                        checkin.setSelected(true);
                        listener.onItemClick(checkin);
                    }
                }
            });
        }
    }

    @Override
    public int getItemCount() {
        return list.size();
    }
    class MyViewHolder extends RecyclerView.ViewHolder{
        private TextView tv_call_custom_name;

        public MyViewHolder(@NonNull View itemView) {
            super(itemView);
            tv_call_custom_name = itemView.findViewById(R.id.tv_call_custom_name);

        }
    }
    public interface OnItemClick{
        void onItemClick(SobotCallCustomerModel user);
    }
}
