package com.sobot.callsdk.v6.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callbase.model.SobotSummaryTemplate;
import com.sobot.callsdk.R;
import com.sobot.callsdk.v6.dialog.DialogItemOnClick;

import java.util.List;

public class CallTemplateAdapter extends RecyclerView.Adapter {
    private List<SobotSummaryTemplate> list;
    private Context mContext;
    private DialogItemOnClick listener;
    public CallTemplateAdapter(Context context, List<SobotSummaryTemplate> list, DialogItemOnClick listener){
        this.mContext = context;
        this.list = list;
        this.listener = listener;
    }

    public List<SobotSummaryTemplate> getList() {
        return list;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup viewGroup, int i) {
        View v = LayoutInflater.from(mContext).inflate(R.layout.sobot_item_select_exts, viewGroup, false);
        return  new MyViewHolder(v);
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder viewHolder, int i) {
        SobotSummaryTemplate checkin = list.get(i);
        MyViewHolder vh = (MyViewHolder) viewHolder;
        if(checkin!=null){
            vh.tv_ext.setText(checkin.getTemplateName());
            if(checkin.isSelect()){
                vh.iv_exts.setVisibility(View.VISIBLE);
            }else{
                vh.iv_exts.setVisibility(View.GONE);
            }
            vh.itemView.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if(listener!=null){
                        checkin.setSelect(true);
                        listener.selectItem(checkin);
                    }
                }
            });
        }
    }

    @Override
    public int getItemCount() {
        return list.size();
    }
    class MyViewHolder extends RecyclerView.ViewHolder{
        private ImageView iv_exts;
        private TextView tv_ext;

        public MyViewHolder(@NonNull View itemView) {
            super(itemView);
            tv_ext = itemView.findViewById(R.id.tv_ext);
            iv_exts = itemView.findViewById(R.id.iv_exts);

        }
    }
}
