package com.sobot.callsdk.v6.dialog;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callbase.model.SobotSummaryClassifies;
import com.sobot.callbase.utils.SobotStringUtils;
import com.sobot.callsdk.R;
import com.sobot.callsdk.dialog.SobotBottomDialog;
import com.sobot.callsdk.utils.CustomFieldsUtils;
import com.sobot.callsdk.v6.adapter.CallClassifyAdapter;
import com.sobot.callsdk.v6.adapter.CallSearchClassifyAdapter;
import com.sobot.utils.SobotLogUtils;
import com.sobot.widget.ui.toast.SobotToastUtil;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SelectClassifyDialog extends SobotBottomDialog implements View.OnClickListener, CallClassifyAdapter.OnItemClickListener, CallSearchClassifyAdapter.OnItemClickListener {
    private LinearLayout coustom_pop_layout, sobot_negativeButton;
    private RecyclerView rv_list, search_list;
    private Button btn_confirm;
    private TextView sobot_tv_title;
    private DialogItemOnClick listener;
    private CallClassifyAdapter adapter;
    private CallSearchClassifyAdapter searchAdatper;
    private List<SobotSummaryClassifies> data;//全部
    private List<SobotSummaryClassifies> checkData;//全部
    private List<SobotSummaryClassifies> list;//当前
    private List<SobotSummaryClassifies> searchList;//当前
    private Map<String, String> selectMap;
    private Activity activity;

    private TextView tv_nodata;
    private LinearLayout ll_have_data, ll_level;
    private int summaryClassificationLevelLimit;//服务分类可选层级限制 0:任意级; 1:末级
    private int level = 1;
    private List<SobotSummaryClassifies> levelList;
    //搜索
    private EditText et_ext;
    private ImageView iv_ext_search, iv_clear;
    private List<String> titles;
    private LinearLayout ll_search;//搜索

    public SelectClassifyDialog(Activity context, int summaryClassificationLevelLimit, DialogItemOnClick listener, List<SobotSummaryClassifies> datas, List<SobotSummaryClassifies> checkData) {
        super(context);
        activity = context;
        this.listener = listener;
        this.data = new ArrayList<>();
        titles = new ArrayList<>();
        this.levelList = new ArrayList<>();
        for (int i = 0; i < datas.size(); i++) {
            if (datas.get(i).getEnabled() == 1) {
                this.data.add(datas.get(i));
            }
        }
        list = new ArrayList<>();
        for (int i = 0; i < this.data.size(); i++) {
            if (this.data.get(i).getClassifyLevel() == level) {
                list.add(this.data.get(i));
            }
        }
        //是否有子类
        for (int i = 0; i < list.size(); i++) {
            for (int j = 0; j < this.data.size(); j++) {
                if (this.data.get(j).getClassifyParentId().equals(list.get(i).getId())) {
                    list.get(i).setHasSonDirectory(true);
                    break;
                }
            }
        }
        this.checkData = new ArrayList<>();
        this.checkData.addAll(checkData);
        selectMap = new HashMap<>();
        for (int i = 0; i < this.data.size(); i++) {
            if (this.data.get(i).isChecked()) {
                selectMap.put(this.data.get(i).getId(), this.data.get(i).getClassifyName());
            }
        }
        this.summaryClassificationLevelLimit = summaryClassificationLevelLimit;
    }

    @Override
    protected int getLayout() {
        return R.layout.call_dialog_select_classify;
    }

    @Override
    protected View getDialogContainer() {
        if (coustom_pop_layout == null) {
            coustom_pop_layout = findViewById(R.id.sobot_container);
        }
        return coustom_pop_layout;
    }

    @Override
    protected void initData() {
        if (data != null && data.size() > 0) {
            tv_nodata.setVisibility(View.GONE);
            ll_have_data.setVisibility(View.VISIBLE);
        } else {
            level = 1;
            getListByLevel();
            ll_have_data.setVisibility(View.GONE);
            tv_nodata.setVisibility(View.VISIBLE);
        }
    }

    @SuppressLint("NotifyDataSetChanged")
    private void getListByLevel() {
        list.clear();
        for (int i = 0; i < data.size(); i++) {
            if (level == 1 && data.get(i).getClassifyParentId().equals("1")) {
                list.add(data.get(i));
            } else if (levelList.size() > 0 && data.get(i).getClassifyParentId().equals(levelList.get(levelList.size() - 1).getClassifyParentId())) {
                list.add(data.get(i));
            }
        }
        //是否有子类
        for (int i = 0; i < list.size(); i++) {
            for (int j = 0; j < data.size(); j++) {
                if (data.get(j).getClassifyParentId().equals(list.get(i).getId())) {
                    list.get(i).setHasSonDirectory(true);
                    break;
                }
            }
        }
        adapter.setDate("");
        adapter.notifyDataSetChanged();
    }

    @SuppressLint("NotifyDataSetChanged")
    private void getListByParentId(String pId) {
        list.clear();
        for (int i = 0; i < data.size(); i++) {
            if (data.get(i).getClassifyParentId().equals(pId)) {
                list.add(data.get(i));
            }
        }
        //是否有子类
        for (int i = 0; i < list.size(); i++) {
            for (int j = 0; j < data.size(); j++) {
                if (data.get(j).getClassifyParentId().equals(list.get(i).getId())) {
                    list.get(i).setHasSonDirectory(true);
                    break;
                }
            }
        }
        adapter.notifyDataSetChanged();
    }

    private List<SobotSummaryClassifies> getChildList(String pId) {
        List<SobotSummaryClassifies> list1 = new ArrayList<>();
        for (int i = 0; i < data.size(); i++) {
            if (data.get(i).getClassifyParentId().equals(pId)) {
                list1.add(data.get(i));
            }
        }
        return list1;
    }

    @Override
    protected void initView() {
        et_ext = findViewById(R.id.et_ext);
        iv_clear = findViewById(R.id.iv_clear);
        ll_search = findViewById(R.id.ll_search);
        iv_ext_search = findViewById(R.id.iv_ext_search);
        sobot_negativeButton = findViewById(R.id.sobot_negativeButton);
        sobot_tv_title = findViewById(R.id.sobot_tv_title);
        sobot_tv_title.setText(activity.getResources().getString(R.string.call_service_class));
        btn_confirm = findViewById(R.id.btn_confirm);
        tv_nodata = findViewById(R.id.tv_nodata);
        ll_have_data = findViewById(R.id.ll_have_data);
        ll_level = findViewById(R.id.ll_level);
        rv_list = findViewById(R.id.rv_list);
        search_list = findViewById(R.id.search_list);
        if (list == null) {
            list = new ArrayList<>();
        }
        if (searchList == null) {
            searchList = new ArrayList<>();
        }
        adapter = new CallClassifyAdapter(activity, list, summaryClassificationLevelLimit, this);
        searchAdatper = new CallSearchClassifyAdapter(activity, searchList, data, summaryClassificationLevelLimit, this);
        LinearLayoutManager layoutManager = new LinearLayoutManager(activity, LinearLayoutManager.VERTICAL, false);
        LinearLayoutManager searchLayoutManager = new LinearLayoutManager(activity, LinearLayoutManager.VERTICAL, false);
        // 设置RecyclerView的LayoutManager
        rv_list.setLayoutManager(layoutManager);
        rv_list.setAdapter(adapter);
        search_list.setLayoutManager(searchLayoutManager);
        search_list.setAdapter(searchAdatper);
        search_list.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                if (event.getAction() == MotionEvent.ACTION_MOVE) {
                    et_ext.clearFocus();
                }
                return false;
            }
        });
        et_ext.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if (hasFocus) {
                    CustomFieldsUtils.showKeyboard(getContext(), et_ext);
                    ll_search.setBackgroundResource(R.drawable.sobot_call_v6_bg_search_f);
                } else {
                    CustomFieldsUtils.hideKeyboard(getContext(), v);
                    ll_search.setBackgroundResource(R.drawable.sobot_call_v6_bg_search);
                }
            }
        });
        et_ext.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                int inputCount = s.length();
                if (inputCount > 0) {
                    iv_clear.setVisibility(View.VISIBLE);
                } else {
                    iv_clear.setVisibility(View.GONE);
                }
                search();
            }
        });
        et_ext.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView textView, int i, KeyEvent keyEvent) {
                if (i == EditorInfo.IME_ACTION_SEARCH) {
                    //搜索
                    search();
                    return true;
                }
                return false;
            }
        });
        sobot_negativeButton.setOnClickListener(this);
        btn_confirm.setOnClickListener(this);
        iv_ext_search.setOnClickListener(this);
        iv_clear.setOnClickListener(this);
        if (selectMap != null && selectMap.size() > 0) {
            String text = getContext().getResources().getString(R.string.sobot_btn_submit);
            String str = "%s (%s)";
            btn_confirm.setText(String.format(str, text, selectMap.size()));
        } else {
            btn_confirm.setText(R.string.sobot_btn_submit);
        }
    }

    @Override
    public void onClick(View v) {
        if (v == sobot_negativeButton) {
            et_ext.clearFocus();
            //关闭
            dismiss();
        } else if (iv_clear == v) {
            et_ext.setText("");
            tv_nodata.setVisibility(View.GONE);
            ll_have_data.setVisibility(View.VISIBLE);
            search();
        } else if (iv_ext_search == v) {
            //搜索
            et_ext.clearFocus();
            search();
        } else if (btn_confirm == v) {
            //回传手机号
            if (listener != null) {
                listener.selectItem(selectMap);
            }
            et_ext.clearFocus();
            dismiss();
        }
    }

    private void search() {
        String searchText = et_ext.getText().toString();
        if (searchText.length() > 0) {
            //显示搜索的结果
            ll_level.setVisibility(View.GONE);
            rv_list.setVisibility(View.GONE);
            search_list.setVisibility(View.VISIBLE);
            searchList.clear();
            for (int i = 0; i < data.size(); i++) {
                boolean flag = false;
                if ((!SobotStringUtils.isEmpty(data.get(i).getClassifyName()) && data.get(i).getClassifyName().contains(searchText))) {
                    flag = true;
                }
                if (!SobotStringUtils.isEmpty(data.get(i).getClassifyCode()) && data.get(i).getClassifyCode().contains(searchText)) {
                    flag = true;
                }
                if (flag) {
                    searchList.add(data.get(i));
                }
            }
            Collections.sort(searchList, new Comparator<SobotSummaryClassifies>() {
                @Override
                public int compare(SobotSummaryClassifies o1, SobotSummaryClassifies o2) {
                    return o1.getSort();
                }
            });
            SobotLogUtils.d("======searchList==" + searchList.size());
            searchAdatper.setDate(searchText);
            if (searchList.size() > 0) {
                tv_nodata.setVisibility(View.GONE);
                ll_have_data.setVisibility(View.VISIBLE);
            } else {
                tv_nodata.setVisibility(View.VISIBLE);
                ll_have_data.setVisibility(View.GONE);
            }
        } else {
            //显示原始的结果
            ll_level.setVisibility(View.VISIBLE);
            rv_list.setVisibility(View.VISIBLE);
            search_list.setVisibility(View.GONE);
        }
    }

    @Override
    public void dismiss() {
        try {
            if (isShowing()) {
                super.dismiss();
            }
        } catch (Exception e) {
//            e.printStackTrace();
        }
    }

    @Override
    public void onItemClick(SobotSummaryClassifies checkin, int index) {
        if (summaryClassificationLevelLimit == 0) {
            //可选任意级
            if (checkin.isHasSonDirectory()) {
                //下一级
                levelList.add(checkin);
                getListByParentId(checkin.getId());
                addLevelText(checkin.getClassifyName());
            } else {
                //走选中逻辑
                if (selectMap.containsKey(checkin.getId())) {
                    list.get(index).setChecked(false);
                    selectMap.remove(checkin.getId());
                } else {
                    if (selectMap.size() >= 10) {
                        list.get(index).setChecked(false);
                        SobotToastUtil.showToast(activity, activity.getResources().getString(R.string.call_summary_service_class_max));
                    } else {
                        selectMap.put(checkin.getId(), checkin.getClassifyName());
                        if (!TextUtils.isEmpty(checkin.getClassifyParentId())) {
                            clearP(checkin.getClassifyParentId());
                        }
                        if (checkin.isHasSonDirectory()) {
                            clearC(checkin);
                        }
                        list.get(index).setChecked(true);
                    }
                }
            }
        } else if (summaryClassificationLevelLimit == 1) {
            if (checkin.isHasSonDirectory()) {
                //下一级
                levelList.add(checkin);
                getListByParentId(checkin.getId());
                addLevelText(checkin.getClassifyName());
            } else {
                if (selectMap.containsKey(checkin.getId())) {
                    list.get(index).setChecked(false);
                    selectMap.remove(checkin.getId());
                } else {
                    if (selectMap.size() >= 10) {
                        list.get(index).setChecked(false);
                        SobotToastUtil.showToast(activity, activity.getResources().getString(R.string.call_summary_service_class_max));
                    } else {
                        selectMap.put(checkin.getId(), checkin.getClassifyName());
                        if (!TextUtils.isEmpty(checkin.getClassifyParentId())) {
                            clearP(checkin.getClassifyParentId());
                        }
                        if (checkin.isHasSonDirectory()) {
                            clearC(checkin);
                        }
                        list.get(index).setChecked(true);
                    }
                }
            }
        }
        adapter.notifyDataSetChanged();
        if (selectMap != null && selectMap.size() > 0) {
            String text = getContext().getResources().getString(R.string.sobot_btn_submit);
            String str = "%s (%s)";
            btn_confirm.setText(String.format(str, text, selectMap.size()));
        } else {
            btn_confirm.setText(R.string.sobot_btn_submit);
        }
    }

    @Override
    public void onItemCheck(SobotSummaryClassifies checkin, int index) {
        //选中逻辑
        if (selectMap.containsKey(checkin.getId())) {
            list.get(index).setChecked(false);
            selectMap.remove(checkin.getId());
        } else {
            if (selectMap.size() >= 10) {
                list.get(index).setChecked(false);
                SobotToastUtil.showToast(activity, activity.getResources().getString(R.string.call_summary_service_class_max));
            } else {
                selectMap.put(checkin.getId(), checkin.getClassifyName());
                if (!TextUtils.isEmpty(checkin.getClassifyParentId())) {
                    clearP(checkin.getClassifyParentId());
                }
                if (checkin.isHasSonDirectory()) {
                    clearC(checkin);
                }
                list.get(index).setChecked(true);
            }
        }
        adapter.notifyDataSetChanged();
        if (selectMap != null && selectMap.size() > 0) {
            String text = getContext().getResources().getString(R.string.sobot_btn_submit);
            String str = "%s (%s)";
            btn_confirm.setText(String.format(str, text, selectMap.size()));
        } else {
            btn_confirm.setText(R.string.sobot_btn_submit);
        }
    }

    //升级
    private void addLevelText(String text) {
        level++;
        titles.add(text);
        ll_level.setVisibility(View.VISIBLE);
        ll_level.removeAllViews();
        TextView view = (TextView) View.inflate(activity, R.layout.sobot_item_select_level, null);
        view.setText(text);
        view.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (level > 1) {
                    level--;
                    //更新头部导航
                    levelLow();
                    //先查询上一级
                    getListByLevel();
                    //再删除存储的上一级，位置不能换
                    levelList.remove(level - 1);
                }
            }
        });
        ll_level.addView(view);
    }

    //降级
    private void levelLow() {
        if (level > 1) {
            titles.remove(list.size() - 1);
            String text = titles.get(titles.size() - 1);
//            ll_level.removeViewAt(level-1);
            ll_level.removeAllViews();
            TextView view = (TextView) View.inflate(activity, R.layout.sobot_item_select_level, null);
            view.setText(text);
            view.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (level > 1) {
                        level--;
                        //更新头部导航
                        levelLow();
                        //先查询上一级
                        getListByLevel();
                        //再删除存储的上一级，位置不能换
                        levelList.remove(level - 1);
                    }
                }
            });
            ll_level.addView(view);
        } else {
            level = 1;
            titles.clear();
            ll_level.removeAllViews();
            ll_level.setVisibility(View.GONE);
        }
    }

    //子类选择后，清除父类
    private void clearP(String pid) {
        if (!TextUtils.isEmpty(pid)) {
            if (selectMap.containsKey(pid) && !"1".equals(pid)) {
                selectMap.remove(pid);
            }
            for (int i = 0; i < data.size(); i++) {
                if (pid.equals(data.get(i).getId())) {
                    data.get(i).setChecked(false);
                    if (!TextUtils.isEmpty(data.get(i).getClassifyParentId()) && !"1".equals(data.get(i).getClassifyParentId())) {
                        clearP(data.get(i).getClassifyParentId());
                    }
                }
            }
        }
    }

    private void clearC(SobotSummaryClassifies summaryClassifies) {
        List<SobotSummaryClassifies> childClass = getChildList(summaryClassifies.getId());
        if (childClass.size() > 0) {
            for (int i = 0; i < childClass.size(); i++) {
                String id = childClass.get(i).getId();
                if (selectMap.containsKey(id) && !"1".equals(id) && !TextUtils.isEmpty(id)) {
                    selectMap.remove(id);
                    for (int j = 0; j < data.size(); j++) {
                        if (data.get(j).getId().equals(id)) {
                            data.get(j).setChecked(false);
                        }
                    }
                }
                //清除子类
                if (childClass.get(i).isHasSonDirectory()) {
                    clearC(childClass.get(i));
                }
            }
        }
    }

    private void reseteLeveList(SobotSummaryClassifies info) {
        levelList.add(info);
        if (!"1".equals(info.getClassifyParentId())) {
            for (int i = 0; i < data.size(); i++) {
                if (data.get(i).getId().equals(info.getClassifyParentId())) {
                    if (!"1".equals(data.get(i).getClassifyParentId())) {
                        reseteLeveList(data.get(i));
                    }
                }
            }
        }
    }

    @Override
    public void onSearchItemClick(SobotSummaryClassifies info, int index) {
        if (summaryClassificationLevelLimit == 0) {
            if (info.isHasSonDirectory()) {
                //下一级,清空输入框
                et_ext.setText("");
                et_ext.clearFocus();
                //显示以前的列表，并显示下一级
                ll_level.setVisibility(View.VISIBLE);
                rv_list.setVisibility(View.VISIBLE);
                search_list.setVisibility(View.GONE);
                levelList.clear();
                reseteLeveList(info);
                addLevelText(info.getClassifyName());
                getListByParentId(info.getId());
            } else {
                //走选中逻辑
                if (selectMap.containsKey(info.getId())) {
                    searchList.get(index).setChecked(false);
                    selectMap.remove(info.getId());
                } else {
                    if (selectMap.size() >= 10) {
                        searchList.get(index).setChecked(false);
                        SobotToastUtil.showToast(activity, activity.getResources().getString(R.string.call_summary_service_class_max));
                    } else {
                        selectMap.put(info.getId(), info.getClassifyName());
                        if (!TextUtils.isEmpty(info.getClassifyParentId())) {
                            clearP(info.getClassifyParentId());
                        }
                        if (info.isHasSonDirectory()) {
                            clearC(info);
                        }
                        searchList.get(index).setChecked(true);
                    }
                }
            }
        } else if (summaryClassificationLevelLimit == 1) {
            if (info.isHasSonDirectory()) {
                //下一级
                et_ext.setText("");
                et_ext.clearFocus();
                //显示以前的列表，并显示下一级
                ll_level.setVisibility(View.VISIBLE);
                rv_list.setVisibility(View.VISIBLE);
                search_list.setVisibility(View.GONE);
                levelList.clear();
                reseteLeveList(info);
                addLevelText(info.getClassifyName());
                getListByParentId(info.getId());
            } else {
                if (selectMap.containsKey(info.getId())) {
                    searchList.get(index).setChecked(false);
                    selectMap.remove(info.getId());
                } else {
                    if (selectMap.size() >= 10) {
                        searchList.get(index).setChecked(false);
                        SobotToastUtil.showToast(activity, activity.getResources().getString(R.string.call_summary_service_class_max));
                    } else {
                        selectMap.put(info.getId(), info.getClassifyName());
                        if (!TextUtils.isEmpty(info.getClassifyParentId())) {
                            clearP(info.getClassifyParentId());
                        }
                        if (info.isHasSonDirectory()) {
                            clearC(info);
                        }
                        searchList.get(index).setChecked(true);

                    }
                }
            }
        }
        searchAdatper.notifyDataSetChanged();
        if (selectMap != null && selectMap.size() > 0) {
            String text = getContext().getResources().getString(R.string.sobot_btn_submit);
            String str = "%s (%s)";
            btn_confirm.setText(String.format(str, text, selectMap.size()));
        } else {
            btn_confirm.setText(R.string.sobot_btn_submit);
        }

    }

    @Override
    public void onSearchItemCheck(SobotSummaryClassifies info, int index) {
        //选中逻辑
        if (selectMap.containsKey(info.getId())) {
            searchList.get(index).setChecked(false);
            selectMap.remove(info.getId());
        } else {
            if (selectMap.size() >= 10) {
                searchList.get(index).setChecked(false);
                SobotToastUtil.showToast(activity, activity.getResources().getString(R.string.call_summary_service_class_max));
            } else {
                selectMap.put(info.getId(), info.getClassifyName());
                if (!TextUtils.isEmpty(info.getClassifyParentId())) {
                    clearP(info.getClassifyParentId());
                }
                if (info.isHasSonDirectory()) {
                    clearC(info);
                }
                searchList.get(index).setChecked(true);
            }
        }
        searchAdatper.notifyDataSetChanged();
        if (selectMap != null && selectMap.size() > 0) {
            String text = getContext().getResources().getString(R.string.sobot_btn_submit);
            String str = "%s (%s)";
            btn_confirm.setText(String.format(str, text, selectMap.size()));
        } else {
            btn_confirm.setText(R.string.sobot_btn_submit);
        }
    }
}
