package com.sobot.callsdk.v6.fragment;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.sobot.callbase.CallPermissionManager;
import com.sobot.callbase.dialog.SobotActionItem;
import com.sobot.callbase.model.SobotSummaryConfig;
import com.sobot.callbase.utils.CommonUtils;
import com.sobot.callbase.utils.SobotDateUtils;
import com.sobot.callbase.widget.CallClassicsFooter;
import com.sobot.callsdk.R;
import com.sobot.callsdk.fargment.SobotBaseFragment;
import com.sobot.callsdk.model.SobotCallCustomerModel;
import com.sobot.callsdk.model.SobotCallRecordEntity;
import com.sobot.callsdk.utils.CallSharedPreferencesUtils;
import com.sobot.callsdk.utils.CustomFieldsUtils;
import com.sobot.callsdk.utils.SobotCallConstant;
import com.sobot.callsdk.v6.activity.CallDetailsActivity;
import com.sobot.callsdk.v6.activity.CustomPickActivity;
import com.sobot.callsdk.v6.adapter.CallCustomAdapter;
import com.sobot.callsdk.v6.adapter.CallHistoryAdapter;
import com.sobot.callsdk.v6.dialog.SobotMoreMenuPop;
import com.sobot.common.login.SobotLoginTools;
import com.sobot.common.login.model.SobotServiceInfoModel;
import com.sobot.common.login.permission.SobotPermissionManager;
import com.sobot.network.http.callback.SobotResultCallBack;
import com.sobot.utils.SobotDensityUtil;
import com.sobot.widget.loading.SobotLoadingLayout;
import com.sobot.widget.refresh.layout.SobotRefreshLayout;
import com.sobot.widget.refresh.layout.api.RefreshLayout;
import com.sobot.widget.refresh.layout.header.ClassicsHeader;
import com.sobot.widget.refresh.layout.listener.OnLoadMoreListener;
import com.sobot.widget.refresh.layout.listener.OnRefreshListener;

import java.util.ArrayList;
import java.util.List;

public class CallHistoryV6Fragment extends SobotBaseFragment implements View.OnClickListener, CallHistoryAdapter.OnItemClickListener, CallCustomAdapter.OnItemClick {
    private RecyclerView recyclerView;
    private LinearLayout ll_search;
    //    private Spinner sp_search_type;
    private TextView tv_search_type;
    private EditText et_search_input;
    private ImageView iv_search;
    private ImageView iv_clear;
    private ImageView iv_search_condition;
    private CallHistoryAdapter mAdapter;

    private int pageNo = 1;
    private int pageSize = 20;
    private SobotRefreshLayout refreshLayout;
    private SobotLoadingLayout loadingLayout;
    private List<SobotCallRecordEntity> mDate;
    private boolean isHasMoreData = false;
    private boolean hidePhone = false;
    long startTime = 0;
    long endTime = 0;
    String callType = "";//呼叫类型
    String answerStatus = "";//接听状态

    private int searchType = 0;//0:号码，1：客户

    //搜索客户相关
    private LinearLayout ll_search_custom;
    private LinearLayout ll_custom_list;
    private RecyclerView rv_search_custom;
    private CallCustomAdapter customAdapter;
    private List<SobotCallCustomerModel> customList;
    private SobotCallCustomerModel selectCustom;
    private TextView no_date;
    //输入后0.5s去搜索
    private long inputTime = 0;
    private PopupWindow popupWindow;
    private List<SobotActionItem> searchItems;
    private String zone = "";

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        zone = CommonUtils.getTimeZone();
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.sobot_fragment_v6_call_history, container, false);
        initView(view);
        return view;
    }

    private void initView(View view) {
        ll_search = view.findViewById(R.id.ll_search);
        iv_clear = view.findViewById(R.id.iv_clear);
        tv_search_type = view.findViewById(R.id.tv_search_type);
//        sp_search_type = view.findViewById(R.id.sp_search_type);
        et_search_input = view.findViewById(R.id.et_search_input);
        iv_search = view.findViewById(R.id.iv_search);
        iv_search_condition = view.findViewById(R.id.iv_search_condition);

        //搜索客户
        ll_search_custom = view.findViewById(R.id.ll_search_custom);
        ll_custom_list = view.findViewById(R.id.ll_custom_list);
        rv_search_custom = view.findViewById(R.id.rv_search_custom);
        rv_search_custom.setLayoutManager(new LinearLayoutManager(getContext()));
        customList = new ArrayList<>();
        customAdapter = new CallCustomAdapter(getSobotActivity(), customList, this);
        rv_search_custom.setAdapter(customAdapter);
        no_date = view.findViewById(R.id.no_date);
        ll_search_custom.setVisibility(View.GONE);

        iv_search.setOnClickListener(this);
        iv_search_condition.setOnClickListener(this);
        iv_clear.setOnClickListener(this);

        //显示历史记录
        recyclerView = view.findViewById(R.id.sobot_rv_history_list);
        refreshLayout = view.findViewById(R.id.sobot_srl_call_record);
        loadingLayout = view.findViewById(R.id.sobot_loading_layout);
        loadingLayout.setEmpty(R.layout.sobot_history_no_data);
        //列表
        recyclerView.setLayoutManager(new LinearLayoutManager(getContext()));
        refreshLayout.setRefreshHeader(new ClassicsHeader(getSobotActivity()));
        refreshLayout.setRefreshFooter(new CallClassicsFooter(getSobotActivity()), SobotDensityUtil.getScreenWidth(getSobotActivity()), SobotDensityUtil.dp2px(getSobotActivity(), 100));
        refreshLayout.setEnableLoadMore(false);
        refreshLayout.setEnableRefresh(true);
        refreshLayout.setEnableAutoLoadMore(true);
        refreshLayout.setEnableFooterFollowWhenNoMoreData(false);
        recyclerView.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                if (event.getAction() == MotionEvent.ACTION_MOVE) {
                    et_search_input.clearFocus();
                }
                return false;
            }
        });
        refreshLayout.setOnLoadMoreListener(new OnLoadMoreListener() {
            @Override
            public void onLoadMore(@NonNull RefreshLayout refreshLayout) {
                if (isHasMoreData) {
                    getCallRecordList(pageNo + 1);
                } else {
                    refreshLayout.setNoMoreData(true);
                }
            }
        });
        refreshLayout.setOnRefreshListener(new OnRefreshListener() {
            @Override
            public void onRefresh(@NonNull RefreshLayout refreshLayout) {
                pageNo = 1;
                getCallRecordList(pageNo);
            }
        });
        mDate = new ArrayList<>();
        mAdapter = new CallHistoryAdapter(getContext(), mDate, this);
        recyclerView.setAdapter(mAdapter);
        initDate();
        et_search_input.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View v, boolean hasFocus) {
                if (hasFocus) {
                    CustomFieldsUtils.showKeyboard(getContext(), et_search_input);
                    ll_search.setBackgroundResource(R.drawable.sobot_call_v6_bg_search_f);
                } else {
                    CustomFieldsUtils.hideKeyboard(getContext(), v);
                    ll_search.setBackgroundResource(R.drawable.sobot_call_v6_bg_search);
                }
            }
        });
        et_search_input.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView textView, int i, KeyEvent keyEvent) {
                if (i == EditorInfo.IME_ACTION_SEARCH) {
                    //搜索
                    search();
                    return true;
                }
                return false;
            }
        });
        et_search_input.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (isautoText) {
                    isautoText = false;
                } else {
                    int inputCount = s.length();
                    if (inputCount > 0) {
                        iv_clear.setVisibility(View.VISIBLE);
                    } else {
                        iv_clear.setVisibility(View.GONE);
                        if (searchType == 0) {
                            //搜索历史记录
                            et_search_input.setHint(getString(R.string.sobot_call_search_tip));
                        } else {
                            //搜索客户
                            et_search_input.setHint(getString(R.string.sobot_nickname_hide_string));
                        }
                    }
                    inputTime = System.currentTimeMillis();
                    new Handler().postDelayed(new Runnable() {
                        @Override
                        public void run() {
                            search();
                        }
                    }, 500);
                }
            }
        });

        SobotActionItem sobot_call_search_number = new SobotActionItem(getResources().getString(R.string.sobot_call_search_number), false);
        SobotActionItem sobot_nickname_string = new SobotActionItem(getResources().getString(R.string.call_custom), false);
        searchItems = new ArrayList<>();
        searchItems.add(sobot_call_search_number);
        searchItems.add(sobot_nickname_string);
        tv_search_type.setOnClickListener(this);
    }

    private void initDate() {
        SobotServiceInfoModel serviceVoModel = SobotLoginTools.getInstance().getServiceInfo();
        if (serviceVoModel != null) {
            pageNo = 1;
            getCallRecordList(pageNo);
        }
        requestConfig();
    }

    //获取服务总结配置
    private void requestConfig() {
        zhiChiApi.getSummaryConfig(getContext(), new SobotResultCallBack<SobotSummaryConfig>() {

            @Override
            public void onSuccess(SobotSummaryConfig sobotSummaryConfig) {
                if (sobotSummaryConfig != null && sobotSummaryConfig.getSummaryFlag() == 1) {
                    //服务总结开着
                    CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.CALL_SERVICE_SUMMARY_FLAG, true);
                } else {
                    //关闭服务总结
                    CallSharedPreferencesUtils.getInstance(getSobotActivity()).put(SobotCallConstant.CALL_SERVICE_SUMMARY_FLAG, false);
                }
            }

            @Override
            public void onFailure(Exception e, String des) {

            }
        });
    }

    private void requestCustom(String customName) {
        ll_search_custom.setVisibility(View.VISIBLE);
        refreshLayout.setVisibility(View.GONE);
        zhiChiApi.searchCustom(getContext(), "1", customName, new SobotResultCallBack<List<SobotCallCustomerModel>>() {
            @Override
            public void onSuccess(List<SobotCallCustomerModel> list) {

                if (list != null && list.size() > 0) {
                    ll_custom_list.setVisibility(View.VISIBLE);
                    no_date.setVisibility(View.GONE);
                    customList.clear();
                    customList.addAll(list);
                    customAdapter.setDate(customName);
                } else {
                    no_date.setVisibility(View.VISIBLE);
                    ll_custom_list.setVisibility(View.GONE);
                }
            }

            @Override
            public void onFailure(Exception e, String des) {

            }
        });
    }

    public void getCallRecordList(int pageIndex) {
        if (refreshLayout == null) {
            return;
        }
        if (ll_custom_list != null) {
            ll_custom_list.setVisibility(View.GONE);
        }
        refreshLayout.setVisibility(View.VISIBLE);
        String serarch = searchType == 0 ? et_search_input.getText().toString() : "";
        zhiChiApi.getCallRecordList(this, startTime <= 0 ? SobotDateUtils.getLastYear(zone) : startTime, endTime <= 0 ? System.currentTimeMillis() : endTime, callType, answerStatus, selectCustom != null ? selectCustom.getId() : "", serarch, pageIndex, pageSize, hidePhone, new SobotResultCallBack<List<SobotCallRecordEntity>>() {

            @SuppressLint("NotifyDataSetChanged")
            @Override
            public void onSuccess(List<SobotCallRecordEntity> sobotCallRecords) {
                refreshLayout.finishRefresh();//停止刷新
                pageNo = pageIndex;
                if (pageIndex == 1) {
                    mDate.clear();//刷新时清空列表
                    if (null == sobotCallRecords || sobotCallRecords.size() == 0) {
                        isHasMoreData = false;
                        loadingLayout.showEmpty();//显示无内容
                        refreshLayout.setEnableFooterFollowWhenNoMoreData(false);
                        return;
                    } else {
                        if (sobotCallRecords.size() > 6) {
                            refreshLayout.setEnableFooterFollowWhenNoMoreData(true);
                        } else {
                            refreshLayout.setEnableFooterFollowWhenNoMoreData(false);
                        }
                    }
                }
                if (sobotCallRecords != null) {
                    if (sobotCallRecords.size() < pageSize) {
                        //加载完毕
                        isHasMoreData = false;
                        refreshLayout.setNoMoreData(true);
                    } else {
                        //有 下一页
                        isHasMoreData = true;
                        refreshLayout.setNoMoreData(false);
                        refreshLayout.setEnableLoadMore(true);
                    }
                    mAdapter.setDate(et_search_input.getText().toString());
                    mDate.addAll(sobotCallRecords);
                    mAdapter.notifyDataSetChanged();
                    loadingLayout.showContent();//显示列表
                    refreshLayout.finishLoadMore();
                }
            }

            @Override
            public void onFailure(Exception e, String des) {
                refreshLayout.finishLoadMore();
                refreshLayout.finishRefresh();
            }
        });
    }

    @Override
    public void onItemClick(SobotCallRecordEntity info) {
        et_search_input.clearFocus();
        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ)) {
            //跳转到详情页面
            Intent intent = new Intent(getSobotActivity(), CallDetailsActivity.class);
            intent.putExtra("callID", info.getCallID());
            intent.putExtra("defaultIndex", 0);//默认打开位置
            intent.putExtra("callType", info.getCallType());
            intent.putExtra("callee", info.getScreenNumber());
            intent.putExtra("customerId", info.getCustomerId());
            intent.putExtra("customerNick", info.getCustomerNick());
            intent.putExtra("callNumber", info.getScreenNumber());
            intent.putExtra("encryptCustomerNumber", info.getEncryptCustomerNumber());
            intent.putExtra("hiddenFlag", "0");
            startActivityForResult(intent, SobotCallConstant.ACTIVITY_RESULT_DETAIL);
        }
    }

    @Override
    public void onClick(View v) {
        if (v == iv_clear) {
            selectCustom = null;
            et_search_input.setText("");
            pageNo = 1;
            search();
        } else if (v == iv_search) {
            et_search_input.clearFocus();
            //搜索
            pageNo = 1;
            iv_search.requestFocus();
            search();
        } else if (v == iv_search_condition) {
            et_search_input.clearFocus();
            //搜索条件
            Intent intent = new Intent(getContext(), CustomPickActivity.class);
            intent.putExtra("startTime", startTime);
            intent.putExtra("endTime", endTime);
            intent.putExtra("callType", callType);
            intent.putExtra("answerStatus", answerStatus);
            startActivityForResult(intent, SobotCallConstant.ACTIVITY_RESULT_GET_CONDITION);
        } else if (v == tv_search_type) {
            if (searchType == 0) {
                searchItems.get(0).setChecked(true);
                searchItems.get(1).setChecked(false);
            } else {
                searchItems.get(0).setChecked(false);
                searchItems.get(1).setChecked(true);
            }
            SobotMoreMenuPop pop = new SobotMoreMenuPop(getSobotActivity(), searchItems, false, true, new SobotMoreMenuPop.PopItemClick() {
                @Override
                public void onPopItemClick(SobotActionItem item, int index) {
                    popupWindow.dismiss();
                    searchType = index;
                    pageNo = 1;
                    if (searchType == 1) {
                        et_search_input.setHint(getString(R.string.sobot_nickname_hide_string));
                        tv_search_type.setText(getResources().getString(R.string.call_custom));
                    } else {
                        selectCustom = null;
                        tv_search_type.setText(getResources().getString(R.string.sobot_call_search_number));
                        et_search_input.setHint(getString(R.string.sobot_call_search_tip));
                    }
                }
            });

            popupWindow = pop.getPopWindow();
            //弹窗出现外部为阴影
            WindowManager.LayoutParams attributes = getActivity().getWindow().getAttributes();
            attributes.alpha = 1f;
            getActivity().getWindow().setAttributes(attributes);
            //弹窗取消监听 取消之后恢复阴影
            popupWindow.setOnDismissListener(new PopupWindow.OnDismissListener() {
                @Override
                public void onDismiss() {
                    WindowManager.LayoutParams attributes = getActivity().getWindow().getAttributes();
                    attributes.alpha = 1;
                    getActivity().getWindow().setAttributes(attributes);
                }
            });
            int offsetY = -(SobotDensityUtil.dp2px(getSobotActivity(), 56 * 2) + tv_search_type.getHeight());
            popupWindow.showAsDropDown(ll_search, 0, 0);
        }
    }

    private void search() {
        if (System.currentTimeMillis() - inputTime < 500) {
            return;
        }
        String searchText = et_search_input.getText().toString();
        if (searchType == 1 && !TextUtils.isEmpty(searchText)) {
            //搜索客户
            ll_search_custom.setVisibility(View.VISIBLE);
            refreshLayout.setVisibility(View.GONE);
            requestCustom(searchText);
        } else {
            loadingLayout.showLoading();
            ll_search_custom.setVisibility(View.GONE);
            refreshLayout.setVisibility(View.VISIBLE);
            pageNo = 1;
            refreshLayout.setEnableLoadMore(true);
            getCallRecordList(pageNo);
        }
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == SobotCallConstant.ACTIVITY_RESULT_GET_CONDITION && resultCode == SobotCallConstant.ACTIVITY_RESULT_GET_CONDITION) {
            startTime = data.getLongExtra("startTime", 0);
            endTime = data.getLongExtra("endTime", 0);
            callType = data.getStringExtra("callType");
            answerStatus = data.getStringExtra("answerStatus");
            if (startTime > 0 || endTime > 0) {
                iv_search_condition.setImageResource(R.drawable.sobot_call_shaixuan_select);
            } else if (!TextUtils.isEmpty(callType) || !TextUtils.isEmpty(answerStatus)) {
                iv_search_condition.setImageResource(R.drawable.sobot_call_shaixuan_select);
            } else {
                iv_search_condition.setImageResource(R.drawable.sobot_call_shaixuan);
            }
            search();
        } else if (requestCode == SobotCallConstant.ACTIVITY_RESULT_DETAIL && resultCode == SobotCallConstant.ACTIVITY_RESULT_DETAIL) {
            //详情修改名字后，刷新列表
            SobotServiceInfoModel serviceVoModel = SobotLoginTools.getInstance().getServiceInfo();
            if (serviceVoModel != null) {
                refreshLayout.autoRefreshAnimationOnly();
                pageNo = 1;
                refreshLayout.setEnableLoadMore(true);
                getCallRecordList(pageNo);
            }
        }
    }

    //是否自动填充的文字
    private boolean isautoText = false;

    @Override
    public void onItemClick(SobotCallCustomerModel user) {
        if (user != null) {
            isautoText = true;
            et_search_input.setText(user.getNick());
            et_search_input.clearFocus();
            ll_search_custom.setVisibility(View.GONE);
            refreshLayout.setVisibility(View.VISIBLE);
            selectCustom = user;
            pageNo = 1;
            getCallRecordList(pageNo);
        }
    }

}
