package com.sobot.callsdk.v6.fragment;

import android.os.Bundle;
import android.os.Handler;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.Nullable;

import com.sobot.callbase.CallPermissionManager;
import com.sobot.callbase.model.CallTaskContactModel;
import com.sobot.callbase.model.CallTemplateFieldEntity;
import com.sobot.callbase.model.CusFieldConfig;
import com.sobot.callbase.model.CusFieldDataInfoList;
import com.sobot.callbase.model.SobotCusFieldEntity;
import com.sobot.callsdk.R;
import com.sobot.callsdk.dialog.CallCommonDialog;
import com.sobot.callsdk.fargment.SobotBaseFragment;
import com.sobot.callsdk.utils.CustomFieldsUtils;
import com.sobot.callsdk.v6.listener.CallTaskStatusListener;
import com.sobot.common.login.permission.SobotPermissionManager;
import com.sobot.network.http.callback.SobotResultCallBack;
import com.sobot.utils.SobotDensityUtil;
import com.sobot.utils.SobotLogUtils;
import com.sobot.utils.SobotStringUtils;
import com.sobot.widget.ui.toast.SobotToastUtil;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 任务--任务总结
 */
public class CallTaskSummaryFragment extends SobotBaseFragment implements View.OnClickListener {

    private String campaignId;//任务id
    private String recordId;//任务明细id
    private List<CallTemplateFieldEntity> dataFields;//服务总结的字段
    private List<CusFieldConfig> cusFieldConfigList;//服务总结的字段转自定义字段
    private Map<String, CusFieldConfig> allCusFields;
    private View mRootView;
    private LinearLayout ll_task_summary_cusfield;
    private LinearLayout ll_edit_s;
    private LinearLayout ll_normal_s;
    private TextView btn_cancel;
    private TextView btn_save;
    private boolean isEdit;//是否是编辑状态
    private boolean isFrist;//是否是编辑状态
    private CallTaskStatusListener statusListener;

    private int type;

    public void setStatusListener(CallTaskStatusListener statusListener) {
        this.statusListener = statusListener;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        mRootView = inflater.inflate(R.layout.fragment_call_task_summary, container, false);
        initView();
        return mRootView;
    }

    private void initView() {
        ll_task_summary_cusfield = mRootView.findViewById(R.id.ll_task_summary_cusfield);
        ll_edit_s = mRootView.findViewById(R.id.ll_edit_s);
        ll_normal_s = mRootView.findViewById(R.id.ll_normal_s);
        ll_normal_s.setOnClickListener(this);
        btn_cancel = mRootView.findViewById(R.id.btn_cancel);
        btn_cancel.setOnClickListener(this);
        btn_save = mRootView.findViewById(R.id.btn_save);
        btn_save.setOnClickListener(this);
        //权限判断
        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_WHRW_RWZJBJ)) {
            ll_edit_s.setVisibility(View.VISIBLE);
        } else {
            ll_edit_s.setVisibility(View.GONE);
        }
        requestCusField();
    }

    private void initDate() {
        if (!TextUtils.isEmpty(campaignId) && !TextUtils.isEmpty(recordId)) {
            zhiChiApi.taskSummary(getSobotActivity(), campaignId, recordId, new SobotResultCallBack<CallTaskContactModel>() {
                @Override
                public void onSuccess(CallTaskContactModel callTaskContactModel) {
                    if (callTaskContactModel != null) {
                        dataFields = callTaskContactModel.getWrapUpFields();//总结信息
                        if (TextUtils.isEmpty(callTaskContactModel.getWrapUpAgent())) {
                            isEdit = true;
                            isFrist = true;
                        } else {
                            isEdit = false;
                            isFrist = false;
                        }
                        cusFieldConfigList = CustomFieldsUtils.templateCheageCofig(dataFields);
                        //设置是否是必填
                        for (int i = 0; i < cusFieldConfigList.size(); i++) {
                            CusFieldConfig temp = allCusFields.get(cusFieldConfigList.get(i).getFieldId());
                            if (temp != null) {
                                SobotLogUtils.d("===11===" + temp.getFieldName() + "==getOpenFlag==" + temp.getOpenFlag());
                                cusFieldConfigList.get(i).setFillFlag(temp.getFillFlag());//是否必填
                                cusFieldConfigList.get(i).setCusFieldDataInfoList(temp.getCusFieldDataInfoList());
                            } else {
                                cusFieldConfigList.get(i).setFieldDelete(true);
                            }
                        }
                        //判断是否删除
                        for (int i = 0; i < cusFieldConfigList.size(); i++) {
                            CusFieldConfig temp = cusFieldConfigList.get(i);
                            if (temp != null && SobotStringUtils.isNoEmpty(temp.getFieldId()) && !temp.getFieldId().equals("compellation") && !temp.getFieldId().equals("number")
                                    && !temp.getTemplateFieldId().equals("contactCode") && !temp.getTemplateFieldId().equals("callingListId") && !temp.getTemplateFieldId().equals("guishudi_android")) {
                                boolean isDelete = true;
                                CusFieldConfig newConfig = allCusFields.get(temp.getFieldId());
                                if (newConfig != null) {
                                    SobotLogUtils.d("===22===" + newConfig.getFieldName() + "==getOpenFlag==" + newConfig.getOpenFlag());
                                    isDelete = false;
                                    if (newConfig.getOpenFlag() == 0) {
                                        isDelete = true;
                                    }
                                    cusFieldConfigList.get(i).setFillFlag(newConfig.getFillFlag());//是否必填
                                    //是否有选项
                                    if (temp.getFieldType() == 6 || temp.getFieldType() == 7 || temp.getFieldType() == 8 || temp.getFieldType() == 9) {
                                        //重新赋值全量选项
                                        cusFieldConfigList.get(i).setCusFieldDataInfoList(newConfig.getCusFieldDataInfoList());
                                        //检查选项是否删除
                                        if (SobotStringUtils.isNoEmpty(temp.getFieldValue())) {

                                            String[] valus = temp.getFieldValue().split(",");
                                            for (int j = 0; j < valus.length; j++) {
                                                boolean isValueDelete = true;
//                                                6、7、8 :dataId 9:dataValue
                                                if (newConfig.getCusFieldDataInfoList() != null) {
                                                    for (int k = 0; k < newConfig.getCusFieldDataInfoList().size(); k++) {
                                                        if (temp.getFieldType() == 9) {
                                                            if (valus[j].equals(newConfig.getCusFieldDataInfoList().get(k).getDataValue())) {
                                                                isValueDelete = false;
                                                            }
                                                        } else {
                                                            if (valus[j].equals(newConfig.getCusFieldDataInfoList().get(k).getDataId())) {
                                                                isValueDelete = false;
                                                            }
                                                        }
                                                    }
                                                    if (isValueDelete) {
                                                        cusFieldConfigList.get(i).setFieldValueDelete(isValueDelete);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                } else if (temp.getTemplateFieldId().equals(temp.getFieldId())) {
                                    isDelete = false;
                                }
                                cusFieldConfigList.get(i).setFieldDelete(isDelete);
                            }
                        }
                        showView(isEdit);
                    }
                }

                @Override
                public void onFailure(Exception e, String des) {

                }
            });
        }
    }

    /**
     * 请求自定义字段
     */
    private void requestCusField() {
        allCusFields = new HashMap<>();
        zhiChiApi.getCusFieldInfoList(getContext(), 3, new SobotResultCallBack<List<SobotCusFieldEntity>>() {
            @Override
            public void onSuccess(List<SobotCusFieldEntity> cusFieldConfigs) {
                if (null != cusFieldConfigs) {
                    for (int i = 0; i < cusFieldConfigs.size(); i++) {
                        CusFieldConfig cusFieldConfig = cusFieldConfigs.get(i).getCusFieldConfig();
                        if (cusFieldConfig != null) {
                            SobotLogUtils.d("===33===" + cusFieldConfig.getFieldName() + "==getOpenFlag==" + cusFieldConfig.getOpenFlag());
                            if (null != cusFieldConfigs.get(i).getCusFieldDataInfoList()) {
                                cusFieldConfig.setCusFieldDataInfoList(cusFieldConfigs.get(i).getCusFieldDataInfoList());
                            }
                            allCusFields.put(cusFieldConfig.getFieldId(), cusFieldConfig);
                        }
                    }
                }
                initDate();
            }

            @Override
            public void onFailure(Exception e, String des) {
                initDate();
            }
        });
    }

    @Override
    public void setArguments(@Nullable Bundle args) {
        super.setArguments(args);
        if (args != null) {
            campaignId = args.getString("campaignId");
            recordId = args.getString("recordId");
        }
    }

    public void refreshDate(String cId, String rId) {
        new Handler().post(new Runnable() {
            @Override
            public void run() {
                campaignId = cId;
                recordId = rId;
                isFrist = false;
                initDate();
            }
        });
    }

    //防止重复点击
    private long lastClickTime = 0;

    @Override
    public void onClick(View v) {
        if (v == ll_normal_s) {
            showView(true);
            if (statusListener != null) {
                statusListener.editStatus();
            }
        } else if (v == btn_cancel) {
            showView(false);
            if (statusListener != null) {
                statusListener.normalStatus();
            }
        } else if (v == btn_save && isEdit) {
            if (System.currentTimeMillis() - lastClickTime > 1000) {
                lastClickTime = System.currentTimeMillis();
                save();
            }
        }
    }

    public boolean isEdit() {
        return isEdit;
    }

    public void setEdit(boolean edit) {
        isEdit = edit;
    }

    private void save() {
        if (cusFieldConfigList != null && cusFieldConfigList.size() > 0) {
            String list = setCustomerFieldValue();
            if (!checkCusFieldRequired()) {
                return;
            }
            zhiChiApi.updateTaskSummary(getSobotActivity(), campaignId, recordId, list, new SobotResultCallBack() {
                @Override
                public void onSuccess(Object o) {
                    isFrist = false;
                    isEdit = false;
                    if (statusListener != null) {
                        statusListener.normalStatus();
                    }
                    initDate();
                }

                @Override
                public void onFailure(Exception e, String des) {
                    if (!TextUtils.isEmpty(des) && null != getActivity()) {
                        Toast.makeText(getActivity(), des, Toast.LENGTH_SHORT).show();
                    }
                }
            });
        }
    }

    /**
     * 获取自定义字段的值
     */
    private String setCustomerFieldValue() {
        JSONArray array = new JSONArray();
        if (cusFieldConfigList != null && cusFieldConfigList.size() != 0) {
            for (int i = 0; i < cusFieldConfigList.size(); i++) {
                if (cusFieldConfigList.get(i).getOpenFlag() != 1 || cusFieldConfigList.get(i).isFieldDelete()) {
                    continue;
                }
                String value = "";
                String ids = "";
                View view = ll_task_summary_cusfield.findViewWithTag(cusFieldConfigList.get(i).getFieldId());
                if (view != null) {
                    if (cusFieldConfigList.get(i).getFieldType() == 1) {
                        //单行文本
                        EditText singleLine = (EditText) view.findViewById(R.id.call_customer_field_text_single);
                        cusFieldConfigList.get(i).setFieldValue(singleLine.getText().toString());
                        value = singleLine.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 2) {
                        //多行文本
                        EditText moreContent = (EditText) view.findViewById(R.id.call_customer_field_text_more_content);
                        cusFieldConfigList.get(i).setFieldValue(moreContent.getText().toString());
                        value = moreContent.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 3) {
                        //日期
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        value = textClick.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 4) {
                        //时间
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldValue(textClick.getText().toString());
                        value = textClick.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 5) {
                        //数值
                        EditText numberContent = (EditText) view.findViewById(R.id.call_customer_field_text_number);
                        cusFieldConfigList.get(i).setFieldValue(numberContent.getText().toString());
                        value = numberContent.getText().toString();
                    } else if (cusFieldConfigList.get(i).getFieldType() == 6) {
                        //下拉列表
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldText(textClick.getText().toString());
                        if (textClick.getTag() != null && textClick.getTag() instanceof CusFieldDataInfoList) {
                            CusFieldDataInfoList selectItem = (CusFieldDataInfoList) textClick.getTag();
                            value = selectItem.getDataId();
                        }
                        cusFieldConfigList.get(i).setFieldValue(value);
                    } else if (cusFieldConfigList.get(i).getFieldType() == 7) {
                        //复选框
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldText(textClick.getText().toString());
                        if (textClick.getTag() != null && textClick.getTag() instanceof List) {
                            List<CusFieldDataInfoList> infoList = (List<CusFieldDataInfoList>) textClick.getTag();
                            StringBuffer sb = new StringBuffer();
                            if (infoList != null && infoList.size() > 0) {
                                for (int j = 0; j < infoList.size(); j++) {
                                    if (sb.length() > 0) {
                                        sb.append(",");
                                    }
                                    sb.append(infoList.get(j).getDataId());
                                }
                            }
                            value = sb.toString();
                        }
                        cusFieldConfigList.get(i).setFieldValue(value);
                    } else if (cusFieldConfigList.get(i).getFieldType() == 8) {
                        //单选框
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldText(textClick.getText().toString());
                        if (textClick.getTag() != null && textClick.getTag() instanceof CusFieldDataInfoList) {
                            CusFieldDataInfoList selectItem = (CusFieldDataInfoList) textClick.getTag();
                            value = selectItem.getDataId();
                        }
                        cusFieldConfigList.get(i).setFieldValue(value);
                    } else if (cusFieldConfigList.get(i).getFieldType() == 9) {
                        //级联
                        TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                        cusFieldConfigList.get(i).setFieldText(textClick.getText().toString());
                        if (textClick.getTag() != null && textClick.getTag() instanceof List) {
                            List<CusFieldDataInfoList> infoList = (List<CusFieldDataInfoList>) textClick.getTag();
                            StringBuffer sb = new StringBuffer();
                            if (infoList != null && infoList.size() > 0) {
                                for (int j = 0; j < infoList.size(); j++) {
                                    if (sb.length() > 0) {
                                        sb.append(",");
                                    }
                                    sb.append(infoList.get(j).getDataValue());
                                }
                            }
                            value = sb.toString();
                        }
                        cusFieldConfigList.get(i).setFieldValue(value);
                    }
                }
                CallTemplateFieldEntity entity = new CallTemplateFieldEntity();
                entity.setTemplateFieldId(cusFieldConfigList.get(i).getTemplateFieldId());
                entity.setFieldValue(value);
                entity.setFieldType(cusFieldConfigList.get(i).getFieldType());
                entity.setFieldName(cusFieldConfigList.get(i).getFieldName());
                if (cusFieldConfigList.get(i).getTemplateFieldId().equals("contactCode") || cusFieldConfigList.get(i).getTemplateFieldId().equals("callingListId")) {
                    continue;
                }
                try {
                    JSONObject object = new JSONObject();
                    object.put("templateFieldId", cusFieldConfigList.get(i).getTemplateFieldId());
                    object.put("fieldName", cusFieldConfigList.get(i).getFieldName());
                    object.put("fieldType", cusFieldConfigList.get(i).getFieldType());
                    object.put("fieldText", cusFieldConfigList.get(i).getFieldText());
                    object.put("fieldValue", TextUtils.isEmpty(value) ? null : value);
                    array.put(object);
                } catch (JSONException e) {
                    throw new RuntimeException(e);
                }
            }
        }
        return array.toString();
    }

    //检测自定义字段是否必填并提示
    private boolean checkCusFieldRequired() {
        if (cusFieldConfigList != null && cusFieldConfigList.size() > 0) {
            for (int i = 0; i < cusFieldConfigList.size(); i++) {
                CusFieldConfig fieldConfig = cusFieldConfigList.get(i);
                if (1 == fieldConfig.getOpenFlag() && 1 == fieldConfig.getFillFlag() && !fieldConfig.isFieldDelete()) {
                    if (TextUtils.isEmpty(fieldConfig.getFieldValue())) {
                        String s = getResources().getString(R.string.call_retcode_500042);
                        SobotToastUtil.showToast(getSobotActivity(), String.format(s, fieldConfig.getFieldName()));
                        return false;
                    }
                }
            }
        }
        return true;
    }

    private void showView(boolean isEdit) {
        this.isEdit = isEdit;
        if (isEdit) {
            //编辑
            boolean isDelete = false;
            for (int i = 0; i < cusFieldConfigList.size(); i++) {
                if (cusFieldConfigList.get(i).isFieldDelete() || cusFieldConfigList.get(i).isFieldValueDelete()) {
                    isDelete = true;
                }
            }
            if (isDelete && !isFrist) {
                //弹框提示
                CallCommonDialog tipDialog = new CallCommonDialog(getString(R.string.call_cus_field_deleted_edit_hide), new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {
                        //过滤已删除的字段
                        if (dataFields != null && dataFields.size() > 0) {
                            //设置自定义字段
                            CustomFieldsUtils.addWorkOrderUserCusFields(getSobotActivity(), cusFieldConfigList, ll_task_summary_cusfield);
                        }
                        if (isFrist) {
                            btn_cancel.setVisibility(View.GONE);
                            LinearLayout.LayoutParams p = (LinearLayout.LayoutParams) btn_save.getLayoutParams();
                            p.setMargins(SobotDensityUtil.dp2px(getSobotActivity(), 40), SobotDensityUtil.dp2px(getSobotActivity(), 10), SobotDensityUtil.dp2px(getSobotActivity(), 40), SobotDensityUtil.dp2px(getSobotActivity(), 10));

                        } else {
                            LinearLayout.LayoutParams p = (LinearLayout.LayoutParams) btn_save.getLayoutParams();
                            p.setMargins(SobotDensityUtil.dp2px(getSobotActivity(), 15), SobotDensityUtil.dp2px(getSobotActivity(), 10), SobotDensityUtil.dp2px(getSobotActivity(), 15), SobotDensityUtil.dp2px(getSobotActivity(), 10));
                            btn_cancel.setVisibility(View.VISIBLE);
                        }
                        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_WHRW_RWZJBJ)) {
                            ll_edit_s.setVisibility(View.VISIBLE);
                        }
                        ll_normal_s.setVisibility(View.GONE);
                    }
                });
                tipDialog.setCancelable(true);
                tipDialog.show(getChildFragmentManager(), "tipDialog");
            } else {
                if (dataFields != null && dataFields.size() > 0) {
                    //设置自定义字段
                    CustomFieldsUtils.addWorkOrderUserCusFields(getSobotActivity(), cusFieldConfigList, ll_task_summary_cusfield);
                }
                if (isFrist) {
                    btn_cancel.setVisibility(View.GONE);
                    LinearLayout.LayoutParams p = (LinearLayout.LayoutParams) btn_save.getLayoutParams();
                    p.setMargins(SobotDensityUtil.dp2px(getSobotActivity(), 40), SobotDensityUtil.dp2px(getSobotActivity(), 10), SobotDensityUtil.dp2px(getSobotActivity(), 40), SobotDensityUtil.dp2px(getSobotActivity(), 10));

                } else {
                    LinearLayout.LayoutParams p = (LinearLayout.LayoutParams) btn_save.getLayoutParams();
                    p.setMargins(SobotDensityUtil.dp2px(getSobotActivity(), 15), SobotDensityUtil.dp2px(getSobotActivity(), 10), SobotDensityUtil.dp2px(getSobotActivity(), 15), SobotDensityUtil.dp2px(getSobotActivity(), 10));
                    btn_cancel.setVisibility(View.VISIBLE);
                }
                if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_WHRW_RWZJBJ)) {
                    ll_edit_s.setVisibility(View.VISIBLE);
                }
                ll_normal_s.setVisibility(View.GONE);
            }
        } else {
            ll_edit_s.setVisibility(View.GONE);
            if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_WHRW_RWZJBJ)) {
                ll_normal_s.setVisibility(View.VISIBLE);
            }
//            非编辑
            if (dataFields != null && dataFields.size() > 0) {
                CustomFieldsUtils.showCusFieldsNew(getSobotActivity(), cusFieldConfigList, ll_task_summary_cusfield);
            }
        }
    }

    public void refresh() {
        if (allCusFields.size() == 0) {
            requestCusField();
        }
    }
}