package com.sobot.callsdk.v6.fragment;

import android.graphics.Typeface;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.os.Handler;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.Nullable;

import com.sobot.callbase.CallPermissionManager;
import com.sobot.callbase.api.SobotCallBaseCode;
import com.sobot.callbase.dialog.SobotCallCommonDialog;
import com.sobot.callbase.model.CanSubmitSummaryModel;
import com.sobot.callbase.model.CusFieldConfig;
import com.sobot.callbase.model.CusFieldDataInfoList;
import com.sobot.callbase.model.SobotCusFieldEntity;
import com.sobot.callbase.model.SobotSummaryClassifies;
import com.sobot.callbase.model.SobotSummaryConfig;
import com.sobot.callbase.model.SobotSummaryEntity;
import com.sobot.callbase.model.SobotSummaryProgress;
import com.sobot.callbase.model.SobotSummaryTemplate;
import com.sobot.callbase.utils.CommonUtils;
import com.sobot.callbase.widget.flexbox.FlexboxLayout;
import com.sobot.callsdk.R;
import com.sobot.callsdk.dialog.CallCommonDialog;
import com.sobot.callsdk.dialog.CallTipDialog;
import com.sobot.callsdk.fargment.SobotBaseFragment;
import com.sobot.callsdk.utils.CallSharedPreferencesUtils;
import com.sobot.callsdk.utils.CustomFieldsUtils;
import com.sobot.callsdk.utils.SobotCallConstant;
import com.sobot.callsdk.v6.dialog.DialogItemOnClick;
import com.sobot.callsdk.v6.dialog.SelectClassifyDialog;
import com.sobot.callsdk.v6.dialog.SelectSumProgressDialog;
import com.sobot.callsdk.v6.dialog.SelectSumTemplateDialog;
import com.sobot.common.login.SobotLoginTools;
import com.sobot.common.login.model.SobotServiceInfoModel;
import com.sobot.common.login.permission.SobotPermissionManager;
import com.sobot.gson.SobotGsonUtil;
import com.sobot.gson.reflect.TypeToken;
import com.sobot.network.http.callback.SobotResultCallBack;
import com.sobot.utils.SobotStringUtils;
import com.sobot.widget.ui.toast.SobotToastUtil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 通话--服务总结
 */
public class ServiceSummaryFragment extends SobotBaseFragment implements View.OnClickListener {

    private RelativeLayout ll_progress;
    private TextView tv_progress, tv_progress_must, tv_progress_value;
    private TextView tv_classify, tv_classify_value, tv_classfiy_must;
    private FlexboxLayout fl_classify_edit;
    private ImageView iv_arrow_classify;
    private TextView tv_template, tv_template_value, tv_template_must;
    private TextView tv_remark, tv_remark_value, tv_remark_must;
    private EditText ed_remark;
    private View v_edit_remark;
    private LinearLayout ll_edit_remark;
    private RelativeLayout rl_question_remark;
    private LinearLayout ll_cus_view;
    private LinearLayout ll_edit_menu;
    private TextView btn_save, btn_cancel;
    private TextView tv_edit;
    private LinearLayout ll_edit_btn;

    private String callID;
    private String customerId;
    private String fromPage;
    private SobotSummaryEntity serviceSummary;
    private List<SobotSummaryProgress> progressList;//所有进度
    private SobotSummaryProgress checkedProgress;
    private List<SobotSummaryClassifies> classifiesList;//所有分类
    private List<SobotSummaryClassifies> checkedClassifiesModels;//选中的分类
    private List<SobotSummaryTemplate> templatesList;//所有可用模板
    private SobotSummaryTemplate checkedTemplate;//选中的模板
    private Map<String, CusFieldConfig> allCusFieldConfigList;//所有自定义字段
    private SelectSumProgressDialog progressDialog;
    private SelectSumTemplateDialog templateDialog;
    private SobotSummaryConfig config;

    private View v_line_p, v_line_c, v_cus_l;
    private boolean edit = false;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_service_summary, container, false);
        initView(view);
        return view;
    }

    @Override
    public void setArguments(@Nullable Bundle bundle) {
        super.setArguments(bundle);
        callID = bundle.getString("callID", "");
        customerId = bundle.getString("customerId", "");
        fromPage = bundle.getString("fromPage", "");
    }

    private void initView(View view) {
        //重新请求配置
        String callConfig = CallSharedPreferencesUtils.getInstance(getSobotActivity()).get(SobotCallConstant.CALL_SUMMARY_CONFIG, "");
        if (!TextUtils.isEmpty(callConfig)) {
            SobotCallBaseCode<SobotSummaryConfig> result = SobotGsonUtil.jsonToBeans(callConfig, new TypeToken<SobotCallBaseCode<SobotSummaryConfig>>() {
            }.getType());
            config = result.getData();
        }
        if (config == null) {
            requestConfig();
        } else {
            requestClassify(false);
        }
        ll_progress = view.findViewById(R.id.ll_progress);
        v_line_p = view.findViewById(R.id.v_line_p);
        v_cus_l = view.findViewById(R.id.v_cus_l);
        v_line_c = view.findViewById(R.id.v_line_c);
        tv_progress = view.findViewById(R.id.tv_progress);
        tv_progress_must = view.findViewById(R.id.tv_progress_must);
        tv_progress_value = view.findViewById(R.id.tv_progress_value);
        tv_classify = view.findViewById(R.id.tv_classify_left_text);
        tv_classify_value = view.findViewById(R.id.tv_classify_value);
        tv_classfiy_must = view.findViewById(R.id.tv_classfiy_must);
        fl_classify_edit = view.findViewById(R.id.fl_classify_edit);
        iv_arrow_classify = view.findViewById(R.id.iv_arrow_classify);
        tv_template = view.findViewById(R.id.tv_template);
        tv_template_value = view.findViewById(R.id.tv_template_value);
        tv_template_must = view.findViewById(R.id.tv_template_must);
        tv_remark = view.findViewById(R.id.tv_remark);
        ed_remark = view.findViewById(R.id.ed_remark);
        v_edit_remark = view.findViewById(R.id.v_edit_remark);
        ll_edit_remark = view.findViewById(R.id.ll_edit_remark);
        rl_question_remark = view.findViewById(R.id.rl_question_remark);
        tv_remark_value = view.findViewById(R.id.tv_remark_value);
        tv_remark_must = view.findViewById(R.id.tv_service_remark_text_must);
        ll_cus_view = view.findViewById(R.id.lin_cus_view);
        ll_edit_menu = view.findViewById(R.id.ll_edit_menu);
        btn_save = view.findViewById(R.id.btn_save);
        btn_cancel = view.findViewById(R.id.btn_cancel);
        tv_edit = view.findViewById(R.id.tv_edit);
        ll_edit_btn = view.findViewById(R.id.ll_edit_btn);
        tv_edit.setOnClickListener(this);
        btn_save.setOnClickListener(this);
        btn_cancel.setOnClickListener(this);
        progressList = new ArrayList<>();
        if (config != null) {
            setConfig();
        }
        classifiesList = new ArrayList<>();
        checkedClassifiesModels = new ArrayList<>();
        templatesList = new ArrayList<>();
        allCusFieldConfigList = new HashMap<>();
        requestCusField();
    }

    private void setConfig() {
        List<SobotSummaryProgress> list = config.getSummaryHandleProgressList();
        for (int i = 0; i < list.size(); i++) {
            if (list.get(i).getEnabled() == 1) {
                progressList.add(list.get(i));
            }
        }

        if (config.getHandleProgressFlag() == 0) {
            //没有服务进度
            ll_progress.setVisibility(View.GONE);
        } else {
            if (progressList.size() > 0) {
                progressList.get(0).setSelect(true);
                tv_progress_value.setText(progressList.get(0).getProgressName());
            }
            ll_progress.setVisibility(View.VISIBLE);
        }
        if (config.getSummaryClassificationRequired() == 1) {
            tv_classfiy_must.setVisibility(View.VISIBLE);
        } else {
            tv_classfiy_must.setVisibility(View.GONE);
        }
        if (config.getSummaryTemplateRequired() == 1) {
            tv_template_must.setVisibility(View.VISIBLE);
        } else {
            tv_template_must.setVisibility(View.GONE);
        }

    }

    //子类获取路径
    private String getParendPath(SobotSummaryClassifies model) {
        if (model == null) return "";
        String path = model.getClassifyName();
        if (!"-1".equals(model.getClassifyParentId())) {
            for (int i = 0; i < classifiesList.size(); i++) {
                if (classifiesList.get(i) != null && model.getClassifyParentId().equals(classifiesList.get(i).getId())) {
                    path = getParendPath(classifiesList.get(i)) + "/" + path;
                    break;
                }
            }
        }
        return path;
    }

    private void initSummary() {
        String classifyName = "--";
        String templateName = "--";
        String remark = "";
        if (serviceSummary != null) {
            if (null != progressList && progressList.size() > 0) {
                //重置处理进度
                for (int i = 0; i < progressList.size(); i++) {
                    progressList.get(i).setSelect(false);
                }
                for (int i = 0; i < progressList.size(); i++) {
                    if (progressList.get(i).getProgressCode() == serviceSummary.getSummaryHandleProgress()) {
                        progressList.get(i).setSelect(true);
                        checkedProgress = progressList.get(i);
                        tv_progress_value.setText(progressList.get(i).getProgressName());
                    }
                }
            } else {
                checkedProgress = new SobotSummaryProgress();
                checkedProgress.setProgressCode(serviceSummary.getSummaryHandleProgress());
            }
//            if (!TextUtils.isEmpty(serviceSummary.getSummaryClassifyNames())) {
//                classifyName = serviceSummary.getSummaryClassifyNames();
//            }
            //分类
            String classfiyIds = serviceSummary.getSummaryClassifyIds();

            checkedClassifiesModels.clear();
            if (!TextUtils.isEmpty(classfiyIds)) {
                String[] classfiyIdArr = classfiyIds.split(",");
                if (classfiyIdArr.length > 0) {
                    if (classifiesList != null && classifiesList.size() > 0) {
                        for (int i = 0; i < classifiesList.size(); i++) {
                            for (int j = 0; j < classfiyIdArr.length; j++) {
                                if (classifiesList.get(i).getId().equals(classfiyIdArr[j])) {
                                    classifiesList.get(i).setChecked(true);
                                    checkedClassifiesModels.add(classifiesList.get(i));
                                }
                            }
                        }
                    } else {
                        String classfiyNames = serviceSummary.getSummaryClassifyNames();
                        String[] classfiyNameArr = classfiyNames.split(",");
                        for (int i = 0; i < classfiyIdArr.length; i++) {
                            SobotSummaryClassifies serviceSummaryClassifiesModel = new SobotSummaryClassifies();
                            serviceSummaryClassifiesModel.setId(classfiyIdArr[i]);
                            if (i < classfiyNameArr.length) {
                                serviceSummaryClassifiesModel.setClassifyName(classfiyNameArr[i]);
                            }
                            serviceSummaryClassifiesModel.setChecked(true);
                            checkedClassifiesModels.add(serviceSummaryClassifiesModel);
                        }
                    }
                    //显示分类
                    updateClassificationLin();
                }
            }
            //模板
            if (!TextUtils.isEmpty(serviceSummary.getSummaryTemplateName())) {
                templateName = serviceSummary.getSummaryTemplateName();
            }
            if (!TextUtils.isEmpty(serviceSummary.getSummaryTemplateId()) && templatesList != null && templatesList.size() > 0) {
                for (int i = 0; i < templatesList.size(); i++) {
                    if (templatesList.get(i).getId().equals(serviceSummary.getSummaryTemplateId())) {
                        checkedTemplate = templatesList.get(i);//显示模板
                    }
                }
            }
            if (null == checkedTemplate) {
                checkedTemplate = new SobotSummaryTemplate();
                checkedTemplate.setTemplateName(serviceSummary.getSummaryTemplateName());
                checkedTemplate.setId(serviceSummary.getSummaryTemplateId());
            }
            //自定义字段
            ArrayList<CusFieldConfig> customerFields = serviceSummary.getCustomerFields();
            if (customerFields == null) {
                customerFields = new ArrayList<>();
            }
            if (null != customerFields && customerFields.size() > 0) {
                for (int i = 0; i < customerFields.size(); i++) {
                    CusFieldConfig temp = allCusFieldConfigList.get(customerFields.get(i).getFieldId());
                    if (temp == null) {
                        customerFields.get(i).setFieldDelete(true);
                    } else {
                        if (temp.getOpenFlag() == 0) {
                            customerFields.get(i).setFieldDelete(true);
                        }
                        //是否有选项
                        if (temp.getFieldType() == 6 || temp.getFieldType() == 7 || temp.getFieldType() == 8 || temp.getFieldType() == 9) {
                            //重新赋值全量选项
                            customerFields.get(i).setCusFieldDataInfoList(temp.getCusFieldDataInfoList());
                            //检查选项是否删除
                            if (SobotStringUtils.isNoEmpty(customerFields.get(i).getFieldValue())) {
                                String[] valus = customerFields.get(i).getFieldValue().split(",");
                                for (int j = 0; j < valus.length; j++) {
                                    boolean isValueDelete = true;
//                                                6、7、8 :dataId 9:dataValue
                                    if (temp.getCusFieldDataInfoList() != null) {
                                        for (int k = 0; k < temp.getCusFieldDataInfoList().size(); k++) {
                                            if (valus[j].equals(temp.getCusFieldDataInfoList().get(k).getDataValue())) {
                                                isValueDelete = false;
                                            }
                                        }
                                        if (isValueDelete) {
                                            customerFields.get(i).setFieldValueDelete(isValueDelete);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            checkedTemplate.setCustomFields(customerFields);
            if (null != checkedTemplate) {
                setTemplate(false);
            } else if (null != customerFields && customerFields.size() > 0) {
                CustomFieldsUtils.showCusFieldsNew(getSobotActivity(), customerFields, ll_cus_view);
            }
            if (!TextUtils.isEmpty(serviceSummary.getRemark())) {
                remark = serviceSummary.getRemark();
            }
        }

        tv_classify_value.setText(classifyName);
        tv_template_value.setText(templateName);
        tv_remark_value.setText(TextUtils.isEmpty(remark) ? "--" : remark);
        ed_remark.setText(TextUtils.isEmpty(remark) ? "" : remark);

    }

    private void requestDate() {
        if (progressList.size() == 0) {
            requestProgress(false);
        }
        requestTemplate(false);
        requestSummary();

    }

    private void requestSummary() {
        if (!TextUtils.isEmpty(callID)) {
            zhiChiApi.searchSummary(getContext(), callID, new SobotResultCallBack<SobotSummaryEntity>() {
                @Override
                public void onSuccess(SobotSummaryEntity summaryModel) {
                    if (summaryModel != null && !TextUtils.isEmpty(summaryModel.getCallID())) {
                        edit = false;
                        serviceSummary = summaryModel;
                        new Handler().post(new Runnable() {
                            @Override
                            public void run() {
                                initSummary();
                                updateUI(edit);
                            }
                        });
                    } else {
                        edit = true;
                        new Handler().post(new Runnable() {
                            @Override
                            public void run() {
                                initSummary();
                                updateUI(edit);
                            }
                        });
                    }
                }

                @Override
                public void onFailure(Exception e, String des) {
                    edit = true;
                    initSummary();
                    updateUI(true);
                }
            });
        } else {
            edit = true;
            updateUI(edit);
        }
    }

    private void requestConfig() {
        zhiChiApi.getSummaryConfig(getContext(), new SobotResultCallBack<SobotSummaryConfig>() {

            @Override
            public void onSuccess(SobotSummaryConfig sobotSummaryConfig) {
                config = sobotSummaryConfig;
                if (config != null) {
                    setConfig();
                }
                requestClassify(false);
            }

            @Override
            public void onFailure(Exception e, String des) {
                requestClassify(false);
            }
        });
    }

    /**
     * 获取模板
     *
     * @param isShow 是否显示对话框
     */
    private void requestTemplate(boolean isShow) {
        zhiChiApi.getSummaryTemplates(getContext(), 1, 50, new SobotResultCallBack<List<SobotSummaryTemplate>>() {
            @Override
            public void onSuccess(List<SobotSummaryTemplate> sobotSummaryTemplates) {
                if (sobotSummaryTemplates != null && sobotSummaryTemplates.size() > 0) {
                    for (int i = 0; i < sobotSummaryTemplates.size(); i++) {
                        if (sobotSummaryTemplates.get(i).getEnabled() == 1) {
                            if (allCusFieldConfigList.size() > 0) {
                                List<CusFieldConfig> cusFieldConfigs = sobotSummaryTemplates.get(i).getCustomFields();
                                if (cusFieldConfigs != null) {
                                    for (int j = 0; j < cusFieldConfigs.size(); j++) {
                                        if (allCusFieldConfigList.get(cusFieldConfigs.get(j).getFieldId()) == null) {
                                            cusFieldConfigs.get(j).setFieldDelete(true);
                                        }
                                    }
                                }
                            }
                            templatesList.add(sobotSummaryTemplates.get(i));
                        }
                    }
                    if (checkedTemplate != null && !TextUtils.isEmpty(checkedTemplate.getId())) {
                        //保存原始值
                        ArrayList<CusFieldConfig> cusFieldConfigs = checkedTemplate.getCustomFields();
                        //获取模板所有配置
                        for (int i = 0; i < templatesList.size(); i++) {
                            if (templatesList.get(i).getId().equals(checkedTemplate.getId())) {
                                checkedTemplate = templatesList.get(i);//显示模板
                            }
                        }
                        //设置模板字段
                        if (null != cusFieldConfigs && cusFieldConfigs.size() > 0) {
                            for (int i = 0; i < cusFieldConfigs.size(); i++) {
                                CusFieldConfig temp = allCusFieldConfigList.get(cusFieldConfigs.get(i).getFieldId());
                                if (temp != null) {
                                    cusFieldConfigs.get(i).setCusFieldDataInfoList(temp.getCusFieldDataInfoList());
                                } else {
                                    cusFieldConfigs.get(i).setFieldDelete(true);
                                }
                            }
                        }
                        checkedTemplate.setCustomFields(cusFieldConfigs);
                        setTemplate(false);
                    }
                    if (isShow) {
                        showTempDialog();
                    }
                }
            }

            @Override
            public void onFailure(Exception e, String des) {

            }
        });
    }

    /**
     * 请求自定义字段
     */
    private void requestCusField() {
        zhiChiApi.getCusFieldInfoList(getContext(), 3, new SobotResultCallBack<List<SobotCusFieldEntity>>() {
            @Override
            public void onSuccess(List<SobotCusFieldEntity> cusFieldConfigs) {
                if (null != cusFieldConfigs) {
                    for (int i = 0; i < cusFieldConfigs.size(); i++) {
                        CusFieldConfig cusFieldConfig = cusFieldConfigs.get(i).getCusFieldConfig();
                        if (cusFieldConfig != null) {
                            if (null != cusFieldConfigs.get(i).getCusFieldDataInfoList()) {
                                cusFieldConfig.setCusFieldDataInfoList(cusFieldConfigs.get(i).getCusFieldDataInfoList());
                            }
                            allCusFieldConfigList.put(cusFieldConfig.getFieldId(), cusFieldConfig);
                        }
                    }
                }
                requestDate();
            }

            @Override
            public void onFailure(Exception e, String des) {
                requestDate();
            }
        });
    }

    /**
     * 获取自定义字段的值
     */
    private ArrayList<CusFieldConfig> setCustomerFieldValue() {
        ArrayList<CusFieldConfig> list = new ArrayList<>();
        if (checkedTemplate != null && checkedTemplate.getCustomFields() != null && checkedTemplate.getCustomFields().size() > 0) {
            List<CusFieldConfig> cusFieldList = checkedTemplate.getCustomFields();
            if (cusFieldList != null && cusFieldList.size() != 0) {
                for (int i = 0; i < cusFieldList.size(); i++) {
                    if (cusFieldList.get(i).getOpenFlag() != 1 || cusFieldList.get(i).isFieldDelete()) {
                        continue;
                    }
                    View view = ll_cus_view.findViewWithTag(cusFieldList.get(i).getFieldId());
                    if (view != null) {
                        if (cusFieldList.get(i).getFieldType() == 1) {
                            EditText singleLine = (EditText) view.findViewById(R.id.call_customer_field_text_single);
                            cusFieldList.get(i).setFieldValue(singleLine.getText().toString());
                        } else if (cusFieldList.get(i).getFieldType() == 2) {
                            EditText moreContent = (EditText) view.findViewById(R.id.call_customer_field_text_more_content);
                            cusFieldList.get(i).setFieldValue(moreContent.getText().toString());
                        } else if (cusFieldList.get(i).getFieldType() == 3) {
                            TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                            cusFieldList.get(i).setFieldValue(textClick.getText().toString());
                        } else if (cusFieldList.get(i).getFieldType() == 4) {
                            TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                            cusFieldList.get(i).setFieldValue(textClick.getText().toString());
                        } else if (cusFieldList.get(i).getFieldType() == 5) {
                            EditText numberContent = (EditText) view.findViewById(R.id.call_customer_field_text_number);
                            cusFieldList.get(i).setFieldValue(numberContent.getText().toString());
                        } else if (cusFieldList.get(i).getFieldType() == 6) {
                            TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                            String text = textClick.getText().toString();//选项内容
                            String value = "";
                            if (textClick.getTag() != null && textClick.getTag() instanceof CusFieldDataInfoList) {
                                CusFieldDataInfoList infoList = (CusFieldDataInfoList) textClick.getTag();
                                value = infoList.getDataValue();
                            }
                            if (!TextUtils.isEmpty(text) && TextUtils.isEmpty(value)) {
                                for (int j = 0; j < cusFieldList.get(i).getCusFieldDataInfoList().size(); j++) {
                                    if (text.equals(cusFieldList.get(i).getCusFieldDataInfoList().get(j).getDataName())) {
                                        value = cusFieldList.get(i).getCusFieldDataInfoList().get(j).getDataValue();
                                    }
                                }
                            }
                            cusFieldList.get(i).setFieldText(text);
                            cusFieldList.get(i).setFieldValue(TextUtils.isEmpty(value) ? null : value);
                        } else if (cusFieldList.get(i).getFieldType() == 7) {
                            TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                            String text = textClick.getText().toString();//选项内容
                            StringBuilder value = new StringBuilder();
                            if (textClick.getTag() != null && textClick.getTag() instanceof List) {
                                List<CusFieldDataInfoList> infoList = (List<CusFieldDataInfoList>) textClick.getTag();
                                if (infoList != null && infoList.size() > 0) {
                                    for (int j = 0; j < infoList.size(); j++) {
                                        if (value.length() > 0) {
                                            value.append(",");
                                        }
                                        value.append(infoList.get(j).getDataValue());
                                    }
                                }
                            }
                            cusFieldList.get(i).setFieldText(text);
                            cusFieldList.get(i).setFieldValue(TextUtils.isEmpty(value.toString()) ? null : value.toString());
                        } else if (cusFieldList.get(i).getFieldType() == 8) {
                            TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                            String text = textClick.getText().toString();//选项内容
                            String value = "";
                            if (textClick.getTag() != null && textClick.getTag() instanceof CusFieldDataInfoList) {
                                CusFieldDataInfoList infoList = (CusFieldDataInfoList) textClick.getTag();
                                value = infoList.getDataValue();
                            }
                            if (!TextUtils.isEmpty(text) && TextUtils.isEmpty(value)) {
                                for (int j = 0; j < cusFieldList.get(i).getCusFieldDataInfoList().size(); j++) {
                                    if (text.equals(cusFieldList.get(i).getCusFieldDataInfoList().get(j).getDataName())) {
                                        value = cusFieldList.get(i).getCusFieldDataInfoList().get(j).getDataValue();
                                    }
                                }
                            }
                            cusFieldList.get(i).setFieldText(text);
                            cusFieldList.get(i).setFieldValue(TextUtils.isEmpty(value) ? null : value);
                        } else if (cusFieldList.get(i).getFieldType() == 9) {
                            TextView textClick = (TextView) view.findViewById(R.id.call_customer_date_text_click);
                            String text = textClick.getText().toString();//选项内容
                            StringBuilder value = new StringBuilder();
                            if (textClick.getTag() != null && textClick.getTag() instanceof List) {
                                List<CusFieldDataInfoList> infoList = (List<CusFieldDataInfoList>) textClick.getTag();
                                if (infoList != null && infoList.size() > 0) {
                                    for (int j = 0; j < infoList.size(); j++) {
                                        if (value.length() > 0) {
                                            value.append(",");
                                        }
                                        value.append(infoList.get(j).getDataValue());
                                    }
                                }
                            }
                            cusFieldList.get(i).setFieldText(text);
                            cusFieldList.get(i).setFieldValue(TextUtils.isEmpty(value.toString()) ? null : value.toString());
                        }
                    }
                    list.add(cusFieldList.get(i));
                }
            }
        }
        return list;
    }

    /**
     * 请求分类
     *
     * @param isShow 是否显示分类对话框
     */
    private void requestClassify(boolean isShow) {
        zhiChiApi.getSummaryClassifies(getContext(), config != null ? String.valueOf(config.getCallPlan()) : "", "", new SobotResultCallBack<List<SobotSummaryClassifies>>() {
            @Override
            public void onSuccess(List<SobotSummaryClassifies> list) {
                if (list != null) {
                    classifiesList.addAll(list);
                    if (isShow) {
                        showClassifyDialog();
                    }
                }
            }

            @Override
            public void onFailure(Exception e, String des) {

            }
        });
    }

    /**
     * 请求处理进度
     *
     * @param isShow 是否显示分类对话框
     */
    private void requestProgress(boolean isShow) {
        zhiChiApi.handleProgress(getContext(), new SobotResultCallBack<List<SobotSummaryProgress>>() {

            @Override
            public void onSuccess(List<SobotSummaryProgress> serviceSummaryProgressModels) {
                if (serviceSummaryProgressModels != null && serviceSummaryProgressModels.size() > 0) {
                    for (int i = 0; i < serviceSummaryProgressModels.size(); i++) {
                        if (serviceSummaryProgressModels.get(i).getEnabled() == 1) {
                            progressList.add(serviceSummaryProgressModels.get(i));
                        }
                    }
                }
                if (isShow) {
                    showProgrssDialog();
                }
            }

            @Override
            public void onFailure(Exception e, String des) {
                if (isShow && getSobotActivity() != null && !TextUtils.isEmpty(des)) {
                    SobotToastUtil.showToast(getSobotActivity(), TextUtils.isEmpty(des) ? getSobotActivity().getResources().getString(R.string.sobot_call_net_error_string) : des);
                }
            }
        });
    }

    /**
     * 选择模板
     */
    private void showTempDialog() {
        if (templateDialog == null) {
            if (serviceSummary != null && !TextUtils.isEmpty(serviceSummary.getSummaryTemplateId())) {
                for (int i = 0; i < templatesList.size(); i++) {
                    if (templatesList.get(i).getId().equals(serviceSummary.getSummaryTemplateId())) {
                        templatesList.get(i).setSelect(true);
                    }
                }
            }
            templateDialog = new SelectSumTemplateDialog(getSobotActivity(), new DialogItemOnClick() {
                @Override
                public void selectItem(Object selectObj) {
                    templateDialog.dismiss();
                    if (selectObj != null) {
                        checkedTemplate = (SobotSummaryTemplate) selectObj;
                        for (int i = 0; i < templatesList.size(); i++) {
                            if (templatesList.get(i).getId().equals(checkedTemplate.getId())) {
                                templatesList.get(i).setSelect(true);
                                tv_template_value.setText(checkedTemplate.getTemplateName());
                                if (allCusFieldConfigList.size() > 0 && (null != checkedTemplate.getCustomFields() && checkedTemplate.getCustomFields().size() > 0)) {
                                    //重新设置自定义字段
                                    ArrayList<CusFieldConfig> list = checkedTemplate.getCustomFields();
                                    for (int k = 0; k < list.size(); k++) {
                                        CusFieldConfig temp = allCusFieldConfigList.get(list.get(k).getFieldId());
                                        if (temp != null) {
                                            list.get(k).setCusFieldDataInfoList(temp.getCusFieldDataInfoList());
                                        } else {
                                            list.get(k).setFieldDelete(true);
                                        }
                                    }
                                    checkedTemplate.setCustomFields(list);
                                }
                                //设置自定义字段
                                setTemplate(true);
                            } else {
                                templatesList.get(i).setSelect(false);
                            }
                        }
                    }
                }
            }, templatesList);
        } else {
            templateDialog.setData(templatesList);
        }
        templateDialog.show();
    }

    private void showProgrssDialog() {
        if (progressDialog == null) {
            if (serviceSummary != null && progressList != null) {
                for (int i = 0; i < progressList.size(); i++) {
                    if (serviceSummary.getSummaryHandleProgress() == progressList.get(i).getProgressCode()) {
                        progressList.get(i).setSelect(true);
                    } else {
                        progressList.get(i).setSelect(false);
                    }
                }
            }
            progressDialog = new SelectSumProgressDialog(getSobotActivity(), new DialogItemOnClick() {
                @Override
                public void selectItem(Object selectObj) {
                    SobotSummaryProgress p = (SobotSummaryProgress) selectObj;
                    checkedProgress = p;
                    progressDialog.dismiss();
                    for (int i = 0; i < progressList.size(); i++) {
                        if (progressList.get(i).getProgressName().equals(p.getProgressName())) {
                            progressList.get(i).setSelect(true);
                            tv_progress_value.setText(p.getProgressName());
                        } else {
                            progressList.get(i).setSelect(false);
                        }
                    }
                    if (p.getProgressCode() == 99 && config != null && config.getRequiredFlag() == 1) {
                        //无效记录时，服务分类、服务模板变为非必填
                        tv_classfiy_must.setVisibility(View.GONE);
                        tv_template_must.setVisibility(View.GONE);
                    } else {
                        if (config != null) {
                            if (config.getSummaryClassificationRequired() == 1) {
                                tv_classfiy_must.setVisibility(View.VISIBLE);
                            }
                            if (config.getSummaryTemplateRequired() == 1) {
                                tv_template_must.setVisibility(View.VISIBLE);
                            }
                        }
                    }
                }
            }, progressList);
        } else {
            progressDialog.setData(progressList);
        }
        progressDialog.show();
    }

    private void showClassifyDialog() {
        for (int i = 0; i < classifiesList.size(); i++) {
            classifiesList.get(i).setChecked(false);
        }
        if (checkedClassifiesModels != null && checkedClassifiesModels.size() > 0) {
            for (int i = 0; i < classifiesList.size(); i++) {
                for (int j = 0; j < checkedClassifiesModels.size(); j++) {
                    if (checkedClassifiesModels.get(j).getId().equals(classifiesList.get(i).getId())) {
                        classifiesList.get(i).setChecked(true);
                    }
                }
            }
        }
        //层级显示
        SelectClassifyDialog classifyDialog = new SelectClassifyDialog(getSobotActivity(), config.getSummaryClassificationLevelLimit(), new DialogItemOnClick() {
            @Override
            public void selectItem(Object selectObj) {
                Map<String, String> map = (Map<String, String>) selectObj;
                checkedClassifiesModels.clear();
                String tempId = "";
                for (String id : map.keySet()) {
                    for (int i = 0; i < classifiesList.size(); i++) {
                        if (classifiesList.get(i).getId().equals(id)) {
                            checkedClassifiesModels.add(classifiesList.get(i));
                            if (TextUtils.isEmpty(tempId) && !TextUtils.isEmpty(classifiesList.get(i).getClassifyTemplateId())) {
                                tempId = classifiesList.get(i).getClassifyTemplateId();
                            }
                        }
                    }
                }
                if (classifiesList.size() > 0) {
                    tv_classify_value.setVisibility(View.GONE);
                    fl_classify_edit.setVisibility(View.VISIBLE);
                } else {
                    tv_classify_value.setText("");
                    tv_classify_value.setVisibility(View.VISIBLE);
                    fl_classify_edit.setVisibility(View.GONE);
                }
                //显示分类
                updateClassificationLin();
                //模板显示
                if (!TextUtils.isEmpty(tempId) && (checkedTemplate == null || TextUtils.isEmpty(checkedTemplate.getId()))) {
                    if (templatesList != null && templatesList.size() > 0) {
                        for (int i = 0; i < templatesList.size(); i++) {
                            if (templatesList.get(i).getId().equals(tempId)) {
                                templatesList.get(i).setSelect(true);
                                tv_template_value.setText(templatesList.get(i).getTemplateName());
                                checkedTemplate = templatesList.get(i);
                                setTemplate(true);
                            } else {
                                templatesList.get(i).setSelect(false);
                            }
                        }
                    }
                }
            }
        }, classifiesList, checkedClassifiesModels);
        classifyDialog.show();
    }

    /**
     * 纯UI修改
     *
     * @param isEdit
     */
    private void updateUI(boolean isEdit) {
        edit = isEdit;
        if (isEdit) {
            boolean isDelete = false;
            if (checkedTemplate != null) {
                List<CusFieldConfig> tmpList = checkedTemplate.getCustomFields();
                if (tmpList != null && tmpList.size() > 0) {
                    for (int i = 0; i < tmpList.size(); i++) {
                        if (tmpList.get(i).isFieldDelete() || tmpList.get(i).getOpenFlag() != 1 || tmpList.get(i).isFieldValueDelete()) {
                            isDelete = true;
                        }
                    }
                }
            }
            if (isDelete) {
                //弹框提示
                CallCommonDialog tipDialog = new CallCommonDialog(getString(R.string.call_cus_field_deleted_edit_hide), new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {
                        editView();
                    }
                });
                tipDialog.setCancelable(true);
                tipDialog.show(getChildFragmentManager(), "tipDialog");
            } else {
                editView();
            }
        } else {
            setTemplate(false);
            v_line_p.setVisibility(View.GONE);
            v_line_c.setVisibility(View.GONE);
            tv_progress.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_classify.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_template.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_remark.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray2));
            tv_progress.setTypeface(null, Typeface.NORMAL);
            tv_classify.setTypeface(null, Typeface.NORMAL);
            tv_template.setTypeface(null, Typeface.NORMAL);
            tv_remark.setTypeface(null, Typeface.NORMAL);
            tv_progress_must.setVisibility(View.GONE);
            tv_classfiy_must.setVisibility(View.GONE);
            iv_arrow_classify.setVisibility(View.GONE);
            fl_classify_edit.setVisibility(View.GONE);
            tv_classify_value.setVisibility(View.VISIBLE);
            tv_template_must.setVisibility(View.GONE);
            tv_remark_must.setVisibility(View.GONE);
            ll_edit_menu.setVisibility(View.GONE);
            ll_edit_remark.setVisibility(View.GONE);
            tv_remark_value.setVisibility(View.VISIBLE);
            if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_BCFWZJ)) {//cccv6-thxq-bcfwzj
                ll_edit_btn.setVisibility(View.VISIBLE);
            } else {
                ll_edit_btn.setVisibility(View.GONE);
            }
            v_edit_remark.setVisibility(View.GONE);
            tv_progress_value.setCompoundDrawables(null, null, null, null);
            tv_classify_value.setCompoundDrawables(null, null, null, null);
            tv_template_value.setCompoundDrawables(null, null, null, null);
            tv_progress_value.setOnClickListener(null);
            tv_template_value.setOnClickListener(null);
            fl_classify_edit.setOnClickListener(null);
            tv_edit.setVisibility(View.VISIBLE);
            if (null != checkedClassifiesModels && checkedClassifiesModels.size() > 0) {
                StringBuilder sbName = new StringBuilder();
                for (int i = 0; i < checkedClassifiesModels.size(); i++) {
                    sbName.append(getParendPath(checkedClassifiesModels.get(i)));
                    if (i < checkedClassifiesModels.size() - 1) {
                        sbName.append(",");
                    }
                }
                tv_classify_value.setText(sbName.toString());
            } else {
                tv_classify_value.setText("--");
            }
            if (null == checkedTemplate || TextUtils.isEmpty(checkedTemplate.getId())) {
                tv_template_value.setText("--");
            }
        }

    }

    private void editView() {
        //显示线
        setTemplate(true);
        v_line_p.setVisibility(View.VISIBLE);
        v_line_c.setVisibility(View.VISIBLE);
        ll_edit_menu.setVisibility(View.VISIBLE);
        tv_edit.setVisibility(View.GONE);
        tv_progress.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
        tv_classify.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
        tv_template.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
        tv_remark.setTextColor(getContext().getResources().getColor(R.color.call_wenzi_gray1));
        tv_progress.setTypeface(null, Typeface.BOLD);
        tv_classify.setTypeface(null, Typeface.BOLD);
        tv_template.setTypeface(null, Typeface.BOLD);
        tv_remark.setTypeface(null, Typeface.BOLD);
        tv_progress_must.setVisibility(View.VISIBLE);
        if (config != null && config.getSummaryClassificationRequired() == 1) {
            if (checkedProgress != null && checkedProgress.getProgressCode() == 99 && config.getRequiredFlag() == 1) {
                tv_classfiy_must.setVisibility(View.GONE);
            } else {
                tv_classfiy_must.setVisibility(View.VISIBLE);
            }
        } else {
            tv_classfiy_must.setVisibility(View.GONE);
        }
        if (config != null && config.getSummaryTemplateRequired() == 1) {
            if (checkedProgress != null && checkedProgress.getProgressCode() == 99 && config.getRequiredFlag() == 1) {
                tv_template_must.setVisibility(View.GONE);
            } else {
                tv_template_must.setVisibility(View.VISIBLE);
            }
        } else {
            tv_template_must.setVisibility(View.GONE);
        }
        iv_arrow_classify.setVisibility(View.VISIBLE);
        if (serviceSummary != null && !TextUtils.isEmpty(serviceSummary.getSummaryClassifyIds()) || (checkedClassifiesModels != null && checkedClassifiesModels.size() > 0)) {
            fl_classify_edit.setVisibility(View.VISIBLE);
            tv_classify_value.setVisibility(View.GONE);
        } else {
            fl_classify_edit.setVisibility(View.GONE);
            tv_classify_value.setText("");
            tv_classify_value.setVisibility(View.VISIBLE);
        }
        if (CallPermissionManager.isHasPermission(SobotPermissionManager.CCCV6_THXQ_BCFWZJ)) {//cccv6-thxq-bcfwzj
            btn_save.setVisibility(View.VISIBLE);
        } else {
            btn_save.setVisibility(View.GONE);
        }
        ll_edit_remark.setVisibility(View.VISIBLE);
        v_edit_remark.setVisibility(View.VISIBLE);
        tv_remark_value.setVisibility(View.GONE);
        ll_edit_btn.setVisibility(View.GONE);
        Drawable drawable = getResources().getDrawable(R.drawable.call_item_arrow);
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());
        tv_progress_value.setCompoundDrawables(null, null, drawable, null);
        tv_template_value.setCompoundDrawables(null, null, drawable, null);
        tv_progress_value.setOnClickListener(ServiceSummaryFragment.this);
        tv_template_value.setOnClickListener(ServiceSummaryFragment.this);
        fl_classify_edit.setOnClickListener(ServiceSummaryFragment.this);
        tv_classify_value.setOnClickListener(ServiceSummaryFragment.this);
        if (serviceSummary == null) {
            btn_cancel.setVisibility(View.GONE);
        } else {
            btn_cancel.setVisibility(View.VISIBLE);
        }
        if (null == checkedTemplate || TextUtils.isEmpty(checkedTemplate.getId())) {
            tv_template_value.setText("");
        }
    }

    //防止重复点击
    private long lastClickTime = 0;

    @Override
    public void onClick(View v) {
        if (v == btn_save && edit) {
            if (System.currentTimeMillis() - lastClickTime > 1000) {
                lastClickTime = System.currentTimeMillis();
                if (!TextUtils.isEmpty(fromPage) && "callStatus".equals(fromPage)) {
                    //判断是否在通话中，通话中和转接过来的不能提交服务总结
                    requestCanSubmit(1);
                } else {
                    submit();
                }
            }
        } else if (v == btn_cancel) {
            requestSummary();
            updateUI(false);
        } else if (v == tv_edit) {
            if (!TextUtils.isEmpty(fromPage) && "callStatus".equals(fromPage)) {
                //判断是否在通话中，通话中和转接过来的不能提交服务总结
                requestCanSubmit(2);
            } else {
                updateUI(true);
            }
        } else if (v == tv_progress_value) {
            //处理进度
            if (null != progressList && progressList.size() > 0) {
                showProgrssDialog();
            } else {
                requestProgress(true);
            }
        } else if (v == tv_template_value) {
            if (!TextUtils.isEmpty(tv_template_value.getText().toString()) && !"--".equals(tv_template_value.getText().toString())) {
                SobotCallCommonDialog dialog = new SobotCallCommonDialog(getResources().getString(R.string.call_switch_template_tips),
                        getResources().getString(R.string.sobot_btn_submit), new SobotCallCommonDialog.OnBtnClickListener() {
                    @Override
                    public void onClick() {
                        //选择模板
                        showTempDialog();
                    }
                }, getResources().getString(R.string.sobot_btn_cancle), null);
                dialog.show(getActivity().getSupportFragmentManager(), "dialog");
            } else {
                showTempDialog();
            }
        } else if (v == tv_classify_value || v == fl_classify_edit) {
            showClassifyDialog();
        }
    }

    private void submit() {
        if (serviceSummary == null) {
            serviceSummary = new SobotSummaryEntity();
        }
        //客户id
        if (!TextUtils.isEmpty(customerId)) {
            serviceSummary.setCustomerId(customerId);
        }
        serviceSummary.setCallID(callID);
        //进度
        int progress = 0;
        for (int i = 0; i < progressList.size(); i++) {
            if (progressList.get(i).isSelect()) {
                progress = progressList.get(i).getProgressCode();
            }
        }
        //进度
        if (config.getHandleProgressFlag() == 1 && progress == 0) {
            SobotToastUtil.showCustomToast(getContext(), getContext().getResources().getString(R.string.call_summary_processing_status));
            return;
        }
        serviceSummary.setSummaryHandleProgress(progress);
        //分类
        StringBuilder classifyId = new StringBuilder();
        StringBuilder classifyCode = new StringBuilder();
        StringBuilder classifyName = new StringBuilder();
        for (int i = 0; i < checkedClassifiesModels.size(); i++) {
            if (checkedClassifiesModels.get(i).isChecked()) {
                if (!TextUtils.isEmpty(classifyId.toString())) {
                    classifyId.append(",");
                    classifyCode.append(",");
                    classifyName.append(",");
                }
                classifyId.append(checkedClassifiesModels.get(i).getId());
                classifyCode.append(checkedClassifiesModels.get(i).getClassifyCode());
                classifyName.append(checkedClassifiesModels.get(i).getClassifyName());
            }
        }
        //分类
        if (config.getSummaryClassificationRequired() == 1 && TextUtils.isEmpty(classifyCode.toString()) && !(progress == 99 && config.getRequiredFlag() == 1)) {
            SobotToastUtil.showCustomToast(getContext(), getContext().getResources().getString(R.string.call_summary_service_class));
            return;
        }
        //模板
        String tempId = "", tempName = "";
        if (null != checkedTemplate) {
            tempName = checkedTemplate.getTemplateName();
            tempId = checkedTemplate.getId();
        }
        //模板
        if (config.getSummaryTemplateRequired() == 1 && TextUtils.isEmpty(tempId) && !(progress == 99 && config.getRequiredFlag() == 1)) {
            SobotToastUtil.showCustomToast(getContext(), getContext().getResources().getString(R.string.call_summary_service_template));
            return;
        }
        serviceSummary.setSummaryTemplateId(tempId);
        serviceSummary.setSummaryTemplateName(tempName);


        serviceSummary.setSummaryClassifyIds(classifyId.toString());
        serviceSummary.setSummaryClassifyCodes(classifyCode.toString());
        serviceSummary.setSummaryClassifyNames(classifyName.toString());
        //备注
        String remark = ed_remark.getText().toString();
        if (checkedTemplate != null && checkedTemplate.getRemarkFlag() == 1 && TextUtils.isEmpty(remark)) {
            SobotToastUtil.showCustomToast(getContext(), getContext().getResources().getString(R.string.sobot_call_plan_remarks_hint));
            return;
        }
        tv_remark_value.setText(remark);
        serviceSummary.setRemark(remark);

        //自定义字段必选填项是否为空
        ArrayList<CusFieldConfig> cusList = setCustomerFieldValue();
        for (int i = 0; i < cusList.size(); i++) {
            if (cusList.get(i).getOpenFlag() == 1 && cusList.get(i).getFillFlag() == 1 && TextUtils.isEmpty(cusList.get(i).getFieldValue())) {
                String tip = String.format(getContext().getResources().getString(R.string.sobot_cus_fiel_not_null), cusList.get(i).getFieldName());
                SobotToastUtil.showCustomToast(getContext(), tip);
                return;
            }
        }
        //自定义字段
        serviceSummary.setCustomerFields(cusList);
        zhiChiApi.submitSummary(getContext(), serviceSummary, config == null ? 1 : config.getCallPlan(), new SobotResultCallBack() {
            @Override
            public void onSuccess(Object o) {
                //重新查询服务总结
                requestSummary();
            }

            @Override
            public void onFailure(Exception e, String des) {
                if (getSobotActivity() != null && !TextUtils.isEmpty(des)) {
                    SobotToastUtil.showCustomToast(getSobotActivity(), !TextUtils.isEmpty(des) ? des : getSobotActivity().getResources().getString(R.string.sobot_call_net_error_string));
                }
            }
        });
    }

    private View getClassifiesItemView(final SobotSummaryClassifies bean) {
        View v = View.inflate(getSobotActivity(), R.layout.call_item_summary_classify, null);
        TextView view = (TextView) v.findViewById(R.id.tv_edit_unit_type);
        FlexboxLayout.LayoutParams layoutParams = new FlexboxLayout.LayoutParams(FlexboxLayout.LayoutParams.WRAP_CONTENT, FlexboxLayout.LayoutParams.WRAP_CONTENT);
        int margin = CommonUtils.dip2px(getSobotActivity(), 10);
        layoutParams.setMargins(0, margin, margin, margin);
        view.setLayoutParams(layoutParams);
        view.setText(getParendPath(bean));
        view.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (classifiesList != null) {
                    for (int i = 0; i < classifiesList.size(); i++) {
                        SobotSummaryClassifies info = classifiesList.get(i);
                        if (info.getId().equals(bean.getId())) {
                            classifiesList.get(i).setChecked(false);
                            break;
                        }
                    }
                }
                if (checkedClassifiesModels != null) {
                    for (int i = 0; i < checkedClassifiesModels.size(); i++) {
                        SobotSummaryClassifies info = checkedClassifiesModels.get(i);
                        if (info.getId().equals(bean.getId())) {
                            checkedClassifiesModels.remove(i);
                            break;
                        }
                    }
                }
                updateClassificationLin();
            }
        });
        return v;
    }

    private void setTemplate(boolean isEdit) {
        if (checkedTemplate == null) {
            v_cus_l.setVisibility(View.GONE);
            return;
        }

        if (checkedTemplate.getCustomFields() == null || checkedTemplate.getCustomFields().size() == 0) {
            v_cus_l.setVisibility(View.GONE);
        } else {
            v_cus_l.setVisibility(View.VISIBLE);
        }
        tv_template_value.setTag(checkedTemplate.getId());
        tv_template_value.setText(checkedTemplate.getTemplateName());

        //备注是否必填
        if (isEdit && checkedTemplate.getRemarkFlag() == 1) {
            tv_remark_must.setVisibility(View.VISIBLE);
        } else {
            tv_remark_must.setVisibility(View.GONE);
        }
        //设置备注的文案
        if (!TextUtils.isEmpty(checkedTemplate.getRemarks())) {
            ed_remark.setText(checkedTemplate.getRemarks());
        }
        //设置自定义字段
        ArrayList<CusFieldConfig> editList = new ArrayList();
        if (allCusFieldConfigList.size() > 0 && (null != checkedTemplate.getCustomFields() && checkedTemplate.getCustomFields().size() > 0)) {
            //重新设置自定义字段
            ArrayList<CusFieldConfig> list = checkedTemplate.getCustomFields();
            for (int i = 0; i < list.size(); i++) {
                CusFieldConfig tmp = allCusFieldConfigList.get(list.get(i).getFieldId());
                if (tmp != null) {
                    list.get(i).setCusFieldDataInfoList(tmp.getCusFieldDataInfoList());
                    editList.add(list.get(i));
                } else {
                    list.get(i).setFieldDelete(true);
                }
            }
            checkedTemplate.setCustomFields(list);
        }
        if (isEdit) {
            CustomFieldsUtils.addWorkOrderUserCusFields(getSobotActivity(), editList, ll_cus_view);
        } else {
            CustomFieldsUtils.showCusFieldsNew(getSobotActivity(), checkedTemplate.getCustomFields(), ll_cus_view);
        }
    }

    /**
     * 刷新标签
     */
    private void updateClassificationLin() {
        fl_classify_edit.removeAllViews();
        int count = 0;
        if (checkedClassifiesModels != null) {
            for (int i = 0; i < checkedClassifiesModels.size(); i++) {
                final SobotSummaryClassifies bean = checkedClassifiesModels.get(i);
                if (bean == null) {
                    continue;
                }
                if (bean.isChecked()) {
                    count++;
                    View v = getClassifiesItemView(bean);
                    fl_classify_edit.addView(v);
                }
            }
        }
        if (count == 0) {
            fl_classify_edit.setVisibility(View.GONE);
            tv_classify_value.setText("--");
            tv_classify_value.setVisibility(View.VISIBLE);
        }
    }

    private void requestCanSubmit(int type) {
        zhiChiApi.queueCanSubmitSummary(getSobotActivity(), callID, new SobotResultCallBack<CanSubmitSummaryModel>() {
            @Override
            public void onSuccess(CanSubmitSummaryModel o) {
                SobotServiceInfoModel serviceVo = SobotLoginTools.getInstance().getServiceInfo();
                String serviceId = null != serviceVo ? serviceVo.getServiceId() : "";
                if (o != null && o.isCalling() && !o.getBelongAgentUUID().equals(serviceId)) {
                    CallTipDialog tipDialog = new CallTipDialog(getString(R.string.call_cant_submit_summary_tip), getString(R.string.call_sign_can_group_tip));
                    tipDialog.setCancelable(true);
                    tipDialog.show(getFragmentManager(), "tipDialog");
                } else {
                    if (type == 1) {
                        submit();
                    } else if (type == 2) {
                        updateUI(true);
                    }
                }
            }

            @Override
            public void onFailure(Exception e, String des) {
                if (type == 1) {
                    submit();
                } else if (type == 2) {
                    updateUI(true);
                }
            }
        });
    }

    @Override
    public void onDestroyView() {
        if (templateDialog != null && templateDialog.isShowing()) {
            templateDialog.dismiss();
        }
        if (progressDialog != null && progressDialog.isShowing()) {
            progressDialog.dismiss();
        }
        super.onDestroyView();
    }
}